package hu.bme.mit.viatra2.genmodelexport;

import hu.optxware.emf2viatra.core.importer.EcoreInstanceImporter_OLD;

import java.io.IOException;
import java.util.Collections;
import java.util.Map;

import org.eclipse.emf.codegen.ecore.genmodel.GenModel;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IInputValidator;
import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.window.Window;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.dialogs.SaveAsDialog;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IModelSpace;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.FrameworkManager;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.frameworkgui.actions.AbstractFrameworkGUIAction;
import org.eclipse.viatra2.frameworkgui.content.FrameworkContainer;
import org.eclipse.viatra2.frameworkgui.views.FrameworkTreeView;
import org.eclipse.viatra2.imports.NativeImporterFactory;

/**
 * @author Zoltan Ujhelyi
 */
public class ExportGenmodelAction extends AbstractFrameworkGUIAction {

	FrameworkManager fwManager = FrameworkManager.getInstance();

	/**
	 * Initializes an Action and sets its text
	 */
	public ExportGenmodelAction() {
		super();
		setText("Export GenModel");
		setImageDescriptor(PlatformUI.getWorkbench().getSharedImages()
				.getImageDescriptor(ISharedImages.IMG_OBJ_ELEMENT));
	}

	/**
	 * Initializes the model space visualisation action
	 * @param part
	 */
	public ExportGenmodelAction(FrameworkTreeView part) {
		this();
		setupInternals(part);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 */
	@Override
	public void run() {
		super.run();
		final Object c = getFirstSelected();
		// Job job = new Job("GenModel Conversion") {

		// @Override
		// protected IStatus run(IProgressMonitor monitor) {
		if (c instanceof FrameworkContainer) {
			try {
				IFramework framework = ((FrameworkContainer) c).getFramework();
				IModelSpace modelspace = framework.getTopmodel();
				final IModelManager modelManager = modelspace.getModelManager();
				// String vpmlFile = "/ttc10-model/v2_school.vpml";
				//
				// IFile ecore = ResourcesPlugin.getWorkspace().getRoot()
				// .getFile(new Path("/ttc10-models/school.ecore"));
				// framework
				// .nativeImport(ecore.getLocation().toOSString(),
				// "hu.optxware.viatra.emf.live.core.importer.EcoreInstance");
				NativeImporterFactory importerFactory = framework
						.getNativeImporters()
						.get("hu.optxware.viatra.emf.live.core.importer.EcoreInstance");
				EcoreInstanceImporter_OLD importer = (EcoreInstanceImporter_OLD) importerFactory
						.getImporterInstance();
				Map<String, EObject> emfMapping = importer.getMapping();

				// IFramework framework = fwManager.createFramework();
				// EPackage emfPackage = createEMFPackage(entity, modelManager);
				SaveAsDialog saveDialog = new SaveAsDialog(Display.getCurrent().getActiveShell());
				if (saveDialog.open() != Dialog.OK) return;
				ResourceSet set = importer.getResourceSet();
				Resource res = set.createResource(URI
						.createPlatformResourceURI(
								saveDialog.getResult().toString(), true));

				// Export machines
				InputDialog dialog = new InputDialog(Display.getCurrent()
						.getActiveShell(), "Select model root",
						"Select the root element ID of the GenModel",
						"nemf.resources.", new IInputValidator() {

							public String isValid(String newText) {
								if (modelManager.getEntityByName(newText) != null)
									return null;
								else
									return "Element not found";
							}
						});
				if (dialog.open() == Window.OK) {
					IEntity entity = modelManager
							.getEntityByName(dialog.getValue());
					ExportGenModel export = new ExportGenModel();
					export.setViatra2Emf(emfMapping);
					GenModel genModel = export.handleGenModel(entity,
							modelManager);

					res.getContents().add(genModel);

					res.save(Collections.emptyMap());
				}
				// res.
				// String ecoreURI = calculateEcoreURI(entity, modelManager);
				// System.out.println(ecoreURI);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (VPMRuntimeException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		// return Status.OK_STATUS;
		// }

		// };
		// job.schedule();
	}
}
