package hu.optxware.emf2viatra.core.eresource;

import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.viatra2.core.IEntity;

/**
 * Interface for accessing Viatra specific informations.
 */
public interface InternalViatraObject extends InternalEObject {

	/**
	 * Returns with related Viatra Entity. This entity stores the state of the
	 * object
	 */
	IEntity getRelatedViatraEntity();

	/**
	 * Sets the related Viatra Entity, which entity stores the state of the
	 * object
	 * @param relatedViatraEntity 
	 */
	void setRelatedViatraEntity(IEntity relatedViatraEntity);

	/**
	 * Returns <code>true</code> if the object has already persisted and has a
	 * related Viatra Entity
	 */
	boolean isPersisted();

	/**
	 * Set the state of the object which indicates whether the object is
	 * persisted or not.
	 * @param isPersisted 
	 */
	void setPersisted(boolean isPersisted);
}
