package hu.optxware.emf2viatra.core.eresource.impl;

import hu.optxware.emf2viatra.core.eresource.InternalViatraObject;

import java.util.HashMap;
import java.util.Map;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.EStoreEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource.Internal;
import org.eclipse.viatra2.core.IEntity;

public class ViatraObjectImpl extends EStoreEObjectImpl implements InternalViatraObject {

	private IEntity relatedViatraEntityInstance;
	private boolean isPersisted;
	// Az�rt kell, hogy ne ker�lj�nk v�gtelen ciklusba!!!!
	private boolean isContainerSet = false;
	private Map<Integer, Object> localStore = null;
	
	// Gondoljuk m�g majd �t TODO
	private Internal localDirectResource = null;

	@Override
	public Object dynamicGet(int dynamicFeatureID) {
		if (!isPersisted) {
			// if (eSettings == null) {
			// return null;
			// }
			// return eSettings[dynamicFeatureID];
			if (localStore == null) {
				return null;
			}
			return localStore.get(dynamicFeatureID);
		}
		// Delegate to ViatraStore
		return super.dynamicGet(dynamicFeatureID);
	}

	@Override
	public void dynamicSet(int dynamicFeatureID, Object value) {
		if (!isPersisted) {
			// eSettings(); // Important to create eSettings array if necessary
			// eSettings[dynamicFeatureID] = value;
			if (localStore == null) {
				localStore = new HashMap<Integer, Object>();
			}
			localStore.put(dynamicFeatureID, value);
		} else {
			// Delegate to ViatraStore
			super.dynamicSet(dynamicFeatureID, value);
		}
	}

	public void dynamicUnset(int dynamicFeatureID) {
		if (!isPersisted) {
			if (localStore == null) {
				localStore = new HashMap<Integer, Object>();
			}
			localStore.remove(dynamicFeatureID);
		} else {
			// Delegate to ViatraStore
			super.dynamicUnset(dynamicFeatureID);
		}
	}

	@Override
	protected boolean eDynamicIsSet(int dynamicFeatureID, EStructuralFeature eFeature) {
		if (!isPersisted) {
			if (localStore == null) {
				localStore = new HashMap<Integer, Object>();
			}
			if (localStore.containsKey(dynamicFeatureID)) {
				return true;
			} else {
				return false;
			}
		} else {
			// Delegate to ViatraStore
			return super.eDynamicIsSet(dynamicFeatureID, eFeature);
		}
		// return dynamicFeatureID < 0 ? eOpenIsSet(eFeature) :
		// eFeature.isTransient() ? eSettingDelegate(eFeature)
		// .dynamicIsSet(this, eSettings(), dynamicFeatureID) :
		// eStore().isSet(this, eFeature);
	}

	public boolean isPersisted() {
		return isPersisted;
	}

	public void setPersisted(boolean isPersisted) {
		this.isPersisted = isPersisted;
	}

	public ViatraObjectImpl() {
		eSetStore(new ViatraStoreImpl());
		eContainer = null;
		isPersisted = false;
	}

	@Override
	protected boolean eIsCaching() {
		return false;
	}
	
	public IEntity getRelatedViatraEntity() {
		return relatedViatraEntityInstance;
	}

	public void setRelatedViatraEntity(IEntity relatedViatraEntity) {
		relatedViatraEntityInstance = relatedViatraEntity;
	}

	@Override
	public boolean equals(Object obj) {

		if (getRelatedViatraEntity() == null) {
			return false;
		}

		if (obj instanceof ViatraObjectImpl) {
			if (((ViatraObjectImpl) obj).getRelatedViatraEntity() == null) {
				return false;
			} else {
				return getRelatedViatraEntity().equals(((ViatraObjectImpl) obj).getRelatedViatraEntity());
			}
		} else {
			return false;
		}

	}

	@Override
	public String toString() {
		String result = getRelatedViatraEntity() != null ? super.toString() + "_"
				+ getRelatedViatraEntity().getFullyQualifiedName() : super.toString();
		return result;
	}

	// TODO
	@Override
	public InternalEObject eInternalContainer() {
		if (isPersisted) {
			if (!isContainerSet) {
				isContainerSet = true;
				eInitializeContainer();
			}
			return eContainer;
		} else {
			return null;
		}
	}

	// TODO
	@Override
	public int eContainerFeatureID() {
		if (isPersisted) {
			if (!isContainerSet) {
				isContainerSet = true;
				eInitializeContainer();
			}
			return eContainerFeatureID;
		} else {
			return -1;
		}
	}

	
	// TODO
	@Override
	public Internal eDirectResource() {
		if (isPersisted) {
			return localDirectResource;			
		} else {
			// TODO gondoljuk �t. �gy kifut egy eproperties r�szbe..
			return super.eDirectResource();
		}
	}
	
	// TODO HACK
	@Override
	public void eSetDirectResource(Internal resource) {
		if (isPersisted) {
			localDirectResource = resource;			
		} else {
			// TODO gondoljuk �t. �gy kifut egy eproperties r�szbe..
			super.eSetDirectResource(resource);
		}
	}

}
