package hu.optxware.emf2viatra.core.importer;

import hu.optxware.emf2viatra.core.managers.EMF2ViatraSynchronizer;
import hu.optxware.emf2viatra.core.managers.EMFCoreEntConst;
import hu.optxware.emf2viatra.core.managers.EMFCoreMetamodelManager;
import hu.optxware.emf2viatra.core.managers.EMFCoreRelConst;
import hu.optxware.emf2viatra.core.managers.ViatraEMFFrameworkManager;
import hu.optxware.emf2viatra.core.managers.ViatraEMFManagersFactory;
import hu.optxware.emf2viatra.utils.NameUtility;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EFactory;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EStructuralFeature.Setting;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;

public class EcoreInstanceImporter_OLD implements NativeImporter {

	private IModelManager modelmanager;
	private EMFCoreMetamodelManager emfCoreManager;
	private ViatraEMFFrameworkManager viatraEMFFrameworkManager = null;
	private EMF2ViatraSynchronizer emf2ViatraSync;
	private static ResourceSet resourceSet;

	private void init(IFramework fw) {
		modelmanager = fw.getTopmodel().getModelManager();
		emfCoreManager = ViatraEMFManagersFactory.getInstance()
				.getEMFcoreMetamodelManager(fw);
		emf2ViatraSync = ViatraEMFManagersFactory.getInstance()
				.getEMF2ViatraSynchronizer(fw);
		viatraEMFFrameworkManager = ViatraEMFManagersFactory.getInstance()
				.getViatraEMFFrameworkManager(fw);
		viatra2Emf = new HashMap<String, EObject>();
	}

	public void process(InputStream f, IFramework fw)
			throws VPMRuntimeException {
		// TODO :)
		System.out.println("a");

	}

	public void processFile(String f, IFramework fw) throws VPMRuntimeException {

		init(fw);
		Collection<EObject> roots = doGetRoot(f, fw);

		try {
			objects.clear();
			// Process Objects
			for (EObject root : roots) {
				processObject(root, emfCoreManager
						.getIEntityForEcoreElement(EMFCoreEntConst.RESOURCES));
			}
			processReferences();
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}

	/**
	 * Calculates the root element of all used EMF resources (even the
	 * referenced ones).
	 * @param f
	 * @param fw
	 * @return the set of root elements
	 */
	protected Collection<EObject> doGetRoot(String f, IFramework fw) {

		resourceSet = new ResourceSetImpl();
		Resource res = resourceSet.createResource(URI.createFileURI(f));
		HashSet<EObject> roots = new HashSet<EObject>();
		try {

			res.load(null);

		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		// Resolving and loading all referenced ecores - using the EcoreUtil
		// class.
		EcoreUtil.resolveAll(resourceSet);
		EObject result = res.getContents().get(0);
		ArrayList<EObject> rootElements = new ArrayList<EObject>();
		rootElements.add(result);
		Map<EObject, Collection<Setting>> references = EcoreUtil.CrossReferencer
				.find(rootElements);
		for (EObject reference : references.keySet()) {
			if (reference instanceof EFactory) continue;
			if (reference.eResource().getURI().toString().contentEquals(
					"http://www.eclipse.org/emf/2002/Ecore")) continue;
			roots.add(reference.eResource().getContents().get(0));
		}
		roots.add(result);

		return roots;
	}

	ArrayList<EObject> objects = new ArrayList<EObject>();

	private Map<EObject, IEntity> emf2Viatra = new HashMap<EObject, IEntity>();
	private static Map<String, EObject> viatra2Emf;
	// TODO: initial solution to get Viatra elements for EObject during the
	// parse of references
	// XXX private static final boolean usingHashMap = false;
	private static final boolean usingHashMap = true;

	private void processReferences() {
		try {
			for (EObject obj : objects) {
				IEntity viatraInstanceMain = getIEntityForEObjectInstance(obj);
				for (EReference eRefType : obj.eClass().getEAllReferences()) {
					Object referencedObj = obj.eGet(eRefType);

					if (referencedObj instanceof List) {
						List<Object> referencedObjList = (List<Object>) referencedObj;
						// prevRelation is needed to make the next relation
						IRelation prevRelation = null;
						for (Object object : referencedObjList) {
							if (object instanceof EObject) {
								IEntity viatraInstanceReferenced = getIEntityForEObjectInstance((EObject) object);
								IRelation viatraMetaRefRelType = emf2ViatraSync
										.getIRelationForEReferenceElement(eRefType);
								if (viatraInstanceReferenced != null
										&& viatraMetaRefRelType != null) {
									IRelation viatraInstanceRefRel = modelmanager
											.newRelation(viatraInstanceMain,
													viatraInstanceReferenced);
									modelmanager.newInstanceOf(
											viatraMetaRefRelType,
											viatraInstanceRefRel);
									// modification for ordered relations
									if (prevRelation != null) {
										IRelation nextRelation = modelmanager
												.newRelation(prevRelation,
														viatraInstanceRefRel);
										modelmanager
												.newInstanceOf(
														emfCoreManager
																.getIRelationForEcoreElement(EMFCoreRelConst.ECORE_EOBJECT_ORDEREDRELATION_NEXT),
														nextRelation);
									}
									prevRelation = viatraInstanceRefRel;
								}
							}
						}
					} else if (referencedObj instanceof EObject) {
						IEntity viatraInstanceReferenced = getIEntityForEObjectInstance((EObject) referencedObj);
						IRelation viatraMetaRefRelType = emf2ViatraSync
								.getIRelationForEReferenceElement(eRefType);
						if (viatraInstanceReferenced != null
								&& viatraMetaRefRelType != null && viatraInstanceMain != null) {
							IRelation viatraInstanceRefRel = modelmanager
									.newRelation(viatraInstanceMain,
											viatraInstanceReferenced);
							modelmanager.newInstanceOf(viatraMetaRefRelType,
									viatraInstanceRefRel);

						}
					}

				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private IEntity processObject(EObject obj, IEntity root) {
		try {
			// parse the Object
			EClass eClass = obj.eClass();
			IEntity viatraMetaEClass = emf2ViatraSync
					.getIEntityForEClass(eClass);
			IEntity viatraInstanceEClass = null;

			String name = NameUtility.getNameOfEObject(obj);

			// If the element has a name attribute, use that, otherwise no name
			if (name != null) {
				viatraInstanceEClass = modelmanager.newEntity(NameUtility
						.convertToValidViatraName(name), root);
			} else {
				viatraInstanceEClass = modelmanager.newEntity(root);
			}

			modelmanager.newInstanceOf(viatraMetaEClass, viatraInstanceEClass);
			if (usingHashMap) {
				emf2Viatra.put(obj, viatraInstanceEClass);
			}
			viatra2Emf.put(viatraInstanceEClass.getFullyQualifiedName(), obj);
			// Set attributes
			for (EAttribute metaAttr : eClass.getEAllAttributes()) {
				Object attrValue = obj.eGet(metaAttr);
				EDataType dataType = metaAttr.getEAttributeType();
				if (metaAttr.isMany()) {
					IRelation prevRelation = null;
					for (Object elementValue : (EList<Object>) attrValue) {

						boolean isEnum = (dataType instanceof EEnum) ? true
								: false;

						IEntity viatraMetaAttributeData = emf2ViatraSync
								.getIEntityForEDataType(dataType);
						IRelation viatraMetaAttribute = emf2ViatraSync
								.getIRelationForEAttributeElement(metaAttr);

						if (elementValue != null
								&& viatraMetaAttributeData != null
								&& viatraMetaAttribute != null) {
							IEntity viatraInstanceAttributeData = null;

							if (isEnum) {
								viatraInstanceAttributeData = emf2ViatraSync
										.getIEntityForEEnumLiteral(
												(EEnum) dataType,
												(Enumerator) elementValue);
							} else {
								viatraInstanceAttributeData = modelmanager
										.newEntity(viatraInstanceEClass);
								modelmanager.setValue(
										viatraInstanceAttributeData,
										elementValue.toString());
								modelmanager.newInstanceOf(
										viatraMetaAttributeData,
										viatraInstanceAttributeData);
							}

							if (viatraInstanceAttributeData != null) {

								IRelation viatraInstanceAttribute = modelmanager
										.newRelation(viatraInstanceEClass,
												viatraInstanceAttributeData);
								modelmanager.newInstanceOf(viatraMetaAttribute,
										viatraInstanceAttribute);

								// Set the next relations between the ordered
								// relations
								if (prevRelation != null) {
									IRelation nextRelation = modelmanager
											.newRelation(prevRelation,
													viatraInstanceAttribute);
									modelmanager
											.newInstanceOf(
													emfCoreManager
															.getIRelationForEcoreElement(EMFCoreRelConst.ECORE_EOBJECT_ORDEREDRELATION_NEXT),
													nextRelation);
								}
								prevRelation = viatraInstanceAttribute;
							}
						}
					}

				} else {
					boolean isEnum = (dataType instanceof EEnum) ? true : false;

					IEntity viatraMetaAttributeData = emf2ViatraSync
							.getIEntityForEDataType(dataType);
					IRelation viatraMetaAttribute = emf2ViatraSync
							.getIRelationForEAttributeElement(metaAttr);

					if (attrValue != null && viatraMetaAttributeData != null
							&& viatraMetaAttribute != null) {
						IEntity viatraInstanceAttributeData = null;

						if (isEnum) {
							viatraInstanceAttributeData = emf2ViatraSync
									.getIEntityForEEnumLiteral(
											(EEnum) dataType,
											(Enumerator) attrValue);
						} else {
							viatraInstanceAttributeData = modelmanager
									.newEntity(viatraInstanceEClass);
							modelmanager.setValue(viatraInstanceAttributeData,
									attrValue.toString());
							modelmanager.newInstanceOf(viatraMetaAttributeData,
									viatraInstanceAttributeData);
						}

						if (viatraInstanceAttributeData != null) {
							IRelation viatraInstanceAttribute = modelmanager
									.newRelation(viatraInstanceEClass,
											viatraInstanceAttributeData);
							modelmanager.newInstanceOf(viatraMetaAttribute,
									viatraInstanceAttribute);
							// TODO: IT has to be removed! (Just for AUTOSAR)
							if (metaAttr.getName().toLowerCase().equals(
									"shortname")) {
								modelmanager.setName(viatraInstanceEClass,
										attrValue.toString());
							}
						}
					}
				}
			}

			// parse recursively the contained objects
			for (EObject containedObj : obj.eContents()) {
				processObject(containedObj, viatraInstanceEClass);
			}

			objects.add(obj);

			return viatraInstanceEClass;

		} catch (VPMCoreException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
	}

	/**
	 * Finds and returns the VPM Entity representing an EObject. TODO : Ez hova
	 * val�???
	 * @param eObject
	 * @return the VPM Entity representation
	 */
	public IEntity getIEntityForEObjectInstance(EObject eObject) {
		IEntity matchedEntity = null;

		if (!usingHashMap) {
			// As long as usingHashMap is public static final with a value of
			// true, this block won't run
			LinkedList<EObject> pathOfObjects = new LinkedList<EObject>();

			EObject actEObject = eObject;

			pathOfObjects.add(actEObject);
			while (actEObject.eContainer() != null) {
				pathOfObjects.addLast(actEObject.eContainer());
				actEObject = actEObject.eContainer();
			}

			IEntity actEntityRoot = emfCoreManager
					.getIEntityForEcoreElement(EMFCoreEntConst.RESOURCES);
			// XXX while (!pathOfObjects.isEmpty() && actEntityRoot == null) {
			while (!pathOfObjects.isEmpty() && actEntityRoot != null) {
				actEntityRoot = findRelatedIEntityForEObjectInstanceInGivenRoot(
						pathOfObjects.getLast(), actEntityRoot);
				pathOfObjects.removeLast();
			}
			matchedEntity = actEntityRoot;
		} else {
			matchedEntity = emf2Viatra.get(eObject);
		}

		// XXX Warning: Hack solution...
		// Cause: We should also be able to refer to metamodel elements as
		// instances
		// See: getIEntityForEClassElement Hack
		if (matchedEntity == null) {
			IEntity viatraPackagesRoot = emfCoreManager
					.getIEntityForEcoreElement(EMFCoreEntConst.PACKAGES);
			String name = NameUtility.getNameOfEObject(eObject);
			if (name != null) {
				String nsURIStringEMF = null;
				if (eObject.eContainer() != null) {
					for (EAttribute eAttribute : eObject.eContainer().eClass()
							.getEAttributes()) {
						if (eAttribute.getName().equals("nsURI")) {
							nsURIStringEMF = (eObject.eContainer()
									.eGet(eAttribute)).toString();
						}
					}
				}
				for (IModelElement viatraMetaPackage : viatraPackagesRoot
						.getElementsInNamespace()) {
					if (viatraMetaPackage instanceof IEntity) {
						String nsUriStringViatra = null;
						Collection<IModelElement> nsUriEntities = viatraMetaPackage
								.getAllRelationTargetByType(emfCoreManager
										.getIRelationForEcoreElement(EMFCoreRelConst.ECORE_EPACKAGE_NSURI));
						if (nsUriEntities.size() == 1) {
							IEntity nsUriEnt = (IEntity) nsUriEntities
									.toArray()[0];
							nsUriStringViatra = nsUriEnt.getValue();
						}
						if (nsUriStringViatra != null && nsURIStringEMF != null
								&& nsUriStringViatra.equals(nsURIStringEMF)) {
							for (IModelElement viatraInstanceModelElement : viatraMetaPackage
									.getElementsInNamespace()) {
								if (viatraInstanceModelElement instanceof IEntity
										&& viatraInstanceModelElement
												.isInstanceOf(emfCoreManager
														.getIEntityForEcoreElement(EMFCoreEntConst.ECORE_ENAMEDELEMENT))) {
									if (viatraEMFFrameworkManager
											.getNameForViatraNamedElement(
													(IEntity) viatraInstanceModelElement)
											.equals(name)) {
										matchedEntity = (IEntity) viatraInstanceModelElement;
									}
								}
							}
						}
					}
				}
			}
		}

		return matchedEntity;
	}

	// TODO : Ez hova val�???
	private IEntity findRelatedIEntityForEObjectInstanceInGivenRoot(
			EObject eObject, IEntity rootEntity) {
		IEntity matchedEntity = null;
		try {

			EClass eClass = eObject.eClass();

			IEntity viatraMetaObjectType = emf2ViatraSync
					.getIEntityForEClass(eClass);

			if (viatraMetaObjectType != null) {

				List<IEntity> typeConfortViatraEntities = new ArrayList<IEntity>();
				typeConfortViatraEntities.clear();

				for (IModelElement contEnt : rootEntity.getContents()) {
					if (contEnt instanceof IEntity
							&& contEnt.isInstanceOf(viatraMetaObjectType)) {
						typeConfortViatraEntities.add((IEntity) contEnt);
					}
				}

				List<IEntity> typeConfortViatraEntitiesToDelete = new ArrayList<IEntity>();
				typeConfortViatraEntitiesToDelete.clear();

				// FIXME ezt nem igy kell, hanem a path alapj�n kell megtal�lni,
				// hogy az-e.
				// Ne �gy z�rjunk ki elemeket, hogy nem ua. az attrib�tum
				// halmaz...
				for (EAttribute eAttrType : eClass.getEAllAttributes()) {
					Object emfAttrValue = eObject.eGet(eAttrType);
					IRelation viartaMetaAttributeRelation = emf2ViatraSync
							.getIRelationForEAttributeElement(eAttrType);
					// TODO System.err.println(viartaMetaAttributeRelation.toString());
					for (IEntity ent : typeConfortViatraEntities) {
						// TODO stringValue is a different structure in EMF ('[value]') and VIATRA ('value') 
						if(viartaMetaAttributeRelation == null){
							//System.err.println("viartaMetaAttributeRelation null");
						}
						else if( eAttrType.getName().equals("stringValue")){
							Collection<IModelElement> targets = ent
									.getAllRelationTargetByType(viartaMetaAttributeRelation);
							if (emfAttrValue != null && targets.size() == 1) {
								IEntity target = (IEntity) targets.toArray()[0];
								String viatraAttrValue = target.getValue();
								if (!viatraAttrValue.equals(emfAttrValue.toString().substring(1,emfAttrValue.toString().length()-1)))
									{if (!typeConfortViatraEntitiesToDelete
											.contains(ent)) {
										//System.err.println("handle stringValue check: " +
										//		emfAttrValue.toString() + " "+ viatraAttrValue);
										typeConfortViatraEntitiesToDelete
												.add(ent);
								}}// else	System.err.println("success");
							}
							
						}
							
							// TODO 'value' not handled (no such relation in VIATRA, data not imported from EMF)
						else{
							Collection<IModelElement> targets = ent
									.getAllRelationTargetByType(viartaMetaAttributeRelation);
							if (emfAttrValue != null && targets.size() == 1) {
								IEntity target = (IEntity) targets.toArray()[0];
								String viatraAttrValue = target.getValue();
								if (eAttrType instanceof EEnum) {
									// TODO TODO TODO
								} else {
									if (!viatraAttrValue.equals(emfAttrValue
											.toString())) {
										if (!typeConfortViatraEntitiesToDelete
												.contains(ent)) {
											typeConfortViatraEntitiesToDelete
													.add(ent);
										}
									}
								}
							}
						}
					}
				}

				typeConfortViatraEntities
						.removeAll(typeConfortViatraEntitiesToDelete);
				typeConfortViatraEntitiesToDelete.clear();
				if (typeConfortViatraEntities.size() > 1){
					// XXX hack for entities appearing as same.
					if(eObject instanceof EOperation) {
						// get number of parameters, if different, delete
						//System.err.println("this is an EOperation");
						int pars = ((EOperation) eObject).getEParameters().size();
						for (IEntity entity : typeConfortViatraEntities) {
							int vpars = 0;
							for (IModelElement content : entity.getContents()) {
								for (IModelElement type : content.getTypes()) {
									if(type.getName().equals("EParameter"))
										vpars++;
								}
							}
							if(vpars != pars){
								if (!typeConfortViatraEntitiesToDelete
										.contains(entity)) {
									typeConfortViatraEntitiesToDelete
											.add(entity);
								}
							}
						}
						
					} else if(eObject instanceof EGenericType){
						System.err.println("this is an EGenericType");
						//eObject.get
					}
					//System.err.println("using first from same entities");
					typeConfortViatraEntities
							.removeAll(typeConfortViatraEntitiesToDelete);
					//matchedEntity = typeConfortViatraEntities.get(0);
				}
				if (typeConfortViatraEntities.size() == 1) {
					matchedEntity = typeConfortViatraEntities.get(0);
				} else{
					System.err.println("Houston, we have a problem!" + eObject.toString());
				}
			}
			return matchedEntity;
		} catch (Exception e) {
			e.printStackTrace();
			return matchedEntity;
		}
	}

	/**
	 * This method returns the static inverse mapping map. This hack is needed
	 * as the importer is instantiated at every call.
	 * @return the inverse mapping
	 */
	public Map<String, EObject> getMapping() {
		return viatra2Emf;
	}

	public ResourceSet getResourceSet() {
		return resourceSet;
	}
}
