package hu.optxware.emf2viatra.core.listener;

import hu.optxware.emf2viatra.core.managers.ViatraEMFFrameworkManager;
import hu.optxware.emf2viatra.core.managers.ViatraEMFManagersFactory;

import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.framework.IFramework;

public class ManyStructuralFeature extends SingleStructuralFeature {

	private IRelation nextRelationInstance;

	private IRelation prevRelationInstance;
	
	private int index;

	public int getIndex() {
		return index;
	}

	public void setIndex(int index) {
		this.index = index;
	}

	public IRelation getNextRelationInstance() {
		return nextRelationInstance;
	}

	public IRelation getPrevRelationInstance() {
		return prevRelationInstance;
	}

	public ManyStructuralFeature(IRelation relationInstance) {
		super(relationInstance);

		if (relationInstance != null) {
			IFramework fw = relationInstance.getModelSpace().getFramework();
			ViatraEMFFrameworkManager viatraEMFFrameworkManager = ViatraEMFManagersFactory.getInstance()
					.getViatraEMFFrameworkManager(fw);
			nextRelationInstance = viatraEMFFrameworkManager.getNext(relationInstance);
			prevRelationInstance = viatraEMFFrameworkManager.getPrev(relationInstance);
		}
	}

	public ManyStructuralFeature(IRelation relationInstance, IRelation prevRelation, IRelation nextRelation) {
		super(relationInstance);
		prevRelationInstance = prevRelation;
		nextRelationInstance = nextRelation;
	}
}
