package hu.optxware.emf2viatra.core.managers;

import java.util.HashMap;

import org.eclipse.viatra2.framework.IFramework;

public class ViatraEMFManagersFactory {

	private static ViatraEMFManagersFactory instance = null;

	private HashMap<IFramework, EMFCoreMetamodelManager> emfCoreManagers = new HashMap<IFramework, EMFCoreMetamodelManager>();

	private HashMap<IFramework, Viatra2EMFSynchronizer> viatra2EMFSynchronizers = new HashMap<IFramework, Viatra2EMFSynchronizer>();

	private HashMap<IFramework, EMF2ViatraSynchronizer> emf2ViatraSynchronizers = new HashMap<IFramework, EMF2ViatraSynchronizer>();

	private HashMap<IFramework, ViatraEMFFrameworkManager> viatraEMFFrameworkManagers = new HashMap<IFramework, ViatraEMFFrameworkManager>();

	// TODO remove
	//private HashMap<IFramework, Resource > fwToResourceMap = new HashMap<IFramework, Resource>();
	
	private ViatraEMFManagersFactory() {

	}

	public static ViatraEMFManagersFactory getInstance() {
		if (instance == null) {
			instance = new ViatraEMFManagersFactory();
		}
		return instance;
	}

	public EMFCoreMetamodelManager getEMFcoreMetamodelManager(IFramework framework) {
		if (emfCoreManagers.get(framework) == null) {
			EMFCoreMetamodelManager manager = new EMFCoreMetamodelManager(framework);
			emfCoreManagers.put(framework, manager);
		}
		return emfCoreManagers.get(framework);
	}

	public Viatra2EMFSynchronizer getViatra2EMFSynchronizer(IFramework framework) {
		if (viatra2EMFSynchronizers.get(framework) == null) {
			Viatra2EMFSynchronizer manager = new Viatra2EMFSynchronizer(framework);
			viatra2EMFSynchronizers.put(framework, manager);
		}
		return viatra2EMFSynchronizers.get(framework);
	}

	public EMF2ViatraSynchronizer getEMF2ViatraSynchronizer(IFramework framework) {
		if (emf2ViatraSynchronizers.get(framework) == null) {
			EMF2ViatraSynchronizer manager = new EMF2ViatraSynchronizer(framework);
			emf2ViatraSynchronizers.put(framework, manager);
		}
		return emf2ViatraSynchronizers.get(framework);
	}

	public ViatraEMFFrameworkManager getViatraEMFFrameworkManager(IFramework framework) {
		if (viatraEMFFrameworkManagers.get(framework) == null) {
			ViatraEMFFrameworkManager manager = new ViatraEMFFrameworkManager(framework);
			viatraEMFFrameworkManagers.put(framework, manager);
		}
		return viatraEMFFrameworkManagers.get(framework);
	}
	
}
