/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Balogh and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Balogh - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.imports.vtml;

import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelSpace;
import org.eclipse.viatra2.errors.VPMCoreException;

/**
 * @author babo
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public abstract class ASTNode {
	
	int line;
	int UID;
	

	/**
	 * @return Returns the line.
	 */
	public int getLine() {
		return line;
	}
	/**
	 * @param line The line to set.
	 */
	public void setLine(int line) {
		this.line = line;
	}
	
	public abstract boolean checkDefintion(ASTBuilder ab, IModelSpace m);
	
	public abstract void generateElements(ASTBuilder ab, IModelSpace m,IEntity temp) throws VPMCoreException;
	public abstract void resolveReferences(ASTBuilder ab) throws VPMCoreException;
	
	public abstract void updateModelspace(ASTBuilder ab, IModelSpace m) throws VPMCoreException;
	
	public int getUID() {
		return UID;
	}
	public void setUID(int uid) {
		UID = uid;
	}
	
	
}
