/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Balogh and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Balogh - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.imports.vtml;

public interface VTMLParserConstants {

  int EOF = 0;
  int ALL = 33;
  int EXISTS = 34;
  int ANDOP = 35;
  int OROP = 36;
  int IMPLOP = 37;
  int ID = 38;
  int VARIABLE = 39;
  int OCTALINT = 40;
  int DECIMALINT = 41;
  int HEXADECIMALINT = 42;
  int FLOATONE = 43;
  int FLOATTWO = 44;
  int STRING = 45;
  int ANYID = 46;

  int DEFAULT = 0;

  String[] tokenImage = {
    "<EOF>",
    "\" \"",
    "\"\\t\"",
    "\"\\n\"",
    "\"\\r\"",
    "<token of kind 5>",
    "<token of kind 6>",
    "<token of kind 7>",
    "\"import\"",
    "\";\"",
    "\"namespace\"",
    "\"(\"",
    "\",\"",
    "\")\"",
    "\"{\"",
    "\"}\"",
    "\"instanceOf\"",
    "\"typeOf\"",
    "\"supertypeOf\"",
    "\"subtypeOf\"",
    "\"isFinalType\"",
    "\"true\"",
    "\"false\"",
    "\"isAggregation\"",
    "\"isAnySource\"",
    "\"isAnyTarget\"",
    "\"inverse\"",
    "\"multiplicity\"",
    "\"one_to_one\"",
    "\"one_to_many\"",
    "\"many_to_one\"",
    "\"many_to_many\"",
    "\".\"",
    "\"all\"",
    "\"exists\"",
    "\"&&\"",
    "\"||\"",
    "\"->\"",
    "<ID>",
    "<VARIABLE>",
    "<OCTALINT>",
    "<DECIMALINT>",
    "<HEXADECIMALINT>",
    "<FLOATONE>",
    "<FLOATTWO>",
    "<STRING>",
    "<ANYID>",
  };

}
