/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Balogh and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Balogh - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.imports.vtml;
import org.eclipse.viatra2.logger.Logger;

import java.util.*;
import java.io.InputStream;
import java.io.FileInputStream;

public class VTMLParserTokenManager implements VTMLParserConstants
{
  public static  java.io.PrintStream debugStream = System.out;
  public static  void setDebugStream(java.io.PrintStream ds) { debugStream = ds; }
private static final int jjStopStringLiteralDfa_0(int pos, long active0)
{
   switch (pos)
   {
      case 0:
         if ((active0 & 0x100000000L) != 0L)
            return 23;
         if ((active0 & 0x6ffff0500L) != 0L)
         {
            jjmatchedKind = 38;
            return 13;
         }
         return -1;
      case 1:
         if ((active0 & 0x6ffff0500L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 1;
            return 13;
         }
         return -1;
      case 2:
         if ((active0 & 0x4ffff0500L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 2;
            return 13;
         }
         if ((active0 & 0x200000000L) != 0L)
            return 13;
         return -1;
      case 3:
         if ((active0 & 0x4ffdf0500L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 3;
            return 13;
         }
         if ((active0 & 0x200000L) != 0L)
            return 13;
         return -1;
      case 4:
         if ((active0 & 0x400000L) != 0L)
            return 13;
         if ((active0 & 0x4ff9f0500L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 4;
            return 13;
         }
         return -1;
      case 5:
         if ((active0 & 0xff9d0400L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 5;
            return 13;
         }
         if ((active0 & 0x400020100L) != 0L)
            return 13;
         return -1;
      case 6:
         if ((active0 & 0xfb9d0400L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 6;
            return 13;
         }
         if ((active0 & 0x4000000L) != 0L)
            return 13;
         return -1;
      case 7:
         if ((active0 & 0xfb9d0400L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 7;
            return 13;
         }
         return -1;
      case 8:
         if ((active0 & 0xfb950000L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 8;
            return 13;
         }
         if ((active0 & 0x80400L) != 0L)
            return 13;
         return -1;
      case 9:
         if ((active0 & 0xeb940000L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 9;
            return 13;
         }
         if ((active0 & 0x10010000L) != 0L)
            return 13;
         return -1;
      case 10:
         if ((active0 & 0x63140000L) != 0L)
            return 13;
         if ((active0 & 0x88800000L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 10;
            return 13;
         }
         return -1;
      case 11:
         if ((active0 & 0x800000L) != 0L)
         {
            jjmatchedKind = 38;
            jjmatchedPos = 11;
            return 13;
         }
         if ((active0 & 0x88000000L) != 0L)
            return 13;
         return -1;
      default :
         return -1;
   }
}
private static final int jjStartNfa_0(int pos, long active0)
{
   return jjMoveNfa_0(jjStopStringLiteralDfa_0(pos, active0), pos + 1);
}
static private final int jjStopAtPos(int pos, int kind)
{
   jjmatchedKind = kind;
   jjmatchedPos = pos;
   return pos + 1;
}
static private final int jjStartNfaWithStates_0(int pos, int kind, int state)
{
   jjmatchedKind = kind;
   jjmatchedPos = pos;
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) { return pos + 1; }
   return jjMoveNfa_0(state, pos + 1);
}
static private final int jjMoveStringLiteralDfa0_0()
{
   switch(curChar)
   {
      case 38:
         return jjMoveStringLiteralDfa1_0(0x800000000L);
      case 40:
         return jjStopAtPos(0, 11);
      case 41:
         return jjStopAtPos(0, 13);
      case 44:
         return jjStopAtPos(0, 12);
      case 45:
         return jjMoveStringLiteralDfa1_0(0x2000000000L);
      case 46:
         return jjStartNfaWithStates_0(0, 32, 23);
      case 59:
         return jjStopAtPos(0, 9);
      case 97:
         return jjMoveStringLiteralDfa1_0(0x200000000L);
      case 101:
         return jjMoveStringLiteralDfa1_0(0x400000000L);
      case 102:
         return jjMoveStringLiteralDfa1_0(0x400000L);
      case 105:
         return jjMoveStringLiteralDfa1_0(0x7910100L);
      case 109:
         return jjMoveStringLiteralDfa1_0(0xc8000000L);
      case 110:
         return jjMoveStringLiteralDfa1_0(0x400L);
      case 111:
         return jjMoveStringLiteralDfa1_0(0x30000000L);
      case 115:
         return jjMoveStringLiteralDfa1_0(0xc0000L);
      case 116:
         return jjMoveStringLiteralDfa1_0(0x220000L);
      case 123:
         return jjStopAtPos(0, 14);
      case 124:
         return jjMoveStringLiteralDfa1_0(0x1000000000L);
      case 125:
         return jjStopAtPos(0, 15);
      default :
         return jjMoveNfa_0(0, 0);
   }
}
static private final int jjMoveStringLiteralDfa1_0(long active0)
{
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(0, active0);
      return 1;
   }
   switch(curChar)
   {
      case 38:
         if ((active0 & 0x800000000L) != 0L)
            return jjStopAtPos(1, 35);
         break;
      case 62:
         if ((active0 & 0x2000000000L) != 0L)
            return jjStopAtPos(1, 37);
         break;
      case 97:
         return jjMoveStringLiteralDfa2_0(active0, 0xc0400400L);
      case 108:
         return jjMoveStringLiteralDfa2_0(active0, 0x200000000L);
      case 109:
         return jjMoveStringLiteralDfa2_0(active0, 0x100L);
      case 110:
         return jjMoveStringLiteralDfa2_0(active0, 0x34010000L);
      case 114:
         return jjMoveStringLiteralDfa2_0(active0, 0x200000L);
      case 115:
         return jjMoveStringLiteralDfa2_0(active0, 0x3900000L);
      case 117:
         return jjMoveStringLiteralDfa2_0(active0, 0x80c0000L);
      case 120:
         return jjMoveStringLiteralDfa2_0(active0, 0x400000000L);
      case 121:
         return jjMoveStringLiteralDfa2_0(active0, 0x20000L);
      case 124:
         if ((active0 & 0x1000000000L) != 0L)
            return jjStopAtPos(1, 36);
         break;
      default :
         break;
   }
   return jjStartNfa_0(0, active0);
}
static private final int jjMoveStringLiteralDfa2_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(0, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(1, active0);
      return 2;
   }
   switch(curChar)
   {
      case 65:
         return jjMoveStringLiteralDfa3_0(active0, 0x3800000L);
      case 70:
         return jjMoveStringLiteralDfa3_0(active0, 0x100000L);
      case 98:
         return jjMoveStringLiteralDfa3_0(active0, 0x80000L);
      case 101:
         return jjMoveStringLiteralDfa3_0(active0, 0x30000000L);
      case 105:
         return jjMoveStringLiteralDfa3_0(active0, 0x400000000L);
      case 108:
         if ((active0 & 0x200000000L) != 0L)
            return jjStartNfaWithStates_0(2, 33, 13);
         return jjMoveStringLiteralDfa3_0(active0, 0x8400000L);
      case 109:
         return jjMoveStringLiteralDfa3_0(active0, 0x400L);
      case 110:
         return jjMoveStringLiteralDfa3_0(active0, 0xc0000000L);
      case 112:
         return jjMoveStringLiteralDfa3_0(active0, 0x60100L);
      case 115:
         return jjMoveStringLiteralDfa3_0(active0, 0x10000L);
      case 117:
         return jjMoveStringLiteralDfa3_0(active0, 0x200000L);
      case 118:
         return jjMoveStringLiteralDfa3_0(active0, 0x4000000L);
      default :
         break;
   }
   return jjStartNfa_0(1, active0);
}
static private final int jjMoveStringLiteralDfa3_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(1, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(2, active0);
      return 3;
   }
   switch(curChar)
   {
      case 95:
         return jjMoveStringLiteralDfa4_0(active0, 0x30000000L);
      case 101:
         if ((active0 & 0x200000L) != 0L)
            return jjStartNfaWithStates_0(3, 21, 13);
         return jjMoveStringLiteralDfa4_0(active0, 0x4060400L);
      case 103:
         return jjMoveStringLiteralDfa4_0(active0, 0x800000L);
      case 105:
         return jjMoveStringLiteralDfa4_0(active0, 0x100000L);
      case 110:
         return jjMoveStringLiteralDfa4_0(active0, 0x3000000L);
      case 111:
         return jjMoveStringLiteralDfa4_0(active0, 0x100L);
      case 115:
         return jjMoveStringLiteralDfa4_0(active0, 0x400400000L);
      case 116:
         return jjMoveStringLiteralDfa4_0(active0, 0x8090000L);
      case 121:
         return jjMoveStringLiteralDfa4_0(active0, 0xc0000000L);
      default :
         break;
   }
   return jjStartNfa_0(2, active0);
}
static private final int jjMoveStringLiteralDfa4_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(2, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(3, active0);
      return 4;
   }
   switch(curChar)
   {
      case 79:
         return jjMoveStringLiteralDfa5_0(active0, 0x20000L);
      case 95:
         return jjMoveStringLiteralDfa5_0(active0, 0xc0000000L);
      case 97:
         return jjMoveStringLiteralDfa5_0(active0, 0x10000L);
      case 101:
         if ((active0 & 0x400000L) != 0L)
            return jjStartNfaWithStates_0(4, 22, 13);
         break;
      case 103:
         return jjMoveStringLiteralDfa5_0(active0, 0x800000L);
      case 105:
         return jjMoveStringLiteralDfa5_0(active0, 0x8000000L);
      case 110:
         return jjMoveStringLiteralDfa5_0(active0, 0x100000L);
      case 114:
         return jjMoveStringLiteralDfa5_0(active0, 0x4040100L);
      case 115:
         return jjMoveStringLiteralDfa5_0(active0, 0x400L);
      case 116:
         return jjMoveStringLiteralDfa5_0(active0, 0x430000000L);
      case 121:
         return jjMoveStringLiteralDfa5_0(active0, 0x3080000L);
      default :
         break;
   }
   return jjStartNfa_0(3, active0);
}
static private final int jjMoveStringLiteralDfa5_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(3, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(4, active0);
      return 5;
   }
   switch(curChar)
   {
      case 83:
         return jjMoveStringLiteralDfa6_0(active0, 0x1000000L);
      case 84:
         return jjMoveStringLiteralDfa6_0(active0, 0x2000000L);
      case 97:
         return jjMoveStringLiteralDfa6_0(active0, 0x100000L);
      case 102:
         if ((active0 & 0x20000L) != 0L)
            return jjStartNfaWithStates_0(5, 17, 13);
         break;
      case 110:
         return jjMoveStringLiteralDfa6_0(active0, 0x10000L);
      case 111:
         return jjMoveStringLiteralDfa6_0(active0, 0x30000000L);
      case 112:
         return jjMoveStringLiteralDfa6_0(active0, 0x8080400L);
      case 114:
         return jjMoveStringLiteralDfa6_0(active0, 0x800000L);
      case 115:
         if ((active0 & 0x400000000L) != 0L)
            return jjStartNfaWithStates_0(5, 34, 13);
         return jjMoveStringLiteralDfa6_0(active0, 0x4000000L);
      case 116:
         if ((active0 & 0x100L) != 0L)
            return jjStartNfaWithStates_0(5, 8, 13);
         return jjMoveStringLiteralDfa6_0(active0, 0xc0040000L);
      default :
         break;
   }
   return jjStartNfa_0(4, active0);
}
static private final int jjMoveStringLiteralDfa6_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(4, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(5, active0);
      return 6;
   }
   switch(curChar)
   {
      case 95:
         return jjMoveStringLiteralDfa7_0(active0, 0x30000000L);
      case 97:
         return jjMoveStringLiteralDfa7_0(active0, 0x2000400L);
      case 99:
         return jjMoveStringLiteralDfa7_0(active0, 0x10000L);
      case 101:
         if ((active0 & 0x4000000L) != 0L)
            return jjStartNfaWithStates_0(6, 26, 13);
         return jjMoveStringLiteralDfa7_0(active0, 0x880000L);
      case 108:
         return jjMoveStringLiteralDfa7_0(active0, 0x8100000L);
      case 111:
         return jjMoveStringLiteralDfa7_0(active0, 0xc1000000L);
      case 121:
         return jjMoveStringLiteralDfa7_0(active0, 0x40000L);
      default :
         break;
   }
   return jjStartNfa_0(5, active0);
}
static private final int jjMoveStringLiteralDfa7_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(5, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(6, active0);
      return 7;
   }
   switch(curChar)
   {
      case 79:
         return jjMoveStringLiteralDfa8_0(active0, 0x80000L);
      case 84:
         return jjMoveStringLiteralDfa8_0(active0, 0x100000L);
      case 95:
         return jjMoveStringLiteralDfa8_0(active0, 0xc0000000L);
      case 99:
         return jjMoveStringLiteralDfa8_0(active0, 0x400L);
      case 101:
         return jjMoveStringLiteralDfa8_0(active0, 0x10000L);
      case 103:
         return jjMoveStringLiteralDfa8_0(active0, 0x800000L);
      case 105:
         return jjMoveStringLiteralDfa8_0(active0, 0x8000000L);
      case 109:
         return jjMoveStringLiteralDfa8_0(active0, 0x20000000L);
      case 111:
         return jjMoveStringLiteralDfa8_0(active0, 0x10000000L);
      case 112:
         return jjMoveStringLiteralDfa8_0(active0, 0x40000L);
      case 114:
         return jjMoveStringLiteralDfa8_0(active0, 0x2000000L);
      case 117:
         return jjMoveStringLiteralDfa8_0(active0, 0x1000000L);
      default :
         break;
   }
   return jjStartNfa_0(6, active0);
}
static private final int jjMoveStringLiteralDfa8_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(6, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(7, active0);
      return 8;
   }
   switch(curChar)
   {
      case 79:
         return jjMoveStringLiteralDfa9_0(active0, 0x10000L);
      case 97:
         return jjMoveStringLiteralDfa9_0(active0, 0x20800000L);
      case 99:
         return jjMoveStringLiteralDfa9_0(active0, 0x8000000L);
      case 101:
         if ((active0 & 0x400L) != 0L)
            return jjStartNfaWithStates_0(8, 10, 13);
         return jjMoveStringLiteralDfa9_0(active0, 0x40000L);
      case 102:
         if ((active0 & 0x80000L) != 0L)
            return jjStartNfaWithStates_0(8, 19, 13);
         break;
      case 103:
         return jjMoveStringLiteralDfa9_0(active0, 0x2000000L);
      case 109:
         return jjMoveStringLiteralDfa9_0(active0, 0x80000000L);
      case 110:
         return jjMoveStringLiteralDfa9_0(active0, 0x10000000L);
      case 111:
         return jjMoveStringLiteralDfa9_0(active0, 0x40000000L);
      case 114:
         return jjMoveStringLiteralDfa9_0(active0, 0x1000000L);
      case 121:
         return jjMoveStringLiteralDfa9_0(active0, 0x100000L);
      default :
         break;
   }
   return jjStartNfa_0(7, active0);
}
static private final int jjMoveStringLiteralDfa9_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(7, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(8, active0);
      return 9;
   }
   switch(curChar)
   {
      case 79:
         return jjMoveStringLiteralDfa10_0(active0, 0x40000L);
      case 97:
         return jjMoveStringLiteralDfa10_0(active0, 0x80000000L);
      case 99:
         return jjMoveStringLiteralDfa10_0(active0, 0x1000000L);
      case 101:
         if ((active0 & 0x10000000L) != 0L)
            return jjStartNfaWithStates_0(9, 28, 13);
         return jjMoveStringLiteralDfa10_0(active0, 0x2000000L);
      case 102:
         if ((active0 & 0x10000L) != 0L)
            return jjStartNfaWithStates_0(9, 16, 13);
         break;
      case 105:
         return jjMoveStringLiteralDfa10_0(active0, 0x8000000L);
      case 110:
         return jjMoveStringLiteralDfa10_0(active0, 0x60000000L);
      case 112:
         return jjMoveStringLiteralDfa10_0(active0, 0x100000L);
      case 116:
         return jjMoveStringLiteralDfa10_0(active0, 0x800000L);
      default :
         break;
   }
   return jjStartNfa_0(8, active0);
}
static private final int jjMoveStringLiteralDfa10_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(8, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(9, active0);
      return 10;
   }
   switch(curChar)
   {
      case 101:
         if ((active0 & 0x100000L) != 0L)
            return jjStartNfaWithStates_0(10, 20, 13);
         else if ((active0 & 0x1000000L) != 0L)
            return jjStartNfaWithStates_0(10, 24, 13);
         else if ((active0 & 0x40000000L) != 0L)
            return jjStartNfaWithStates_0(10, 30, 13);
         break;
      case 102:
         if ((active0 & 0x40000L) != 0L)
            return jjStartNfaWithStates_0(10, 18, 13);
         break;
      case 105:
         return jjMoveStringLiteralDfa11_0(active0, 0x800000L);
      case 110:
         return jjMoveStringLiteralDfa11_0(active0, 0x80000000L);
      case 116:
         if ((active0 & 0x2000000L) != 0L)
            return jjStartNfaWithStates_0(10, 25, 13);
         return jjMoveStringLiteralDfa11_0(active0, 0x8000000L);
      case 121:
         if ((active0 & 0x20000000L) != 0L)
            return jjStartNfaWithStates_0(10, 29, 13);
         break;
      default :
         break;
   }
   return jjStartNfa_0(9, active0);
}
static private final int jjMoveStringLiteralDfa11_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(9, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(10, active0);
      return 11;
   }
   switch(curChar)
   {
      case 111:
         return jjMoveStringLiteralDfa12_0(active0, 0x800000L);
      case 121:
         if ((active0 & 0x8000000L) != 0L)
            return jjStartNfaWithStates_0(11, 27, 13);
         else if ((active0 & 0x80000000L) != 0L)
            return jjStartNfaWithStates_0(11, 31, 13);
         break;
      default :
         break;
   }
   return jjStartNfa_0(10, active0);
}
static private final int jjMoveStringLiteralDfa12_0(long old0, long active0)
{
   if (((active0 &= old0)) == 0L)
      return jjStartNfa_0(10, old0); 
   try { curChar = input_stream.readChar(); }
   catch(java.io.IOException e) {
      jjStopStringLiteralDfa_0(11, active0);
      return 12;
   }
   switch(curChar)
   {
      case 110:
         if ((active0 & 0x800000L) != 0L)
            return jjStartNfaWithStates_0(12, 23, 13);
         break;
      default :
         break;
   }
   return jjStartNfa_0(11, active0);
}
static private final void jjCheckNAdd(int state)
{
   if (jjrounds[state] != jjround)
   {
      jjstateSet[jjnewStateCnt++] = state;
      jjrounds[state] = jjround;
   }
}
static private final void jjAddStates(int start, int end)
{
   do {
      jjstateSet[jjnewStateCnt++] = jjnextStates[start];
   } while (start++ != end);
}
static private final void jjCheckNAddTwoStates(int state1, int state2)
{
   jjCheckNAdd(state1);
   jjCheckNAdd(state2);
}
static private final void jjCheckNAddStates(int start, int end)
{
   do {
      jjCheckNAdd(jjnextStates[start]);
   } while (start++ != end);
}
static private final void jjCheckNAddStates(int start)
{
   jjCheckNAdd(jjnextStates[start]);
   jjCheckNAdd(jjnextStates[start + 1]);
}
static final long[] jjbitVec0 = {
   0xfffffffffffffffeL, 0xffffffffffffffffL, 0xffffffffffffffffL, 0xffffffffffffffffL
};
static final long[] jjbitVec2 = {
   0x0L, 0x0L, 0xffffffffffffffffL, 0xffffffffffffffffL
};
static private final int jjMoveNfa_0(int startState, int curPos)
{
   int[] nextStates;
   int startsAt = 0;
   jjnewStateCnt = 65;
   int i = 1;
   jjstateSet[0] = startState;
   int j, kind = 0x7fffffff;
   for (;;)
   {
      if (++jjround == 0x7fffffff)
         ReInitRounds();
      if (curChar < 64)
      {
         long l = 1L << curChar;
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(0, 5);
                  else if (curChar == 47)
                     jjAddStates(6, 7);
                  else if (curChar == 39)
                     jjCheckNAddTwoStates(38, 39);
                  else if (curChar == 34)
                     jjCheckNAddStates(8, 10);
                  else if (curChar == 46)
                     jjCheckNAdd(23);
                  else if (curChar == 35)
                     jjCheckNAddTwoStates(1, 2);
                  if ((0x3fe000000000000L & l) != 0L)
                  {
                     if (kind > 41)
                        kind = 41;
                     jjCheckNAddTwoStates(20, 21);
                  }
                  else if (curChar == 48)
                     jjAddStates(11, 12);
                  if (curChar == 48)
                  {
                     if (kind > 40)
                        kind = 40;
                     jjCheckNAddTwoStates(17, 18);
                  }
                  break;
               case 1:
                  if ((0x100000200L & l) != 0L)
                     jjCheckNAddTwoStates(1, 2);
                  break;
               case 2:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(13, 16);
                  break;
               case 3:
                  if ((0x100000200L & l) != 0L)
                     jjCheckNAddTwoStates(3, 4);
                  break;
               case 4:
                  if (curChar == 34)
                     jjCheckNAdd(5);
                  break;
               case 5:
                  if ((0xfffffffbffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(5, 6);
                  break;
               case 6:
                  if (curChar == 34)
                     jjCheckNAddStates(17, 19);
                  break;
               case 7:
                  if (curChar == 10 && kind > 7)
                     kind = 7;
                  break;
               case 8:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(20, 23);
                  break;
               case 9:
                  if ((0x100000200L & l) != 0L)
                     jjCheckNAddStates(24, 26);
                  break;
               case 10:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(10, 7);
                  break;
               case 11:
                  if ((0x100000200L & l) != 0L)
                     jjCheckNAddStates(27, 31);
                  break;
               case 13:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 38)
                     kind = 38;
                  jjstateSet[jjnewStateCnt++] = 13;
                  break;
               case 15:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 39)
                     kind = 39;
                  jjstateSet[jjnewStateCnt++] = 15;
                  break;
               case 16:
                  if (curChar != 48)
                     break;
                  if (kind > 40)
                     kind = 40;
                  jjCheckNAddTwoStates(17, 18);
                  break;
               case 17:
                  if ((0xff000000000000L & l) == 0L)
                     break;
                  if (kind > 40)
                     kind = 40;
                  jjCheckNAddTwoStates(17, 18);
                  break;
               case 19:
                  if ((0x3fe000000000000L & l) == 0L)
                     break;
                  if (kind > 41)
                     kind = 41;
                  jjCheckNAddTwoStates(20, 21);
                  break;
               case 20:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 41)
                     kind = 41;
                  jjCheckNAddTwoStates(20, 21);
                  break;
               case 22:
                  if (curChar == 46)
                     jjCheckNAdd(23);
                  break;
               case 23:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 43)
                     kind = 43;
                  jjCheckNAddStates(32, 34);
                  break;
               case 25:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(26);
                  break;
               case 26:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 43)
                     kind = 43;
                  jjCheckNAddTwoStates(26, 27);
                  break;
               case 28:
                  if (curChar == 34)
                     jjCheckNAddStates(8, 10);
                  break;
               case 29:
                  if ((0xfffffffbffffdbffL & l) != 0L)
                     jjCheckNAddStates(8, 10);
                  break;
               case 31:
                  if ((0x8400000000L & l) != 0L)
                     jjCheckNAddStates(8, 10);
                  break;
               case 32:
                  if (curChar == 34 && kind > 45)
                     kind = 45;
                  break;
               case 33:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(35, 38);
                  break;
               case 34:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAddStates(8, 10);
                  break;
               case 35:
                  if ((0xf000000000000L & l) != 0L)
                     jjstateSet[jjnewStateCnt++] = 36;
                  break;
               case 36:
                  if ((0xff000000000000L & l) != 0L)
                     jjCheckNAdd(34);
                  break;
               case 37:
                  if (curChar == 39)
                     jjCheckNAddTwoStates(38, 39);
                  break;
               case 38:
                  if ((0xffffff7fffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(38, 39);
                  break;
               case 39:
                  if (curChar == 39 && kind > 46)
                     kind = 46;
                  break;
               case 40:
                  if (curChar == 48)
                     jjAddStates(11, 12);
                  break;
               case 42:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 42)
                     kind = 42;
                  jjAddStates(39, 40);
                  break;
               case 45:
                  if (curChar == 47)
                     jjAddStates(6, 7);
                  break;
               case 46:
                  if (curChar == 47)
                     jjCheckNAddTwoStates(47, 48);
                  break;
               case 47:
                  if ((0xfffffffffffffbffL & l) != 0L)
                     jjCheckNAddTwoStates(47, 48);
                  break;
               case 48:
                  if (curChar == 10 && kind > 5)
                     kind = 5;
                  break;
               case 49:
                  if (curChar == 42)
                     jjCheckNAddTwoStates(50, 51);
                  break;
               case 50:
                  if ((0xfffffbffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(50, 51);
                  break;
               case 51:
                  if (curChar == 42)
                     jjAddStates(41, 42);
                  break;
               case 52:
                  if ((0xffff7fffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(53, 51);
                  break;
               case 53:
                  if ((0xfffffbffffffffffL & l) != 0L)
                     jjCheckNAddTwoStates(53, 51);
                  break;
               case 54:
                  if (curChar == 47 && kind > 6)
                     kind = 6;
                  break;
               case 55:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddStates(0, 5);
                  break;
               case 56:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(56, 57);
                  break;
               case 57:
                  if (curChar != 46)
                     break;
                  if (kind > 43)
                     kind = 43;
                  jjCheckNAddStates(43, 45);
                  break;
               case 58:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 43)
                     kind = 43;
                  jjCheckNAddStates(43, 45);
                  break;
               case 59:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(59, 22);
                  break;
               case 60:
                  if ((0x3ff000000000000L & l) != 0L)
                     jjCheckNAddTwoStates(60, 61);
                  break;
               case 62:
                  if ((0x280000000000L & l) != 0L)
                     jjCheckNAdd(63);
                  break;
               case 63:
                  if ((0x3ff000000000000L & l) == 0L)
                     break;
                  if (kind > 44)
                     kind = 44;
                  jjCheckNAddTwoStates(63, 64);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else if (curChar < 128)
      {
         long l = 1L << (curChar & 077);
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 0:
                  if ((0x7fffffeL & l) != 0L)
                  {
                     if (kind > 39)
                        kind = 39;
                     jjCheckNAdd(15);
                  }
                  else if ((0x7fffffe00000000L & l) != 0L)
                  {
                     if (kind > 38)
                        kind = 38;
                     jjCheckNAdd(13);
                  }
                  break;
               case 5:
                  jjAddStates(46, 47);
                  break;
               case 12:
                  if ((0x7fffffe00000000L & l) == 0L)
                     break;
                  if (kind > 38)
                     kind = 38;
                  jjCheckNAdd(13);
                  break;
               case 13:
                  if ((0x7fffffe87fffffeL & l) == 0L)
                     break;
                  if (kind > 38)
                     kind = 38;
                  jjCheckNAdd(13);
                  break;
               case 14:
                  if ((0x7fffffeL & l) == 0L)
                     break;
                  if (kind > 39)
                     kind = 39;
                  jjCheckNAdd(15);
                  break;
               case 15:
                  if ((0x7fffffe87fffffeL & l) == 0L)
                     break;
                  if (kind > 39)
                     kind = 39;
                  jjCheckNAdd(15);
                  break;
               case 18:
                  if ((0x20100000201000L & l) != 0L && kind > 40)
                     kind = 40;
                  break;
               case 21:
                  if ((0x20100000201000L & l) != 0L && kind > 41)
                     kind = 41;
                  break;
               case 24:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(48, 49);
                  break;
               case 27:
                  if ((0x104000001040L & l) != 0L && kind > 43)
                     kind = 43;
                  break;
               case 29:
                  if ((0xffffffffefffffffL & l) != 0L)
                     jjCheckNAddStates(8, 10);
                  break;
               case 30:
                  if (curChar == 92)
                     jjAddStates(50, 52);
                  break;
               case 31:
                  if ((0x14404410000000L & l) != 0L)
                     jjCheckNAddStates(8, 10);
                  break;
               case 38:
                  jjAddStates(53, 54);
                  break;
               case 41:
                  if (curChar == 120)
                     jjCheckNAdd(42);
                  break;
               case 42:
                  if ((0x7e0000007eL & l) == 0L)
                     break;
                  if (kind > 42)
                     kind = 42;
                  jjCheckNAddTwoStates(42, 43);
                  break;
               case 43:
                  if ((0x20100000201000L & l) != 0L && kind > 42)
                     kind = 42;
                  break;
               case 44:
                  if (curChar == 88)
                     jjCheckNAdd(42);
                  break;
               case 47:
                  jjAddStates(55, 56);
                  break;
               case 50:
                  jjCheckNAddTwoStates(50, 51);
                  break;
               case 52:
               case 53:
                  jjCheckNAddTwoStates(53, 51);
                  break;
               case 61:
                  if ((0x2000000020L & l) != 0L)
                     jjAddStates(57, 58);
                  break;
               case 64:
                  if ((0x104000001040L & l) != 0L && kind > 44)
                     kind = 44;
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      else
      {
         int hiByte = (int)(curChar >> 8);
         int i1 = hiByte >> 6;
         long l1 = 1L << (hiByte & 077);
         int i2 = (curChar & 0xff) >> 6;
         long l2 = 1L << (curChar & 077);
         MatchLoop: do
         {
            switch(jjstateSet[--i])
            {
               case 5:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(46, 47);
                  break;
               case 29:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(8, 10);
                  break;
               case 38:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(53, 54);
                  break;
               case 47:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjAddStates(55, 56);
                  break;
               case 50:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(50, 51);
                  break;
               case 52:
               case 53:
                  if (jjCanMove_0(hiByte, i1, i2, l1, l2))
                     jjCheckNAddTwoStates(53, 51);
                  break;
               default : break;
            }
         } while(i != startsAt);
      }
      if (kind != 0x7fffffff)
      {
         jjmatchedKind = kind;
         jjmatchedPos = curPos;
         kind = 0x7fffffff;
      }
      ++curPos;
      if ((i = jjnewStateCnt) == (startsAt = 65 - (jjnewStateCnt = startsAt)))
         return curPos;
      try { curChar = input_stream.readChar(); }
      catch(java.io.IOException e) { return curPos; }
   }
}
static final int[] jjnextStates = {
   56, 57, 59, 22, 60, 61, 46, 49, 29, 30, 32, 41, 44, 2, 3, 4, 
   7, 7, 8, 11, 9, 10, 7, 8, 9, 10, 7, 9, 10, 7, 8, 11, 
   23, 24, 27, 29, 30, 34, 32, 42, 43, 52, 54, 58, 24, 27, 5, 6, 
   25, 26, 31, 33, 35, 38, 39, 47, 48, 62, 63, 
};
private static final boolean jjCanMove_0(int hiByte, int i1, int i2, long l1, long l2)
{
   switch(hiByte)
   {
      case 0:
         return ((jjbitVec2[i2] & l2) != 0L);
      default : 
         if ((jjbitVec0[i1] & l1) != 0L)
            return true;
         return false;
   }
}
public static final String[] jjstrLiteralImages = {
"", null, null, null, null, null, null, null, "\151\155\160\157\162\164", 
"\73", "\156\141\155\145\163\160\141\143\145", "\50", "\54", "\51", "\173", "\175", 
"\151\156\163\164\141\156\143\145\117\146", "\164\171\160\145\117\146", "\163\165\160\145\162\164\171\160\145\117\146", 
"\163\165\142\164\171\160\145\117\146", "\151\163\106\151\156\141\154\124\171\160\145", "\164\162\165\145", 
"\146\141\154\163\145", "\151\163\101\147\147\162\145\147\141\164\151\157\156", 
"\151\163\101\156\171\123\157\165\162\143\145", "\151\163\101\156\171\124\141\162\147\145\164", 
"\151\156\166\145\162\163\145", "\155\165\154\164\151\160\154\151\143\151\164\171", 
"\157\156\145\137\164\157\137\157\156\145", "\157\156\145\137\164\157\137\155\141\156\171", 
"\155\141\156\171\137\164\157\137\157\156\145", "\155\141\156\171\137\164\157\137\155\141\156\171", "\56", "\141\154\154", 
"\145\170\151\163\164\163", "\46\46", "\174\174", "\55\76", null, null, null, null, null, null, null, null, 
null, };
public static final String[] lexStateNames = {
   "DEFAULT", 
};
static final long[] jjtoToken = {
   0x7fffffffff01L, 
};
static final long[] jjtoSkip = {
   0xfeL, 
};
static protected JavaCharStream input_stream;
static private final int[] jjrounds = new int[65];
static private final int[] jjstateSet = new int[130];
static protected char curChar;
public VTMLParserTokenManager(JavaCharStream stream)
{
   if (input_stream != null)
      throw new TokenMgrError("ERROR: Second call to constructor of static lexer. You must use ReInit() to initialize the static variables.", TokenMgrError.STATIC_LEXER_ERROR);
   input_stream = stream;
}
public VTMLParserTokenManager(JavaCharStream stream, int lexState)
{
   this(stream);
   SwitchTo(lexState);
}
static public void ReInit(JavaCharStream stream)
{
   jjmatchedPos = jjnewStateCnt = 0;
   curLexState = defaultLexState;
   input_stream = stream;
   ReInitRounds();
}
static private final void ReInitRounds()
{
   int i;
   jjround = 0x80000001;
   for (i = 65; i-- > 0;)
      jjrounds[i] = 0x80000000;
}
static public void ReInit(JavaCharStream stream, int lexState)
{
   ReInit(stream);
   SwitchTo(lexState);
}
static public void SwitchTo(int lexState)
{
   if (lexState >= 1 || lexState < 0)
      throw new TokenMgrError("Error: Ignoring invalid lexical state : " + lexState + ". State unchanged.", TokenMgrError.INVALID_LEXICAL_STATE);
   else
      curLexState = lexState;
}

static protected Token jjFillToken()
{
   Token t = Token.newToken(jjmatchedKind);
   t.kind = jjmatchedKind;
   String im = jjstrLiteralImages[jjmatchedKind];
   t.image = (im == null) ? input_stream.GetImage() : im;
   t.beginLine = input_stream.getBeginLine();
   t.beginColumn = input_stream.getBeginColumn();
   t.endLine = input_stream.getEndLine();
   t.endColumn = input_stream.getEndColumn();
   return t;
}

static int curLexState = 0;
static int defaultLexState = 0;
static int jjnewStateCnt;
static int jjround;
static int jjmatchedPos;
static int jjmatchedKind;

public static Token getNextToken() 
{
  int kind;
  Token specialToken = null;
  Token matchedToken;
  int curPos = 0;

  EOFLoop :
  for (;;)
  {   
   try   
   {     
      curChar = input_stream.BeginToken();
   }     
   catch(java.io.IOException e)
   {        
      jjmatchedKind = 0;
      matchedToken = jjFillToken();
      return matchedToken;
   }

   try { input_stream.backup(0);
      while (curChar <= 32 && (0x100002600L & (1L << curChar)) != 0L)
         curChar = input_stream.BeginToken();
   }
   catch (java.io.IOException e1) { continue EOFLoop; }
   jjmatchedKind = 0x7fffffff;
   jjmatchedPos = 0;
   curPos = jjMoveStringLiteralDfa0_0();
   if (jjmatchedKind != 0x7fffffff)
   {
      if (jjmatchedPos + 1 < curPos)
         input_stream.backup(curPos - jjmatchedPos - 1);
      if ((jjtoToken[jjmatchedKind >> 6] & (1L << (jjmatchedKind & 077))) != 0L)
      {
         matchedToken = jjFillToken();
         return matchedToken;
      }
      else
      {
         continue EOFLoop;
      }
   }
   int error_line = input_stream.getEndLine();
   int error_column = input_stream.getEndColumn();
   String error_after = null;
   boolean EOFSeen = false;
   try { input_stream.readChar(); input_stream.backup(1); }
   catch (java.io.IOException e1) {
      EOFSeen = true;
      error_after = curPos <= 1 ? "" : input_stream.GetImage();
      if (curChar == '\n' || curChar == '\r') {
         error_line++;
         error_column = 0;
      }
      else
         error_column++;
   }
   if (!EOFSeen) {
      input_stream.backup(1);
      error_after = curPos <= 1 ? "" : input_stream.GetImage();
   }
   throw new TokenMgrError(EOFSeen, curLexState, error_line, error_column, error_after, curChar, TokenMgrError.LEXICAL_ERROR);
  }
}

}
