/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.viatra2.codegen.CodeOutputPlugin;
import org.eclipse.viatra2.codegen.CodeOutputPluginFactory;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;

public class GeneralCodeoutFactory implements CodeOutputPluginFactory {
	String name;

	String id;

	NativeImporter importer;

	String[] fileExtensionList;

	IConfigurationElement el;

	public GeneralCodeoutFactory(String id, String name,
			IConfigurationElement el) {
		this.id = id;
		this.name = name;
		this.el = el;
	}

	public void setFileExtensionList(String[] fileExtensionList) {
		this.fileExtensionList = fileExtensionList;
	}

	public CodeOutputPlugin createCodeoutPlugin(IFramework fw) {
		try {
			CodeOutputPlugin o = (CodeOutputPlugin) el
					.createExecutableExtension("class");
			return o;
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	public String getCodeOutName() {
		return name;
	}

	public String getCodeOutId() {
		return id;
	}

}
