/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.codegen;

import org.eclipse.viatra2.framework.IFramework;

/**
 * Factory interface to instantiate code output plugins.
 * 
 * @author Andras Schmidt
 * 
 */
public interface CodeOutputPluginFactory {
	/**
	 * Instantiate a code output plugin
	 * 
	 * @param fw
	 * @return
	 */
	CodeOutputPlugin createCodeoutPlugin(IFramework fw);

	/**
	 * Name of the code output plugin type
	 * 
	 * @return name of the code output plugin type
	 */
	String getCodeOutName();

	/**
	 * ID of the code output plugin type.
	 * 
	 * @return ID of the code output plugin type
	 */
	String getCodeOutId();
}
