/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core;

/**
 * Semantics of model element deletion.
 * 
 * @author Andras Schmidt
 * 
 */
public enum EDeleteSemantics {
	/**
	 * Delete semantics. Means that the element will be deleted with: - all type
	 * relations - all realations - all functions - all contained entities will
	 * be moved to the root entiy
	 */
	DELETE_SEMANTICS_FORCE,
	/**
	 * Delete semantics. Means that the element will be deleted with: - all type
	 * relations - all realations - all functions - all elements in namespace
	 * will also be deleted recursively
	 */
	DELETE_SEMANTICS_BRANCH_FORCE
}
