/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core;

import org.eclipse.viatra2.core.notification.ICoreNotificationObject;

/**
 * This interface defines the notification delivery mechanism
 * 
 * @author Andras Balogh
 * 
 */
public interface ICoreNotificationListener {
	/**
	 * Listener category that listens all notifications in order to make it
	 * possible to undo them.
	 */
	public static int UNDO_LISTENER = 0;

	/**
	 * This method is called if a new notification event is generated in a model
	 * element associated with the current listener.
	 * 
	 * @param notification
	 *            this object stores the type and parameters of the notification
	 */
	public void actionPerformed(ICoreNotificationObject notification);

	/**
	 * Returns the category of this listener.
	 * 
	 * @return category
	 */
	public int getListenerCategory();

}
