/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core;

import org.eclipse.viatra2.errors.VPMCoreException;

/**
 * Interface for extra model management functionality.
 * 
 * @author Istvan Rath
 * 
 */
public interface IModelManagerExtended extends IModelManager {

	public IEntity newEntity(IEntity type);

	public IEntity newEntity(String name, IEntity type) throws VPMCoreException;

	public IEntity newEntity(String name, String value, IEntity type)
			throws VPMCoreException;

	public IEntity newEntity(String name, IEntity container, IEntity type)
			throws VPMCoreException;

	public IRelation newRelation(IModelElement from, IModelElement to,
			IRelation type) throws VPMCoreException;

	public IRelation newRelation(String name, IModelElement from,
			IModelElement to, IRelation type) throws VPMCoreException;

	public IRelation newRelation(String name, IModelElement from,
			IModelElement to, EMultiplicityKind multiplicity,
			boolean isAggregation, IRelation inverse, IRelation type)
			throws VPMCoreException;

	// more to come.

}
