/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.constraint;

/**
 * This enumeration contains all types of relations in which two model elements
 * can be.
 * 
 * @author Andras Schmidt
 * 
 */
public enum EConstraint {
	/** This is an element and tg is linked to this on from side */
	REL_FROM,
	/** This is an element and tg is linked to this on to side */
	REL_TO,
	/**
	 * This is a relation and tg is the end point of the relation on the from
	 * side
	 */
	ENTITY_REL_FROM,
	/**
	 * This is a relation and tg is the end point of the relation on the to side
	 */
	ENTITY_REL_TO,
	/** src is over of tg */
	OVER,
	/** tg is child of src */
	CHILD,
	/** tg is parent of src */
	PARENT,
	/** tg is subtype of source */
	SUBTYPE,
	/** tg is supertype of source */
	SUPERTYPE,
	/** source is type of tg */
	INSTANCE,
	/** source is instance of tg */
	TYPE,
	/** source is entity tg is null */
	ENTITY,
	/** source is relation tg is null */
	RELATION,
	/** src is below tg */
	BELOW, DSUBTYPE, DSUPERTYPE, DINSTANCE, DTYPE,
}
