/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectCreateEntity;

/**
 * @author Andras Schmidt
 * 
 *         TODO To change the template for this generated type comment go to
 *         Window - Preferences - Java - Code Style - Code Templates
 */
public class NotificationObjectCreateEntity extends NotificationObject
		implements ICoreNotificationObjectCreateEntity {
	String name;

	String value;

	IEntity created;

	IEntity container;

	public NotificationObjectCreateEntity(IEntity created, IEntity container) {
		this.name = created.getName();
		this.value = created.getValue();
		this.created = created;
		this.container = container;
		addListener(created);
		addListener(container);
	}

	public String getActionType() {
		return ICoreNotificationObject.ACTION_CREATE_ENTITY;
	}

	public IEntity getContainer() {
		return container;
	}

	public IEntity getCreated() {
		return created;
	}

	public String getName() {
		return name;
	}

	public String getValue() {
		return value;
	}
}
