/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectCreateSupertypeOf;

/**
 * @author Andras Schmidt
 * 
 *         TODO To change the template for this generated type comment go to
 *         Window - Preferences - Java - Code Style - Code Templates
 */
public class NotificationObjectCreateSupertypeOf extends NotificationObject
		implements ICoreNotificationObjectCreateSupertypeOf {
	IModelElement sup;

	IModelElement sub;

	public NotificationObjectCreateSupertypeOf(IModelElement sup,
			IModelElement sub) {
		this.sup = sup;
		this.sub = sub;
		addListener(sup);
		addListener(sub);
	}

	public String getActionType() {
		return ICoreNotificationObject.ACTION_CREATE_SUPERTYPEOF;
	}

	public IModelElement getSuper() {
		return sup;
	}

	public IModelElement getSub() {
		return sub;
	}
}
