/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectDeleteContainment;
import org.eclipse.viatra2.core.simple.SimpleEntity;
import org.eclipse.viatra2.core.simple.SimpleModelElement;

/**
 * @author Andras Schmidt
 * 
 */
public class NotificationObjectDeleteContainment extends NotificationObject
		implements ICoreNotificationObjectDeleteContainment {
	SimpleEntity parent;

	SimpleModelElement child;

	/**
	 * 
	 */
	public NotificationObjectDeleteContainment(SimpleEntity parent,
			SimpleModelElement child) {
		this.parent = parent;
		this.child = child;
		addListener(parent);
		addListener(child);
	}

	public String getActionType() {
		return ICoreNotificationObject.ACTION_DELETE_CONTAINMENT;
	}

	public IEntity getParent() {
		return parent;
	}

	public IModelElement getChild() {
		return child;
	}

}
