/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectDeleteEntity;
import org.eclipse.viatra2.core.simple.SimpleEntity;

/**
 * @author Andras Schmidt
 * 
 *         TODO To change the template for this generated type comment go to
 *         Window - Preferences - Java - Code Style - Code Templates
 */
public class NotificationObjectDeleteEntity extends NotificationObject
		implements ICoreNotificationObjectDeleteEntity {
	String name;

	String value;

	SimpleEntity deleted;

	SimpleEntity parent;

	public NotificationObjectDeleteEntity(SimpleEntity deleted,
			SimpleEntity parent) {
		this.deleted = deleted;
		this.parent = parent;
		name = deleted.getName();
		value = deleted.getValue();
		addListener(deleted);
		addListener(parent);
	}

	public String getActionType() {
		return ICoreNotificationObject.ACTION_DELETE_ENTITY;
	}

	public IEntity getDeleted() {
		return deleted;
	}

	public String getName() {
		return name;
	}

	public String getValue() {
		return value;
	}

	public IEntity getParent() {
		return parent;
	}

}
