/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectDeleteRelation;
import org.eclipse.viatra2.core.simple.SimpleModelElement;
import org.eclipse.viatra2.core.simple.SimpleRelation;

/**
 * @author Andras Schmidt
 * 
 *         TODO To change the template for this generated type comment go to
 *         Window - Preferences - Java - Code Style - Code Templates
 */
public class NotificationObjectDeleteRelation extends NotificationObject
		implements ICoreNotificationObjectDeleteRelation {
	String name;

	SimpleRelation deleted;

	SimpleModelElement from;

	SimpleModelElement to;

	public NotificationObjectDeleteRelation(SimpleRelation deleted,
			SimpleModelElement from, SimpleModelElement to) {
		this.deleted = deleted;
		this.from = from;
		this.to = to;
		name = deleted.getName();
		addListener(deleted);
		addListener(from);
		addListener(to);
	}

	public String getActionType() {
		return ICoreNotificationObject.ACTION_DELETE_RELATION;
	}

	public IRelation getDeleted() {
		return deleted;
	}

	public String getName() {
		return name;
	}

	public IModelElement getFrom() {
		return from;
	}

	public IModelElement getTo() {
		return to;
	}

}
