/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectMoveTo;
import org.eclipse.viatra2.core.simple.SimpleEntity;

/**
 * @author Andras Schmidt
 * 
 *         TODO To change the template for this generated type comment go to
 *         Window - Preferences - Java - Code Style - Code Templates
 */
public class NotificationObjectMoveTo extends NotificationObject implements
		ICoreNotificationObjectMoveTo {
	SimpleEntity newCont;

	SimpleEntity oldCont;

	SimpleEntity elem;

	public NotificationObjectMoveTo(SimpleEntity elem, SimpleEntity newCont,
			SimpleEntity oldCont) {
		this.newCont = newCont;
		this.oldCont = oldCont;
		this.elem = elem;
		addListener(newCont);
		addListener(oldCont);
		addListener(elem);
	}

	public String getActionType() {
		return ICoreNotificationObject.ACTION_MOVE_ELEMENT_TO;
	}

	public IEntity getNewContainer() {
		return newCont;
	}

	public IEntity getElement() {
		return elem;
	}

	public IEntity getOldContainer() {
		return oldCont;
	}

}
