/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectSetIsAny;

public class NotificationObjectSetIsAny extends NotificationObject implements
		ICoreNotificationObjectSetIsAny {

	IRelation me;

	boolean isAny;

	boolean isAnyOld;

	boolean isFromSide;

	public NotificationObjectSetIsAny(IRelation me, boolean isAny,
			boolean isFromSide, boolean isAnyOld) {
		this.me = me;
		this.isAny = isAny;
		this.isFromSide = isFromSide;
		addListener(me);
	}

	@Override
	public String getActionType() {
		return ICoreNotificationObject.ACTION_SET_ISANY;
	}

	public IModelElement getRelation() {
		return me;
	}

	public boolean getIsAny() {
		return isAny;
	}

	public boolean getIsFromSideSet() {
		return isFromSide;
	}

	public boolean getIsAnyOld() {
		return isAnyOld;
	}

}
