/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectSetIsFinalType;

/**
 * 
 * @author Istvan Rath
 * 
 */
public class NotificationObjectSetIsFinalType extends NotificationObject
		implements ICoreNotificationObjectSetIsFinalType {

	IModelElement me;

	boolean isfinaltype;

	boolean isfinaltypeOld;

	public NotificationObjectSetIsFinalType(IModelElement me,
			boolean isfinaltype, boolean isfinalTypeOld) {
		this.me = me;
		this.isfinaltype = isfinaltype;
		this.isfinaltypeOld = isfinalTypeOld;
		addListener(me);
	}

	@Override
	public String getActionType() {
		return ICoreNotificationObject.ACTION_SET_ISFINALTYPE;
	}

	public IModelElement getElement() {
		return me;
	}

	public boolean getIsFinalType() {
		return isfinaltype;
	}

	public boolean getIsFinalTypeOld() {
		return isfinaltypeOld;
	}

}
