/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectSetName;

/**
 * @author Andras Schmidt
 * 
 */
public class NotificationObjectSetName extends NotificationObject implements
		ICoreNotificationObjectSetName {
	String newName;

	String oldName;

	IModelElement me;

	public NotificationObjectSetName(IModelElement me, String newName,
			String oldName) {
		this.me = me;
		this.newName = newName;
		this.oldName = oldName;
		addListener(me);
	}

	public String getActionType() {
		return ICoreNotificationObject.ACTION_SET_NAME;
	}

	public String getNewName() {
		return newName;
	}

	public String getOldName() {
		return oldName;
	}

	public IModelElement getElement() {
		return me;
	}
}
