/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.core.simple.notification;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.core.notification.ICoreNotificationObject;
import org.eclipse.viatra2.core.notification.ICoreNotificationObjectSetRelationTo;
import org.eclipse.viatra2.core.simple.SimpleModelElement;
import org.eclipse.viatra2.core.simple.SimpleRelation;

/**
 * @author Andras Schmidt
 * 
 *         TODO To change the template for this generated type comment go to
 *         Window - Preferences - Java - Code Style - Code Templates
 */
public class NotificationObjectSetRelationTo extends NotificationObject
		implements ICoreNotificationObjectSetRelationTo {
	SimpleRelation rel;

	SimpleModelElement oldTo;

	SimpleModelElement newTo;

	public NotificationObjectSetRelationTo(SimpleRelation rel,
			SimpleModelElement oldTo, SimpleModelElement newTo) {
		this.rel = rel;
		this.oldTo = oldTo;
		this.newTo = newTo;
		addListener(rel);
		addListener(oldTo);
		addListener(newTo);
	}

	public String getActionType() {
		return ICoreNotificationObject.ACTION_SET_RELATION_TO;
	}

	public IRelation getRelation() {
		return rel;
	}

	public IModelElement getOldTo() {
		return oldTo;
	}

	public IModelElement getNewTo() {
		return newTo;
	}
}
