/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.framework;

/**
 * A listener interface for managed frameworks list changes (framework close and
 * initiation). (The framework manager view implements this interface so the
 * changes in framework list are refreshed on the view)
 * 
 * @author Istvan Rath
 * 
 */
public interface IFrameworkListChangedListener {
	/**
	 * The list of framworks has changed
	 * 
	 */
	// public void FrameworkListChanged();
	public void frameworkAdded(IFramework f);

	public void frameworkRemoved(IFramework f);
}
