/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.framework;

/**
 * A listener interface for machine set changes. Whenever a machine is loaded or
 * dropped, listeners will be notified.
 * 
 * @author Istvan Rath
 * 
 */
public interface IMachineSetChangedListener {
	/**
	 * The set of machines has changed
	 * 
	 */
	// public void machineSetChanged(IFramework where);
	public void machineAdded(Object machine);

	public void machineRemoved(Object machine);
}
