/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.framework.properties;

/**
 * Interface for listening to property changed events.
 * 
 * @author Istvan Rath
 */
public interface IViatraPropertyChangedListener {

	/**
	 * Notifies the listener that a property has changed.
	 * 
	 * @param providerID
	 *            the originating provider's ID
	 * @param propertyID
	 *            the property ID that has changed
	 * @param oldVal
	 *            the value before the change
	 * @param newVal
	 *            the value after the change
	 */
	public void propertyChanged(String providerID, String propertyID,
			String oldVal, String newVal);

}
