/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.framework.properties.providers;

import org.eclipse.viatra2.framework.properties.VIATRAPropertyKind;

/**
 * Dummy property provider class, used to contain properties which do not belong
 * to any active registered property provider.
 * 
 * @author Istvan Rath
 * 
 */
public class DummyPropertyProvider extends DefaultPropertyProvider {

	public DummyPropertyProvider(String id) {
		super(id);
	}

	public boolean isActive() {
		return false; // dummy providers are ALWAYS inactive
	}

	public String getDefaultPropertyValue(String id) {
		return id + "::DummyDefault"; // dummy defaults are never used
	}

	@Override
	public void init() {
		// the dummy provider is too dumb to init itself :)
	}

	public VIATRAPropertyKind getPropertyKind(String id) {
		return VIATRAPropertyKind.STRING;
	}

}
