/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.framework.properties.providers;

import org.eclipse.viatra2.framework.properties.VIATRAPropertyKind;

public class VPMLoggerPropertyProvider extends DefaultPropertyProvider {

	public VPMLoggerPropertyProvider() {
		super("Logging");
	}

	public boolean isActive() {
		return true;
	}

	public String getDefaultPropertyValue(String id) {
		if (id.equals("Log level"))
			return "3";
		// else if (id.equals("output"))
		// return "screen";
		return "unknown";
	}

	@Override
	public void init() {
		allids.add("Log level");
		// allids.add("output");
	}

	public VIATRAPropertyKind getPropertyKind(String id) {
		return VIATRAPropertyKind.INTEGER;
	}

}
