/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.frameworkgui.actions;

import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.viatra2.frameworkgui.views.FrameworkTreeView;

public class ClearTagsAction extends AbstractFrameworkGUIAction {

	public ClearTagsAction(FrameworkTreeView part) {
		super();
		setupInternals(part);
		setText("Clear all tags");
		setToolTipText("Clears all information and error tag markers");
//		setImageDescriptor(PlatformUI.getWorkbench().getSharedImages()
//				.getImageDescriptor(ISharedImages.IMG_ELCL_REMOVE));
	}

	
	public void run() {
		refreshSelection();
		this.iViatraFramework.getTagManager().clearAllTags();
	}

}
