/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.frameworkgui.content.transformation;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.ISharedImages;
import org.eclipse.ui.PlatformUI;
import org.eclipse.viatra2.framework.FrameworkException;
import org.eclipse.viatra2.frameworkgui.actions.AbstractFrameworkGUIAction;
import org.eclipse.viatra2.frameworkgui.content.transformation.TransformationContent.MachineDummy;
import org.eclipse.viatra2.frameworkgui.views.FrameworkTreeView;

public class DeleteModelAction extends AbstractFrameworkGUIAction {

	public DeleteModelAction(FrameworkTreeView part) {
		super();
		//setId(ActionFactory.DELETE.getId());
		setupInternals(part);
		setText("Drop");
		setToolTipText("Drops the machine model from the framework");
		setImageDescriptor(PlatformUI.getWorkbench().getSharedImages()
				.getImageDescriptor(ISharedImages.IMG_TOOL_DELETE));
		//setAccelerator(SWT.DEL);
		setActionDefinitionId("org.eclipse.ui.edit.delete");
	}
	
	@Override
	public boolean isEnabled() {
		return true;
	}
	
	@Override
	public void run() {
		refreshSelection();
		try 
		{
			for (Object c : ((IStructuredSelection) iFT.getSelection()).toArray() )
			{
				if (c instanceof MachineDummy)
				{
					iViatraFramework.removeMachine(((MachineDummy)c).machine.getFqn());
				}
			}
		}
		catch (FrameworkException e)
		{
			iFT.showMessage("Framework error: " +e.getMessage());
		}
		
	}
	
}
