/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.frameworkgui.property;

import org.eclipse.viatra2.frameworkgui.content.FrameworkContainer;
import org.eclipse.viatra2.frameworkgui.content.ITreeObject;

import org.eclipse.ui.views.properties.IPropertySource;
import org.eclipse.ui.views.properties.IPropertySourceProvider;

public class FrameworkGUIPPropertySourceProvider implements
		IPropertySourceProvider {

	
	String iProviderID;
	
	public FrameworkGUIPPropertySourceProvider(String providerID)
	{
		iProviderID = providerID;
	}
	
	
	public IPropertySource getPropertySource(Object object) {
		if (object instanceof FrameworkContainer)
		{
			return new FrameworkGUIPropertySource( ((FrameworkContainer)object).getFramework(), iProviderID);
		}
		else if (object instanceof ITreeObject) 
		{
			return ((ITreeObject)object).getPropertySource();
		}
		return null;
	}

}
