/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.frameworkgui.views.code;

import java.util.HashMap;

import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.widgets.Display;

public class ColorFactory {

	private static ColorFactory instance = new ColorFactory();
	
	public static ColorFactory getInstance()
	{
		if (instance == null)
			instance = new ColorFactory();
		return instance;
	}
	
	private ColorFactory()
	{
		colors = new HashMap<RGB, Color>();
	}
	
	private HashMap<RGB, Color> colors;
	
	public static Color getColor(int R, int G, int B)
	{
		Color color = getInstance().colors.get(new RGB(R,G,B));
		if (color == null)
		{
			color = new Color(Display.getCurrent(),R,G,B);
			getInstance().colors.put(new RGB(R,G,B), color);
		}
		return color;
	}
	
}
