/*******************************************************************************
 * Copyright (c) 2008-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.frameworkgui.views.console.commands.builtin;

import java.util.List;

import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.frameworkgui.views.console.commands.IVIATRAConsoleCommandProvider;

/**
 * Supertrivial implementation for the "about" command.
 * @author istvan
 *
 */
public class About implements IVIATRAConsoleCommandProvider {

	public void executeCommand(IFramework fw, List<String> parameters) {
		fw.getLogger().info("This is the VIATRA2 R3.1 Console. Copyright 2009 Istvan Rath.");
	}

	public String getCommandSignature() {
		return "about()";
	}

	public String getDescription() {
		return "Prints some information about the VIATRA2 R3.1 Console system.";
	}

	public String getHelpText() {
		return getDescription();
	}

}
