/*******************************************************************************
 * Copyright (c) 2008-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.frameworkgui.views.console.commands.builtin;

import java.util.List;

import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.frameworkgui.views.console.commands.CommandExecutor;
import org.eclipse.viatra2.frameworkgui.views.console.commands.IVIATRAConsoleCommandProvider;

public class ClearCommandHistory implements IVIATRAConsoleCommandProvider {

	public void executeCommand(IFramework fw, List<String> parameters) {
		CommandExecutor.clearCommandHistory(fw);
		fw.getLogger().info("VIATRA2 Console command history cleared.");
	}

	public String getCommandSignature() {
		return "clearcommandhistory()";
	}

	public String getDescription() {
		return "Clears the historical record of VIATRA2 Console commands";
	}

	public String getHelpText() {
		return "This command clears the history of commands executed in the VIATRA2 Console.";
	}

}
