/*******************************************************************************
 * Copyright (c) 2008-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.frameworkgui.views.console.commands.xform;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.frameworkgui.views.console.commands.IVIATRAConsoleCommandProvider;
import org.eclipse.viatra2.frameworkgui.views.console.commands.IVIATRAConsoleCommandProviderFactory;

/**
 * Advanked console commandprovider factory which provides xform debugging functions
 *  - runMachine
 *  - runMachineUndoable
 *  - runRule
 *  - runRuleUndoable
 *  - undoTransaction
 *  - ...?
 *  
 * @author istvan rath
 *
 */
public class TransformationDebuggingCommands implements IVIATRAConsoleCommandProviderFactory {

	public TransformationDebuggingCommands() {
	}

	public List<IVIATRAConsoleCommandProvider> getProviders(IFramework fw) {
		ArrayList<IVIATRAConsoleCommandProvider> ps = new ArrayList<IVIATRAConsoleCommandProvider>();
		ps.add(new RunMachine());
		ps.add(new RunMachineUndoable());
		ps.add(new RunRule());
		ps.add(new RunRuleUndoable());
		ps.add(new UndoTransaction());
		return ps;
	}

	
	
	
	
}
