/*******************************************************************************
 * Copyright (c) 2004-2008 Peter Pasztor, Akos Horvath, Gergely Varro, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Peter Pasztor, Akos Horvath, Gergely Varro, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.gtasm.interpreter.executionEnvironment;

import org.eclipse.emf.common.util.EList;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.definitions.ASMFunction;

/**
 * Listener interface for clients that wish to be notified when a value in an
 * ASMFunction changes.
 * 
 * @author Istvan Rath
 * 
 */
public interface ASMFunctionContentChangeListener {

	/**
	 * Signals that a given key-value pair has changed.
	 * 
	 * @param f
	 * @param key
	 * @param newValue
	 */
	public void valueChanged(ASMFunction f, EList<Object> key, Object newValue);

}
