/*******************************************************************************
 * Copyright (c) 2004-2009 Akos Horvath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath - initial API and implementation
 *******************************************************************************/


package org.eclipse.viatra2.gtasm.interpreter.extension;

import org.eclipse.viatra2.gtasm.interpreter.internal.ViatraGTASMInterpreterPlugin;

/** Interface class for ASM native rules
 * @author Akos Horvath
 *
 */
public class NativeASMRuleProvider {
	
	
	/** Returns the Native ASM rule if it is available by the input fqn name
	 * @param fqn The fqn of the asm rule
	 * @return The INativeASMRule implementing the rule 
	 */
	public static INativeASMRule getNativeASMRule(String fqn){
	//checks if the native rule is available at the org.eclipse.viatra2.gtasm.patternmatcher.extension point 
	INativeASMRule nativeRule = ViatraGTASMInterpreterPlugin.getDefault().getNativeAMSRules(fqn);
	return nativeRule;
	}
}
