/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher;

/**
 * Holds the parameter of a pattern call context,
 * PatternCallSignature,
 * 
 * @author Akos Horvath
 *
 */
public class PatternMatcherParameters {
	
	PatternCallSignature[] callSignature;
	Object[]	inputMapping;
	Integer[] quantificationOrder;

	/** Pattern invocation context information
	 * @param signatures PatternCall signature of the invocation
	 * @param inputMapping The actual value of the input parameters
	 * @param quantific Quantification order of the input variables
	 */
	public PatternMatcherParameters(PatternCallSignature[] signatures, Object[] inputMapping, Integer[] quantific)
	{	
		this.inputMapping = inputMapping;
		this.callSignature = signatures;
		this.quantificationOrder = quantific;
	}

	/**
	 * @return the callSignature
	 */
	public PatternCallSignature[] getCallSignature() {
		return callSignature;
	}

	/**
	 * @param callSignature the callSignature to set
	 */
	public void setCallSignature(PatternCallSignature[] callSignature) {
		this.callSignature = callSignature;
	}

	/**
	 * @return the inputMapping
	 */
	public Object[] getInputMapping() {
		return inputMapping;
	}

	/**
	 * @param inputMapping the inputMapping to set
	 */
	public void setInputMapping(Object[] inputMapping) {
		this.inputMapping = inputMapping;
	}

	/**
	 * @return the quantificationOrder
	 */
	public Integer[] getQuantificationOrder() {
		return quantificationOrder;
	}

	/**
	 * @param quantificationOrder the quantificationOrder to set
	 */
	public void setQuantificationOrder(Integer[] quantificationOrder) {
		this.quantificationOrder = quantificationOrder;
	}

	

}
