/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.gtasm.patternmatcher.exceptions;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;

public class PatternMatcherCompileTimeException extends PatternMatcherException {
	private static final long serialVersionUID = -3332378474994166891L;

	public PatternMatcherCompileTimeException(String msg, String[] values, AnnotatedElement element) {
		super(msg, values, element);
	}
	
	public PatternMatcherCompileTimeException(String msg, String[] values, AnnotatedElement element, Throwable cause) {
		super(msg, values, element, cause);
	}
	
	@Override
	public PatternMatcherCompileTimeException addNewStackElement(EObject element) {
	    	if(element != null && element instanceof AnnotatedElement)
	    		{
	    		StackTraceElement _ste = createStackTraceElement((AnnotatedElement)element);
	    		interpreterStackTrace.add(_ste);
	    		}
	    	return this;
	}
}
