/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.internal.operation;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.IModelManager;


/**
 * @author Akos Horvath
 *
 */
public abstract class CreateConstant2Bound extends CreateElement {
	protected IModelElement source;
	protected int target;
	
	
	
	/**
	 * @param manager
	 * @param variableI
	 */
	public CreateConstant2Bound(IModelManager manager, int variableI) {
		super(manager, variableI);
	}

	/**
	 * @param m
	 */
	public CreateConstant2Bound(IModelManager m) {
		super(m);
	}

	/**
	 * @return the source
	 */
	public IModelElement getSource() {
		return source;
	}

	/**
	 * @return the target
	 */
	public int getTarget() {
		return target;
	}

	/**
	 * @param source the source to set
	 */
	protected void setSource(IModelElement source) {
		this.source = source;
	}

	/**
	 * @param target the target to set
	 */
	protected void setTarget(int target) {
		this.target = target;
	}

}
