/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.internal.operation;

import org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.exceptions.GTOperationException;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.MatchingFrame;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;


public interface IUpdatePlanOperation {
	/** Executes the operation
	 * @param frame The matching frame of the invocation context
	 * @return true if the execution finished without problems else false
	 * @throws GTOperationException
	 */
	public boolean update(MatchingFrame frame) throws GTOperationException;
	/**A detailed serialized description of the operation
	 * @param frame The matching frame of the invocation context
	 * @return
	 */
	public String toString(MatchingFrame frame);
	/**Returns the GTASM element from which the operation was created (also which caused the error durng the execution)
	 * @param frame The matching frame of the invocation context
	 * @return
	 */
	public AnnotatedElement getErrorfulElement(MatchingFrame frame);
}
