/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.operation;

import java.util.Set;

import org.eclipse.viatra2.gtasm.patternmatcher.exceptions.PatternMatcherRuntimeException;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.MatchingFrame;


/**
 * The root of the search plan operation hierarchy.
 */
public abstract class SearchPlanOperation implements ISearchPlanOperation{
	abstract public void preprocess(MatchingFrame frame) 
        throws PatternMatcherRuntimeException;

	abstract public void postprocess(MatchingFrame frame) 
        throws PatternMatcherRuntimeException;

	abstract public boolean execute(MatchingFrame frame) 
        throws PatternMatcherRuntimeException;
	
    public boolean update(MatchingFrame frame) throws PatternMatcherRuntimeException {
            return execute(frame);
    }
    
    public String toString() {
        return getClass().getSimpleName();
    }

    public void calculateSidewaysPassedVariables(Set<Integer> variables) {
		/* default generated stub */;
		
	}
    
    public void calculateLocalVariables(Set<Integer> variables) {
		/* default generated stub */;
    	
    }
    
    public String toString(MatchingFrame frame) {
		return toString();
	}
}
