/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.searchgraph;

import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.callgraph.PatternNode;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.searchgraph.traceability.PatternCallNodeTraceabilityElement;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.searchgraph.traceability.VariableNodeTraceabilityElement;


/**
 * @author Akos Horvath
 *
 */
public class PatternCallSearchGraphNode extends VariableSearchGraphNode {

	/**
	 * 
	 */
	
	private Integer[] inputParameterMapping;
	private PatternNode patternNode = null;
	private PatternCallNodeTraceabilityElement traceabilityElement;
	
	
	public PatternCallSearchGraphNode(int size) {
		inputParameterMapping = new Integer[size];
		
	}

	public PatternCallSearchGraphNode() {
		super();
		inputParameterMapping = null;
	}

	public Integer[] getInputParameterMapping() {
		return inputParameterMapping;
	}

	public void setInputParameterMapping(Integer[] inputParameterMapping) {
		this.inputParameterMapping = inputParameterMapping;
	}

	public PatternNode getPatternNode() {
		return patternNode;
	}

	public void setPatternNode(PatternNode patternNode) {
		this.patternNode = patternNode;
	}
	
/*	@Override
	public PatternCallNodeTraceabilityElement getTraceabilityElement() {
		return traceabilityElement;
	}
	
	public void setTraceabilityElement(PatternCallNodeTraceabilityElement element) {
		traceabilityElement = element;
	}
*/
}
