/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.searchgraph;

import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.VPMModelElementType;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.searchgraph.traceability.VariableNodeTraceabilityElement;


public class VariableSearchGraphNode extends SearchGraphNode {
    private Integer id;
    private boolean isInput = false;
    private VPMModelElementType vpmModelElementType;
    private VariableNodeTraceabilityElement traceabilityElement;
    
	public void clear(){
	super.clear();
		isInput = false;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	/**
	 * @return the isInput
	 */
	public boolean isInput() {
		return isInput;
	}

	/**
	 * @param isInput the isInput to set
	 */
	public void setInput(boolean isInput) {
		this.isInput = isInput;
	}

	/**
	 * @return the vpmModelElementType
	 */
	public VPMModelElementType getVpmModelElementType() {
		return vpmModelElementType;
	}

	/**
	 * @param vpmModelElementType the vpmModelElementType to set
	 */
	public void setVpmModelElementType(VPMModelElementType vpmModelElementType) {
		this.vpmModelElementType = vpmModelElementType;
	}

	@Override
	public VariableNodeTraceabilityElement getTraceabilityElement() {
		return traceabilityElement;
	}
	
	public void setTraceabilityElement(VariableNodeTraceabilityElement element) {
		traceabilityElement = element;
	}
}
