/*******************************************************************************
 * Copyright (c) 2004-2008 Gabor Bergmann and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Gabor Bergmann - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.boundary;

import java.util.Collection;

import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.matcher.IPatternMatcherRuntimeContext;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.matcher.IPatternMatcherContext.Pair;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.network.ReteContainer;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.network.StandardNode;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.tuple.FlatTuple;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.tuple.Tuple;


public class GeneralizationFeederNode extends StandardNode {

	protected IPatternMatcherRuntimeContext<?> context;
	protected ReteBoundary<?> boundary;

	public GeneralizationFeederNode(IPatternMatcherRuntimeContext<?> context,
			ReteContainer reteNet, ReteBoundary<?> boundary) {
		super(reteNet);
		this.context = context;
		this.boundary = boundary;
	}

	public void pullInto(Collection<Tuple> collector) {
		for (Pair<Object, Object> generalization: context.enumerateAllGeneralizations())
			collector.add(new FlatTuple(boundary.wrapElement(generalization.getFirst()),
					boundary.wrapElement(generalization.getSecond())));
	}

}
