/*******************************************************************************
 * Copyright (c) 2004-2008 Gabor Bergmann and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Gabor Bergmann - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.boundary;

import java.util.Collection;

import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.matcher.IPatternMatcherRuntimeContext;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.matcher.IPatternMatcherContext.Pair;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.network.ReteContainer;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.network.StandardNode;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.tuple.FlatTuple;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.tuple.Tuple;


public class InstantiationFeederNode extends StandardNode {

	protected IPatternMatcherRuntimeContext<?> context;
	protected ReteBoundary<?> boundary;

	public InstantiationFeederNode(IPatternMatcherRuntimeContext<?> context,
			ReteContainer reteContainer, ReteBoundary<?> boundary) {
		super(reteContainer);
		this.context = context;
		this.boundary = boundary;
	}

	public void pullInto(Collection<Tuple> collector) {
		for (Pair<Object, Object> instantiation: context.enumerateAllInstantiations())
			collector.add(new FlatTuple(boundary.wrapElement(instantiation.getFirst()),
					boundary.wrapElement(instantiation.getSecond())));
	}

}
