/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Okros, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Okros - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.trigger.view;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.viatra2.frameworkgui.actions.AbstractFrameworkGUIAction;
import org.eclipse.viatra2.frameworkgui.views.FrameworkTreeView;
import org.eclipse.viatra2.gtasm.trigger.Activator;
import org.eclipse.viatra2.gtasm.trigger.engine.TriggerEngineManager;
import org.eclipse.viatra2.gtasm.trigger.view.FrameworkViewExtension.TriggerDummy;

/**
 * An action for deleting triggers from the execution engine. 
 * @author Andr�s �kr�s
 */
public class StartTriggerAction extends AbstractFrameworkGUIAction {
	
	private static ImageDescriptor trigger_start = Activator.getImageDescriptor("icons/thread_start.png");
	
	public StartTriggerAction(FrameworkTreeView part) {
		super();
		setupInternals(part);
		setText("Start");
		setToolTipText("Starts the trigger");
		setImageDescriptor(trigger_start);
	}
	
	@Override
	public boolean isEnabled() {
		return true;
	}
	
	@Override
	public void run() {
		refreshSelection();
		Object o = getFirstSelected();
		if (o instanceof TriggerDummy)
			{
			TriggerEngineManager.getInstance().getTriggerEngine(iViatraFramework).startTriggerWithCommit(((TriggerDummy)o).getTrigger());
			}

	}	
	
}


