/**
 *  * Copyright (c) 2008 Daniel Varro
 *  * All rights reserved. This program and the accompanying materials
 *  * are made available under the terms of the Eclipse Public License v1.0
 *  * which accompanies this distribution, and is available at
 *  * http://www.eclipse.org/legal/epl-v10.html
 *  *
 *  * Contributors:
 *  *    Daniel Varro - initial API and implementation
 * 
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasm.typerules;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Rule Set</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasm.typerules.RuleSet#getExtends <em>Extends</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasm.typerules.RuleSet#getTyperules <em>Typerules</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasm.typerules.TyperulesPackage#getRuleSet()
 * @model
 * @generated
 */
public interface RuleSet extends EObject {
	/**
	 * Returns the value of the '<em><b>Extends</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Extends</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Extends</em>' reference.
	 * @see #setExtends(RuleSet)
	 * @see org.eclipse.viatra2.gtasm.typerules.TyperulesPackage#getRuleSet_Extends()
	 * @model
	 * @generated
	 */
	RuleSet getExtends();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasm.typerules.RuleSet#getExtends <em>Extends</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Extends</em>' reference.
	 * @see #getExtends()
	 * @generated
	 */
	void setExtends(RuleSet value);

	/**
	 * Returns the value of the '<em><b>Typerules</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasm.typerules.TypeRule}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Typerules</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Typerules</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasm.typerules.TyperulesPackage#getRuleSet_Typerules()
	 * @model containment="true"
	 * @generated
	 */
	EList<TypeRule> getTyperules();

} // RuleSet
