/**
 *  * Copyright (c) 2008 Daniel Varro
 *  * All rights reserved. This program and the accompanying materials
 *  * are made available under the terms of the Eclipse Public License v1.0
 *  * which accompanies this distribution, and is available at
 *  * http://www.eclipse.org/legal/epl-v10.html
 *  *
 *  * Contributors:
 *  *    Daniel Varro - initial API and implementation
 * 
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasm.typerules;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Type Rule</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasm.typerules.TypeRule#getJudgements <em>Judgements</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasm.typerules.TypeRule#getOperator <em>Operator</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasm.typerules.TyperulesPackage#getTypeRule()
 * @model
 * @generated
 */
public interface TypeRule extends EObject {
	/**
	 * Returns the value of the '<em><b>Judgements</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasm.typerules.TypeJudgement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Judgements</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Judgements</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasm.typerules.TyperulesPackage#getTypeRule_Judgements()
	 * @model containment="true"
	 * @generated
	 */
	EList<TypeJudgement> getJudgements();

	/**
	 * Returns the value of the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Operator</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Operator</em>' attribute.
	 * @see #setOperator(String)
	 * @see org.eclipse.viatra2.gtasm.typerules.TyperulesPackage#getTypeRule_Operator()
	 * @model
	 * @generated
	 */
	String getOperator();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasm.typerules.TypeRule#getOperator <em>Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Operator</em>' attribute.
	 * @see #getOperator()
	 * @generated
	 */
	void setOperator(String value);

} // TypeRule
