/**
 *  * Copyright (c) 2008 Daniel Varro
 *  * All rights reserved. This program and the accompanying materials
 *  * are made available under the terms of the Eclipse Public License v1.0
 *  * which accompanies this distribution, and is available at
 *  * http://www.eclipse.org/legal/epl-v10.html
 *  *
 *  * Contributors:
 *  *    Daniel Varro - initial API and implementation
 * 
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasm.typerules;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasm.typerules.TyperulesFactory
 * @model kind="package"
 * @generated
 */
public interface TyperulesPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "typerules";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///typerules.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "typerules";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TyperulesPackage eINSTANCE = org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.RuleSetImpl <em>Rule Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.RuleSetImpl
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getRuleSet()
	 * @generated
	 */
	int RULE_SET = 0;

	/**
	 * The feature id for the '<em><b>Extends</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_SET__EXTENDS = 0;

	/**
	 * The feature id for the '<em><b>Typerules</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_SET__TYPERULES = 1;

	/**
	 * The number of structural features of the '<em>Rule Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_SET_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.TypeJudgementImpl <em>Type Judgement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.TypeJudgementImpl
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getTypeJudgement()
	 * @generated
	 */
	int TYPE_JUDGEMENT = 1;

	/**
	 * The feature id for the '<em><b>Is Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_JUDGEMENT__IS_VALID = 0;

	/**
	 * The feature id for the '<em><b>Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_JUDGEMENT__RESULT = 1;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_JUDGEMENT__NAME = 2;

	/**
	 * The number of structural features of the '<em>Type Judgement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_JUDGEMENT_FEATURE_COUNT = 3;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.UnaryTypeJudgementImpl <em>Unary Type Judgement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.UnaryTypeJudgementImpl
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getUnaryTypeJudgement()
	 * @generated
	 */
	int UNARY_TYPE_JUDGEMENT = 2;

	/**
	 * The feature id for the '<em><b>Is Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_TYPE_JUDGEMENT__IS_VALID = TYPE_JUDGEMENT__IS_VALID;

	/**
	 * The feature id for the '<em><b>Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_TYPE_JUDGEMENT__RESULT = TYPE_JUDGEMENT__RESULT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_TYPE_JUDGEMENT__NAME = TYPE_JUDGEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Operand</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_TYPE_JUDGEMENT__OPERAND = TYPE_JUDGEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Unary Type Judgement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_TYPE_JUDGEMENT_FEATURE_COUNT = TYPE_JUDGEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.BinaryTypeJudgementImpl <em>Binary Type Judgement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.BinaryTypeJudgementImpl
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getBinaryTypeJudgement()
	 * @generated
	 */
	int BINARY_TYPE_JUDGEMENT = 3;

	/**
	 * The feature id for the '<em><b>Is Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_TYPE_JUDGEMENT__IS_VALID = TYPE_JUDGEMENT__IS_VALID;

	/**
	 * The feature id for the '<em><b>Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_TYPE_JUDGEMENT__RESULT = TYPE_JUDGEMENT__RESULT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_TYPE_JUDGEMENT__NAME = TYPE_JUDGEMENT__NAME;

	/**
	 * The feature id for the '<em><b>First Operand</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_TYPE_JUDGEMENT__FIRST_OPERAND = TYPE_JUDGEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Second Operand</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_TYPE_JUDGEMENT__SECOND_OPERAND = TYPE_JUDGEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Binary Type Judgement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_TYPE_JUDGEMENT_FEATURE_COUNT = TYPE_JUDGEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.TypeRuleImpl <em>Type Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.TypeRuleImpl
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getTypeRule()
	 * @generated
	 */
	int TYPE_RULE = 4;

	/**
	 * The feature id for the '<em><b>Judgements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_RULE__JUDGEMENTS = 0;

	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_RULE__OPERATOR = 1;

	/**
	 * The number of structural features of the '<em>Type Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_RULE_FEATURE_COUNT = 2;


	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.CustomTypeJudgementImpl <em>Custom Type Judgement</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.CustomTypeJudgementImpl
	 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getCustomTypeJudgement()
	 * @generated
	 */
	int CUSTOM_TYPE_JUDGEMENT = 5;

	/**
	 * The feature id for the '<em><b>Is Valid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOM_TYPE_JUDGEMENT__IS_VALID = TYPE_JUDGEMENT__IS_VALID;

	/**
	 * The feature id for the '<em><b>Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOM_TYPE_JUDGEMENT__RESULT = TYPE_JUDGEMENT__RESULT;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOM_TYPE_JUDGEMENT__NAME = TYPE_JUDGEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Operands</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOM_TYPE_JUDGEMENT__OPERANDS = TYPE_JUDGEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Custom Type Judgement</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CUSTOM_TYPE_JUDGEMENT_FEATURE_COUNT = TYPE_JUDGEMENT_FEATURE_COUNT + 1;


	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasm.typerules.RuleSet <em>Rule Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rule Set</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.RuleSet
	 * @generated
	 */
	EClass getRuleSet();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.viatra2.gtasm.typerules.RuleSet#getExtends <em>Extends</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Extends</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.RuleSet#getExtends()
	 * @see #getRuleSet()
	 * @generated
	 */
	EReference getRuleSet_Extends();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasm.typerules.RuleSet#getTyperules <em>Typerules</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Typerules</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.RuleSet#getTyperules()
	 * @see #getRuleSet()
	 * @generated
	 */
	EReference getRuleSet_Typerules();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasm.typerules.TypeJudgement <em>Type Judgement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type Judgement</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.TypeJudgement
	 * @generated
	 */
	EClass getTypeJudgement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasm.typerules.TypeJudgement#isIsValid <em>Is Valid</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Valid</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.TypeJudgement#isIsValid()
	 * @see #getTypeJudgement()
	 * @generated
	 */
	EAttribute getTypeJudgement_IsValid();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasm.typerules.TypeJudgement#getResult <em>Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Result</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.TypeJudgement#getResult()
	 * @see #getTypeJudgement()
	 * @generated
	 */
	EAttribute getTypeJudgement_Result();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasm.typerules.TypeJudgement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.TypeJudgement#getName()
	 * @see #getTypeJudgement()
	 * @generated
	 */
	EAttribute getTypeJudgement_Name();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasm.typerules.UnaryTypeJudgement <em>Unary Type Judgement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Type Judgement</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.UnaryTypeJudgement
	 * @generated
	 */
	EClass getUnaryTypeJudgement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasm.typerules.UnaryTypeJudgement#getOperand <em>Operand</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operand</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.UnaryTypeJudgement#getOperand()
	 * @see #getUnaryTypeJudgement()
	 * @generated
	 */
	EAttribute getUnaryTypeJudgement_Operand();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasm.typerules.BinaryTypeJudgement <em>Binary Type Judgement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Type Judgement</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.BinaryTypeJudgement
	 * @generated
	 */
	EClass getBinaryTypeJudgement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasm.typerules.BinaryTypeJudgement#getFirstOperand <em>First Operand</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>First Operand</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.BinaryTypeJudgement#getFirstOperand()
	 * @see #getBinaryTypeJudgement()
	 * @generated
	 */
	EAttribute getBinaryTypeJudgement_FirstOperand();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasm.typerules.BinaryTypeJudgement#getSecondOperand <em>Second Operand</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Second Operand</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.BinaryTypeJudgement#getSecondOperand()
	 * @see #getBinaryTypeJudgement()
	 * @generated
	 */
	EAttribute getBinaryTypeJudgement_SecondOperand();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasm.typerules.TypeRule <em>Type Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type Rule</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.TypeRule
	 * @generated
	 */
	EClass getTypeRule();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasm.typerules.TypeRule#getJudgements <em>Judgements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Judgements</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.TypeRule#getJudgements()
	 * @see #getTypeRule()
	 * @generated
	 */
	EReference getTypeRule_Judgements();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasm.typerules.TypeRule#getOperator <em>Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operator</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.TypeRule#getOperator()
	 * @see #getTypeRule()
	 * @generated
	 */
	EAttribute getTypeRule_Operator();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasm.typerules.CustomTypeJudgement <em>Custom Type Judgement</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Custom Type Judgement</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.CustomTypeJudgement
	 * @generated
	 */
	EClass getCustomTypeJudgement();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.viatra2.gtasm.typerules.CustomTypeJudgement#getOperands <em>Operands</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Operands</em>'.
	 * @see org.eclipse.viatra2.gtasm.typerules.CustomTypeJudgement#getOperands()
	 * @see #getCustomTypeJudgement()
	 * @generated
	 */
	EAttribute getCustomTypeJudgement_Operands();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	TyperulesFactory getTyperulesFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.RuleSetImpl <em>Rule Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.RuleSetImpl
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getRuleSet()
		 * @generated
		 */
		EClass RULE_SET = eINSTANCE.getRuleSet();

		/**
		 * The meta object literal for the '<em><b>Extends</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RULE_SET__EXTENDS = eINSTANCE.getRuleSet_Extends();

		/**
		 * The meta object literal for the '<em><b>Typerules</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RULE_SET__TYPERULES = eINSTANCE.getRuleSet_Typerules();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.TypeJudgementImpl <em>Type Judgement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.TypeJudgementImpl
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getTypeJudgement()
		 * @generated
		 */
		EClass TYPE_JUDGEMENT = eINSTANCE.getTypeJudgement();

		/**
		 * The meta object literal for the '<em><b>Is Valid</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TYPE_JUDGEMENT__IS_VALID = eINSTANCE.getTypeJudgement_IsValid();

		/**
		 * The meta object literal for the '<em><b>Result</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TYPE_JUDGEMENT__RESULT = eINSTANCE.getTypeJudgement_Result();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TYPE_JUDGEMENT__NAME = eINSTANCE.getTypeJudgement_Name();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.UnaryTypeJudgementImpl <em>Unary Type Judgement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.UnaryTypeJudgementImpl
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getUnaryTypeJudgement()
		 * @generated
		 */
		EClass UNARY_TYPE_JUDGEMENT = eINSTANCE.getUnaryTypeJudgement();

		/**
		 * The meta object literal for the '<em><b>Operand</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute UNARY_TYPE_JUDGEMENT__OPERAND = eINSTANCE.getUnaryTypeJudgement_Operand();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.BinaryTypeJudgementImpl <em>Binary Type Judgement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.BinaryTypeJudgementImpl
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getBinaryTypeJudgement()
		 * @generated
		 */
		EClass BINARY_TYPE_JUDGEMENT = eINSTANCE.getBinaryTypeJudgement();

		/**
		 * The meta object literal for the '<em><b>First Operand</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BINARY_TYPE_JUDGEMENT__FIRST_OPERAND = eINSTANCE.getBinaryTypeJudgement_FirstOperand();

		/**
		 * The meta object literal for the '<em><b>Second Operand</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BINARY_TYPE_JUDGEMENT__SECOND_OPERAND = eINSTANCE.getBinaryTypeJudgement_SecondOperand();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.TypeRuleImpl <em>Type Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.TypeRuleImpl
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getTypeRule()
		 * @generated
		 */
		EClass TYPE_RULE = eINSTANCE.getTypeRule();

		/**
		 * The meta object literal for the '<em><b>Judgements</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference TYPE_RULE__JUDGEMENTS = eINSTANCE.getTypeRule_Judgements();

		/**
		 * The meta object literal for the '<em><b>Operator</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TYPE_RULE__OPERATOR = eINSTANCE.getTypeRule_Operator();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasm.typerules.impl.CustomTypeJudgementImpl <em>Custom Type Judgement</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.CustomTypeJudgementImpl
		 * @see org.eclipse.viatra2.gtasm.typerules.impl.TyperulesPackageImpl#getCustomTypeJudgement()
		 * @generated
		 */
		EClass CUSTOM_TYPE_JUDGEMENT = eINSTANCE.getCustomTypeJudgement();

		/**
		 * The meta object literal for the '<em><b>Operands</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CUSTOM_TYPE_JUDGEMENT__OPERANDS = eINSTANCE.getCustomTypeJudgement_Operands();

	}

} //TyperulesPackage
