/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums;

import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.EnumsFactory
 * @model kind="package"
 * @generated
 */
public interface EnumsPackage extends EPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "enums";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///viatragtasmmodel/gtasm/metamodel/asm/enums.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "viatragtasmmodel.gtasm.metamodel.asm.enums";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	EnumsPackage eINSTANCE = org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.CopySemantics <em>Copy Semantics</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.CopySemantics
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getCopySemantics()
	 * @generated
	 */
	int COPY_SEMANTICS = 0;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DeleteSemantics <em>Delete Semantics</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DeleteSemantics
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getDeleteSemantics()
	 * @generated
	 */
	int DELETE_SEMANTICS = 1;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.LogLevel <em>Log Level</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.LogLevel
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getLogLevel()
	 * @generated
	 */
	int LOG_LEVEL = 2;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ContainmentMode <em>Containment Mode</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ContainmentMode
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getContainmentMode()
	 * @generated
	 */
	int CONTAINMENT_MODE = 3;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ValueKind <em>Value Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ValueKind
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getValueKind()
	 * @generated
	 */
	int VALUE_KIND = 4;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DirectionKind <em>Direction Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DirectionKind
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getDirectionKind()
	 * @generated
	 */
	int DIRECTION_KIND = 5;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.MultiplicityKind <em>Multiplicity Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.MultiplicityKind
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getMultiplicityKind()
	 * @generated
	 */
	int MULTIPLICITY_KIND = 6;


	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ChangeKind <em>Change Kind</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ChangeKind
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getChangeKind()
	 * @generated
	 */
	int CHANGE_KIND = 7;


	/**
	 * Returns the meta object for enum '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.CopySemantics <em>Copy Semantics</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Copy Semantics</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.CopySemantics
	 * @generated
	 */
	EEnum getCopySemantics();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DeleteSemantics <em>Delete Semantics</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Delete Semantics</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DeleteSemantics
	 * @generated
	 */
	EEnum getDeleteSemantics();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.LogLevel <em>Log Level</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Log Level</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.LogLevel
	 * @generated
	 */
	EEnum getLogLevel();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ContainmentMode <em>Containment Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Containment Mode</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ContainmentMode
	 * @generated
	 */
	EEnum getContainmentMode();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ValueKind <em>Value Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Value Kind</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ValueKind
	 * @generated
	 */
	EEnum getValueKind();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DirectionKind <em>Direction Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Direction Kind</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DirectionKind
	 * @generated
	 */
	EEnum getDirectionKind();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.MultiplicityKind <em>Multiplicity Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Multiplicity Kind</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.MultiplicityKind
	 * @generated
	 */
	EEnum getMultiplicityKind();

	/**
	 * Returns the meta object for enum '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ChangeKind <em>Change Kind</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Change Kind</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ChangeKind
	 * @generated
	 */
	EEnum getChangeKind();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	EnumsFactory getEnumsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.CopySemantics <em>Copy Semantics</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.CopySemantics
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getCopySemantics()
		 * @generated
		 */
		EEnum COPY_SEMANTICS = eINSTANCE.getCopySemantics();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DeleteSemantics <em>Delete Semantics</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DeleteSemantics
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getDeleteSemantics()
		 * @generated
		 */
		EEnum DELETE_SEMANTICS = eINSTANCE.getDeleteSemantics();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.LogLevel <em>Log Level</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.LogLevel
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getLogLevel()
		 * @generated
		 */
		EEnum LOG_LEVEL = eINSTANCE.getLogLevel();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ContainmentMode <em>Containment Mode</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ContainmentMode
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getContainmentMode()
		 * @generated
		 */
		EEnum CONTAINMENT_MODE = eINSTANCE.getContainmentMode();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ValueKind <em>Value Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ValueKind
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getValueKind()
		 * @generated
		 */
		EEnum VALUE_KIND = eINSTANCE.getValueKind();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DirectionKind <em>Direction Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.DirectionKind
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getDirectionKind()
		 * @generated
		 */
		EEnum DIRECTION_KIND = eINSTANCE.getDirectionKind();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.MultiplicityKind <em>Multiplicity Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.MultiplicityKind
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getMultiplicityKind()
		 * @generated
		 */
		EEnum MULTIPLICITY_KIND = eINSTANCE.getMultiplicityKind();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ChangeKind <em>Change Kind</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.ChangeKind
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.enums.impl.EnumsPackageImpl#getChangeKind()
		 * @generated
		 */
		EEnum CHANGE_KIND = eINSTANCE.getChangeKind();

	}

} //EnumsPackage
