/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.builtInFunctions.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.builtInFunctions.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class BuiltInFunctionsFactoryImpl extends EFactoryImpl implements BuiltInFunctionsFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static BuiltInFunctionsFactory init() {
		try {
			BuiltInFunctionsFactory theBuiltInFunctionsFactory = (BuiltInFunctionsFactory)EPackage.Registry.INSTANCE.getEFactory("http:///viatragtasmmodel/gtasm/metamodel/asm/terms/builtInFunctions.ecore"); 
			if (theBuiltInFunctionsFactory != null) {
				return theBuiltInFunctionsFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new BuiltInFunctionsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BuiltInFunctionsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case BuiltInFunctionsPackage.REMAINDER: return createRemainder();
			case BuiltInFunctionsPackage.MULTIPLY: return createMultiply();
			case BuiltInFunctionsPackage.PLUS: return createPlus();
			case BuiltInFunctionsPackage.MINUS: return createMinus();
			case BuiltInFunctionsPackage.DIVISION: return createDivision();
			case BuiltInFunctionsPackage.AND: return createAnd();
			case BuiltInFunctionsPackage.EQUALS: return createEquals();
			case BuiltInFunctionsPackage.GREATER_THAN: return createGreaterThan();
			case BuiltInFunctionsPackage.GREATER_THAN_OR_EQUAL_TO: return createGreaterThanOrEqualTo();
			case BuiltInFunctionsPackage.LESS_THAN: return createLessThan();
			case BuiltInFunctionsPackage.LESS_THAN_OR_EQUAL_TO: return createLessThanOrEqualTo();
			case BuiltInFunctionsPackage.NOT: return createNot();
			case BuiltInFunctionsPackage.NOT_EQUALS: return createNotEquals();
			case BuiltInFunctionsPackage.OR: return createOr();
			case BuiltInFunctionsPackage.XOR: return createXOr();
			case BuiltInFunctionsPackage.TO_STRING: return createToString();
			case BuiltInFunctionsPackage.TO_INT: return createToInt();
			case BuiltInFunctionsPackage.TO_BOOLEAN: return createToBoolean();
			case BuiltInFunctionsPackage.TO_DOUBLE: return createToDouble();
			case BuiltInFunctionsPackage.TO_MODEL_ELEMENT: return createToModelElement();
			case BuiltInFunctionsPackage.TO_MULTIPLICITY: return createToMultiplicity();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Remainder createRemainder() {
		RemainderImpl remainder = new RemainderImpl();
		return remainder;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Multiply createMultiply() {
		MultiplyImpl multiply = new MultiplyImpl();
		return multiply;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Plus createPlus() {
		PlusImpl plus = new PlusImpl();
		return plus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Minus createMinus() {
		MinusImpl minus = new MinusImpl();
		return minus;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Division createDivision() {
		DivisionImpl division = new DivisionImpl();
		return division;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public And createAnd() {
		AndImpl and = new AndImpl();
		return and;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Equals createEquals() {
		EqualsImpl equals = new EqualsImpl();
		return equals;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GreaterThan createGreaterThan() {
		GreaterThanImpl greaterThan = new GreaterThanImpl();
		return greaterThan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GreaterThanOrEqualTo createGreaterThanOrEqualTo() {
		GreaterThanOrEqualToImpl greaterThanOrEqualTo = new GreaterThanOrEqualToImpl();
		return greaterThanOrEqualTo;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LessThan createLessThan() {
		LessThanImpl lessThan = new LessThanImpl();
		return lessThan;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LessThanOrEqualTo createLessThanOrEqualTo() {
		LessThanOrEqualToImpl lessThanOrEqualTo = new LessThanOrEqualToImpl();
		return lessThanOrEqualTo;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Not createNot() {
		NotImpl not = new NotImpl();
		return not;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotEquals createNotEquals() {
		NotEqualsImpl notEquals = new NotEqualsImpl();
		return notEquals;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Or createOr() {
		OrImpl or = new OrImpl();
		return or;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XOr createXOr() {
		XOrImpl xOr = new XOrImpl();
		return xOr;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ToString createToString() {
		ToStringImpl toString = new ToStringImpl();
		return toString;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ToInt createToInt() {
		ToIntImpl toInt = new ToIntImpl();
		return toInt;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ToBoolean createToBoolean() {
		ToBooleanImpl toBoolean = new ToBooleanImpl();
		return toBoolean;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ToDouble createToDouble() {
		ToDoubleImpl toDouble = new ToDoubleImpl();
		return toDouble;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ToModelElement createToModelElement() {
		ToModelElementImpl toModelElement = new ToModelElementImpl();
		return toModelElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ToMultiplicity createToMultiplicity() {
		ToMultiplicityImpl toMultiplicity = new ToMultiplicityImpl();
		return toMultiplicity;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BuiltInFunctionsPackage getBuiltInFunctionsPackage() {
		return (BuiltInFunctionsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static BuiltInFunctionsPackage getPackage() {
		return BuiltInFunctionsPackage.eINSTANCE;
	}

} //BuiltInFunctionsFactoryImpl
