/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.TermsPackage;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>GT Pattern Call</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.impl.GTPatternCallImpl#getActualParameters <em>Actual Parameters</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.impl.GTPatternCallImpl#getCalledPattern <em>Called Pattern</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.impl.GTPatternCallImpl#getMatchCounter <em>Match Counter</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class GTPatternCallImpl extends TermImpl implements GTPatternCall {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * The cached value of the '{@link #getActualParameters() <em>Actual Parameters</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActualParameters()
	 * @generated
	 * @ordered
	 */
	protected EList<Term> actualParameters;

	/**
	 * The cached value of the '{@link #getCalledPattern() <em>Called Pattern</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCalledPattern()
	 * @generated
	 * @ordered
	 */
	protected GTPattern calledPattern;

	/**
	 * The cached value of the '{@link #getMatchCounter() <em>Match Counter</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMatchCounter()
	 * @generated
	 * @ordered
	 */
	protected GTMatchCounter matchCounter;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GTPatternCallImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return TermsPackage.Literals.GT_PATTERN_CALL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Term> getActualParameters() {
		if (actualParameters == null) {
			actualParameters = new EObjectContainmentEList<Term>(Term.class, this, TermsPackage.GT_PATTERN_CALL__ACTUAL_PARAMETERS);
		}
		return actualParameters;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTPattern getCalledPattern() {
		if (calledPattern != null && calledPattern.eIsProxy()) {
			InternalEObject oldCalledPattern = (InternalEObject)calledPattern;
			calledPattern = (GTPattern)eResolveProxy(oldCalledPattern);
			if (calledPattern != oldCalledPattern) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, TermsPackage.GT_PATTERN_CALL__CALLED_PATTERN, oldCalledPattern, calledPattern));
			}
		}
		return calledPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTPattern basicGetCalledPattern() {
		return calledPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCalledPattern(GTPattern newCalledPattern) {
		GTPattern oldCalledPattern = calledPattern;
		calledPattern = newCalledPattern;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TermsPackage.GT_PATTERN_CALL__CALLED_PATTERN, oldCalledPattern, calledPattern));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTMatchCounter getMatchCounter() {
		return matchCounter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetMatchCounter(GTMatchCounter newMatchCounter, NotificationChain msgs) {
		GTMatchCounter oldMatchCounter = matchCounter;
		matchCounter = newMatchCounter;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER, oldMatchCounter, newMatchCounter);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMatchCounter(GTMatchCounter newMatchCounter) {
		if (newMatchCounter != matchCounter) {
			NotificationChain msgs = null;
			if (matchCounter != null)
				msgs = ((InternalEObject)matchCounter).eInverseRemove(this, GtPackage.GT_MATCH_COUNTER__PATTERN_CALL, GTMatchCounter.class, msgs);
			if (newMatchCounter != null)
				msgs = ((InternalEObject)newMatchCounter).eInverseAdd(this, GtPackage.GT_MATCH_COUNTER__PATTERN_CALL, GTMatchCounter.class, msgs);
			msgs = basicSetMatchCounter(newMatchCounter, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER, newMatchCounter, newMatchCounter));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER:
				if (matchCounter != null)
					msgs = ((InternalEObject)matchCounter).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER, null, msgs);
				return basicSetMatchCounter((GTMatchCounter)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case TermsPackage.GT_PATTERN_CALL__ACTUAL_PARAMETERS:
				return ((InternalEList<?>)getActualParameters()).basicRemove(otherEnd, msgs);
			case TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER:
				return basicSetMatchCounter(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case TermsPackage.GT_PATTERN_CALL__ACTUAL_PARAMETERS:
				return getActualParameters();
			case TermsPackage.GT_PATTERN_CALL__CALLED_PATTERN:
				if (resolve) return getCalledPattern();
				return basicGetCalledPattern();
			case TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER:
				return getMatchCounter();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case TermsPackage.GT_PATTERN_CALL__ACTUAL_PARAMETERS:
				getActualParameters().clear();
				getActualParameters().addAll((Collection<? extends Term>)newValue);
				return;
			case TermsPackage.GT_PATTERN_CALL__CALLED_PATTERN:
				setCalledPattern((GTPattern)newValue);
				return;
			case TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER:
				setMatchCounter((GTMatchCounter)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case TermsPackage.GT_PATTERN_CALL__ACTUAL_PARAMETERS:
				getActualParameters().clear();
				return;
			case TermsPackage.GT_PATTERN_CALL__CALLED_PATTERN:
				setCalledPattern((GTPattern)null);
				return;
			case TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER:
				setMatchCounter((GTMatchCounter)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case TermsPackage.GT_PATTERN_CALL__ACTUAL_PARAMETERS:
				return actualParameters != null && !actualParameters.isEmpty();
			case TermsPackage.GT_PATTERN_CALL__CALLED_PATTERN:
				return calledPattern != null;
			case TermsPackage.GT_PATTERN_CALL__MATCH_COUNTER:
				return matchCounter != null;
		}
		return super.eIsSet(featureID);
	}

} //GTPatternCallImpl
