/**
 *  * Copyright (c) 2006-2008 Istvan Rath and Daniel Varro
 *  * All rights reserved. This program and the accompanying materials
 *  * are made available under the terms of the Eclipse Public License v1.0
 *  * which accompanies this distribution, and is available at
 *  * http://www.eclipse.org/legal/epl-v10.html
 *  *
 *  * Contributors:
 *  *    Istvan Rath, Daniel Varro - initial API and implementation
 * 
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.GTASMElement;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.VariableReference;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>GT Match Counter</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getPatternCall <em>Pattern Call</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getVariableReference <em>Variable Reference</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTMatchCounter()
 * @model
 * @generated
 */
public interface GTMatchCounter extends GTASMElement {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Returns the value of the '<em><b>Pattern Call</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall#getMatchCounter <em>Match Counter</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pattern Call</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pattern Call</em>' container reference.
	 * @see #setPatternCall(GTPatternCall)
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTMatchCounter_PatternCall()
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall#getMatchCounter
	 * @model opposite="matchCounter" transient="false"
	 * @generated
	 */
	GTPatternCall getPatternCall();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getPatternCall <em>Pattern Call</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pattern Call</em>' container reference.
	 * @see #getPatternCall()
	 * @generated
	 */
	void setPatternCall(GTPatternCall value);

	/**
	 * Returns the value of the '<em><b>Variable Reference</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Variable Reference</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Variable Reference</em>' containment reference.
	 * @see #setVariableReference(VariableReference)
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTMatchCounter_VariableReference()
	 * @model containment="true"
	 * @generated
	 */
	VariableReference getVariableReference();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getVariableReference <em>Variable Reference</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Variable Reference</em>' containment reference.
	 * @see #getVariableReference()
	 * @generated
	 */
	void setVariableReference(VariableReference value);

} // GTMatchCounter
