/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt;

import org.eclipse.emf.common.util.EList;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.GTASMElement;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>GT Pattern Body</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getNegativePatterns <em>Negative Patterns</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getLocalVariables <em>Local Variables</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getCalledPatterns <em>Called Patterns</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getCheckExpressions <em>Check Expressions</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getPatternGraph <em>Pattern Graph</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getContainmentConstraints <em>Containment Constraints</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getLocalPatternDefinition <em>Local Pattern Definition</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getVariableAssignments <em>Variable Assignments</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getHeader <em>Header</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getElementWrappers <em>Element Wrappers</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getDanglingRelationships <em>Dangling Relationships</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getDanglingRelations <em>Dangling Relations</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getNonInjectivityConstraints <em>Non Injectivity Constraints</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody()
 * @model
 * @generated
 */
public interface GTPatternBody extends GTASMElement {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Returns the value of the '<em><b>Negative Patterns</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Negative Patterns</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Negative Patterns</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_NegativePatterns()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<GTPatternCall> getNegativePatterns();

	/**
	 * Returns the value of the '<em><b>Local Variables</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariable}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Local Variables</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Local Variables</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_LocalVariables()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<PatternVariable> getLocalVariables();

	/**
	 * Returns the value of the '<em><b>Called Patterns</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Called Patterns</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Called Patterns</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_CalledPatterns()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<GTPatternCall> getCalledPatterns();

	/**
	 * Returns the value of the '<em><b>Check Expressions</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Check Expressions</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Check Expressions</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_CheckExpressions()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<Term> getCheckExpressions();

	/**
	 * Returns the value of the '<em><b>Pattern Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pattern Graph</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pattern Graph</em>' containment reference.
	 * @see #setPatternGraph(Entity)
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_PatternGraph()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	Entity getPatternGraph();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getPatternGraph <em>Pattern Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pattern Graph</em>' containment reference.
	 * @see #getPatternGraph()
	 * @generated
	 */
	void setPatternGraph(Entity value);

	/**
	 * Returns the value of the '<em><b>Containment Constraints</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Containment Constraints</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Containment Constraints</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_ContainmentConstraints()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<ContainmentConstraint> getContainmentConstraints();

	/**
	 * Returns the value of the '<em><b>Local Pattern Definition</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Local Pattern Definition</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Local Pattern Definition</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_LocalPatternDefinition()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<GTPattern> getLocalPatternDefinition();

	/**
	 * Returns the value of the '<em><b>Variable Assignments</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableAssignment}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Variable Assignments</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Variable Assignments</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_VariableAssignments()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<PatternVariableAssignment> getVariableAssignments();

	/**
	 * Returns the value of the '<em><b>Header</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#getPatternBodies <em>Pattern Bodies</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Header</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Header</em>' container reference.
	 * @see #setHeader(GTPattern)
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_Header()
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#getPatternBodies
	 * @model opposite="patternBodies" required="true" transient="false"
	 * @generated
	 */
	GTPattern getHeader();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getHeader <em>Header</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Header</em>' container reference.
	 * @see #getHeader()
	 * @generated
	 */
	void setHeader(GTPattern value);

	/**
	 * Returns the value of the '<em><b>Element Wrappers</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Element Wrappers</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Element Wrappers</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_ElementWrappers()
	 * @model containment="true"
	 * @generated
	 */
	EList<ModelElement> getElementWrappers();

	/**
	 * Returns the value of the '<em><b>Dangling Relationships</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dangling Relationships</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dangling Relationships</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_DanglingRelationships()
	 * @model containment="true"
	 * @generated
	 */
	EList<Relationship> getDanglingRelationships();

	/**
	 * Returns the value of the '<em><b>Dangling Relations</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dangling Relations</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dangling Relations</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_DanglingRelations()
	 * @model containment="true"
	 * @generated
	 */
	EList<Relation> getDanglingRelations();

	/**
	 * Returns the value of the '<em><b>Non Injectivity Constraints</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.NonInjectivityConstraint}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Non Injectivity Constraints</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Non Injectivity Constraints</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage#getGTPatternBody_NonInjectivityConstraints()
	 * @model containment="true"
	 * @generated
	 */
	EList<NonInjectivityConstraint> getNonInjectivityConstraints();

} // GTPatternBody
