/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.CorePackage;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.definitions.DefinitionsPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtFactory
 * @model kind="package"
 * @generated
 */
public interface GtPackage extends EPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "gt";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///viatragtasmmodel/gtasm/metamodel/gt.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "viatragtasmmodel.gtasm.metamodel.gt";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	GtPackage eINSTANCE = org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl <em>GT Pattern Body</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getGTPatternBody()
	 * @generated
	 */
	int GT_PATTERN_BODY = 0;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__ANNOTATIONS = CorePackage.GTASM_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__NAME = CorePackage.GTASM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__ID = CorePackage.GTASM_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__FQN = CorePackage.GTASM_ELEMENT__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__RUNTIME_ANNOTATIONS = CorePackage.GTASM_ELEMENT__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Negative Patterns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__NEGATIVE_PATTERNS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Local Variables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__LOCAL_VARIABLES = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Called Patterns</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__CALLED_PATTERNS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Check Expressions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__CHECK_EXPRESSIONS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Pattern Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__PATTERN_GRAPH = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Containment Constraints</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__CONTAINMENT_CONSTRAINTS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Local Pattern Definition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__LOCAL_PATTERN_DEFINITION = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Variable Assignments</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__VARIABLE_ASSIGNMENTS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Header</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__HEADER = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Element Wrappers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__ELEMENT_WRAPPERS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Dangling Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__DANGLING_RELATIONSHIPS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Dangling Relations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__DANGLING_RELATIONS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Non Injectivity Constraints</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY__NON_INJECTIVITY_CONSTRAINTS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 12;

	/**
	 * The number of structural features of the '<em>GT Pattern Body</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_BODY_FEATURE_COUNT = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 13;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternImpl <em>GT Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getGTPattern()
	 * @generated
	 */
	int GT_PATTERN = 1;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__ANNOTATIONS = CorePackage.GTASM_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__NAME = CorePackage.GTASM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__ID = CorePackage.GTASM_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__FQN = CorePackage.GTASM_ELEMENT__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__RUNTIME_ANNOTATIONS = CorePackage.GTASM_ELEMENT__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Sym Parameters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__SYM_PARAMETERS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Pattern Bodies</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__PATTERN_BODIES = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__NAMESPACE = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Distinct Matching</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN__DISTINCT_MATCHING = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>GT Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_PATTERN_FEATURE_COUNT = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableImpl <em>Pattern Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getPatternVariable()
	 * @generated
	 */
	int PATTERN_VARIABLE = 2;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__ANNOTATIONS = DefinitionsPackage.VARIABLE__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__NAME = DefinitionsPackage.VARIABLE__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__ID = DefinitionsPackage.VARIABLE__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__FQN = DefinitionsPackage.VARIABLE__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__RUNTIME_ANNOTATIONS = DefinitionsPackage.VARIABLE__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>References</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__REFERENCES = DefinitionsPackage.VARIABLE__REFERENCES;

	/**
	 * The feature id for the '<em><b>Scope</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__SCOPE = DefinitionsPackage.VARIABLE__SCOPE;

	/**
	 * The feature id for the '<em><b>Variable Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__VARIABLE_TYPE = DefinitionsPackage.VARIABLE__VARIABLE_TYPE;

	/**
	 * The feature id for the '<em><b>Element In Pattern</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE__ELEMENT_IN_PATTERN = DefinitionsPackage.VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Pattern Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_FEATURE_COUNT = DefinitionsPackage.VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableConstraintImpl <em>Pattern Variable Constraint</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableConstraintImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getPatternVariableConstraint()
	 * @generated
	 */
	int PATTERN_VARIABLE_CONSTRAINT = 8;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_CONSTRAINT__ANNOTATIONS = CorePackage.GTASM_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_CONSTRAINT__NAME = CorePackage.GTASM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_CONSTRAINT__ID = CorePackage.GTASM_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_CONSTRAINT__FQN = CorePackage.GTASM_ELEMENT__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_CONSTRAINT__RUNTIME_ANNOTATIONS = CorePackage.GTASM_ELEMENT__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Left Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_CONSTRAINT__LEFT_VALUE = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Right Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_CONSTRAINT__RIGHT_VALUE = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Pattern Variable Constraint</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_CONSTRAINT_FEATURE_COUNT = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableAssignmentImpl <em>Pattern Variable Assignment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableAssignmentImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getPatternVariableAssignment()
	 * @generated
	 */
	int PATTERN_VARIABLE_ASSIGNMENT = 3;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_ASSIGNMENT__ANNOTATIONS = PATTERN_VARIABLE_CONSTRAINT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_ASSIGNMENT__NAME = PATTERN_VARIABLE_CONSTRAINT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_ASSIGNMENT__ID = PATTERN_VARIABLE_CONSTRAINT__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_ASSIGNMENT__FQN = PATTERN_VARIABLE_CONSTRAINT__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_ASSIGNMENT__RUNTIME_ANNOTATIONS = PATTERN_VARIABLE_CONSTRAINT__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Left Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_ASSIGNMENT__LEFT_VALUE = PATTERN_VARIABLE_CONSTRAINT__LEFT_VALUE;

	/**
	 * The feature id for the '<em><b>Right Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_ASSIGNMENT__RIGHT_VALUE = PATTERN_VARIABLE_CONSTRAINT__RIGHT_VALUE;

	/**
	 * The number of structural features of the '<em>Pattern Variable Assignment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PATTERN_VARIABLE_ASSIGNMENT_FEATURE_COUNT = PATTERN_VARIABLE_CONSTRAINT_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTRuleImpl <em>GT Rule</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTRuleImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getGTRule()
	 * @generated
	 */
	int GT_RULE = 4;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__ANNOTATIONS = CorePackage.GTASM_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__NAME = CorePackage.GTASM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__ID = CorePackage.GTASM_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__FQN = CorePackage.GTASM_ELEMENT__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__RUNTIME_ANNOTATIONS = CorePackage.GTASM_ELEMENT__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Sym Parameters</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__SYM_PARAMETERS = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Precondition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__PRECONDITION = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Local Variables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__LOCAL_VARIABLES = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Action</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__ACTION = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Postcondition</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__POSTCONDITION = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Local Pattern Definition</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__LOCAL_PATTERN_DEFINITION = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE__NAMESPACE = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>GT Rule</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_RULE_FEATURE_COUNT = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.ContainmentConstraintImpl <em>Containment Constraint</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.ContainmentConstraintImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getContainmentConstraint()
	 * @generated
	 */
	int CONTAINMENT_CONSTRAINT = 5;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT__ANNOTATIONS = CorePackage.GTASM_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT__NAME = CorePackage.GTASM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT__ID = CorePackage.GTASM_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT__FQN = CorePackage.GTASM_ELEMENT__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT__RUNTIME_ANNOTATIONS = CorePackage.GTASM_ELEMENT__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Variable</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT__VARIABLE = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Mode</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT__MODE = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT__PARENT = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Containment Constraint</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINMENT_CONSTRAINT_FEATURE_COUNT = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 3;


	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTMatchCounterImpl <em>GT Match Counter</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTMatchCounterImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getGTMatchCounter()
	 * @generated
	 */
	int GT_MATCH_COUNTER = 6;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_MATCH_COUNTER__ANNOTATIONS = CorePackage.GTASM_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_MATCH_COUNTER__NAME = CorePackage.GTASM_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_MATCH_COUNTER__ID = CorePackage.GTASM_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_MATCH_COUNTER__FQN = CorePackage.GTASM_ELEMENT__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_MATCH_COUNTER__RUNTIME_ANNOTATIONS = CorePackage.GTASM_ELEMENT__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Pattern Call</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_MATCH_COUNTER__PATTERN_CALL = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Variable Reference</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_MATCH_COUNTER__VARIABLE_REFERENCE = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>GT Match Counter</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GT_MATCH_COUNTER_FEATURE_COUNT = CorePackage.GTASM_ELEMENT_FEATURE_COUNT + 2;


	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.NonInjectivityConstraintImpl <em>Non Injectivity Constraint</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.NonInjectivityConstraintImpl
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getNonInjectivityConstraint()
	 * @generated
	 */
	int NON_INJECTIVITY_CONSTRAINT = 7;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_INJECTIVITY_CONSTRAINT__ANNOTATIONS = PATTERN_VARIABLE_CONSTRAINT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_INJECTIVITY_CONSTRAINT__NAME = PATTERN_VARIABLE_CONSTRAINT__NAME;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_INJECTIVITY_CONSTRAINT__ID = PATTERN_VARIABLE_CONSTRAINT__ID;

	/**
	 * The feature id for the '<em><b>Fqn</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_INJECTIVITY_CONSTRAINT__FQN = PATTERN_VARIABLE_CONSTRAINT__FQN;

	/**
	 * The feature id for the '<em><b>Runtime Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_INJECTIVITY_CONSTRAINT__RUNTIME_ANNOTATIONS = PATTERN_VARIABLE_CONSTRAINT__RUNTIME_ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Left Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_INJECTIVITY_CONSTRAINT__LEFT_VALUE = PATTERN_VARIABLE_CONSTRAINT__LEFT_VALUE;

	/**
	 * The feature id for the '<em><b>Right Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_INJECTIVITY_CONSTRAINT__RIGHT_VALUE = PATTERN_VARIABLE_CONSTRAINT__RIGHT_VALUE;

	/**
	 * The number of structural features of the '<em>Non Injectivity Constraint</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NON_INJECTIVITY_CONSTRAINT_FEATURE_COUNT = PATTERN_VARIABLE_CONSTRAINT_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody <em>GT Pattern Body</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GT Pattern Body</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody
	 * @generated
	 */
	EClass getGTPatternBody();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getNegativePatterns <em>Negative Patterns</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Negative Patterns</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getNegativePatterns()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_NegativePatterns();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getLocalVariables <em>Local Variables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Local Variables</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getLocalVariables()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_LocalVariables();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getCalledPatterns <em>Called Patterns</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Called Patterns</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getCalledPatterns()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_CalledPatterns();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getCheckExpressions <em>Check Expressions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Check Expressions</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getCheckExpressions()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_CheckExpressions();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getPatternGraph <em>Pattern Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Pattern Graph</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getPatternGraph()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_PatternGraph();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getContainmentConstraints <em>Containment Constraints</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Containment Constraints</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getContainmentConstraints()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_ContainmentConstraints();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getLocalPatternDefinition <em>Local Pattern Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Local Pattern Definition</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getLocalPatternDefinition()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_LocalPatternDefinition();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getVariableAssignments <em>Variable Assignments</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Variable Assignments</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getVariableAssignments()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_VariableAssignments();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getHeader <em>Header</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Header</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getHeader()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_Header();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getElementWrappers <em>Element Wrappers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Element Wrappers</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getElementWrappers()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_ElementWrappers();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getDanglingRelationships <em>Dangling Relationships</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Dangling Relationships</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getDanglingRelationships()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_DanglingRelationships();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getDanglingRelations <em>Dangling Relations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Dangling Relations</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getDanglingRelations()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_DanglingRelations();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getNonInjectivityConstraints <em>Non Injectivity Constraints</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Non Injectivity Constraints</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody#getNonInjectivityConstraints()
	 * @see #getGTPatternBody()
	 * @generated
	 */
	EReference getGTPatternBody_NonInjectivityConstraints();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern <em>GT Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GT Pattern</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern
	 * @generated
	 */
	EClass getGTPattern();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#getSymParameters <em>Sym Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sym Parameters</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#getSymParameters()
	 * @see #getGTPattern()
	 * @generated
	 */
	EReference getGTPattern_SymParameters();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#getPatternBodies <em>Pattern Bodies</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Pattern Bodies</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#getPatternBodies()
	 * @see #getGTPattern()
	 * @generated
	 */
	EReference getGTPattern_PatternBodies();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Namespace</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#getNamespace()
	 * @see #getGTPattern()
	 * @generated
	 */
	EReference getGTPattern_Namespace();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#isDistinctMatching <em>Distinct Matching</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Distinct Matching</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern#isDistinctMatching()
	 * @see #getGTPattern()
	 * @generated
	 */
	EAttribute getGTPattern_DistinctMatching();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariable <em>Pattern Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pattern Variable</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariable
	 * @generated
	 */
	EClass getPatternVariable();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariable#getElementInPattern <em>Element In Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Element In Pattern</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariable#getElementInPattern()
	 * @see #getPatternVariable()
	 * @generated
	 */
	EReference getPatternVariable_ElementInPattern();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableAssignment <em>Pattern Variable Assignment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pattern Variable Assignment</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableAssignment
	 * @generated
	 */
	EClass getPatternVariableAssignment();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule <em>GT Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GT Rule</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule
	 * @generated
	 */
	EClass getGTRule();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getSymParameters <em>Sym Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sym Parameters</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getSymParameters()
	 * @see #getGTRule()
	 * @generated
	 */
	EReference getGTRule_SymParameters();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getPrecondition <em>Precondition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Precondition</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getPrecondition()
	 * @see #getGTRule()
	 * @generated
	 */
	EReference getGTRule_Precondition();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getLocalVariables <em>Local Variables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Local Variables</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getLocalVariables()
	 * @see #getGTRule()
	 * @generated
	 */
	EReference getGTRule_LocalVariables();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getAction <em>Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Action</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getAction()
	 * @see #getGTRule()
	 * @generated
	 */
	EReference getGTRule_Action();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getPostcondition <em>Postcondition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Postcondition</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getPostcondition()
	 * @see #getGTRule()
	 * @generated
	 */
	EReference getGTRule_Postcondition();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getLocalPatternDefinition <em>Local Pattern Definition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Local Pattern Definition</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getLocalPatternDefinition()
	 * @see #getGTRule()
	 * @generated
	 */
	EReference getGTRule_LocalPatternDefinition();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Namespace</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule#getNamespace()
	 * @see #getGTRule()
	 * @generated
	 */
	EReference getGTRule_Namespace();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint <em>Containment Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Containment Constraint</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint
	 * @generated
	 */
	EClass getContainmentConstraint();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint#getVariable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Variable</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint#getVariable()
	 * @see #getContainmentConstraint()
	 * @generated
	 */
	EReference getContainmentConstraint_Variable();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint#getMode <em>Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mode</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint#getMode()
	 * @see #getContainmentConstraint()
	 * @generated
	 */
	EAttribute getContainmentConstraint_Mode();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Parent</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint#getParent()
	 * @see #getContainmentConstraint()
	 * @generated
	 */
	EReference getContainmentConstraint_Parent();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter <em>GT Match Counter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>GT Match Counter</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter
	 * @generated
	 */
	EClass getGTMatchCounter();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getPatternCall <em>Pattern Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Pattern Call</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getPatternCall()
	 * @see #getGTMatchCounter()
	 * @generated
	 */
	EReference getGTMatchCounter_PatternCall();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getVariableReference <em>Variable Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Variable Reference</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getVariableReference()
	 * @see #getGTMatchCounter()
	 * @generated
	 */
	EReference getGTMatchCounter_VariableReference();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.NonInjectivityConstraint <em>Non Injectivity Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Non Injectivity Constraint</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.NonInjectivityConstraint
	 * @generated
	 */
	EClass getNonInjectivityConstraint();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableConstraint <em>Pattern Variable Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Pattern Variable Constraint</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableConstraint
	 * @generated
	 */
	EClass getPatternVariableConstraint();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableConstraint#getLeftValue <em>Left Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Left Value</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableConstraint#getLeftValue()
	 * @see #getPatternVariableConstraint()
	 * @generated
	 */
	EReference getPatternVariableConstraint_LeftValue();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableConstraint#getRightValue <em>Right Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Right Value</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableConstraint#getRightValue()
	 * @see #getPatternVariableConstraint()
	 * @generated
	 */
	EReference getPatternVariableConstraint_RightValue();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	GtFactory getGtFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl <em>GT Pattern Body</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getGTPatternBody()
		 * @generated
		 */
		EClass GT_PATTERN_BODY = eINSTANCE.getGTPatternBody();

		/**
		 * The meta object literal for the '<em><b>Negative Patterns</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__NEGATIVE_PATTERNS = eINSTANCE.getGTPatternBody_NegativePatterns();

		/**
		 * The meta object literal for the '<em><b>Local Variables</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__LOCAL_VARIABLES = eINSTANCE.getGTPatternBody_LocalVariables();

		/**
		 * The meta object literal for the '<em><b>Called Patterns</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__CALLED_PATTERNS = eINSTANCE.getGTPatternBody_CalledPatterns();

		/**
		 * The meta object literal for the '<em><b>Check Expressions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__CHECK_EXPRESSIONS = eINSTANCE.getGTPatternBody_CheckExpressions();

		/**
		 * The meta object literal for the '<em><b>Pattern Graph</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__PATTERN_GRAPH = eINSTANCE.getGTPatternBody_PatternGraph();

		/**
		 * The meta object literal for the '<em><b>Containment Constraints</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__CONTAINMENT_CONSTRAINTS = eINSTANCE.getGTPatternBody_ContainmentConstraints();

		/**
		 * The meta object literal for the '<em><b>Local Pattern Definition</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__LOCAL_PATTERN_DEFINITION = eINSTANCE.getGTPatternBody_LocalPatternDefinition();

		/**
		 * The meta object literal for the '<em><b>Variable Assignments</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__VARIABLE_ASSIGNMENTS = eINSTANCE.getGTPatternBody_VariableAssignments();

		/**
		 * The meta object literal for the '<em><b>Header</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__HEADER = eINSTANCE.getGTPatternBody_Header();

		/**
		 * The meta object literal for the '<em><b>Element Wrappers</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__ELEMENT_WRAPPERS = eINSTANCE.getGTPatternBody_ElementWrappers();

		/**
		 * The meta object literal for the '<em><b>Dangling Relationships</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__DANGLING_RELATIONSHIPS = eINSTANCE.getGTPatternBody_DanglingRelationships();

		/**
		 * The meta object literal for the '<em><b>Dangling Relations</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__DANGLING_RELATIONS = eINSTANCE.getGTPatternBody_DanglingRelations();

		/**
		 * The meta object literal for the '<em><b>Non Injectivity Constraints</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN_BODY__NON_INJECTIVITY_CONSTRAINTS = eINSTANCE.getGTPatternBody_NonInjectivityConstraints();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternImpl <em>GT Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getGTPattern()
		 * @generated
		 */
		EClass GT_PATTERN = eINSTANCE.getGTPattern();

		/**
		 * The meta object literal for the '<em><b>Sym Parameters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN__SYM_PARAMETERS = eINSTANCE.getGTPattern_SymParameters();

		/**
		 * The meta object literal for the '<em><b>Pattern Bodies</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN__PATTERN_BODIES = eINSTANCE.getGTPattern_PatternBodies();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_PATTERN__NAMESPACE = eINSTANCE.getGTPattern_Namespace();

		/**
		 * The meta object literal for the '<em><b>Distinct Matching</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute GT_PATTERN__DISTINCT_MATCHING = eINSTANCE.getGTPattern_DistinctMatching();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableImpl <em>Pattern Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getPatternVariable()
		 * @generated
		 */
		EClass PATTERN_VARIABLE = eINSTANCE.getPatternVariable();

		/**
		 * The meta object literal for the '<em><b>Element In Pattern</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PATTERN_VARIABLE__ELEMENT_IN_PATTERN = eINSTANCE.getPatternVariable_ElementInPattern();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableAssignmentImpl <em>Pattern Variable Assignment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableAssignmentImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getPatternVariableAssignment()
		 * @generated
		 */
		EClass PATTERN_VARIABLE_ASSIGNMENT = eINSTANCE.getPatternVariableAssignment();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTRuleImpl <em>GT Rule</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTRuleImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getGTRule()
		 * @generated
		 */
		EClass GT_RULE = eINSTANCE.getGTRule();

		/**
		 * The meta object literal for the '<em><b>Sym Parameters</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_RULE__SYM_PARAMETERS = eINSTANCE.getGTRule_SymParameters();

		/**
		 * The meta object literal for the '<em><b>Precondition</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_RULE__PRECONDITION = eINSTANCE.getGTRule_Precondition();

		/**
		 * The meta object literal for the '<em><b>Local Variables</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_RULE__LOCAL_VARIABLES = eINSTANCE.getGTRule_LocalVariables();

		/**
		 * The meta object literal for the '<em><b>Action</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_RULE__ACTION = eINSTANCE.getGTRule_Action();

		/**
		 * The meta object literal for the '<em><b>Postcondition</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_RULE__POSTCONDITION = eINSTANCE.getGTRule_Postcondition();

		/**
		 * The meta object literal for the '<em><b>Local Pattern Definition</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_RULE__LOCAL_PATTERN_DEFINITION = eINSTANCE.getGTRule_LocalPatternDefinition();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_RULE__NAMESPACE = eINSTANCE.getGTRule_Namespace();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.ContainmentConstraintImpl <em>Containment Constraint</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.ContainmentConstraintImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getContainmentConstraint()
		 * @generated
		 */
		EClass CONTAINMENT_CONSTRAINT = eINSTANCE.getContainmentConstraint();

		/**
		 * The meta object literal for the '<em><b>Variable</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTAINMENT_CONSTRAINT__VARIABLE = eINSTANCE.getContainmentConstraint_Variable();

		/**
		 * The meta object literal for the '<em><b>Mode</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONTAINMENT_CONSTRAINT__MODE = eINSTANCE.getContainmentConstraint_Mode();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTAINMENT_CONSTRAINT__PARENT = eINSTANCE.getContainmentConstraint_Parent();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTMatchCounterImpl <em>GT Match Counter</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTMatchCounterImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getGTMatchCounter()
		 * @generated
		 */
		EClass GT_MATCH_COUNTER = eINSTANCE.getGTMatchCounter();

		/**
		 * The meta object literal for the '<em><b>Pattern Call</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_MATCH_COUNTER__PATTERN_CALL = eINSTANCE.getGTMatchCounter_PatternCall();

		/**
		 * The meta object literal for the '<em><b>Variable Reference</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference GT_MATCH_COUNTER__VARIABLE_REFERENCE = eINSTANCE.getGTMatchCounter_VariableReference();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.NonInjectivityConstraintImpl <em>Non Injectivity Constraint</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.NonInjectivityConstraintImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getNonInjectivityConstraint()
		 * @generated
		 */
		EClass NON_INJECTIVITY_CONSTRAINT = eINSTANCE.getNonInjectivityConstraint();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableConstraintImpl <em>Pattern Variable Constraint</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.PatternVariableConstraintImpl
		 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GtPackageImpl#getPatternVariableConstraint()
		 * @generated
		 */
		EClass PATTERN_VARIABLE_CONSTRAINT = eINSTANCE.getPatternVariableConstraint();

		/**
		 * The meta object literal for the '<em><b>Left Value</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PATTERN_VARIABLE_CONSTRAINT__LEFT_VALUE = eINSTANCE.getPatternVariableConstraint_LeftValue();

		/**
		 * The meta object literal for the '<em><b>Right Value</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PATTERN_VARIABLE_CONSTRAINT__RIGHT_VALUE = eINSTANCE.getPatternVariableConstraint_RightValue();

	}

} //GtPackage
