/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.impl.GTASMElementImpl;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GtPackage;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.NonInjectivityConstraint;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariable;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.PatternVariableAssignment;

import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>GT Pattern Body</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getNegativePatterns <em>Negative Patterns</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getLocalVariables <em>Local Variables</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getCalledPatterns <em>Called Patterns</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getCheckExpressions <em>Check Expressions</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getPatternGraph <em>Pattern Graph</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getContainmentConstraints <em>Containment Constraints</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getLocalPatternDefinition <em>Local Pattern Definition</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getVariableAssignments <em>Variable Assignments</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getHeader <em>Header</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getElementWrappers <em>Element Wrappers</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getDanglingRelationships <em>Dangling Relationships</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getDanglingRelations <em>Dangling Relations</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl.GTPatternBodyImpl#getNonInjectivityConstraints <em>Non Injectivity Constraints</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class GTPatternBodyImpl extends GTASMElementImpl implements GTPatternBody {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * The cached value of the '{@link #getNegativePatterns() <em>Negative Patterns</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNegativePatterns()
	 * @generated
	 * @ordered
	 */
	protected EList<GTPatternCall> negativePatterns;

	/**
	 * The cached value of the '{@link #getLocalVariables() <em>Local Variables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocalVariables()
	 * @generated
	 * @ordered
	 */
	protected EList<PatternVariable> localVariables;

	/**
	 * The cached value of the '{@link #getCalledPatterns() <em>Called Patterns</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCalledPatterns()
	 * @generated
	 * @ordered
	 */
	protected EList<GTPatternCall> calledPatterns;

	/**
	 * The cached value of the '{@link #getCheckExpressions() <em>Check Expressions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCheckExpressions()
	 * @generated
	 * @ordered
	 */
	protected EList<Term> checkExpressions;

	/**
	 * The cached value of the '{@link #getPatternGraph() <em>Pattern Graph</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPatternGraph()
	 * @generated
	 * @ordered
	 */
	protected Entity patternGraph;

	/**
	 * The cached value of the '{@link #getContainmentConstraints() <em>Containment Constraints</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainmentConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<ContainmentConstraint> containmentConstraints;

	/**
	 * The cached value of the '{@link #getLocalPatternDefinition() <em>Local Pattern Definition</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLocalPatternDefinition()
	 * @generated
	 * @ordered
	 */
	protected EList<GTPattern> localPatternDefinition;

	/**
	 * The cached value of the '{@link #getVariableAssignments() <em>Variable Assignments</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getVariableAssignments()
	 * @generated
	 * @ordered
	 */
	protected EList<PatternVariableAssignment> variableAssignments;

	/**
	 * The cached value of the '{@link #getElementWrappers() <em>Element Wrappers</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getElementWrappers()
	 * @generated
	 * @ordered
	 */
	protected EList<ModelElement> elementWrappers;

	/**
	 * The cached value of the '{@link #getDanglingRelationships() <em>Dangling Relationships</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDanglingRelationships()
	 * @generated
	 * @ordered
	 */
	protected EList<Relationship> danglingRelationships;

	/**
	 * The cached value of the '{@link #getDanglingRelations() <em>Dangling Relations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDanglingRelations()
	 * @generated
	 * @ordered
	 */
	protected EList<Relation> danglingRelations;

	/**
	 * The cached value of the '{@link #getNonInjectivityConstraints() <em>Non Injectivity Constraints</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNonInjectivityConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<NonInjectivityConstraint> nonInjectivityConstraints;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GTPatternBodyImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return GtPackage.Literals.GT_PATTERN_BODY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GTPatternCall> getNegativePatterns() {
		if (negativePatterns == null) {
			negativePatterns = new EObjectContainmentEList<GTPatternCall>(GTPatternCall.class, this, GtPackage.GT_PATTERN_BODY__NEGATIVE_PATTERNS);
		}
		return negativePatterns;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PatternVariable> getLocalVariables() {
		if (localVariables == null) {
			localVariables = new EObjectContainmentEList<PatternVariable>(PatternVariable.class, this, GtPackage.GT_PATTERN_BODY__LOCAL_VARIABLES);
		}
		return localVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GTPatternCall> getCalledPatterns() {
		if (calledPatterns == null) {
			calledPatterns = new EObjectContainmentEList<GTPatternCall>(GTPatternCall.class, this, GtPackage.GT_PATTERN_BODY__CALLED_PATTERNS);
		}
		return calledPatterns;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Term> getCheckExpressions() {
		if (checkExpressions == null) {
			checkExpressions = new EObjectContainmentEList<Term>(Term.class, this, GtPackage.GT_PATTERN_BODY__CHECK_EXPRESSIONS);
		}
		return checkExpressions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Entity getPatternGraph() {
		return patternGraph;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPatternGraph(Entity newPatternGraph, NotificationChain msgs) {
		Entity oldPatternGraph = patternGraph;
		patternGraph = newPatternGraph;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH, oldPatternGraph, newPatternGraph);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPatternGraph(Entity newPatternGraph) {
		if (newPatternGraph != patternGraph) {
			NotificationChain msgs = null;
			if (patternGraph != null)
				msgs = ((InternalEObject)patternGraph).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH, null, msgs);
			if (newPatternGraph != null)
				msgs = ((InternalEObject)newPatternGraph).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH, null, msgs);
			msgs = basicSetPatternGraph(newPatternGraph, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH, newPatternGraph, newPatternGraph));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ContainmentConstraint> getContainmentConstraints() {
		if (containmentConstraints == null) {
			containmentConstraints = new EObjectContainmentEList<ContainmentConstraint>(ContainmentConstraint.class, this, GtPackage.GT_PATTERN_BODY__CONTAINMENT_CONSTRAINTS);
		}
		return containmentConstraints;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<GTPattern> getLocalPatternDefinition() {
		if (localPatternDefinition == null) {
			localPatternDefinition = new EObjectContainmentEList<GTPattern>(GTPattern.class, this, GtPackage.GT_PATTERN_BODY__LOCAL_PATTERN_DEFINITION);
		}
		return localPatternDefinition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<PatternVariableAssignment> getVariableAssignments() {
		if (variableAssignments == null) {
			variableAssignments = new EObjectContainmentEList<PatternVariableAssignment>(PatternVariableAssignment.class, this, GtPackage.GT_PATTERN_BODY__VARIABLE_ASSIGNMENTS);
		}
		return variableAssignments;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTPattern getHeader() {
		if (eContainerFeatureID() != GtPackage.GT_PATTERN_BODY__HEADER) return null;
		return (GTPattern)eContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetHeader(GTPattern newHeader, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newHeader, GtPackage.GT_PATTERN_BODY__HEADER, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setHeader(GTPattern newHeader) {
		if (newHeader != eInternalContainer() || (eContainerFeatureID() != GtPackage.GT_PATTERN_BODY__HEADER && newHeader != null)) {
			if (EcoreUtil.isAncestor(this, newHeader))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newHeader != null)
				msgs = ((InternalEObject)newHeader).eInverseAdd(this, GtPackage.GT_PATTERN__PATTERN_BODIES, GTPattern.class, msgs);
			msgs = basicSetHeader(newHeader, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, GtPackage.GT_PATTERN_BODY__HEADER, newHeader, newHeader));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ModelElement> getElementWrappers() {
		if (elementWrappers == null) {
			elementWrappers = new EObjectContainmentEList<ModelElement>(ModelElement.class, this, GtPackage.GT_PATTERN_BODY__ELEMENT_WRAPPERS);
		}
		return elementWrappers;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relationship> getDanglingRelationships() {
		if (danglingRelationships == null) {
			danglingRelationships = new EObjectContainmentEList<Relationship>(Relationship.class, this, GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONSHIPS);
		}
		return danglingRelationships;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relation> getDanglingRelations() {
		if (danglingRelations == null) {
			danglingRelations = new EObjectContainmentEList<Relation>(Relation.class, this, GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONS);
		}
		return danglingRelations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<NonInjectivityConstraint> getNonInjectivityConstraints() {
		if (nonInjectivityConstraints == null) {
			nonInjectivityConstraints = new EObjectContainmentEList<NonInjectivityConstraint>(NonInjectivityConstraint.class, this, GtPackage.GT_PATTERN_BODY__NON_INJECTIVITY_CONSTRAINTS);
		}
		return nonInjectivityConstraints;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case GtPackage.GT_PATTERN_BODY__HEADER:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetHeader((GTPattern)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case GtPackage.GT_PATTERN_BODY__NEGATIVE_PATTERNS:
				return ((InternalEList<?>)getNegativePatterns()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__LOCAL_VARIABLES:
				return ((InternalEList<?>)getLocalVariables()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__CALLED_PATTERNS:
				return ((InternalEList<?>)getCalledPatterns()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__CHECK_EXPRESSIONS:
				return ((InternalEList<?>)getCheckExpressions()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH:
				return basicSetPatternGraph(null, msgs);
			case GtPackage.GT_PATTERN_BODY__CONTAINMENT_CONSTRAINTS:
				return ((InternalEList<?>)getContainmentConstraints()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__LOCAL_PATTERN_DEFINITION:
				return ((InternalEList<?>)getLocalPatternDefinition()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__VARIABLE_ASSIGNMENTS:
				return ((InternalEList<?>)getVariableAssignments()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__HEADER:
				return basicSetHeader(null, msgs);
			case GtPackage.GT_PATTERN_BODY__ELEMENT_WRAPPERS:
				return ((InternalEList<?>)getElementWrappers()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONSHIPS:
				return ((InternalEList<?>)getDanglingRelationships()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONS:
				return ((InternalEList<?>)getDanglingRelations()).basicRemove(otherEnd, msgs);
			case GtPackage.GT_PATTERN_BODY__NON_INJECTIVITY_CONSTRAINTS:
				return ((InternalEList<?>)getNonInjectivityConstraints()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case GtPackage.GT_PATTERN_BODY__HEADER:
				return eInternalContainer().eInverseRemove(this, GtPackage.GT_PATTERN__PATTERN_BODIES, GTPattern.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case GtPackage.GT_PATTERN_BODY__NEGATIVE_PATTERNS:
				return getNegativePatterns();
			case GtPackage.GT_PATTERN_BODY__LOCAL_VARIABLES:
				return getLocalVariables();
			case GtPackage.GT_PATTERN_BODY__CALLED_PATTERNS:
				return getCalledPatterns();
			case GtPackage.GT_PATTERN_BODY__CHECK_EXPRESSIONS:
				return getCheckExpressions();
			case GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH:
				return getPatternGraph();
			case GtPackage.GT_PATTERN_BODY__CONTAINMENT_CONSTRAINTS:
				return getContainmentConstraints();
			case GtPackage.GT_PATTERN_BODY__LOCAL_PATTERN_DEFINITION:
				return getLocalPatternDefinition();
			case GtPackage.GT_PATTERN_BODY__VARIABLE_ASSIGNMENTS:
				return getVariableAssignments();
			case GtPackage.GT_PATTERN_BODY__HEADER:
				return getHeader();
			case GtPackage.GT_PATTERN_BODY__ELEMENT_WRAPPERS:
				return getElementWrappers();
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONSHIPS:
				return getDanglingRelationships();
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONS:
				return getDanglingRelations();
			case GtPackage.GT_PATTERN_BODY__NON_INJECTIVITY_CONSTRAINTS:
				return getNonInjectivityConstraints();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case GtPackage.GT_PATTERN_BODY__NEGATIVE_PATTERNS:
				getNegativePatterns().clear();
				getNegativePatterns().addAll((Collection<? extends GTPatternCall>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__LOCAL_VARIABLES:
				getLocalVariables().clear();
				getLocalVariables().addAll((Collection<? extends PatternVariable>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__CALLED_PATTERNS:
				getCalledPatterns().clear();
				getCalledPatterns().addAll((Collection<? extends GTPatternCall>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__CHECK_EXPRESSIONS:
				getCheckExpressions().clear();
				getCheckExpressions().addAll((Collection<? extends Term>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH:
				setPatternGraph((Entity)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__CONTAINMENT_CONSTRAINTS:
				getContainmentConstraints().clear();
				getContainmentConstraints().addAll((Collection<? extends ContainmentConstraint>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__LOCAL_PATTERN_DEFINITION:
				getLocalPatternDefinition().clear();
				getLocalPatternDefinition().addAll((Collection<? extends GTPattern>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__VARIABLE_ASSIGNMENTS:
				getVariableAssignments().clear();
				getVariableAssignments().addAll((Collection<? extends PatternVariableAssignment>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__HEADER:
				setHeader((GTPattern)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__ELEMENT_WRAPPERS:
				getElementWrappers().clear();
				getElementWrappers().addAll((Collection<? extends ModelElement>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONSHIPS:
				getDanglingRelationships().clear();
				getDanglingRelationships().addAll((Collection<? extends Relationship>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONS:
				getDanglingRelations().clear();
				getDanglingRelations().addAll((Collection<? extends Relation>)newValue);
				return;
			case GtPackage.GT_PATTERN_BODY__NON_INJECTIVITY_CONSTRAINTS:
				getNonInjectivityConstraints().clear();
				getNonInjectivityConstraints().addAll((Collection<? extends NonInjectivityConstraint>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case GtPackage.GT_PATTERN_BODY__NEGATIVE_PATTERNS:
				getNegativePatterns().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__LOCAL_VARIABLES:
				getLocalVariables().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__CALLED_PATTERNS:
				getCalledPatterns().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__CHECK_EXPRESSIONS:
				getCheckExpressions().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH:
				setPatternGraph((Entity)null);
				return;
			case GtPackage.GT_PATTERN_BODY__CONTAINMENT_CONSTRAINTS:
				getContainmentConstraints().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__LOCAL_PATTERN_DEFINITION:
				getLocalPatternDefinition().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__VARIABLE_ASSIGNMENTS:
				getVariableAssignments().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__HEADER:
				setHeader((GTPattern)null);
				return;
			case GtPackage.GT_PATTERN_BODY__ELEMENT_WRAPPERS:
				getElementWrappers().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONSHIPS:
				getDanglingRelationships().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONS:
				getDanglingRelations().clear();
				return;
			case GtPackage.GT_PATTERN_BODY__NON_INJECTIVITY_CONSTRAINTS:
				getNonInjectivityConstraints().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case GtPackage.GT_PATTERN_BODY__NEGATIVE_PATTERNS:
				return negativePatterns != null && !negativePatterns.isEmpty();
			case GtPackage.GT_PATTERN_BODY__LOCAL_VARIABLES:
				return localVariables != null && !localVariables.isEmpty();
			case GtPackage.GT_PATTERN_BODY__CALLED_PATTERNS:
				return calledPatterns != null && !calledPatterns.isEmpty();
			case GtPackage.GT_PATTERN_BODY__CHECK_EXPRESSIONS:
				return checkExpressions != null && !checkExpressions.isEmpty();
			case GtPackage.GT_PATTERN_BODY__PATTERN_GRAPH:
				return patternGraph != null;
			case GtPackage.GT_PATTERN_BODY__CONTAINMENT_CONSTRAINTS:
				return containmentConstraints != null && !containmentConstraints.isEmpty();
			case GtPackage.GT_PATTERN_BODY__LOCAL_PATTERN_DEFINITION:
				return localPatternDefinition != null && !localPatternDefinition.isEmpty();
			case GtPackage.GT_PATTERN_BODY__VARIABLE_ASSIGNMENTS:
				return variableAssignments != null && !variableAssignments.isEmpty();
			case GtPackage.GT_PATTERN_BODY__HEADER:
				return getHeader() != null;
			case GtPackage.GT_PATTERN_BODY__ELEMENT_WRAPPERS:
				return elementWrappers != null && !elementWrappers.isEmpty();
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONSHIPS:
				return danglingRelationships != null && !danglingRelationships.isEmpty();
			case GtPackage.GT_PATTERN_BODY__DANGLING_RELATIONS:
				return danglingRelations != null && !danglingRelations.isEmpty();
			case GtPackage.GT_PATTERN_BODY__NON_INJECTIVITY_CONSTRAINTS:
				return nonInjectivityConstraints != null && !nonInjectivityConstraints.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //GTPatternBodyImpl
