/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class GtFactoryImpl extends EFactoryImpl implements GtFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static GtFactory init() {
		try {
			GtFactory theGtFactory = (GtFactory)EPackage.Registry.INSTANCE.getEFactory("http:///viatragtasmmodel/gtasm/metamodel/gt.ecore"); 
			if (theGtFactory != null) {
				return theGtFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new GtFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GtFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case GtPackage.GT_PATTERN_BODY: return createGTPatternBody();
			case GtPackage.GT_PATTERN: return createGTPattern();
			case GtPackage.PATTERN_VARIABLE: return createPatternVariable();
			case GtPackage.PATTERN_VARIABLE_ASSIGNMENT: return createPatternVariableAssignment();
			case GtPackage.GT_RULE: return createGTRule();
			case GtPackage.CONTAINMENT_CONSTRAINT: return createContainmentConstraint();
			case GtPackage.GT_MATCH_COUNTER: return createGTMatchCounter();
			case GtPackage.NON_INJECTIVITY_CONSTRAINT: return createNonInjectivityConstraint();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTPatternBody createGTPatternBody() {
		GTPatternBodyImpl gtPatternBody = new GTPatternBodyImpl();
		return gtPatternBody;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTPattern createGTPattern() {
		GTPatternImpl gtPattern = new GTPatternImpl();
		return gtPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PatternVariable createPatternVariable() {
		PatternVariableImpl patternVariable = new PatternVariableImpl();
		return patternVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PatternVariableAssignment createPatternVariableAssignment() {
		PatternVariableAssignmentImpl patternVariableAssignment = new PatternVariableAssignmentImpl();
		return patternVariableAssignment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTRule createGTRule() {
		GTRuleImpl gtRule = new GTRuleImpl();
		return gtRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ContainmentConstraint createContainmentConstraint() {
		ContainmentConstraintImpl containmentConstraint = new ContainmentConstraintImpl();
		return containmentConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTMatchCounter createGTMatchCounter() {
		GTMatchCounterImpl gtMatchCounter = new GTMatchCounterImpl();
		return gtMatchCounter;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NonInjectivityConstraint createNonInjectivityConstraint() {
		NonInjectivityConstraintImpl nonInjectivityConstraint = new NonInjectivityConstraintImpl();
		return nonInjectivityConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GtPackage getGtPackage() {
		return (GtPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static GtPackage getPackage() {
		return GtPackage.eINSTANCE;
	}

} //GtFactoryImpl
