/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.copymove.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.impl.ModelManipulationRuleImpl;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.copymove.CopymovePackage;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.copymove.MoveRule;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Move Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.copymove.impl.MoveRuleImpl#getTrgContainer <em>Trg Container</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.copymove.impl.MoveRuleImpl#getSrcRoot <em>Src Root</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MoveRuleImpl extends ModelManipulationRuleImpl implements MoveRule {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * The cached value of the '{@link #getTrgContainer() <em>Trg Container</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTrgContainer()
	 * @generated
	 * @ordered
	 */
	protected Term trgContainer;

	/**
	 * The cached value of the '{@link #getSrcRoot() <em>Src Root</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSrcRoot()
	 * @generated
	 * @ordered
	 */
	protected Term srcRoot;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MoveRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CopymovePackage.Literals.MOVE_RULE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Term getTrgContainer() {
		return trgContainer;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTrgContainer(Term newTrgContainer, NotificationChain msgs) {
		Term oldTrgContainer = trgContainer;
		trgContainer = newTrgContainer;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CopymovePackage.MOVE_RULE__TRG_CONTAINER, oldTrgContainer, newTrgContainer);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTrgContainer(Term newTrgContainer) {
		if (newTrgContainer != trgContainer) {
			NotificationChain msgs = null;
			if (trgContainer != null)
				msgs = ((InternalEObject)trgContainer).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CopymovePackage.MOVE_RULE__TRG_CONTAINER, null, msgs);
			if (newTrgContainer != null)
				msgs = ((InternalEObject)newTrgContainer).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CopymovePackage.MOVE_RULE__TRG_CONTAINER, null, msgs);
			msgs = basicSetTrgContainer(newTrgContainer, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CopymovePackage.MOVE_RULE__TRG_CONTAINER, newTrgContainer, newTrgContainer));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Term getSrcRoot() {
		return srcRoot;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetSrcRoot(Term newSrcRoot, NotificationChain msgs) {
		Term oldSrcRoot = srcRoot;
		srcRoot = newSrcRoot;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CopymovePackage.MOVE_RULE__SRC_ROOT, oldSrcRoot, newSrcRoot);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSrcRoot(Term newSrcRoot) {
		if (newSrcRoot != srcRoot) {
			NotificationChain msgs = null;
			if (srcRoot != null)
				msgs = ((InternalEObject)srcRoot).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CopymovePackage.MOVE_RULE__SRC_ROOT, null, msgs);
			if (newSrcRoot != null)
				msgs = ((InternalEObject)newSrcRoot).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CopymovePackage.MOVE_RULE__SRC_ROOT, null, msgs);
			msgs = basicSetSrcRoot(newSrcRoot, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CopymovePackage.MOVE_RULE__SRC_ROOT, newSrcRoot, newSrcRoot));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CopymovePackage.MOVE_RULE__TRG_CONTAINER:
				return basicSetTrgContainer(null, msgs);
			case CopymovePackage.MOVE_RULE__SRC_ROOT:
				return basicSetSrcRoot(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CopymovePackage.MOVE_RULE__TRG_CONTAINER:
				return getTrgContainer();
			case CopymovePackage.MOVE_RULE__SRC_ROOT:
				return getSrcRoot();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CopymovePackage.MOVE_RULE__TRG_CONTAINER:
				setTrgContainer((Term)newValue);
				return;
			case CopymovePackage.MOVE_RULE__SRC_ROOT:
				setSrcRoot((Term)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CopymovePackage.MOVE_RULE__TRG_CONTAINER:
				setTrgContainer((Term)null);
				return;
			case CopymovePackage.MOVE_RULE__SRC_ROOT:
				setSrcRoot((Term)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CopymovePackage.MOVE_RULE__TRG_CONTAINER:
				return trgContainer != null;
			case CopymovePackage.MOVE_RULE__SRC_ROOT:
				return srcRoot != null;
		}
		return super.eIsSet(featureID);
	}

} //MoveRuleImpl
