/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.update;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.update.UpdatePackage
 * @generated
 */
public interface UpdateFactory extends EFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	UpdateFactory eINSTANCE = org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.update.impl.UpdateFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Rename Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rename Rule</em>'.
	 * @generated
	 */
	RenameRule createRenameRule();

	/**
	 * Returns a new object of class '<em>Set Value Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Value Rule</em>'.
	 * @generated
	 */
	SetValueRule createSetValueRule();

	/**
	 * Returns a new object of class '<em>Set Relation To</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Relation To</em>'.
	 * @generated
	 */
	SetRelationTo createSetRelationTo();

	/**
	 * Returns a new object of class '<em>Set Relation From</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Relation From</em>'.
	 * @generated
	 */
	SetRelationFrom createSetRelationFrom();

	/**
	 * Returns a new object of class '<em>Set Multiplicity Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Multiplicity Rule</em>'.
	 * @generated
	 */
	SetMultiplicityRule createSetMultiplicityRule();

	/**
	 * Returns a new object of class '<em>Set Inverse Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Inverse Rule</em>'.
	 * @generated
	 */
	SetInverseRule createSetInverseRule();

	/**
	 * Returns a new object of class '<em>Set Any Target Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Any Target Rule</em>'.
	 * @generated
	 */
	SetAnyTargetRule createSetAnyTargetRule();

	/**
	 * Returns a new object of class '<em>Set Any Source Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Any Source Rule</em>'.
	 * @generated
	 */
	SetAnySourceRule createSetAnySourceRule();

	/**
	 * Returns a new object of class '<em>Set Aggregation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Set Aggregation Rule</em>'.
	 * @generated
	 */
	SetAggregationRule createSetAggregationRule();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	UpdatePackage getUpdatePackage();

} //UpdateFactory
