/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.update.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.update.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class UpdateFactoryImpl extends EFactoryImpl implements UpdateFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static UpdateFactory init() {
		try {
			UpdateFactory theUpdateFactory = (UpdateFactory)EPackage.Registry.INSTANCE.getEFactory("http:///viatragtasmmodel/gtasm/metamodel/modelmanagement/manipulationRules/update.ecore"); 
			if (theUpdateFactory != null) {
				return theUpdateFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new UpdateFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UpdateFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case UpdatePackage.RENAME_RULE: return createRenameRule();
			case UpdatePackage.SET_VALUE_RULE: return createSetValueRule();
			case UpdatePackage.SET_RELATION_TO: return createSetRelationTo();
			case UpdatePackage.SET_RELATION_FROM: return createSetRelationFrom();
			case UpdatePackage.SET_MULTIPLICITY_RULE: return createSetMultiplicityRule();
			case UpdatePackage.SET_INVERSE_RULE: return createSetInverseRule();
			case UpdatePackage.SET_ANY_TARGET_RULE: return createSetAnyTargetRule();
			case UpdatePackage.SET_ANY_SOURCE_RULE: return createSetAnySourceRule();
			case UpdatePackage.SET_AGGREGATION_RULE: return createSetAggregationRule();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RenameRule createRenameRule() {
		RenameRuleImpl renameRule = new RenameRuleImpl();
		return renameRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SetValueRule createSetValueRule() {
		SetValueRuleImpl setValueRule = new SetValueRuleImpl();
		return setValueRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SetRelationTo createSetRelationTo() {
		SetRelationToImpl setRelationTo = new SetRelationToImpl();
		return setRelationTo;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SetRelationFrom createSetRelationFrom() {
		SetRelationFromImpl setRelationFrom = new SetRelationFromImpl();
		return setRelationFrom;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SetMultiplicityRule createSetMultiplicityRule() {
		SetMultiplicityRuleImpl setMultiplicityRule = new SetMultiplicityRuleImpl();
		return setMultiplicityRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SetInverseRule createSetInverseRule() {
		SetInverseRuleImpl setInverseRule = new SetInverseRuleImpl();
		return setInverseRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SetAnyTargetRule createSetAnyTargetRule() {
		SetAnyTargetRuleImpl setAnyTargetRule = new SetAnyTargetRuleImpl();
		return setAnyTargetRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SetAnySourceRule createSetAnySourceRule() {
		SetAnySourceRuleImpl setAnySourceRule = new SetAnySourceRuleImpl();
		return setAnySourceRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SetAggregationRule createSetAggregationRule() {
		SetAggregationRuleImpl setAggregationRule = new SetAggregationRuleImpl();
		return setAggregationRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UpdatePackage getUpdatePackage() {
		return (UpdatePackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static UpdatePackage getPackage() {
		return UpdatePackage.eINSTANCE;
	}

} //UpdateFactoryImpl
