/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.update.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.GTASMElement;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.ASMRuleInvocation;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.ModelManipulationRule;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.update.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.update.UpdatePackage
 * @generated
 */
public class UpdateSwitch<T> {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static UpdatePackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UpdateSwitch() {
		if (modelPackage == null) {
			modelPackage = UpdatePackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case UpdatePackage.RENAME_RULE: {
				RenameRule renameRule = (RenameRule)theEObject;
				T result = caseRenameRule(renameRule);
				if (result == null) result = caseSetRule(renameRule);
				if (result == null) result = caseModelManipulationRule(renameRule);
				if (result == null) result = caseASMRuleInvocation(renameRule);
				if (result == null) result = caseGTASMElement(renameRule);
				if (result == null) result = caseAnnotatedElement(renameRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_RULE: {
				SetRule setRule = (SetRule)theEObject;
				T result = caseSetRule(setRule);
				if (result == null) result = caseModelManipulationRule(setRule);
				if (result == null) result = caseASMRuleInvocation(setRule);
				if (result == null) result = caseGTASMElement(setRule);
				if (result == null) result = caseAnnotatedElement(setRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_VALUE_RULE: {
				SetValueRule setValueRule = (SetValueRule)theEObject;
				T result = caseSetValueRule(setValueRule);
				if (result == null) result = caseSetRule(setValueRule);
				if (result == null) result = caseModelManipulationRule(setValueRule);
				if (result == null) result = caseASMRuleInvocation(setValueRule);
				if (result == null) result = caseGTASMElement(setValueRule);
				if (result == null) result = caseAnnotatedElement(setValueRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_RELATION_TO: {
				SetRelationTo setRelationTo = (SetRelationTo)theEObject;
				T result = caseSetRelationTo(setRelationTo);
				if (result == null) result = caseSetRelationEndPoint(setRelationTo);
				if (result == null) result = caseSetRule(setRelationTo);
				if (result == null) result = caseModelManipulationRule(setRelationTo);
				if (result == null) result = caseASMRuleInvocation(setRelationTo);
				if (result == null) result = caseGTASMElement(setRelationTo);
				if (result == null) result = caseAnnotatedElement(setRelationTo);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_RELATION_END_POINT: {
				SetRelationEndPoint setRelationEndPoint = (SetRelationEndPoint)theEObject;
				T result = caseSetRelationEndPoint(setRelationEndPoint);
				if (result == null) result = caseSetRule(setRelationEndPoint);
				if (result == null) result = caseModelManipulationRule(setRelationEndPoint);
				if (result == null) result = caseASMRuleInvocation(setRelationEndPoint);
				if (result == null) result = caseGTASMElement(setRelationEndPoint);
				if (result == null) result = caseAnnotatedElement(setRelationEndPoint);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_RELATION_FROM: {
				SetRelationFrom setRelationFrom = (SetRelationFrom)theEObject;
				T result = caseSetRelationFrom(setRelationFrom);
				if (result == null) result = caseSetRelationEndPoint(setRelationFrom);
				if (result == null) result = caseSetRule(setRelationFrom);
				if (result == null) result = caseModelManipulationRule(setRelationFrom);
				if (result == null) result = caseASMRuleInvocation(setRelationFrom);
				if (result == null) result = caseGTASMElement(setRelationFrom);
				if (result == null) result = caseAnnotatedElement(setRelationFrom);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_MULTIPLICITY_RULE: {
				SetMultiplicityRule setMultiplicityRule = (SetMultiplicityRule)theEObject;
				T result = caseSetMultiplicityRule(setMultiplicityRule);
				if (result == null) result = caseSetRule(setMultiplicityRule);
				if (result == null) result = caseModelManipulationRule(setMultiplicityRule);
				if (result == null) result = caseASMRuleInvocation(setMultiplicityRule);
				if (result == null) result = caseGTASMElement(setMultiplicityRule);
				if (result == null) result = caseAnnotatedElement(setMultiplicityRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_INVERSE_RULE: {
				SetInverseRule setInverseRule = (SetInverseRule)theEObject;
				T result = caseSetInverseRule(setInverseRule);
				if (result == null) result = caseSetRule(setInverseRule);
				if (result == null) result = caseModelManipulationRule(setInverseRule);
				if (result == null) result = caseASMRuleInvocation(setInverseRule);
				if (result == null) result = caseGTASMElement(setInverseRule);
				if (result == null) result = caseAnnotatedElement(setInverseRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_ANY_TARGET_RULE: {
				SetAnyTargetRule setAnyTargetRule = (SetAnyTargetRule)theEObject;
				T result = caseSetAnyTargetRule(setAnyTargetRule);
				if (result == null) result = caseSetAnyEndpointRule(setAnyTargetRule);
				if (result == null) result = caseSetRule(setAnyTargetRule);
				if (result == null) result = caseModelManipulationRule(setAnyTargetRule);
				if (result == null) result = caseASMRuleInvocation(setAnyTargetRule);
				if (result == null) result = caseGTASMElement(setAnyTargetRule);
				if (result == null) result = caseAnnotatedElement(setAnyTargetRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_ANY_ENDPOINT_RULE: {
				SetAnyEndpointRule setAnyEndpointRule = (SetAnyEndpointRule)theEObject;
				T result = caseSetAnyEndpointRule(setAnyEndpointRule);
				if (result == null) result = caseSetRule(setAnyEndpointRule);
				if (result == null) result = caseModelManipulationRule(setAnyEndpointRule);
				if (result == null) result = caseASMRuleInvocation(setAnyEndpointRule);
				if (result == null) result = caseGTASMElement(setAnyEndpointRule);
				if (result == null) result = caseAnnotatedElement(setAnyEndpointRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_ANY_SOURCE_RULE: {
				SetAnySourceRule setAnySourceRule = (SetAnySourceRule)theEObject;
				T result = caseSetAnySourceRule(setAnySourceRule);
				if (result == null) result = caseSetAnyEndpointRule(setAnySourceRule);
				if (result == null) result = caseSetRule(setAnySourceRule);
				if (result == null) result = caseModelManipulationRule(setAnySourceRule);
				if (result == null) result = caseASMRuleInvocation(setAnySourceRule);
				if (result == null) result = caseGTASMElement(setAnySourceRule);
				if (result == null) result = caseAnnotatedElement(setAnySourceRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case UpdatePackage.SET_AGGREGATION_RULE: {
				SetAggregationRule setAggregationRule = (SetAggregationRule)theEObject;
				T result = caseSetAggregationRule(setAggregationRule);
				if (result == null) result = caseSetRule(setAggregationRule);
				if (result == null) result = caseModelManipulationRule(setAggregationRule);
				if (result == null) result = caseASMRuleInvocation(setAggregationRule);
				if (result == null) result = caseGTASMElement(setAggregationRule);
				if (result == null) result = caseAnnotatedElement(setAggregationRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rename Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rename Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRenameRule(RenameRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetRule(SetRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Value Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Value Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetValueRule(SetValueRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Relation To</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Relation To</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetRelationTo(SetRelationTo object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Relation End Point</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Relation End Point</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetRelationEndPoint(SetRelationEndPoint object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Relation From</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Relation From</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetRelationFrom(SetRelationFrom object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Multiplicity Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Multiplicity Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetMultiplicityRule(SetMultiplicityRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Inverse Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Inverse Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetInverseRule(SetInverseRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Any Target Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Any Target Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetAnyTargetRule(SetAnyTargetRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Any Endpoint Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Any Endpoint Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetAnyEndpointRule(SetAnyEndpointRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Any Source Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Any Source Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetAnySourceRule(SetAnySourceRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Set Aggregation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Set Aggregation Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSetAggregationRule(SetAggregationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Annotated Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnnotatedElement(AnnotatedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>GTASM Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>GTASM Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGTASMElement(GTASMElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ASM Rule Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ASM Rule Invocation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseASMRuleInvocation(ASMRuleInvocation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Model Manipulation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Model Manipulation Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModelManipulationRule(ModelManipulationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //UpdateSwitch
