/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.vpm.editmodel;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.CorePackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelFactory
 * @model kind="package"
 * @generated
 */
public interface EditmodelPackage extends EPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "editmodel";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///viatragtasmmodel/vpm/editmodel.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "viatragtasmmodel.vpm.editmodel";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	EditmodelPackage eINSTANCE = org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.VPMElementImpl <em>VPM Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.VPMElementImpl
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getVPMElement()
	 * @generated
	 */
	int VPM_ELEMENT = 6;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VPM_ELEMENT__ANNOTATIONS = CorePackage.ANNOTATED_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Variable References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VPM_ELEMENT__VARIABLE_REFERENCES = CorePackage.ANNOTATED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>VPM Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VPM_ELEMENT_FEATURE_COUNT = CorePackage.ANNOTATED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl <em>Model Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getModelElement()
	 * @generated
	 */
	int MODEL_ELEMENT = 0;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__ANNOTATIONS = VPM_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Variable References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__VARIABLE_REFERENCES = VPM_ELEMENT__VARIABLE_REFERENCES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__TYPE = VPM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__INSTANCE = VPM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Supertype</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__SUPERTYPE = VPM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Subtype</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__SUBTYPE = VPM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Relations To</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__RELATIONS_TO = VPM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Sub Relationships</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__SUB_RELATIONSHIPS = VPM_ELEMENT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Super Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__SUPER_RELATIONSHIPS = VPM_ELEMENT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Type Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__TYPE_STR = VPM_ELEMENT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__NAME = VPM_ELEMENT_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Namespace Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__NAMESPACE_STR = VPM_ELEMENT_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Real Element</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__REAL_ELEMENT = VPM_ELEMENT_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Relations From</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__RELATIONS_FROM = VPM_ELEMENT_FEATURE_COUNT + 11;

	/**
	 * The number of structural features of the '<em>Model Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT_FEATURE_COUNT = VPM_ELEMENT_FEATURE_COUNT + 12;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.RelationshipImpl <em>Relationship</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.RelationshipImpl
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getRelationship()
	 * @generated
	 */
	int RELATIONSHIP = 1;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__ANNOTATIONS = VPM_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Variable References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__VARIABLE_REFERENCES = VPM_ELEMENT__VARIABLE_REFERENCES;

	/**
	 * The feature id for the '<em><b>Client Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__CLIENT_STR = VPM_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Supplier Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__SUPPLIER_STR = VPM_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Client</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__CLIENT = VPM_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Supplier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP__SUPPLIER = VPM_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Relationship</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_FEATURE_COUNT = VPM_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EntityImpl <em>Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EntityImpl
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getEntity()
	 * @generated
	 */
	int ENTITY = 2;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__ANNOTATIONS = MODEL_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Variable References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__VARIABLE_REFERENCES = MODEL_ELEMENT__VARIABLE_REFERENCES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__TYPE = MODEL_ELEMENT__TYPE;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__INSTANCE = MODEL_ELEMENT__INSTANCE;

	/**
	 * The feature id for the '<em><b>Supertype</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__SUPERTYPE = MODEL_ELEMENT__SUPERTYPE;

	/**
	 * The feature id for the '<em><b>Subtype</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__SUBTYPE = MODEL_ELEMENT__SUBTYPE;

	/**
	 * The feature id for the '<em><b>Relations To</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__RELATIONS_TO = MODEL_ELEMENT__RELATIONS_TO;

	/**
	 * The feature id for the '<em><b>Sub Relationships</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__SUB_RELATIONSHIPS = MODEL_ELEMENT__SUB_RELATIONSHIPS;

	/**
	 * The feature id for the '<em><b>Super Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__SUPER_RELATIONSHIPS = MODEL_ELEMENT__SUPER_RELATIONSHIPS;

	/**
	 * The feature id for the '<em><b>Type Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__TYPE_STR = MODEL_ELEMENT__TYPE_STR;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__NAME = MODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Namespace Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__NAMESPACE_STR = MODEL_ELEMENT__NAMESPACE_STR;

	/**
	 * The feature id for the '<em><b>Real Element</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__REAL_ELEMENT = MODEL_ELEMENT__REAL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Relations From</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__RELATIONS_FROM = MODEL_ELEMENT__RELATIONS_FROM;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__PARENT = MODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__COMPONENTS = MODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY__VALUE = MODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENTITY_FEATURE_COUNT = MODEL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.RelationImpl <em>Relation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.RelationImpl
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getRelation()
	 * @generated
	 */
	int RELATION = 3;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__ANNOTATIONS = MODEL_ELEMENT__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Variable References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__VARIABLE_REFERENCES = MODEL_ELEMENT__VARIABLE_REFERENCES;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__TYPE = MODEL_ELEMENT__TYPE;

	/**
	 * The feature id for the '<em><b>Instance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__INSTANCE = MODEL_ELEMENT__INSTANCE;

	/**
	 * The feature id for the '<em><b>Supertype</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__SUPERTYPE = MODEL_ELEMENT__SUPERTYPE;

	/**
	 * The feature id for the '<em><b>Subtype</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__SUBTYPE = MODEL_ELEMENT__SUBTYPE;

	/**
	 * The feature id for the '<em><b>Relations To</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__RELATIONS_TO = MODEL_ELEMENT__RELATIONS_TO;

	/**
	 * The feature id for the '<em><b>Sub Relationships</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__SUB_RELATIONSHIPS = MODEL_ELEMENT__SUB_RELATIONSHIPS;

	/**
	 * The feature id for the '<em><b>Super Relationships</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__SUPER_RELATIONSHIPS = MODEL_ELEMENT__SUPER_RELATIONSHIPS;

	/**
	 * The feature id for the '<em><b>Type Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__TYPE_STR = MODEL_ELEMENT__TYPE_STR;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__NAME = MODEL_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Namespace Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__NAMESPACE_STR = MODEL_ELEMENT__NAMESPACE_STR;

	/**
	 * The feature id for the '<em><b>Real Element</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__REAL_ELEMENT = MODEL_ELEMENT__REAL_ELEMENT;

	/**
	 * The feature id for the '<em><b>Relations From</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__RELATIONS_FROM = MODEL_ELEMENT__RELATIONS_FROM;

	/**
	 * The feature id for the '<em><b>To</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__TO = MODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>From Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__FROM_STR = MODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>To Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__TO_STR = MODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>From</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION__FROM = MODEL_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Relation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATION_FEATURE_COUNT = MODEL_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.TypeOfImpl <em>Type Of</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.TypeOfImpl
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getTypeOf()
	 * @generated
	 */
	int TYPE_OF = 4;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_OF__ANNOTATIONS = RELATIONSHIP__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Variable References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_OF__VARIABLE_REFERENCES = RELATIONSHIP__VARIABLE_REFERENCES;

	/**
	 * The feature id for the '<em><b>Client Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_OF__CLIENT_STR = RELATIONSHIP__CLIENT_STR;

	/**
	 * The feature id for the '<em><b>Supplier Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_OF__SUPPLIER_STR = RELATIONSHIP__SUPPLIER_STR;

	/**
	 * The feature id for the '<em><b>Client</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_OF__CLIENT = RELATIONSHIP__CLIENT;

	/**
	 * The feature id for the '<em><b>Supplier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_OF__SUPPLIER = RELATIONSHIP__SUPPLIER;

	/**
	 * The number of structural features of the '<em>Type Of</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TYPE_OF_FEATURE_COUNT = RELATIONSHIP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.SupertypeOfImpl <em>Supertype Of</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.SupertypeOfImpl
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getSupertypeOf()
	 * @generated
	 */
	int SUPERTYPE_OF = 5;

	/**
	 * The feature id for the '<em><b>Annotations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUPERTYPE_OF__ANNOTATIONS = RELATIONSHIP__ANNOTATIONS;

	/**
	 * The feature id for the '<em><b>Variable References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUPERTYPE_OF__VARIABLE_REFERENCES = RELATIONSHIP__VARIABLE_REFERENCES;

	/**
	 * The feature id for the '<em><b>Client Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUPERTYPE_OF__CLIENT_STR = RELATIONSHIP__CLIENT_STR;

	/**
	 * The feature id for the '<em><b>Supplier Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUPERTYPE_OF__SUPPLIER_STR = RELATIONSHIP__SUPPLIER_STR;

	/**
	 * The feature id for the '<em><b>Client</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUPERTYPE_OF__CLIENT = RELATIONSHIP__CLIENT;

	/**
	 * The feature id for the '<em><b>Supplier</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUPERTYPE_OF__SUPPLIER = RELATIONSHIP__SUPPLIER;

	/**
	 * The number of structural features of the '<em>Supertype Of</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUPERTYPE_OF_FEATURE_COUNT = RELATIONSHIP_FEATURE_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement <em>Model Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Element</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement
	 * @generated
	 */
	EClass getModelElement();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Type</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getType()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_Type();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Instance</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getInstance()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_Instance();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSupertype <em>Supertype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Supertype</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSupertype()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_Supertype();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubtype <em>Subtype</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Subtype</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubtype()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_Subtype();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsTo <em>Relations To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Relations To</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsTo()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_RelationsTo();

	/**
	 * Returns the meta object for the reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubRelationships <em>Sub Relationships</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Sub Relationships</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubRelationships()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_SubRelationships();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSuperRelationships <em>Super Relationships</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Super Relationships</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSuperRelationships()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_SuperRelationships();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getTypeStr <em>Type Str</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type Str</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getTypeStr()
	 * @see #getModelElement()
	 * @generated
	 */
	EAttribute getModelElement_TypeStr();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getName()
	 * @see #getModelElement()
	 * @generated
	 */
	EAttribute getModelElement_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getNamespaceStr <em>Namespace Str</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace Str</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getNamespaceStr()
	 * @see #getModelElement()
	 * @generated
	 */
	EAttribute getModelElement_NamespaceStr();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRealElement <em>Real Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Real Element</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRealElement()
	 * @see #getModelElement()
	 * @generated
	 */
	EAttribute getModelElement_RealElement();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsFrom <em>Relations From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Relations From</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsFrom()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_RelationsFrom();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relationship</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship
	 * @generated
	 */
	EClass getRelationship();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClientStr <em>Client Str</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Client Str</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClientStr()
	 * @see #getRelationship()
	 * @generated
	 */
	EAttribute getRelationship_ClientStr();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplierStr <em>Supplier Str</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Supplier Str</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplierStr()
	 * @see #getRelationship()
	 * @generated
	 */
	EAttribute getRelationship_SupplierStr();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClient <em>Client</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Client</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClient()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_Client();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplier <em>Supplier</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Supplier</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplier()
	 * @see #getRelationship()
	 * @generated
	 */
	EReference getRelationship_Supplier();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity <em>Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Entity</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity
	 * @generated
	 */
	EClass getEntity();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getParent()
	 * @see #getEntity()
	 * @generated
	 */
	EReference getEntity_Parent();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getComponents <em>Components</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Components</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getComponents()
	 * @see #getEntity()
	 * @generated
	 */
	EReference getEntity_Components();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getValue()
	 * @see #getEntity()
	 * @generated
	 */
	EAttribute getEntity_Value();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation <em>Relation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relation</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation
	 * @generated
	 */
	EClass getRelation();

	/**
	 * Returns the meta object for the reference '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getTo <em>To</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>To</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getTo()
	 * @see #getRelation()
	 * @generated
	 */
	EReference getRelation_To();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFromStr <em>From Str</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>From Str</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFromStr()
	 * @see #getRelation()
	 * @generated
	 */
	EAttribute getRelation_FromStr();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getToStr <em>To Str</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>To Str</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getToStr()
	 * @see #getRelation()
	 * @generated
	 */
	EAttribute getRelation_ToStr();

	/**
	 * Returns the meta object for the container reference '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFrom <em>From</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>From</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFrom()
	 * @see #getRelation()
	 * @generated
	 */
	EReference getRelation_From();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.TypeOf <em>Type Of</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Type Of</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.TypeOf
	 * @generated
	 */
	EClass getTypeOf();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.SupertypeOf <em>Supertype Of</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Supertype Of</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.SupertypeOf
	 * @generated
	 */
	EClass getSupertypeOf();

	/**
	 * Returns the meta object for class '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.VPMElement <em>VPM Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>VPM Element</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.VPMElement
	 * @generated
	 */
	EClass getVPMElement();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.VPMElement#getVariableReferences <em>Variable References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Variable References</em>'.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.VPMElement#getVariableReferences()
	 * @see #getVPMElement()
	 * @generated
	 */
	EReference getVPMElement_VariableReferences();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	EditmodelFactory getEditmodelFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl <em>Model Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getModelElement()
		 * @generated
		 */
		EClass MODEL_ELEMENT = eINSTANCE.getModelElement();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__TYPE = eINSTANCE.getModelElement_Type();

		/**
		 * The meta object literal for the '<em><b>Instance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__INSTANCE = eINSTANCE.getModelElement_Instance();

		/**
		 * The meta object literal for the '<em><b>Supertype</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__SUPERTYPE = eINSTANCE.getModelElement_Supertype();

		/**
		 * The meta object literal for the '<em><b>Subtype</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__SUBTYPE = eINSTANCE.getModelElement_Subtype();

		/**
		 * The meta object literal for the '<em><b>Relations To</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__RELATIONS_TO = eINSTANCE.getModelElement_RelationsTo();

		/**
		 * The meta object literal for the '<em><b>Sub Relationships</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__SUB_RELATIONSHIPS = eINSTANCE.getModelElement_SubRelationships();

		/**
		 * The meta object literal for the '<em><b>Super Relationships</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__SUPER_RELATIONSHIPS = eINSTANCE.getModelElement_SuperRelationships();

		/**
		 * The meta object literal for the '<em><b>Type Str</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_ELEMENT__TYPE_STR = eINSTANCE.getModelElement_TypeStr();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_ELEMENT__NAME = eINSTANCE.getModelElement_Name();

		/**
		 * The meta object literal for the '<em><b>Namespace Str</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_ELEMENT__NAMESPACE_STR = eINSTANCE.getModelElement_NamespaceStr();

		/**
		 * The meta object literal for the '<em><b>Real Element</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_ELEMENT__REAL_ELEMENT = eINSTANCE.getModelElement_RealElement();

		/**
		 * The meta object literal for the '<em><b>Relations From</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__RELATIONS_FROM = eINSTANCE.getModelElement_RelationsFrom();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.RelationshipImpl <em>Relationship</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.RelationshipImpl
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getRelationship()
		 * @generated
		 */
		EClass RELATIONSHIP = eINSTANCE.getRelationship();

		/**
		 * The meta object literal for the '<em><b>Client Str</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATIONSHIP__CLIENT_STR = eINSTANCE.getRelationship_ClientStr();

		/**
		 * The meta object literal for the '<em><b>Supplier Str</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATIONSHIP__SUPPLIER_STR = eINSTANCE.getRelationship_SupplierStr();

		/**
		 * The meta object literal for the '<em><b>Client</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP__CLIENT = eINSTANCE.getRelationship_Client();

		/**
		 * The meta object literal for the '<em><b>Supplier</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP__SUPPLIER = eINSTANCE.getRelationship_Supplier();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EntityImpl <em>Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EntityImpl
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getEntity()
		 * @generated
		 */
		EClass ENTITY = eINSTANCE.getEntity();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY__PARENT = eINSTANCE.getEntity_Parent();

		/**
		 * The meta object literal for the '<em><b>Components</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ENTITY__COMPONENTS = eINSTANCE.getEntity_Components();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ENTITY__VALUE = eINSTANCE.getEntity_Value();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.RelationImpl <em>Relation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.RelationImpl
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getRelation()
		 * @generated
		 */
		EClass RELATION = eINSTANCE.getRelation();

		/**
		 * The meta object literal for the '<em><b>To</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATION__TO = eINSTANCE.getRelation_To();

		/**
		 * The meta object literal for the '<em><b>From Str</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATION__FROM_STR = eINSTANCE.getRelation_FromStr();

		/**
		 * The meta object literal for the '<em><b>To Str</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATION__TO_STR = eINSTANCE.getRelation_ToStr();

		/**
		 * The meta object literal for the '<em><b>From</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATION__FROM = eINSTANCE.getRelation_From();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.TypeOfImpl <em>Type Of</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.TypeOfImpl
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getTypeOf()
		 * @generated
		 */
		EClass TYPE_OF = eINSTANCE.getTypeOf();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.SupertypeOfImpl <em>Supertype Of</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.SupertypeOfImpl
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getSupertypeOf()
		 * @generated
		 */
		EClass SUPERTYPE_OF = eINSTANCE.getSupertypeOf();

		/**
		 * The meta object literal for the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.VPMElementImpl <em>VPM Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.VPMElementImpl
		 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.EditmodelPackageImpl#getVPMElement()
		 * @generated
		 */
		EClass VPM_ELEMENT = eINSTANCE.getVPMElement();

		/**
		 * The meta object literal for the '<em><b>Variable References</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference VPM_ELEMENT__VARIABLE_REFERENCES = eINSTANCE.getVPMElement_VariableReferences();

	}

} //EditmodelPackage
