/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.vpm.editmodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Entity</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getParent <em>Parent</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getComponents <em>Components</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getValue <em>Value</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getEntity()
 * @model
 * @generated
 */
public interface Entity extends ModelElement {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Returns the value of the '<em><b>Parent</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getComponents <em>Components</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent</em>' container reference.
	 * @see #setParent(Entity)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getEntity_Parent()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getComponents
	 * @model opposite="components" transient="false"
	 * @generated
	 */
	Entity getParent();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getParent <em>Parent</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent</em>' container reference.
	 * @see #getParent()
	 * @generated
	 */
	void setParent(Entity value);

	/**
	 * Returns the value of the '<em><b>Components</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Components</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Components</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getEntity_Components()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getParent
	 * @model opposite="parent" containment="true" ordered="false"
	 * @generated
	 */
	EList<Entity> getComponents();

	/**
	 * Returns the value of the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Value</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Value</em>' attribute.
	 * @see #setValue(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getEntity_Value()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getValue();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Entity#getValue <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Value</em>' attribute.
	 * @see #getValue()
	 * @generated
	 */
	void setValue(String value);

} // Entity
