/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.vpm.editmodel;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Relation</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getTo <em>To</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFromStr <em>From Str</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getToStr <em>To Str</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFrom <em>From</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelation()
 * @model
 * @generated
 */
public interface Relation extends ModelElement {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Returns the value of the '<em><b>To</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsTo <em>Relations To</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To</em>' reference.
	 * @see #setTo(ModelElement)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelation_To()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsTo
	 * @model opposite="relationsTo" required="true" ordered="false"
	 * @generated
	 */
	ModelElement getTo();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getTo <em>To</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To</em>' reference.
	 * @see #getTo()
	 * @generated
	 */
	void setTo(ModelElement value);

	/**
	 * Returns the value of the '<em><b>From Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From Str</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From Str</em>' attribute.
	 * @see #setFromStr(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelation_FromStr()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getFromStr();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFromStr <em>From Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From Str</em>' attribute.
	 * @see #getFromStr()
	 * @generated
	 */
	void setFromStr(String value);

	/**
	 * Returns the value of the '<em><b>To Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>To Str</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>To Str</em>' attribute.
	 * @see #setToStr(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelation_ToStr()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getToStr();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getToStr <em>To Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>To Str</em>' attribute.
	 * @see #getToStr()
	 * @generated
	 */
	void setToStr(String value);

	/**
	 * Returns the value of the '<em><b>From</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsFrom <em>Relations From</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>From</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>From</em>' container reference.
	 * @see #setFrom(ModelElement)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelation_From()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsFrom
	 * @model opposite="relationsFrom" required="true" transient="false"
	 * @generated
	 */
	ModelElement getFrom();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFrom <em>From</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>From</em>' container reference.
	 * @see #getFrom()
	 * @generated
	 */
	void setFrom(ModelElement value);

} // Relation
