/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.vpm.editmodel;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Relationship</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClientStr <em>Client Str</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplierStr <em>Supplier Str</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClient <em>Client</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplier <em>Supplier</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelationship()
 * @model abstract="true"
 * @generated
 */
public interface Relationship extends VPMElement {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Returns the value of the '<em><b>Client Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Client Str</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Client Str</em>' attribute.
	 * @see #setClientStr(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelationship_ClientStr()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getClientStr();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClientStr <em>Client Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Client Str</em>' attribute.
	 * @see #getClientStr()
	 * @generated
	 */
	void setClientStr(String value);

	/**
	 * Returns the value of the '<em><b>Supplier Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Supplier Str</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Supplier Str</em>' attribute.
	 * @see #setSupplierStr(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelationship_SupplierStr()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getSupplierStr();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplierStr <em>Supplier Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Supplier Str</em>' attribute.
	 * @see #getSupplierStr()
	 * @generated
	 */
	void setSupplierStr(String value);

	/**
	 * Returns the value of the '<em><b>Client</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSuperRelationships <em>Super Relationships</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Client</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Client</em>' container reference.
	 * @see #setClient(ModelElement)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelationship_Client()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSuperRelationships
	 * @model opposite="superRelationships" required="true" ordered="false"
	 * @generated
	 */
	ModelElement getClient();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClient <em>Client</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Client</em>' container reference.
	 * @see #getClient()
	 * @generated
	 */
	void setClient(ModelElement value);

	/**
	 * Returns the value of the '<em><b>Supplier</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubRelationships <em>Sub Relationships</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Supplier</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Supplier</em>' reference.
	 * @see #setSupplier(ModelElement)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getRelationship_Supplier()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubRelationships
	 * @model opposite="subRelationships" required="true" ordered="false"
	 * @generated
	 */
	ModelElement getSupplier();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplier <em>Supplier</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Supplier</em>' reference.
	 * @see #getSupplier()
	 * @generated
	 */
	void setSupplier(ModelElement value);

} // Relationship
