/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation;
import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Model Element</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getInstance <em>Instance</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getSupertype <em>Supertype</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getSubtype <em>Subtype</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getRelationsTo <em>Relations To</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getSubRelationships <em>Sub Relationships</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getSuperRelationships <em>Super Relationships</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getTypeStr <em>Type Str</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getNamespaceStr <em>Namespace Str</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getRealElement <em>Real Element</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.impl.ModelElementImpl#getRelationsFrom <em>Relations From</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class ModelElementImpl extends VPMElementImpl implements ModelElement {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected EList<ModelElement> type;

	/**
	 * The cached value of the '{@link #getInstance() <em>Instance</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInstance()
	 * @generated
	 * @ordered
	 */
	protected EList<ModelElement> instance;

	/**
	 * The cached value of the '{@link #getSupertype() <em>Supertype</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSupertype()
	 * @generated
	 * @ordered
	 */
	protected EList<ModelElement> supertype;

	/**
	 * The cached value of the '{@link #getSubtype() <em>Subtype</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubtype()
	 * @generated
	 * @ordered
	 */
	protected EList<ModelElement> subtype;

	/**
	 * The cached value of the '{@link #getRelationsTo() <em>Relations To</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelationsTo()
	 * @generated
	 * @ordered
	 */
	protected EList<Relation> relationsTo;

	/**
	 * The cached value of the '{@link #getSubRelationships() <em>Sub Relationships</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubRelationships()
	 * @generated
	 * @ordered
	 */
	protected EList<Relationship> subRelationships;

	/**
	 * The cached value of the '{@link #getSuperRelationships() <em>Super Relationships</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSuperRelationships()
	 * @generated
	 * @ordered
	 */
	protected EList<Relationship> superRelationships;

	/**
	 * The default value of the '{@link #getTypeStr() <em>Type Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTypeStr()
	 * @generated
	 * @ordered
	 */
	protected static final String TYPE_STR_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTypeStr() <em>Type Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTypeStr()
	 * @generated
	 * @ordered
	 */
	protected String typeStr = TYPE_STR_EDEFAULT;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getNamespaceStr() <em>Namespace Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNamespaceStr()
	 * @generated
	 * @ordered
	 */
	protected static final String NAMESPACE_STR_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getNamespaceStr() <em>Namespace Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getNamespaceStr()
	 * @generated
	 * @ordered
	 */
	protected String namespaceStr = NAMESPACE_STR_EDEFAULT;

	/**
	 * The default value of the '{@link #getRealElement() <em>Real Element</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRealElement()
	 * @generated
	 * @ordered
	 */
	protected static final String REAL_ELEMENT_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getRealElement() <em>Real Element</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRealElement()
	 * @generated
	 * @ordered
	 */
	protected String realElement = REAL_ELEMENT_EDEFAULT;

	/**
	 * The cached value of the '{@link #getRelationsFrom() <em>Relations From</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRelationsFrom()
	 * @generated
	 * @ordered
	 */
	protected EList<Relation> relationsFrom;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModelElementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return EditmodelPackage.Literals.MODEL_ELEMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ModelElement> getType() {
		if (type == null) {
			type = new EObjectWithInverseResolvingEList.ManyInverse<ModelElement>(ModelElement.class, this, EditmodelPackage.MODEL_ELEMENT__TYPE, EditmodelPackage.MODEL_ELEMENT__INSTANCE);
		}
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ModelElement> getInstance() {
		if (instance == null) {
			instance = new EObjectWithInverseResolvingEList.ManyInverse<ModelElement>(ModelElement.class, this, EditmodelPackage.MODEL_ELEMENT__INSTANCE, EditmodelPackage.MODEL_ELEMENT__TYPE);
		}
		return instance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ModelElement> getSupertype() {
		if (supertype == null) {
			supertype = new EObjectWithInverseResolvingEList.ManyInverse<ModelElement>(ModelElement.class, this, EditmodelPackage.MODEL_ELEMENT__SUPERTYPE, EditmodelPackage.MODEL_ELEMENT__SUBTYPE);
		}
		return supertype;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ModelElement> getSubtype() {
		if (subtype == null) {
			subtype = new EObjectWithInverseResolvingEList.ManyInverse<ModelElement>(ModelElement.class, this, EditmodelPackage.MODEL_ELEMENT__SUBTYPE, EditmodelPackage.MODEL_ELEMENT__SUPERTYPE);
		}
		return subtype;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relation> getRelationsTo() {
		if (relationsTo == null) {
			relationsTo = new EObjectWithInverseResolvingEList<Relation>(Relation.class, this, EditmodelPackage.MODEL_ELEMENT__RELATIONS_TO, EditmodelPackage.RELATION__TO);
		}
		return relationsTo;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relationship> getSubRelationships() {
		if (subRelationships == null) {
			subRelationships = new EObjectWithInverseResolvingEList<Relationship>(Relationship.class, this, EditmodelPackage.MODEL_ELEMENT__SUB_RELATIONSHIPS, EditmodelPackage.RELATIONSHIP__SUPPLIER);
		}
		return subRelationships;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relationship> getSuperRelationships() {
		if (superRelationships == null) {
			superRelationships = new EObjectContainmentWithInverseEList<Relationship>(Relationship.class, this, EditmodelPackage.MODEL_ELEMENT__SUPER_RELATIONSHIPS, EditmodelPackage.RELATIONSHIP__CLIENT);
		}
		return superRelationships;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getTypeStr() {
		return typeStr;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTypeStr(String newTypeStr) {
		String oldTypeStr = typeStr;
		typeStr = newTypeStr;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EditmodelPackage.MODEL_ELEMENT__TYPE_STR, oldTypeStr, typeStr));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EditmodelPackage.MODEL_ELEMENT__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getNamespaceStr() {
		return namespaceStr;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setNamespaceStr(String newNamespaceStr) {
		String oldNamespaceStr = namespaceStr;
		namespaceStr = newNamespaceStr;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EditmodelPackage.MODEL_ELEMENT__NAMESPACE_STR, oldNamespaceStr, namespaceStr));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getRealElement() {
		return realElement;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRealElement(String newRealElement) {
		String oldRealElement = realElement;
		realElement = newRealElement;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, EditmodelPackage.MODEL_ELEMENT__REAL_ELEMENT, oldRealElement, realElement));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Relation> getRelationsFrom() {
		if (relationsFrom == null) {
			relationsFrom = new EObjectContainmentWithInverseEList<Relation>(Relation.class, this, EditmodelPackage.MODEL_ELEMENT__RELATIONS_FROM, EditmodelPackage.RELATION__FROM);
		}
		return relationsFrom;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case EditmodelPackage.MODEL_ELEMENT__TYPE:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getType()).basicAdd(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__INSTANCE:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInstance()).basicAdd(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__SUPERTYPE:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSupertype()).basicAdd(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__SUBTYPE:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSubtype()).basicAdd(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_TO:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getRelationsTo()).basicAdd(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__SUB_RELATIONSHIPS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSubRelationships()).basicAdd(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__SUPER_RELATIONSHIPS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getSuperRelationships()).basicAdd(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_FROM:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getRelationsFrom()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case EditmodelPackage.MODEL_ELEMENT__TYPE:
				return ((InternalEList<?>)getType()).basicRemove(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__INSTANCE:
				return ((InternalEList<?>)getInstance()).basicRemove(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__SUPERTYPE:
				return ((InternalEList<?>)getSupertype()).basicRemove(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__SUBTYPE:
				return ((InternalEList<?>)getSubtype()).basicRemove(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_TO:
				return ((InternalEList<?>)getRelationsTo()).basicRemove(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__SUB_RELATIONSHIPS:
				return ((InternalEList<?>)getSubRelationships()).basicRemove(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__SUPER_RELATIONSHIPS:
				return ((InternalEList<?>)getSuperRelationships()).basicRemove(otherEnd, msgs);
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_FROM:
				return ((InternalEList<?>)getRelationsFrom()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case EditmodelPackage.MODEL_ELEMENT__TYPE:
				return getType();
			case EditmodelPackage.MODEL_ELEMENT__INSTANCE:
				return getInstance();
			case EditmodelPackage.MODEL_ELEMENT__SUPERTYPE:
				return getSupertype();
			case EditmodelPackage.MODEL_ELEMENT__SUBTYPE:
				return getSubtype();
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_TO:
				return getRelationsTo();
			case EditmodelPackage.MODEL_ELEMENT__SUB_RELATIONSHIPS:
				return getSubRelationships();
			case EditmodelPackage.MODEL_ELEMENT__SUPER_RELATIONSHIPS:
				return getSuperRelationships();
			case EditmodelPackage.MODEL_ELEMENT__TYPE_STR:
				return getTypeStr();
			case EditmodelPackage.MODEL_ELEMENT__NAME:
				return getName();
			case EditmodelPackage.MODEL_ELEMENT__NAMESPACE_STR:
				return getNamespaceStr();
			case EditmodelPackage.MODEL_ELEMENT__REAL_ELEMENT:
				return getRealElement();
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_FROM:
				return getRelationsFrom();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case EditmodelPackage.MODEL_ELEMENT__TYPE:
				getType().clear();
				getType().addAll((Collection<? extends ModelElement>)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__INSTANCE:
				getInstance().clear();
				getInstance().addAll((Collection<? extends ModelElement>)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__SUPERTYPE:
				getSupertype().clear();
				getSupertype().addAll((Collection<? extends ModelElement>)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__SUBTYPE:
				getSubtype().clear();
				getSubtype().addAll((Collection<? extends ModelElement>)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_TO:
				getRelationsTo().clear();
				getRelationsTo().addAll((Collection<? extends Relation>)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__SUB_RELATIONSHIPS:
				getSubRelationships().clear();
				getSubRelationships().addAll((Collection<? extends Relationship>)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__SUPER_RELATIONSHIPS:
				getSuperRelationships().clear();
				getSuperRelationships().addAll((Collection<? extends Relationship>)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__TYPE_STR:
				setTypeStr((String)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__NAME:
				setName((String)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__NAMESPACE_STR:
				setNamespaceStr((String)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__REAL_ELEMENT:
				setRealElement((String)newValue);
				return;
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_FROM:
				getRelationsFrom().clear();
				getRelationsFrom().addAll((Collection<? extends Relation>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case EditmodelPackage.MODEL_ELEMENT__TYPE:
				getType().clear();
				return;
			case EditmodelPackage.MODEL_ELEMENT__INSTANCE:
				getInstance().clear();
				return;
			case EditmodelPackage.MODEL_ELEMENT__SUPERTYPE:
				getSupertype().clear();
				return;
			case EditmodelPackage.MODEL_ELEMENT__SUBTYPE:
				getSubtype().clear();
				return;
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_TO:
				getRelationsTo().clear();
				return;
			case EditmodelPackage.MODEL_ELEMENT__SUB_RELATIONSHIPS:
				getSubRelationships().clear();
				return;
			case EditmodelPackage.MODEL_ELEMENT__SUPER_RELATIONSHIPS:
				getSuperRelationships().clear();
				return;
			case EditmodelPackage.MODEL_ELEMENT__TYPE_STR:
				setTypeStr(TYPE_STR_EDEFAULT);
				return;
			case EditmodelPackage.MODEL_ELEMENT__NAME:
				setName(NAME_EDEFAULT);
				return;
			case EditmodelPackage.MODEL_ELEMENT__NAMESPACE_STR:
				setNamespaceStr(NAMESPACE_STR_EDEFAULT);
				return;
			case EditmodelPackage.MODEL_ELEMENT__REAL_ELEMENT:
				setRealElement(REAL_ELEMENT_EDEFAULT);
				return;
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_FROM:
				getRelationsFrom().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case EditmodelPackage.MODEL_ELEMENT__TYPE:
				return type != null && !type.isEmpty();
			case EditmodelPackage.MODEL_ELEMENT__INSTANCE:
				return instance != null && !instance.isEmpty();
			case EditmodelPackage.MODEL_ELEMENT__SUPERTYPE:
				return supertype != null && !supertype.isEmpty();
			case EditmodelPackage.MODEL_ELEMENT__SUBTYPE:
				return subtype != null && !subtype.isEmpty();
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_TO:
				return relationsTo != null && !relationsTo.isEmpty();
			case EditmodelPackage.MODEL_ELEMENT__SUB_RELATIONSHIPS:
				return subRelationships != null && !subRelationships.isEmpty();
			case EditmodelPackage.MODEL_ELEMENT__SUPER_RELATIONSHIPS:
				return superRelationships != null && !superRelationships.isEmpty();
			case EditmodelPackage.MODEL_ELEMENT__TYPE_STR:
				return TYPE_STR_EDEFAULT == null ? typeStr != null : !TYPE_STR_EDEFAULT.equals(typeStr);
			case EditmodelPackage.MODEL_ELEMENT__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case EditmodelPackage.MODEL_ELEMENT__NAMESPACE_STR:
				return NAMESPACE_STR_EDEFAULT == null ? namespaceStr != null : !NAMESPACE_STR_EDEFAULT.equals(namespaceStr);
			case EditmodelPackage.MODEL_ELEMENT__REAL_ELEMENT:
				return REAL_ELEMENT_EDEFAULT == null ? realElement != null : !REAL_ELEMENT_EDEFAULT.equals(realElement);
			case EditmodelPackage.MODEL_ELEMENT__RELATIONS_FROM:
				return relationsFrom != null && !relationsFrom.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (typeStr: ");
		result.append(typeStr);
		result.append(", name: ");
		result.append(name);
		result.append(", namespaceStr: ");
		result.append(namespaceStr);
		result.append(", realElement: ");
		result.append(realElement);
		result.append(')');
		return result.toString();
	}

} //ModelElementImpl
