/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports;

import java.io.InputStream;

import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;

/**
 * Interface to modules which import models into an existing modelspace
 * 
 * @author Andras Balogh
 */
public interface NativeImporter {
	/**
	 * Processes the given file, and imports its content to the modelspace
	 * 
	 * @param f
	 *            File name
	 * @param fw
	 *            The current framework
	 * @throws VPMRuntimeException
	 */
	public void processFile(String f, IFramework fw) throws VPMRuntimeException;

	/**
	 * Processes the given stream, and imports its content to the modelspace
	 * 
	 * @param f
	 *            The stream to process
	 * @param fw
	 *            The current framework
	 * @throws VPMRuntimeException
	 */
	public void process(InputStream f, IFramework fw)
			throws VPMRuntimeException;

}
