/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter.uml;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;
import org.eclipse.viatra2.imports.uml2.galileo.modelimporter.*;
import org.eclipse.uml2.uml.*;
/* @generated */
public class ActivityGroupProcessor extends AbstractProcessor {
public ActivityGroupProcessor(IModelManager mm, UmlModelImporter im) {
	super(mm,im); }

public IEntity process(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof ActivityGroup)) return null;
	ActivityGroup c = (ActivityGroup)oc;
	if (e==null)
	{
		e = mm.newEntity(container);
		mm.newInstanceOf(imp.ref.ENT_UML_ACTIVITYGROUP,e);
		imp.elemref.put(c,e);
	}

	imp.routeProcessLocal("EObject",c,e,container);
	imp.routeProcessLocal("EModelElement",c,e,container);
	imp.routeProcessLocal("Element",c,e,container);

	processLocal(c,e,container);

	return e;
}

public IEntity processLocal(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof ActivityGroup)) return null;
	ActivityGroup c = (ActivityGroup)oc;

	IEntity attr;
	IRelation arel;
	Iterator it;


	if (c.getSubgroups()!=null)
	{
		it = c.getSubgroups().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYGROUP_SUBGROUP,it.next()));
		}
	}


	if (c.getSuperGroup()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYGROUP_SUPERGROUP,c.getSuperGroup()));
	}


	if (c.getInActivity()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYGROUP_INACTIVITY,c.getInActivity()));
	}


	if (c.getContainedEdges()!=null)
	{
		it = c.getContainedEdges().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYGROUP_CONTAINEDEDGE,it.next()));
		}
	}


	if (c.getContainedNodes()!=null)
	{
		it = c.getContainedNodes().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYGROUP_CONTAINEDNODE,it.next()));
		}
	}
	return e;
}
}
