/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter.uml;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;
import org.eclipse.viatra2.imports.uml2.galileo.modelimporter.*;
import org.eclipse.uml2.uml.*;
/* @generated */
public class ActivityNodeProcessor extends AbstractProcessor {
public ActivityNodeProcessor(IModelManager mm, UmlModelImporter im) {
	super(mm,im); }

public IEntity process(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof ActivityNode)) return null;
	ActivityNode c = (ActivityNode)oc;
	if (e==null)
	{
		e = mm.newEntity(container);
		mm.newInstanceOf(imp.ref.ENT_UML_ACTIVITYNODE,e);
		imp.elemref.put(c,e);
		if (c.getName()!=null) mm.setValue(e,c.getName());
		if (c.getName()!=null) mm.setName(e,imp.convertName(c.getName()));
	}

	imp.routeProcessLocal("EObject",c,e,container);
	imp.routeProcessLocal("EModelElement",c,e,container);
	imp.routeProcessLocal("Element",c,e,container);
	imp.routeProcessLocal("NamedElement",c,e,container);
	imp.routeProcessLocal("RedefinableElement",c,e,container);

	processLocal(c,e,container);

	return e;
}

public IEntity processLocal(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof ActivityNode)) return null;
	ActivityNode c = (ActivityNode)oc;

	IEntity attr;
	IRelation arel;
	Iterator it;


	if (c.getInStructuredNode()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYNODE_INSTRUCTUREDNODE,c.getInStructuredNode()));
	}


	if (c.getActivity()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYNODE_ACTIVITY,c.getActivity()));
	}


	if (c.getOutgoings()!=null)
	{
		it = c.getOutgoings().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYNODE_OUTGOING,it.next()));
		}
	}


	if (c.getIncomings()!=null)
	{
		it = c.getIncomings().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYNODE_INCOMING,it.next()));
		}
	}


	if (c.getInPartitions()!=null)
	{
		it = c.getInPartitions().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYNODE_INPARTITION,it.next()));
		}
	}


	if (c.getInInterruptibleRegions()!=null)
	{
		it = c.getInInterruptibleRegions().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYNODE_ININTERRUPTIBLEREGION,it.next()));
		}
	}


	if (c.getInGroups()!=null)
	{
		it = c.getInGroups().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYNODE_INGROUP,it.next()));
		}
	}


	if (c.getRedefinedNodes()!=null)
	{
		it = c.getRedefinedNodes().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYNODE_REDEFINEDNODE,it.next()));
		}
	}
	return e;
}
}
