/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter.uml;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;
import org.eclipse.viatra2.imports.uml2.galileo.modelimporter.*;
import org.eclipse.uml2.uml.*;
/* @generated */
public class ActivityPartitionProcessor extends AbstractProcessor {
public ActivityPartitionProcessor(IModelManager mm, UmlModelImporter im) {
	super(mm,im); }

public IEntity process(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof ActivityPartition)) return null;
	ActivityPartition c = (ActivityPartition)oc;
	if (e==null)
	{
		e = mm.newEntity(container);
		mm.newInstanceOf(imp.ref.ENT_UML_ACTIVITYPARTITION,e);
		imp.elemref.put(c,e);
		if (c.getName()!=null) mm.setValue(e,c.getName());
		if (c.getName()!=null) mm.setName(e,imp.convertName(c.getName()));
	}

	imp.routeProcessLocal("EObject",c,e,container);
	imp.routeProcessLocal("EModelElement",c,e,container);
	imp.routeProcessLocal("Element",c,e,container);
	imp.routeProcessLocal("NamedElement",c,e,container);
	imp.routeProcessLocal("ActivityGroup",c,e,container);

	processLocal(c,e,container);

	return e;
}

public IEntity processLocal(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof ActivityPartition)) return null;
	ActivityPartition c = (ActivityPartition)oc;

	IEntity attr;
	IRelation arel;
	Iterator it;


	if (c.isDimension())
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.isDimension()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.Boolean"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_ACTIVITYPARTITION_ISDIMENSION,arel);}
	}


	if (c.isExternal())
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.isExternal()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.Boolean"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_ACTIVITYPARTITION_ISEXTERNAL,arel);}
	}


	if (c.getNodes()!=null)
	{
		it = c.getNodes().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYPARTITION_NODE,it.next()));
		}
	}


	if (c.getSubpartitions()!=null)
	{
		it = c.getSubpartitions().iterator();
		while(it.hasNext())
		{
			attr=imp.routeProcessing(it.next(),e);
			if (attr!=null) {arel = mm.newRelation(e,attr);
			mm.newInstanceOf(imp.ref.REL_UML_ACTIVITYPARTITION_SUBPARTITION,arel);}
		}
	}


	if (c.getSuperPartition()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYPARTITION_SUPERPARTITION,c.getSuperPartition()));
	}


	if (c.getRepresents()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYPARTITION_REPRESENTS,c.getRepresents()));
	}


	if (c.getEdges()!=null)
	{
		it = c.getEdges().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITYPARTITION_EDGE,it.next()));
		}
	}
	return e;
}
}
