/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter.uml;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;
import org.eclipse.viatra2.imports.uml2.galileo.modelimporter.*;
import org.eclipse.uml2.uml.*;
/* @generated */
public class ActivityProcessor extends AbstractProcessor {
public ActivityProcessor(IModelManager mm, UmlModelImporter im) {
	super(mm,im); }

public IEntity process(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof Activity)) return null;
	Activity c = (Activity)oc;
	if (e==null)
	{
		e = mm.newEntity(container);
		mm.newInstanceOf(imp.ref.ENT_UML_ACTIVITY,e);
		imp.elemref.put(c,e);
		if (c.getName()!=null) mm.setValue(e,c.getName());
		if (c.getName()!=null) mm.setName(e,imp.convertName(c.getName()));
	}

	imp.routeProcessLocal("EObject",c,e,container);
	imp.routeProcessLocal("EModelElement",c,e,container);
	imp.routeProcessLocal("Element",c,e,container);
	imp.routeProcessLocal("NamedElement",c,e,container);
	imp.routeProcessLocal("Namespace",c,e,container);
	imp.routeProcessLocal("RedefinableElement",c,e,container);
	imp.routeProcessLocal("ParameterableElement",c,e,container);
	imp.routeProcessLocal("PackageableElement",c,e,container);
	imp.routeProcessLocal("Type",c,e,container);
	imp.routeProcessLocal("TemplateableElement",c,e,container);
	imp.routeProcessLocal("Classifier",c,e,container);
	imp.routeProcessLocal("StructuredClassifier",c,e,container);
	imp.routeProcessLocal("EncapsulatedClassifier",c,e,container);
	imp.routeProcessLocal("BehavioredClassifier",c,e,container);
	imp.routeProcessLocal("Class",c,e,container);
	imp.routeProcessLocal("Behavior",c,e,container);

	processLocal(c,e,container);

	return e;
}

public IEntity processLocal(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof Activity)) return null;
	Activity c = (Activity)oc;

	IEntity attr;
	IRelation arel;
	Iterator it;


	if (c.isReadOnly())
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.isReadOnly()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.Boolean"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_ACTIVITY_ISREADONLY,arel);}
	}


	if (c.isSingleExecution())
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.isSingleExecution()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.Boolean"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_ACTIVITY_ISSINGLEEXECUTION,arel);}
	}


	if (c.getStructuredNodes()!=null)
	{
		it = c.getStructuredNodes().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITY_STRUCTUREDNODE,it.next()));
		}
	}


	if (c.getVariables()!=null)
	{
		it = c.getVariables().iterator();
		while(it.hasNext())
		{
			attr=imp.routeProcessing(it.next(),e);
			if (attr!=null) {arel = mm.newRelation(e,attr);
			mm.newInstanceOf(imp.ref.REL_UML_ACTIVITY_VARIABLE,arel);}
		}
	}


	if (c.getNodes()!=null)
	{
		it = c.getNodes().iterator();
		while(it.hasNext())
		{
			attr=imp.routeProcessing(it.next(),e);
			if (attr!=null) {arel = mm.newRelation(e,attr);
			mm.newInstanceOf(imp.ref.REL_UML_ACTIVITY_NODE,arel);}
		}
	}


	if (c.getEdges()!=null)
	{
		it = c.getEdges().iterator();
		while(it.hasNext())
		{
			attr=imp.routeProcessing(it.next(),e);
			if (attr!=null) {arel = mm.newRelation(e,attr);
			mm.newInstanceOf(imp.ref.REL_UML_ACTIVITY_EDGE,arel);}
		}
	}


	if (c.getPartitions()!=null)
	{
		it = c.getPartitions().iterator();
		while(it.hasNext())
		{
			imp.references.add(new RelationReference(e,imp.ref.REL_UML_ACTIVITY_PARTITION,it.next()));
		}
	}


	if (c.getGroups()!=null)
	{
		it = c.getGroups().iterator();
		while(it.hasNext())
		{
			attr=imp.routeProcessing(it.next(),e);
			if (attr!=null) {arel = mm.newRelation(e,attr);
			mm.newInstanceOf(imp.ref.REL_UML_ACTIVITY_GROUP,arel);}
		}
	}
	return e;
}
}
