/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter.uml;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;
import org.eclipse.viatra2.imports.uml2.galileo.modelimporter.*;
import org.eclipse.uml2.uml.*;
/* @generated */
public class MessageProcessor extends AbstractProcessor {
public MessageProcessor(IModelManager mm, UmlModelImporter im) {
	super(mm,im); }

public IEntity process(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof Message)) return null;
	Message c = (Message)oc;
	if (e==null)
	{
		e = mm.newEntity(container);
		mm.newInstanceOf(imp.ref.ENT_UML_MESSAGE,e);
		imp.elemref.put(c,e);
		if (c.getName()!=null) mm.setValue(e,c.getName());
		if (c.getName()!=null) mm.setName(e,imp.convertName(c.getName()));
	}

	imp.routeProcessLocal("EObject",c,e,container);
	imp.routeProcessLocal("EModelElement",c,e,container);
	imp.routeProcessLocal("Element",c,e,container);
	imp.routeProcessLocal("NamedElement",c,e,container);

	processLocal(c,e,container);

	return e;
}

public IEntity processLocal(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof Message)) return null;
	Message c = (Message)oc;

	IEntity attr;
	IRelation arel;
	Iterator it;


	if (c.getMessageKind()!=null)
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.getMessageKind()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.MessageKind"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_MESSAGE_MESSAGEKIND,arel);}
	}


	if (c.getMessageSort()!=null)
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.getMessageSort()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.MessageSort"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_MESSAGE_MESSAGESORT,arel);}
	}


	if (c.getReceiveEvent()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_MESSAGE_RECEIVEEVENT,c.getReceiveEvent()));
	}


	if (c.getSendEvent()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_MESSAGE_SENDEVENT,c.getSendEvent()));
	}


	if (c.getConnector()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_MESSAGE_CONNECTOR,c.getConnector()));
	}


	if (c.getInteraction()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_MESSAGE_INTERACTION,c.getInteraction()));
	}


	if (c.getArguments()!=null)
	{
		it = c.getArguments().iterator();
		while(it.hasNext())
		{
			attr=imp.routeProcessing(it.next(),e);
			if (attr!=null) {arel = mm.newRelation(e,attr);
			mm.newInstanceOf(imp.ref.REL_UML_MESSAGE_ARGUMENT,arel);}
		}
	}


	if (c.getSignature()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_MESSAGE_SIGNATURE,c.getSignature()));
	}
	return e;
}
}
