/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter.uml;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;
import org.eclipse.viatra2.imports.uml2.galileo.modelimporter.*;
import org.eclipse.uml2.uml.*;
/* @generated */
public class MultiplicityElementProcessor extends AbstractProcessor {
public MultiplicityElementProcessor(IModelManager mm, UmlModelImporter im) {
	super(mm,im); }

public IEntity process(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof MultiplicityElement)) return null;
	MultiplicityElement c = (MultiplicityElement)oc;
	if (e==null)
	{
		e = mm.newEntity(container);
		mm.newInstanceOf(imp.ref.ENT_UML_MULTIPLICITYELEMENT,e);
		imp.elemref.put(c,e);
	}

	imp.routeProcessLocal("EObject",c,e,container);
	imp.routeProcessLocal("EModelElement",c,e,container);
	imp.routeProcessLocal("Element",c,e,container);

	processLocal(c,e,container);

	return e;
}

public IEntity processLocal(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof MultiplicityElement)) return null;
	MultiplicityElement c = (MultiplicityElement)oc;

	IEntity attr;
	IRelation arel;
	Iterator it;


	if (c.isOrdered())
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.isOrdered()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.Boolean"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_MULTIPLICITYELEMENT_ISORDERED,arel);}
	}


	if (c.isUnique())
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.isUnique()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.Boolean"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_MULTIPLICITYELEMENT_ISUNIQUE,arel);}
	}


//	if (c.getUpper())
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.getUpper()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.UnlimitedNatural"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_MULTIPLICITYELEMENT_UPPER,arel);}
	}


//	if (c.getLower()!=null)
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.getLower()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.Integer"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_MULTIPLICITYELEMENT_LOWER,arel);}
	}


	if (c.getUpperValue()!=null)
	{
		attr = imp.routeProcessing(c.getUpperValue(),e);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_MULTIPLICITYELEMENT_UPPERVALUE,arel);}
	}


	if (c.getLowerValue()!=null)
	{
		attr = imp.routeProcessing(c.getLowerValue(),e);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_MULTIPLICITYELEMENT_LOWERVALUE,arel);}
	}
	return e;
}
}
