/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter.uml;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;
import org.eclipse.viatra2.imports.uml2.galileo.modelimporter.*;
import org.eclipse.uml2.uml.*;
/* @generated */
public class StringExpressionProcessor extends AbstractProcessor {
public StringExpressionProcessor(IModelManager mm, UmlModelImporter im) {
	super(mm,im); }

public IEntity process(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof StringExpression)) return null;
	StringExpression c = (StringExpression)oc;
	if (e==null)
	{
		e = mm.newEntity(container);
		mm.newInstanceOf(imp.ref.ENT_UML_STRINGEXPRESSION,e);
		imp.elemref.put(c,e);
		if (c.getName()!=null) mm.setValue(e,c.getName());
		if (c.getName()!=null) mm.setName(e,imp.convertName(c.getName()));
	}

	imp.routeProcessLocal("EObject",c,e,container);
	imp.routeProcessLocal("EModelElement",c,e,container);
	imp.routeProcessLocal("Element",c,e,container);
	imp.routeProcessLocal("NamedElement",c,e,container);
	imp.routeProcessLocal("ParameterableElement",c,e,container);
	imp.routeProcessLocal("PackageableElement",c,e,container);
	imp.routeProcessLocal("TypedElement",c,e,container);
	imp.routeProcessLocal("ValueSpecification",c,e,container);
	imp.routeProcessLocal("Expression",c,e,container);
	imp.routeProcessLocal("TemplateableElement",c,e,container);

	processLocal(c,e,container);

	return e;
}

public IEntity processLocal(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof StringExpression)) return null;
	StringExpression c = (StringExpression)oc;

	IEntity attr;
	IRelation arel;
	Iterator it;


	if (c.getSubExpressions()!=null)
	{
		it = c.getSubExpressions().iterator();
		while(it.hasNext())
		{
			attr=imp.routeProcessing(it.next(),e);
			if (attr!=null) {arel = mm.newRelation(e,attr);
			mm.newInstanceOf(imp.ref.REL_UML_STRINGEXPRESSION_SUBEXPRESSION,arel);}
		}
	}


	if (c.getOwningExpression()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_STRINGEXPRESSION_OWNINGEXPRESSION,c.getOwningExpression()));
	}
	return e;
}
}
