/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter.uml;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.imports.NativeImporter;
import org.eclipse.viatra2.imports.uml2.galileo.modelimporter.*;
import org.eclipse.uml2.uml.*;
/* @generated */
public class TransitionProcessor extends AbstractProcessor {
public TransitionProcessor(IModelManager mm, UmlModelImporter im) {
	super(mm,im); }

public IEntity process(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof Transition)) return null;
	Transition c = (Transition)oc;
	if (e==null)
	{
		e = mm.newEntity(container);
		mm.newInstanceOf(imp.ref.ENT_UML_TRANSITION,e);
		imp.elemref.put(c,e);
		if (c.getName()!=null) mm.setValue(e,c.getName());
		if (c.getName()!=null) mm.setName(e,imp.convertName(c.getName()));
	}

	imp.routeProcessLocal("EObject",c,e,container);
	imp.routeProcessLocal("EModelElement",c,e,container);
	imp.routeProcessLocal("Element",c,e,container);
	imp.routeProcessLocal("NamedElement",c,e,container);
	imp.routeProcessLocal("Namespace",c,e,container);
	imp.routeProcessLocal("RedefinableElement",c,e,container);

	processLocal(c,e,container);

	return e;
}

public IEntity processLocal(java.lang.Object oc,IEntity e,IEntity container) throws VPMRuntimeException,VPMCoreException
{
	if (!(oc instanceof Transition)) return null;
	Transition c = (Transition)oc;

	IEntity attr;
	IRelation arel;
	Iterator it;


	if (c.getKind()!=null)
	{
		attr = mm.newEntity(e);
		mm.setValue(attr,((java.lang.Object)c.getKind()).toString());
		mm.newInstanceOf(mm.getEntityByName("uml.metamodel.uml.TransitionKind"),attr);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_TRANSITION_KIND,arel);}
	}


	if (c.getContainer()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_TRANSITION_CONTAINER,c.getContainer()));
	}


	if (c.getSource()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_TRANSITION_SOURCE,c.getSource()));
	}


	if (c.getTarget()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_TRANSITION_TARGET,c.getTarget()));
	}


	if (c.getRedefinedTransition()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_TRANSITION_REDEFINEDTRANSITION,c.getRedefinedTransition()));
	}


	if (c.getGuard()!=null)
	{
		imp.references.add(new RelationReference(e,imp.ref.REL_UML_TRANSITION_GUARD,c.getGuard()));
	}


	if (c.getEffect()!=null)
	{
		attr = imp.routeProcessing(c.getEffect(),e);
		if (attr!=null) {arel = mm.newRelation(e,attr);
		mm.newInstanceOf(imp.ref.REL_UML_TRANSITION_EFFECT,arel);}
	}


	if (c.getTriggers()!=null)
	{
		it = c.getTriggers().iterator();
		while(it.hasNext())
		{
			attr=imp.routeProcessing(it.next(),e);
			if (attr!=null) {arel = mm.newRelation(e,attr);
			mm.newInstanceOf(imp.ref.REL_UML_TRANSITION_TRIGGER,arel);}
		}
	}
	return e;
}
}
