/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Balogh and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Balogh - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.imports.uml2.preferences;



import org.eclipse.jface.dialogs.InputDialog;
import org.eclipse.jface.preference.ListEditor;
import org.eclipse.swt.widgets.Composite;

public class MyListEditor extends ListEditor {

	public MyListEditor(String name, String labelText, Composite parent)
	{
		super (name,labelText,parent);
	}
	@Override
	protected String createList(String[] items) {
		if (items.length==0) return "";
		String tmp="";
		for (int i=0;i<items.length-1;i++)
			tmp+=items[i]+"|";
		tmp+=items[items.length-1];
		return tmp;
	}

	@Override
	protected String getNewInputObject() {
		InputDialog id = new InputDialog(getPage().getShell(),"Ignored profile","Please specify profile name","",null);
		if (id.open()==id.OK) return id.getValue();
		return 	null;
	}

	@Override
	protected String[] parseString(String stringList) {
		
		return stringList.split("\\|");
	}

}
