/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Balogh and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Balogh - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.imports.uml2.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.viatra2.imports.uml2.galileo.Activator;


/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = Activator.getDefault()
				.getPreferenceStore();
		store.setDefault(PreferenceConstants.P_IGNORE, true);
		store.setDefault(PreferenceConstants.P_PROFILES,
				"Ecore|ecore|uml|Standard|UML|Business Modeling|" +
				"CORBA Transformation|CPPTransformation|Default|Deployment|" +
				"DoDAF|EJBTransformProfile|JavaTransformation5.0|" +
				"JavaTransformation1.4|LogicalDataModel|ProfileBase|" +
				"RUPAnalysis|Software Services Profile|XSDProfile");
			
	}

}
