/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.interpreters.debugInterface;

import java.util.List;
import java.util.Set;

/**
 * @author Andras Schmidt
 * 
 */
public interface IASMFunctions {
	/**
	 * Returns the names of all functions available.
	 * 
	 * @return
	 */
	Set getFunctions();

	/**
	 * get the value set for the function at location.
	 * 
	 * @param fun
	 *            name of function
	 * @param loc
	 *            location to get
	 * @return null if UNDEF, the value otherwise
	 */
	Object getFunctionValue(String fun, List loc);

	/**
	 * Sets the value for the function fun
	 * 
	 * @param fun
	 *            name of function.
	 * @param loc
	 *            location in the function.
	 * @param val
	 *            value to be set.
	 */
	void setFunctionValue(String fun, List loc, Object val);

	/**
	 * Add a new function
	 * 
	 * @param fun
	 *            name of new function.
	 * @param n
	 *            arity of new function.
	 */
	void addFunction(String fun, int n);

	// ASMFunction getFunction(String name);
}
