/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.interpreters.debugInterface;

import java.util.Map;

/**
 * @author Andras Schmidt
 * 
 */
public interface RunningThread {
	/**
	 * Returns the local variable bindings.
	 * 
	 * @return mapping from variable name (String) to value (Object: Integer,
	 *         Double, String, null, IModelElement)
	 * @throws NotSupportedException
	 */
	Map getLocalVariables() throws NotSupportedException;

	/**
	 * Sets the local variable bindings. Parameter must be the same as
	 * getLocalVariables returns.
	 * 
	 * @throws NotSupportedException
	 */
	void setLocalVariables(Map bindings) throws NotSupportedException;
}
