/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.logger;

import org.eclipse.viatra2.framework.properties.VPMProperties;

/**
 * Logger class interface.
 * 
 * @author Andras Balogh
 */
public interface Logger {

	public static final int FATAL = 0;

	public static final int ERROR = 1;

	public static final int WARNING = 2;

	public static final int INFO = 3;

	public static final int DEBUG = 4;

	public static final int ALL = 4;

	public static String[] levelnames = { "fatal", "error", "warning", "info",
			"debug" };

	/**
	 * Sets the log level.
	 * 
	 * @param l
	 *            the new log level.
	 */
	public void setLevel(int l);

	public void message(int level, String msg, Throwable cause);

	public void message(int level, String msg);

	public void debug(String s);

	public void warning(String s);

	public void error(String s);

	public void fatal(String s);

	public void info(String s);

	public void init(VPMProperties p);
	
	public void printStackTrace(Throwable t);
}
