/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.logger;

/**
 * Describes a factory class capable of instantiating a logger.
 * 
 * @author Istvan Rath
 * 
 */
public interface LoggerFactory {
	/**
	 * The id of the logger.
	 */
	public String loggerId();

	/**
	 * The name of the logger.
	 */
	public String loggerName();

	/**
	 * The textual description of the logger.
	 */
	public String loggerDescription();

	/**
	 * The logger instance.
	 */
	public Logger getLogger();
}
