/**
* Copyright (c) 2008 - 2010 OptXware Research and Development LLC.
* All rights reserved.   This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*   Daniel Varro - Initial API and implementation
*/
/**
 * 
 */
package org.eclipse.viatra2.lpgparser.typechecker;

/**
 * @author Zoltan Ujhelyi
 */
public class VTCLTypeNameConstants {
	/**
	 * Represents a supertype in the context of the type checker
	 */
	public static final String SUPERTYPE = "SUPERTYPE";
	/**
	 * Represents an any type value in the type checker
	 */
	public static final String STAR = "STAR";
	/**
	 * Represent the self type in the type checker
	 */
	public static final String MYSELF = "MYSELF";
	/**
	 * Represents an invalid type value (contradictory constraints)
	 */
	public static final String BOTTOM = "BOTTOM";
	/**
	 * Represents an unknown type value (any type is possible)
	 */
	public static final String TOP = "TOP";
	/**
	 * Represents a model element type (common parent)
	 */
	public static final String MODELELEMENT = "MODELELEMENT";
	/**
	 * Represents a relation type (common parent)
	 */
	public static final String RELATION = "RELATION";
	/**
	 * Represents an entity type (common parent)
	 */
	public static final String ENTITY = "ENTITY";

	public static boolean isConcreteTypeString(String typeStr) {
		return !typeStr.contentEquals(VTCLTypeNameConstants.MODELELEMENT)
				&& !typeStr.contentEquals(VTCLTypeNameConstants.ENTITY)
				&& !typeStr.contentEquals(VTCLTypeNameConstants.RELATION);
	}
}
