/*******************************************************************************
 * Copyright (c) 2004-2010, Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.modelChecker;

import org.eclipse.viatra2.framework.properties.VIATRAPropertyKind;
import org.eclipse.viatra2.framework.properties.providers.DefaultPropertyProvider;

public class ModelCheckerPropertyProvider extends DefaultPropertyProvider
{

	public ModelCheckerPropertyProvider() {
		super("Model checking");
	}

	@Override
	public void init() {
		allids.add("On-the-fly model checking");
	}

	public String getDefaultPropertyValue(String id) {
		return "false";
	}

	public VIATRAPropertyKind getPropertyKind(String id) {
		return VIATRAPropertyKind.BOOLEAN;
	}

	public boolean isActive() 
	{
		return true;
	}



}
