/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Schmidt, Andras Balogh, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.natives;

import org.eclipse.viatra2.core.IModelSpace;
import org.eclipse.viatra2.errors.VPMRuntimeException;

/**
 * An ASMNativeFunction is a Java function which can be called directly from a
 * VTCL program.
 * 
 * @author Andras Balogh
 */
public interface ASMNativeFunction {

	/**
	 * This function will be called by the GTASM interpreter.
	 */
	public Object evaluate(IModelSpace msp, Object[] params)
			throws VPMRuntimeException;

	/**
	 * The name of the native function.
	 */
	public String getName();

	/**
	 * The unique ID of the native function.
	 */
	public String getID();

	/**
	 * The textual description of the native function.
	 */
	public String getDescription();
}
