/*******************************************************************************
 * Copyright (c) 2004-2010, Andras Schmidt, Andras Balogh, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.natives;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.IModelSpace;
import org.eclipse.viatra2.errors.VPMRuntimeException;

@VIATRANativeFunction(name="getId", 
		params = { @NativeFunctionParameter(type={NativeFunctionParameter.ParameterType.MODEL_ELEMENT}, name = "modelElement") }, 
		returns = { NativeFunctionParameter.ParameterType.STRING })
public class GetVIATRAID implements ASMNativeFunction {

	public Object evaluate(IModelSpace msp, Object[] params)
			throws VPMRuntimeException {
		return ((IModelElement)params[0]).getID();
	}

	public String getDescription() {
		return "Fetches the internal VIATRA ID of an element";
	}

	public String getID() {
	return this.getClass().getCanonicalName();
	}

	public String getName() {
		return "getId";
	}

}
