package org.eclipse.viatra2.natives.strings.impl;

import org.eclipse.viatra2.core.IModelSpace;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.natives.ASMNativeFunction;

public class Format implements ASMNativeFunction {

	public Object evaluate(IModelSpace msp, Object[] params)
			throws VPMRuntimeException {
		if (params!=null && (params.length>=1))
		{
			String fmt = params[0].toString();
			if (params.length>1)
			{
				Object[] pars = new Object[params.length-1];
				for (int i=0;i<pars.length;i++) pars[i]=params[i+1];
				return String.format(fmt,pars);
			}
			else
				return String.format(fmt);
		}
		return null;
	}

	public String getName() {
		return "str.format";
	}

	public String getID() {
		return "str.format";
	}

	public String getDescription() {
		return "str.format";
	}

}
