package org.eclipse.viatra2.natives.strings.impl;

import org.eclipse.viatra2.core.IModelSpace;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.natives.ASMNativeFunction;

public class RegionMatches implements ASMNativeFunction {


	public Object evaluate(IModelSpace msp, Object[] params)
			throws VPMRuntimeException {
		if (params!=null && (params.length>=5) && (params.length<=6))
		{
			String str1 = params[0].toString();
			String str2 = params[2].toString();
			int of1 = 0;
			int of2 = 0;
			int len = 0;
			if (params[1] instanceof Integer) of1=(Integer)params[1]; else return null;
			if (params[3] instanceof Integer) of2=(Integer)params[3]; else return null;
			if (params[4] instanceof Integer) len=(Integer)params[4]; else return null;
			boolean ignore = false;
			if (params.length==6)
			{
				if (params[5] instanceof Boolean) ignore=(Boolean)params[5]; else return null;
			}
			return str1.regionMatches(ignore,of1,str2,of2,len);
		}
		return null;
	}

	public String getName() {

		return "str.regionMatches";
	}

	public String getID() {
		return "str.regionMatches";	
	}

	public String getDescription() {
		return "str.regionMatches";
	}

}
