package org.eclipse.viatra2.natives.strings.impl;

import org.eclipse.viatra2.core.IModelSpace;
import org.eclipse.viatra2.errors.VPMRuntimeException;
import org.eclipse.viatra2.natives.ASMNativeFunction;

public class SubString implements ASMNativeFunction {

	public Object evaluate(IModelSpace msp, Object[] params)
			throws VPMRuntimeException {
		if (params!=null && (params.length>=2) && (params.length<=3))
		{
			int start = 0;
			Integer end = null;
			if (params.length==3)
			{
				if (params[2] instanceof Integer) end = (Integer)params[2];
				else return null;
			}
			if (params[1] instanceof Integer) start = (Integer)params[1];
			else return null;

			if (end==null) return params[0].toString().substring(start);
			else  return params[0].toString().substring(start,end);
		}
		return null;
	}

	public String getName() {

		return "str.substring";
	}

	public String getID() {

		return "str.substring";
	}

	public String getDescription() {

		return "str.substring";
	}

}
