/*******************************************************************************
 * Copyright (c) 2009 Zoltan Ujhelyi and Daniel Varro.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Zoltan Ujhelyi - initial API and implementation
 *******************************************************************************/
package org.eclipse.viatra2.visualisation.color;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.IModelSpace;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.core.constraint.EConstraint;

/**
 * This class represents a dummy model element used in the Preview Graph
 * in the Color Settings dialog
 * @author Zoltan Ujhelyi
 *
 */
class PreviewModelElement implements IModelElement {
	
	String name;
	/**
	 * Initializes a preview model element
	 * @param name
	 */
	public PreviewModelElement(String name) {
		this.name = name;
	}

	public Collection<IModelElement> getAllElementsInNamespace() {
		return null;
	}

	public Collection<IModelElement> getAllInstances() {
		return null;
	}

	public Collection<IRelation> getAllRelationFromByType(IRelation type) {
		return null;
	}

	public Collection<IModelElement> getAllRelationSourceByType(IRelation type) {
		return null;
	}

	public Collection<IModelElement> getAllRelationTargetByType(IRelation type) {
		return null;
	}

	public Collection<IRelation> getAllRelationToByType(IRelation type) {
		return null;
	}

	public Collection<IModelElement> getAllSubtypes() {
		return null;
	}

	public Collection<IModelElement> getAllSupertypes() {
		return null;
	}

	public Collection<IModelElement> getAllTypes() {
		return null;
	}

	public IModelElement getElementInNamespaceByName(String name) {
		return null;
	}

	public Collection<IModelElement> getElementsInNamespace() {
		return null;
	}

	public Collection<IModelElement> getElementsInRelation(
			EConstraint relationType) {
		return null;
	}

	public String getFullyQualifiedName() {
		return name;
	}

	public String getID() {
		return name;
	}

	public Collection<IModelElement> getInstances() {
		return null;
	}

	public boolean getIsFinalType() {
		return false;
	}

	public IModelSpace getModelSpace() {
		return null;
	}

	public String getName() {
		return name;
	}

	public IModelElement getNamespace() {
		return null;
	}

	public IRelation getRelationByName(String n) {
		return null;
	}

	public IRelation getRelationByType(IModelElement n) {
		return null;
	}

	public IRelation getRelationFromByName(String name) {
		return null;
	}

	public IRelation getRelationFromByType(IModelElement type) {
		return null;
	}

	public IModelElement getRelationSourceByType(IRelation type) {
		return null;
	}

	public IModelElement getRelationTargetByType(IRelation type) {
		return null;
	}

	public IRelation getRelationToByName(String name) {
		return null;
	}

	public IRelation getRelationToByType(IModelElement type) {
		return null;
	}

	public Collection<IRelation> getRelations() {
		return null;
	}

	public Collection<IRelation> getRelationsFrom() {
		return null;
	}

	public Collection<IRelation> getRelationsTo() {
		return null;
	}

	public Collection<IModelElement> getSubtypes() {
		return null;
	}

	public Collection<IModelElement> getSupertypes() {
		return null;
	}

	public Collection<IModelElement> getTypes() {
		return new ArrayList<IModelElement>();
	}

	public String getViewInfo() {
		return null;
	}

	public boolean isBelowNamespace(IModelElement grandpa) {
		return false;
	}

	public boolean isDeleted() {
		return false;
	}

	public boolean isDirectInstanceOf(IModelElement inst) {
		return false;
	}

	public boolean isDirectSubtypeOf(IModelElement sub) {
		return false;
	}

	public boolean isDirectSupertypeOf(IModelElement sup) {
		return false;
	}

	public boolean isDirectTypeOf(IModelElement type) {
		return false;
	}

	public boolean isEntity() {
		return false;
	}

	public boolean isInstanceOf(IModelElement type) {
		return false;
	}

	public boolean isRelation() {
		return false;
	}

	public boolean isSubtypeOf(IModelElement sup) {
		return false;
	}

	public boolean isSupertypeOf(IModelElement sup) {
		return false;
	}

	public boolean isTypeOf(IModelElement inst) {
		return false;
	}

	public int compareTo(IModelElement o) {
		return 0;
	}

}
