/*******************************************************************************
 * Copyright (c) 2009 Zoltan Ujhelyi and Daniel Varro.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Zoltan Ujhelyi - initial API and implementation
 *******************************************************************************/
package org.eclipse.viatra2.visualisation.color;

import org.eclipse.viatra2.core.EMultiplicityKind;
import org.eclipse.viatra2.core.IModelElement;
import org.eclipse.viatra2.core.IRelation;

/**
 * This class is used as a dummy IRelation element to provide live preview
 * in the color settings page.
 * @author Zoltan Ujhelyi
 *
 */
class PreviewRelation extends PreviewModelElement implements IRelation {
	
	/**
	 * Initializes a preview relation
	 * @param name
	 */
	public PreviewRelation(String name) {
		super(name);
	}

	public IModelElement getFrom() {
		return null;
	}

	public IRelation getInverse() {
		return null;
	}

	public boolean getIsAggregation() {
		return false;
	}

	public boolean getIsAnyFrom() {
		return false;
	}

	public boolean getIsAnyTo() {
		return false;
	}

	public EMultiplicityKind getMultiplicity() {
		return null;
	}

	public IModelElement getTo() {
		return null;
	}

}
