/*******************************************************************************
 * Copyright (c) 2009 Zoltan Ujhelyi and Daniel Varro.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Zoltan Ujhelyi - initial API and implementation
 *******************************************************************************/
package org.eclipse.viatra2.visualisation.layouts.simulatedcooling;

import org.eclipse.zest.layouts.LayoutAlgorithm;

/**
 * A Layout algorithm can implement this interface if it can be
 * continued. It is recommended for slow algorithms, therefore they
 * can be executed in small steps.
 * @author Grill Balazs (balage.g@gmail.com)
 *
 */
public interface IContinuableLayoutAlgorithm extends LayoutAlgorithm{

	/**
	 * Determines if the algorithm should still be recalled after the
	 * last run.
	 * @return true if the algorithm should be recalled again.
	 */
	public boolean needsRecall();
	
	public void startLayouting();
	public void finishLayouting();
	
	public void cancel();
	
}
