/*******************************************************************************
 * Copyright (c) 2009 Zoltan Ujhelyi and Daniel Varro.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Zoltan Ujhelyi - initial API and implementation
 *******************************************************************************/
package org.eclipse.viatra2.visualisation.modelspace.datasource;

import org.eclipse.viatra2.core.IRelation;

/**
 * @author Zoltan Ujhelyi
 *
 */
public class GraphRelationArc extends GraphArc {

	private IRelation relation;
	
	/**
	 * Initializes a graph arc representation from a relation element
	 * @param relation the relation to use
	 */
	public GraphRelationArc(IRelation relation) {
		this.relation = relation;
		setEntity1(relation.getFrom());
		setEntity2(relation.getTo());
		setMultiplicity(1);
	}

	/**
	 * @return the relation
	 */
	public IRelation getRelation() {
		return relation;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.viatra2.visualisation.view.GraphArc#getName()
	 */
	@Override
	public String getName() {
		if (relation != null) return relation.getName();
		else return super.getName();
	}
}
