/*******************************************************************************
 * Copyright (c) 2009 Zoltan Ujhelyi and Daniel Varro.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Zoltan Ujhelyi - initial API and implementation
 *******************************************************************************/
package org.eclipse.viatra2.visualisation.patterns.viewmodel;

/**
 * Represent the parent of all view model items.
 * @author Zoltan Ujhelyi
 *
 */
public abstract class AbstractViewModelElement {
	
	/**
	 * Returns the name of the view model element
	 * @return the name
	 */
	public abstract String getName();
	/**
	 * Returns the fully qualified name of the view model element
	 * @return the fully qualified name
	 */
	public String getFQName() {
		return getName();
	}
	/**
	 * Returns the type of the view model element
	 * @return a string describing the type of the view model element  
	 */
	public abstract String getTypeString();
}
