/*******************************************************************************
 * Copyright (c) 2009 Zoltan Ujhelyi and Daniel Varro.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Zoltan Ujhelyi - initial API and implementation
 *******************************************************************************/
package org.eclipse.viatra2.visualisation.patterns.viewmodel;

/**
 * Describes a graph arc between two model elements. These arcs are only used
 * when relations are described as nodes.
 * @author Zoltan Ujhelyi
 */
public class PatternGraphArc extends AbstractViewModelElement {

	ViewPatternModelElement source, destination;

	/**
	 * Initializes a pattern graph arc
	 */
	public PatternGraphArc() {

	}

	/**
	 * Initializes a pattern graph arc between two pattern model elements.
	 * @param source
	 *            the source of the arc
	 * @param destination
	 *            the destination of the arc
	 */
	public PatternGraphArc(ViewPatternModelElement source,
			ViewPatternModelElement destination) {
		this.source = source;
		this.destination = destination;
	}

	/**
	 * @return the source
	 */
	public ViewPatternModelElement getSource() {
		return source;
	}

	/**
	 * @param source
	 *            the source to set
	 */
	public void setSource(ViewPatternModelElement source) {
		this.source = source;
	}

	/**
	 * @return the destination
	 */
	public ViewPatternModelElement getDestination() {
		return destination;
	}

	/**
	 * @param destination
	 *            the destination to set
	 */
	public void setDestination(ViewPatternModelElement destination) {
		this.destination = destination;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see
	 * org.eclipse.viatra2.visualisation.patterns.viewmodel.AbstractViewModelElement
	 * #getName()
	 */
	@Override
	public String getName() {
		return "";
	}

	@Override
	public String getTypeString() {
		return "";
	}

}
