/*******************************************************************************
 * Copyright (c) 2009 Zoltan Ujhelyi and Daniel Varro.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Zoltan Ujhelyi - initial API and implementation
 *******************************************************************************/
package org.eclipse.viatra2.visualisation.patterns.viewmodel;


/**
 * Represents a parameter assignment in the view model.
 * @author Zoltan Ujhelyi
 *
 */
public class ViewParameterAssignment extends AbstractViewModelElement{

	ViewPatternModelElement parameter;
	ViewPattern pattern;
	String paramName;
	/**
	 * @return the paramName
	 */
	public String getParamName() {
		return paramName;
	}
	/**
	 * @param paramName the paramName to set
	 */
	public void setParamName(String paramName) {
		this.paramName = paramName;
	}
	/**
	 * @return the parameter
	 */
	public ViewPatternModelElement getParameter() {
		return parameter;
	}
	/**
	 * @param parameter the parameter to set
	 */
	public void setParameter(ViewPatternModelElement parameter) {
		this.parameter = parameter;
	}
	/**
	 * @return the pattern
	 */
	public ViewPattern getPattern() {
		return pattern;
	}
	/**
	 * @param pattern the pattern to set
	 */
	public void setPattern(ViewPattern pattern) {
		this.pattern = pattern;
	}
	@Override
	public String getName() {
		return getParamName();
	}
	@Override
	public String getTypeString() {
		return "Parameter Assignment";
	}
	
	
}
