/*******************************************************************************
 * Copyright (c) 2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.editor.text.markers;

import org.eclipse.core.resources.IResource;
import org.eclipse.viatra2.errors.info.ErrorInformation;

public interface IVTCLErrorReporter {

	/**
	 * Creates a new problem marker from the {@link ErrorInformation} info 
	 * @param info: {@link ErrorInformation}
	 */
	public void reportError(ErrorInformation info);

	/**
	 * Removes problem marker from {@link IResource} resource of a certain type
	 * @param resource
	 * @param type
	 */
	public void deleteMarkers(IResource resource, String type);

}