/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.frameworkgui.content;

import java.util.Collection;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IContributionItem;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.views.properties.IPropertySource2;

public interface ITreeObject 
{

	public FrameworkContainer getFrameworkContainer();
	
	public ITreeParent getParent();
	
	public String getLabelText();
	
	public Image getLabelImage();
	
	public IPropertySource2 getPropertySource();
	
	public Collection<IContributionItem> getContributionItems();
	
	public Collection<IAction> getActions();
	
	public IAction getDoubleClickAction();
	
}
