/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.frameworkgui.content.nativefunctions;

import java.util.Collection;
import java.util.HashSet;
import java.util.Set;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IContributionItem;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.views.properties.IPropertySource2;
import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.frameworkgui.FrameworkGUIPlugin;
import org.eclipse.viatra2.frameworkgui.content.FrameworkContainer;
import org.eclipse.viatra2.frameworkgui.content.IFrameworkContentProviderExtension;
import org.eclipse.viatra2.frameworkgui.content.ITreeObject;
import org.eclipse.viatra2.frameworkgui.content.ITreeParent;
import org.eclipse.viatra2.frameworkgui.views.FrameworkTreeView;
import org.eclipse.viatra2.natives.ASMNativeFunction;

public class NativeFunctionContent implements
		IFrameworkContentProviderExtension, ITreeParent {


	public void dispose() { }


	public ITreeObject getTopLevelEntry() {return this;}

	FrameworkContainer cont;
	IFramework fw;
	

	public void init(FrameworkTreeView fv, IFramework fw, FrameworkContainer c) 
	{
		cont = c;
		this.fw = fw;
	}


	public Set<ITreeObject> getChildren() 
	{
		HashSet<ITreeObject> r = new HashSet<ITreeObject>();
		for (final ASMNativeFunction nf : fw.getNativeFunctionManager().getAllNativeFunctions())
		{
			r.add(new ITreeObject(){


				public Collection<IAction> getActions() {return null;}


				public Collection<IContributionItem> getContributionItems() {return null;}

	
				public IAction getDoubleClickAction() {return null;}


				public FrameworkContainer getFrameworkContainer() { return cont; }

				public Image getLabelImage() {
					return nf_image;
				}

	
				public String getLabelText() {
					return nf.getName();//+" ("+nf.getDescription()+")";
				}


				public ITreeParent getParent() { return NativeFunctionContent.this; }


				public IPropertySource2 getPropertySource() {
					return new NativeFunctionPropertySource(nf);
				}
				
			});
		}
		return r;
	}


	public boolean hasChildren() {
		return true;
	}


	public Collection<IAction> getActions() { return null; }


	public Collection<IContributionItem> getContributionItems() { return null; }


	public IAction getDoubleClickAction() { return null; }


	public FrameworkContainer getFrameworkContainer() { return cont; }

	protected static Image nf_image = FrameworkGUIPlugin.getImageDescriptor("icons/nf_transparent.png").createImage();
		

	public Image getLabelImage() {return null;}


	public String getLabelText() { return "Native functions"; }


	public ITreeParent getParent() { return cont; }


	public IPropertySource2 getPropertySource() { return null; }

}
