/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.frameworkgui.content.transformation;

import java.util.ArrayList;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.definitions.Machine;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource2;
import org.eclipse.ui.views.properties.PropertyDescriptor;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;

/**
 * Property support for Machines.
 * @author istvan rath
 *
 */
public class MachinePropertySource implements IPropertySource2 {

	enum PROP_IDS { FQN, NAME, MODULE_NAME };
	
	
	Machine machine;
	
	public MachinePropertySource(Machine m) 
	{
		machine = m;
	}
	
	
	public boolean isPropertyResettable(Object id) {
		return false;
	}

	public boolean isPropertySet(Object id) {
		return false;
	}

	public Object getEditableValue() {
		return null;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() 
	{
		ArrayList<IPropertyDescriptor> ret = new ArrayList<IPropertyDescriptor>();
		ret.add(new PropertyDescriptor(PROP_IDS.NAME, "Name"));
		ret.add(new PropertyDescriptor(PROP_IDS.FQN, "Fully qualified name"));
		ret.add(new PropertyDescriptor(PROP_IDS.MODULE_NAME, "Module"));
		return ret.toArray(new IPropertyDescriptor[]{});
	}

	public Object getPropertyValue(Object id) {
		if (id.equals(PROP_IDS.FQN))
			return machine.getFqn();
		else if (id.equals(PROP_IDS.NAME))
			return machine.getName();
		else if (id.equals(PROP_IDS.MODULE_NAME))
			return machine.getModule().getFileName();
		return null;
	}

	public void resetPropertyValue(Object id) {
		// not supported (yet)
	}

	public void setPropertyValue(Object id, Object value) {	
		// not supported (yet)
	}

}
