/*******************************************************************************
 * Copyright (c) 2008-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.frameworkgui.views.console.commands.builtin;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.viatra2.framework.IFramework;
import org.eclipse.viatra2.frameworkgui.views.console.commands.IVIATRAConsoleCommandProvider;
import org.eclipse.viatra2.frameworkgui.views.console.commands.IVIATRAConsoleCommandProviderFactory;

/**
 * Basic console commandprovider factory which provides basic functions such as
 *  - about
 *  - listcommands
 *  - help
 *  
 * @author istvan rath
 *
 */
public class BuiltInCommands implements IVIATRAConsoleCommandProviderFactory {

	public BuiltInCommands() {
	}

	public List<IVIATRAConsoleCommandProvider> getProviders(IFramework fw) {
		ArrayList<IVIATRAConsoleCommandProvider> ps = new ArrayList<IVIATRAConsoleCommandProvider>();
		ps.add(new About());
		ps.add(new ListCommands());
		ps.add(new Help());
		ps.add(new ClearCommandHistory());
		ps.add(new PrintCommandHistory());
		ps.add(new SaveCommandScript());
		ps.add(new ExecuteCommandScript());
		return ps;
	}

	
	
	
	
}
