/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.frameworkgui.wizards.model;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * DTO class to pass parameters to the UI and then to the JET engine.
 * @author Istvan Rath
 *
 */
public class FileTemplateExtension 
{
	public class TemplateParameter
	{
		public String name="";
		public String defaultValue="";
		public String value="";
		public String description="";
	}
	
	public String name="";
	public String extension="";
	public String templateFile="";
	public String desc="";
	public String contributorID="";
	
	public Set<TemplateParameter> params=new HashSet<TemplateParameter>();
	
	@Override
	public String toString() 
	{
		return name + " (" + desc + ")";
	}
	
	public Map<String, String> getParameterMap()
	{
		HashMap<String, String> r = new HashMap<String, String>();
		for (TemplateParameter tp : params)
		{
			r.put(tp.name, tp.value);
		}
		return r;
	}
}
