/*******************************************************************************
 * Copyright (c) 2004-2008 Peter Pasztor, Akos Horvath, Gergely Varro, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Peter Pasztor, Akos Horvath, Gergely Varro, Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.gtasm.patternmatcher.extension;

import org.eclipse.viatra2.gtasm.interpreter.exception.ViatraTransformationException;
import org.eclipse.viatra2.gtasm.interpreter.executionEnvironment.IExecutionEnvironment;
import org.eclipse.viatra2.gtasm.patternmatcher.PatternMatcherParameters;
import org.eclipse.viatra2.gtasm.patternmatcher.patterns.IGTRuleMatcher;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTRule;


/**
 * The org.eclipse.viatra2.gtasm.patternmatcher.extension point for the GT matcher
 * 
 * @author Akos Horvath
 * 
 */
public interface IGTRuleMatcherFactory {

	/**
	 * Returns a GT rule matcher to work with
	 * 
	 * @param gtEnviroment
	 *            The execution environment on which the TERMs are evaluated
	 * @param gtRule
	 *            The invoked GT rule
	 * @param mp
	 *            The invocation context of the GT rule
	 * @return a gt rule matcher for the gtRule
	 * @throws ViatraTransformationException
	 */
	public IGTRuleMatcher getGTMatcher(IExecutionEnvironment gtEnviroment,
			GTRule gtRule, PatternMatcherParameters mp)
			throws ViatraTransformationException;

}
