/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.extension;

import org.eclipse.viatra2.gtasm.interpreter.exception.ViatraTransformationException;
import org.eclipse.viatra2.gtasm.interpreter.executionEnvironment.IExecutionEnvironment;
import org.eclipse.viatra2.gtasm.patternmatcher.patterns.IPatternMatcher;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern;


/**
 * The org.eclipse.viatra2.gtasm.patternmatcher.extension point for an alternative LHS matcher for the GT org.eclipse.viatra2.gtasm.interpreter.impl.rules
 * @author Akos Horvath
 */
public interface IAlternativePatternMatcherFactory {
	
	/** Returns a pattern matcher for the input GTPattern 
	 * @param environment The Execution environment
	 * @param pattern The pattern for which the matcher is created
	 * @return
	 * @throws GTASMException
	 */
	public IPatternMatcher getPatternMatcher(IExecutionEnvironment environment, GTPattern pattern) throws ViatraTransformationException;

}
