/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.internal;

/**A mapping between the LHS and RHS input elements 
 * @author Akos Horvath
 *
 */

public class GTElementMapping {
	
	private int  lhsInputOrderIndex , rhsInputOrderIndex;
	private GTElementMappingType mappingType;
	//private GTElementRelationShipMapping relationShips;
	

	public GTElementMapping(int lhsInputIndex,int rhsInputIndex, GTElementMappingType type){
		lhsInputOrderIndex = lhsInputIndex;
		rhsInputOrderIndex = rhsInputIndex;
		mappingType = type;
		//relationShips = new GTElementRelationShipMapping();
	}
	
	public GTElementMapping(int lhsInputIndex,int rhsInputIndex){
		lhsInputOrderIndex = lhsInputIndex;
		rhsInputOrderIndex = rhsInputIndex;
		mappingType = null;
		//relationShips = new GTElementRelationShipMapping();
	}
	
	
	/**
	 * @return the mappingType
	 */
	public GTElementMappingType getMappingType() {
		return mappingType;
	}

	/**
	 * @param mappingType the mappingType to set
	 */
	public void setMappingType(GTElementMappingType mappingType) {
		this.mappingType = mappingType;
	}

	/**
	 * @return the rhsInputOrderIndex
	 */
	public int getRhsInputOrderIndex() {
		return rhsInputOrderIndex;
	}

	/**
	 * @param rhsInputOrderIndex the rhsInputOrderIndex to set
	 */
	public void setRhsInputOrderIndex(int rhsInputOrderIndex) {
		this.rhsInputOrderIndex = rhsInputOrderIndex;
	}

	/**
	 * @return the lhsInputOrderIndex
	 */
	public int getLhsInputOrderIndex() {
		return lhsInputOrderIndex;
	}

	/**
	 * @param lhsInputOrderIndex the lhsInputOrderIndex to set
	 */
	public void setLhsInputOrderIndex(int lhsInputOrderIndex) {
		this.lhsInputOrderIndex = lhsInputOrderIndex;
	}

	/**
	 * @return the relationShips
	 */
//	public GTElementRelationShipMapping getRelationShips() {
//		return relationShips;
//	}

}
