/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.internal;

import java.util.Collection;
import java.util.Vector;

import org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.internal.operation.IUpdatePlanOperation;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.MatchingFrame;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.operation.ISearchPlanOperation;


/**Holds the non-input specific operations of a GT Rule
 * @author Akos Horvath
 *
 */
public class GTOperationContext {
	
	private MatchingFrame returnFrame;
	private Collection<IUpdatePlanOperation> finalOperations; //non input specific operations
	private Collection<ISearchPlanOperation> CheckSet; //containment check operation based on the input parameters parent constraint

	public GTOperationContext(MatchingFrame returnFrame, Collection<IUpdatePlanOperation> finalOperations,
			Collection<ISearchPlanOperation> CheckSet) {
		this.finalOperations = finalOperations;
		this.returnFrame = returnFrame;
		this.CheckSet = CheckSet;
	}

	/**
	 * @return the finalOperations
	 */
	public Collection<IUpdatePlanOperation> getFinalOperations() {
		return finalOperations;
	}

	/**
	 * @return the returnFrame
	 */
	public MatchingFrame getReturnFrame() {
		return returnFrame;
	}

	/**
	 * @param finalOperations the finalOperations to set
	 */
	public void setFinalOperations(Vector<IUpdatePlanOperation> finalOperations) {
		this.finalOperations = finalOperations;
	}

	/**
	 * @return the checkSet
	 */
	protected Collection<ISearchPlanOperation> getCheckSet() {
		return CheckSet;
	}

	/**
	 * @param checkSet the checkSet to set
	 */
	protected void setCheckSet(Collection<ISearchPlanOperation> checkSet) {
		CheckSet = checkSet;
	}

}
