/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.internal.operation;

import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.exceptions.GTOperationException;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.MatchingFrame;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.searchgraph.VariableSearchGraphNode;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;



/**
 * @author Akos Horvath
 *
 */
public class CreateEntity extends CreateElement{

	
	/**
	 * 
	 */
	public CreateEntity(int id, IModelManager manager){
		super(manager,id);
	}
	
	
	@Override
	protected boolean create(MatchingFrame frame) throws GTOperationException{
		frame.setValue(variableIndex, manager.newEntity()); 

		return true;
	}
    
	 public String toString() {
			return getClass().getSimpleName() + " : " + 
					variableIndex;
		}


	public String toString(MatchingFrame frame) {
		
		return "Create Entity: "+ variableIndex;
	}
	
	 @Override
	public AnnotatedElement getErrorfulElement(MatchingFrame frame){
	   	return frame.getPattern().getSearchGraph().getSearchNode(variableIndex).getTraceabilityElement().getRepresentativeEMFElement();
	}	

}
