/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.internal.operation;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.gtmatcher.exceptions.GTOperationException;
import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.MatchingFrame;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.GTASMElement;


/**The root of the manipulation operation hierarchy
 * @author Akos Horvath
 *
 */
public abstract class ElementManipulationOperation implements IUpdatePlanOperation {
	
	public boolean update(MatchingFrame frame) throws GTOperationException {
		return false;
	}
    
    public String toString() {
        return getClass().getSimpleName();
    }
    
    public AnnotatedElement getErrorfulElement(MatchingFrame frame){
    	return null;
    }
    
    public String toString(MatchingFrame frame) {
		return toString();
	}
}