/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.callgraph;

import org.eclipse.viatra2.gtasmmodel.vpm.editmodel.VPMElement;

/** Holds a dangling relation's or relationship's context information
 * @author Akos Horvath
 *
 */
public class DanglingVPMElementDTO {

	VPMElement element;
	BodyNode bodyNode;
	public DanglingVPMElementDTO(VPMElement element, BodyNode bodyNode) {
		this.element = element;
		this.bodyNode = bodyNode;
	}
	/**
	 * @return the bodyNode
	 */
	public BodyNode getBodyNode() {
		return bodyNode;
	}
	/**
	 * @param bodyNode the bodyNode to set
	 */
	public void setBodyNode(BodyNode bodyNode) {
		this.bodyNode = bodyNode;
	}
	/**
	 * @return the element
	 */
	public VPMElement getElement() {
		return element;
	}
	/**
	 * @param element the element to set
	 */
	public void setElement(VPMElement element) {
		this.element = element;
	}
}
