/*******************************************************************************
 * Copyright (c) 2004-2009 Akos Horvath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath - initial API and implementation
 *******************************************************************************/


/**
 * 
 */
package org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.searchgraph.traceability;

import org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.internal.searchgraph.ConstantSearchGraphNode;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;


/**
 * @author Akos Horvath
 *
 */
public class ConstantNodeTraceabilityElement extends NodeTraceabilityElement {

	ConstantSearchGraphNode constantSearchGraphNode;
	
	public ConstantNodeTraceabilityElement(ConstantSearchGraphNode node, AnnotatedElement element){
		super(element);
		constantSearchGraphNode = node;
		constantSearchGraphNode.setTraceabilityElement(this);
	}
	
	@Override
	public ConstantSearchGraphNode getVPMElement() {
		return constantSearchGraphNode;
	}

}
