/*******************************************************************************
 * Copyright (c) 2004-2008 Akos Horvath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Akos Horvath, Gergely Varro - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.patternmatcher.impl.patternmatcher.term;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern;

public abstract class TermHandler implements ITermHandler {
    /* (non-Javadoc)
	 * @see org.eclipse.viatra2.gtasm.patternmatcher.term.ITermHandler#getTermEvaluationOperation(org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern, int, org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term, int)
	 */
    abstract public AbstractTermCheckOperation getTermEvaluationOperation(GTPattern pattern, int uid, Term term, int resultSlot);
    /* (non-Javadoc)
	 * @see org.eclipse.viatra2.gtasm.patternmatcher.term.ITermHandler#getTermCheckOperation(org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern, int, org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term)
	 */
    abstract public AbstractTermCheckOperation getTermCheckOperation(GTPattern pattern, int uid, Term term);
}
