/*******************************************************************************
 * Copyright (c) 2004-2008 Gabor Bergmann and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Gabor Bergmann - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.gtasm.patternmatcher.incremental.simple;

import org.eclipse.viatra2.gtasm.patternmatcher.incremental.adapters.GTASMBuildable;
import org.eclipse.viatra2.gtasm.patternmatcher.incremental.rete.construction.RetePatternBuildException;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPatternBody;



class PatternScaffold<StubHandle, Collector> {
	protected SimpleReteBuilder<StubHandle, Collector> builder;
	protected GTASMBuildable<StubHandle, Collector> buildable;

	protected GTPattern gtPattern;
	protected Collector prodNode; // FIXME

	/**
	 * @param builder
	 * @param pattern
	 */
	public PatternScaffold(SimpleReteBuilder<StubHandle, Collector> builder, GTPattern gtPattern,
			Collector production) {
		super();
		this.builder = builder;
		this.buildable = builder.buildable; // TODO select container?
		this.gtPattern = gtPattern;
		this.prodNode = production;
	}

	public Collector run() throws RetePatternBuildException {
		builder.context.logDebug(
				"SimpleReteBuilder starts construction of: " + gtPattern.getName());

		// Production prodNode = builder.boundary.accessProduction(gtPattern);

		Collector collector = prodNode; 
		// if (false /*gtPattern.isDistinctMatching()*/)
		// {
		// UniquenessEnforcerNode uen = new
		// UniquenessEnforcerNode(builder.reteNet);
		// builder.reteNet.connect(uen,collector);
		// collector = uen;
		// }

		for (Object body : gtPattern.getPatternBodies()) {
			new BodyScaffold<StubHandle, Collector>(builder, this, (GTPatternBody) body, collector)
					.run();
		}

		return prodNode;

	}

}
