/*******************************************************************************
 * Copyright (c) 2004-2008 Andras Okros, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Andras Okros - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.gtasm.trigger.view;

import org.eclipse.viatra2.gtasm.trigger.model.Trigger;

import org.eclipse.ui.views.properties.IPropertyDescriptor;
import org.eclipse.ui.views.properties.IPropertySource2;
import org.eclipse.ui.views.properties.TextPropertyDescriptor;

public class TriggerPropertySource implements IPropertySource2 {

	Trigger trigger;
	protected int priority;
	protected String name;
	protected String mode;  // always (default) | once
	protected String sensitivity; // rise (default) | fall
	protected String startup; // active (default)  | passive
	protected String execution; // forall (default) | iterate
	protected String running;
	
	public TriggerPropertySource(Trigger t){
		super();
		trigger = t;
		
		name = trigger.getName();
		priority = trigger.getPriority();
		mode = trigger.getMode();  
		sensitivity = trigger.getSensitivity(); 
		startup = trigger.getStartup(); 
		execution = trigger.getExecution();
		if (trigger.isRunning()) running = "true"; else running = "false";
	}
	
	public boolean isPropertyResettable(Object id) {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isPropertySet(Object id) {
		// TODO Auto-generated method stub
		return false;
	}

	public Object getEditableValue() {
		// TODO Auto-generated method stub
		return null;
	}

	public IPropertyDescriptor[] getPropertyDescriptors() {
		IPropertyDescriptor[] ipd = new IPropertyDescriptor[7];
		
		TextPropertyDescriptor tpdname = new TextPropertyDescriptor(name,"01. Name");
		TextPropertyDescriptor tpdpriority = new TextPropertyDescriptor(priority,"02. Priority");
		TextPropertyDescriptor tpdsensitivity = new TextPropertyDescriptor(sensitivity,"03. Sensitivity");
		TextPropertyDescriptor tpdexecution = new TextPropertyDescriptor(execution,"04. Execution");
		TextPropertyDescriptor tpdmode = new TextPropertyDescriptor(mode,"05. Mode");
		TextPropertyDescriptor tpdstartup = new TextPropertyDescriptor(startup,"06. Startup");
		TextPropertyDescriptor tpdrunning = new TextPropertyDescriptor(running,"07. Running");
		
		ipd[0] = tpdname;
		ipd[1] = tpdpriority;
		ipd[2] = tpdexecution;
		ipd[3] = tpdsensitivity;
		ipd[4] = tpdmode;
		ipd[5] = tpdstartup;
		ipd[6] = tpdrunning;
		
		return ipd;

	}

	public Object getPropertyValue(Object id) {
		if (id.equals(name) || id.equals(priority) || id.equals(execution) || id.equals(sensitivity) || id.equals(mode) || id.equals(startup) || id.equals(running)) {
			return (id);
		} else return null;
	}

	public void resetPropertyValue(Object id) {
		// TODO Auto-generated method stub
		
	}

	public void setPropertyValue(Object id, Object value) {
		// TODO Auto-generated method stub
		
	}
	

}
