/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.compoundRules.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.compoundRules.CollectionIteratorRule;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.compoundRules.CompoundRulesPackage;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.GTRuleInvocation;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.SimpleRulesPackage;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.ContainmentConstraint;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Collection Iterator Rule</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.compoundRules.impl.CollectionIteratorRuleImpl#getContainmentConstraints <em>Containment Constraints</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.compoundRules.impl.CollectionIteratorRuleImpl#getCondition <em>Condition</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.compoundRules.impl.CollectionIteratorRuleImpl#getGtrule <em>Gtrule</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class CollectionIteratorRuleImpl extends BlockRuleImpl implements CollectionIteratorRule {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * The cached value of the '{@link #getContainmentConstraints() <em>Containment Constraints</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getContainmentConstraints()
	 * @generated
	 * @ordered
	 */
	protected EList<ContainmentConstraint> containmentConstraints;

	/**
	 * The cached value of the '{@link #getCondition() <em>Condition</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCondition()
	 * @generated
	 * @ordered
	 */
	protected Term condition;

	/**
	 * The cached value of the '{@link #getGtrule() <em>Gtrule</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getGtrule()
	 * @generated
	 * @ordered
	 */
	protected GTRuleInvocation gtrule;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CollectionIteratorRuleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CompoundRulesPackage.Literals.COLLECTION_ITERATOR_RULE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ContainmentConstraint> getContainmentConstraints() {
		if (containmentConstraints == null) {
			containmentConstraints = new EObjectContainmentEList<ContainmentConstraint>(ContainmentConstraint.class, this, CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONTAINMENT_CONSTRAINTS);
		}
		return containmentConstraints;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Term getCondition() {
		return condition;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCondition(Term newCondition, NotificationChain msgs) {
		Term oldCondition = condition;
		condition = newCondition;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION, oldCondition, newCondition);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCondition(Term newCondition) {
		if (newCondition != condition) {
			NotificationChain msgs = null;
			if (condition != null)
				msgs = ((InternalEObject)condition).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION, null, msgs);
			if (newCondition != null)
				msgs = ((InternalEObject)newCondition).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION, null, msgs);
			msgs = basicSetCondition(newCondition, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION, newCondition, newCondition));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTRuleInvocation getGtrule() {
		return gtrule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetGtrule(GTRuleInvocation newGtrule, NotificationChain msgs) {
		GTRuleInvocation oldGtrule = gtrule;
		gtrule = newGtrule;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE, oldGtrule, newGtrule);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setGtrule(GTRuleInvocation newGtrule) {
		if (newGtrule != gtrule) {
			NotificationChain msgs = null;
			if (gtrule != null)
				msgs = ((InternalEObject)gtrule).eInverseRemove(this, SimpleRulesPackage.GT_RULE_INVOCATION__INVOKER, GTRuleInvocation.class, msgs);
			if (newGtrule != null)
				msgs = ((InternalEObject)newGtrule).eInverseAdd(this, SimpleRulesPackage.GT_RULE_INVOCATION__INVOKER, GTRuleInvocation.class, msgs);
			msgs = basicSetGtrule(newGtrule, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE, newGtrule, newGtrule));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE:
				if (gtrule != null)
					msgs = ((InternalEObject)gtrule).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE, null, msgs);
				return basicSetGtrule((GTRuleInvocation)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONTAINMENT_CONSTRAINTS:
				return ((InternalEList<?>)getContainmentConstraints()).basicRemove(otherEnd, msgs);
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION:
				return basicSetCondition(null, msgs);
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE:
				return basicSetGtrule(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONTAINMENT_CONSTRAINTS:
				return getContainmentConstraints();
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION:
				return getCondition();
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE:
				return getGtrule();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONTAINMENT_CONSTRAINTS:
				getContainmentConstraints().clear();
				getContainmentConstraints().addAll((Collection<? extends ContainmentConstraint>)newValue);
				return;
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION:
				setCondition((Term)newValue);
				return;
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE:
				setGtrule((GTRuleInvocation)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONTAINMENT_CONSTRAINTS:
				getContainmentConstraints().clear();
				return;
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION:
				setCondition((Term)null);
				return;
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE:
				setGtrule((GTRuleInvocation)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONTAINMENT_CONSTRAINTS:
				return containmentConstraints != null && !containmentConstraints.isEmpty();
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__CONDITION:
				return condition != null;
			case CompoundRulesPackage.COLLECTION_ITERATOR_RULE__GTRULE:
				return gtrule != null;
		}
		return super.eIsSet(featureID);
	}

} //CollectionIteratorRuleImpl
