/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.compoundRules.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.compoundRules.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CompoundRulesFactoryImpl extends EFactoryImpl implements CompoundRulesFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static CompoundRulesFactory init() {
		try {
			CompoundRulesFactory theCompoundRulesFactory = (CompoundRulesFactory)EPackage.Registry.INSTANCE.getEFactory("http:///viatragtasmmodel/gtasm/metamodel/asm/compoundRules.ecore"); 
			if (theCompoundRulesFactory != null) {
				return theCompoundRulesFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new CompoundRulesFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompoundRulesFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case CompoundRulesPackage.SEQUENTIAL_RULE: return createSequentialRule();
			case CompoundRulesPackage.RANDOM_RULE: return createRandomRule();
			case CompoundRulesPackage.PARALLEL_RULE: return createParallelRule();
			case CompoundRulesPackage.CHOOSE_RULE: return createChooseRule();
			case CompoundRulesPackage.FORALL_RULE: return createForallRule();
			case CompoundRulesPackage.ITERATE_RULE: return createIterateRule();
			case CompoundRulesPackage.LET_RULE: return createLetRule();
			case CompoundRulesPackage.WHEN_RULE: return createWhenRule();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SequentialRule createSequentialRule() {
		SequentialRuleImpl sequentialRule = new SequentialRuleImpl();
		return sequentialRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomRule createRandomRule() {
		RandomRuleImpl randomRule = new RandomRuleImpl();
		return randomRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParallelRule createParallelRule() {
		ParallelRuleImpl parallelRule = new ParallelRuleImpl();
		return parallelRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ChooseRule createChooseRule() {
		ChooseRuleImpl chooseRule = new ChooseRuleImpl();
		return chooseRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ForallRule createForallRule() {
		ForallRuleImpl forallRule = new ForallRuleImpl();
		return forallRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IterateRule createIterateRule() {
		IterateRuleImpl iterateRule = new IterateRuleImpl();
		return iterateRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LetRule createLetRule() {
		LetRuleImpl letRule = new LetRuleImpl();
		return letRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public WhenRule createWhenRule() {
		WhenRuleImpl whenRule = new WhenRuleImpl();
		return whenRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CompoundRulesPackage getCompoundRulesPackage() {
		return (CompoundRulesPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static CompoundRulesPackage getPackage() {
		return CompoundRulesPackage.eINSTANCE;
	}

} //CompoundRulesFactoryImpl
