/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules;

import org.eclipse.emf.ecore.EFactory;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.SimpleRulesPackage
 * @generated
 */
public interface SimpleRulesFactory extends EFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SimpleRulesFactory eINSTANCE = org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.impl.SimpleRulesFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Conditional Rule Try</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Conditional Rule Try</em>'.
	 * @generated
	 */
	ConditionalRuleTry createConditionalRuleTry();

	/**
	 * Returns a new object of class '<em>Conditional Rule If</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Conditional Rule If</em>'.
	 * @generated
	 */
	ConditionalRuleIf createConditionalRuleIf();

	/**
	 * Returns a new object of class '<em>Call Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Call Rule</em>'.
	 * @generated
	 */
	CallRule createCallRule();

	/**
	 * Returns a new object of class '<em>Rule Update Variable</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rule Update Variable</em>'.
	 * @generated
	 */
	RuleUpdateVariable createRuleUpdateVariable();

	/**
	 * Returns a new object of class '<em>GT Rule Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>GT Rule Invocation</em>'.
	 * @generated
	 */
	GTRuleInvocation createGTRuleInvocation();

	/**
	 * Returns a new object of class '<em>Rule Update ASM Function</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Rule Update ASM Function</em>'.
	 * @generated
	 */
	RuleUpdateASMFunction createRuleUpdateASMFunction();

	/**
	 * Returns a new object of class '<em>Fail Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Fail Rule</em>'.
	 * @generated
	 */
	FailRule createFailRule();

	/**
	 * Returns a new object of class '<em>Log Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Log Rule</em>'.
	 * @generated
	 */
	LogRule createLogRule();

	/**
	 * Returns a new object of class '<em>Print Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Print Rule</em>'.
	 * @generated
	 */
	PrintRule createPrintRule();

	/**
	 * Returns a new object of class '<em>Skip Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Skip Rule</em>'.
	 * @generated
	 */
	SkipRule createSkipRule();

	/**
	 * Returns a new object of class '<em>Print Ln Rule</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Print Ln Rule</em>'.
	 * @generated
	 */
	PrintLnRule createPrintLnRule();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	SimpleRulesPackage getSimpleRulesPackage();

} //SimpleRulesFactory
