/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class SimpleRulesFactoryImpl extends EFactoryImpl implements SimpleRulesFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static SimpleRulesFactory init() {
		try {
			SimpleRulesFactory theSimpleRulesFactory = (SimpleRulesFactory)EPackage.Registry.INSTANCE.getEFactory("http:///viatragtasmmodel/gtasm/metamodel/asm/simpleRules.ecore"); 
			if (theSimpleRulesFactory != null) {
				return theSimpleRulesFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new SimpleRulesFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimpleRulesFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case SimpleRulesPackage.CONDITIONAL_RULE_TRY: return createConditionalRuleTry();
			case SimpleRulesPackage.CONDITIONAL_RULE_IF: return createConditionalRuleIf();
			case SimpleRulesPackage.CALL_RULE: return createCallRule();
			case SimpleRulesPackage.RULE_UPDATE_VARIABLE: return createRuleUpdateVariable();
			case SimpleRulesPackage.GT_RULE_INVOCATION: return createGTRuleInvocation();
			case SimpleRulesPackage.RULE_UPDATE_ASM_FUNCTION: return createRuleUpdateASMFunction();
			case SimpleRulesPackage.FAIL_RULE: return createFailRule();
			case SimpleRulesPackage.LOG_RULE: return createLogRule();
			case SimpleRulesPackage.PRINT_RULE: return createPrintRule();
			case SimpleRulesPackage.SKIP_RULE: return createSkipRule();
			case SimpleRulesPackage.PRINT_LN_RULE: return createPrintLnRule();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConditionalRuleTry createConditionalRuleTry() {
		ConditionalRuleTryImpl conditionalRuleTry = new ConditionalRuleTryImpl();
		return conditionalRuleTry;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ConditionalRuleIf createConditionalRuleIf() {
		ConditionalRuleIfImpl conditionalRuleIf = new ConditionalRuleIfImpl();
		return conditionalRuleIf;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CallRule createCallRule() {
		CallRuleImpl callRule = new CallRuleImpl();
		return callRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RuleUpdateVariable createRuleUpdateVariable() {
		RuleUpdateVariableImpl ruleUpdateVariable = new RuleUpdateVariableImpl();
		return ruleUpdateVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public GTRuleInvocation createGTRuleInvocation() {
		GTRuleInvocationImpl gtRuleInvocation = new GTRuleInvocationImpl();
		return gtRuleInvocation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RuleUpdateASMFunction createRuleUpdateASMFunction() {
		RuleUpdateASMFunctionImpl ruleUpdateASMFunction = new RuleUpdateASMFunctionImpl();
		return ruleUpdateASMFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FailRule createFailRule() {
		FailRuleImpl failRule = new FailRuleImpl();
		return failRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LogRule createLogRule() {
		LogRuleImpl logRule = new LogRuleImpl();
		return logRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PrintRule createPrintRule() {
		PrintRuleImpl printRule = new PrintRuleImpl();
		return printRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SkipRule createSkipRule() {
		SkipRuleImpl skipRule = new SkipRuleImpl();
		return skipRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PrintLnRule createPrintLnRule() {
		PrintLnRuleImpl printLnRule = new PrintLnRuleImpl();
		return printLnRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimpleRulesPackage getSimpleRulesPackage() {
		return (SimpleRulesPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static SimpleRulesPackage getPackage() {
		return SimpleRulesPackage.eINSTANCE;
	}

} //SimpleRulesFactoryImpl
