/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.GTASMElement;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.SimpleRulesPackage
 * @generated
 */
public class SimpleRulesSwitch<T> {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static SimpleRulesPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SimpleRulesSwitch() {
		if (modelPackage == null) {
			modelPackage = SimpleRulesPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case SimpleRulesPackage.CONDITIONAL_RULE_TRY: {
				ConditionalRuleTry conditionalRuleTry = (ConditionalRuleTry)theEObject;
				T result = caseConditionalRuleTry(conditionalRuleTry);
				if (result == null) result = caseASMRuleInvocation(conditionalRuleTry);
				if (result == null) result = caseGTASMElement(conditionalRuleTry);
				if (result == null) result = caseAnnotatedElement(conditionalRuleTry);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.CONDITIONAL_RULE_IF: {
				ConditionalRuleIf conditionalRuleIf = (ConditionalRuleIf)theEObject;
				T result = caseConditionalRuleIf(conditionalRuleIf);
				if (result == null) result = caseASMRuleInvocation(conditionalRuleIf);
				if (result == null) result = caseGTASMElement(conditionalRuleIf);
				if (result == null) result = caseAnnotatedElement(conditionalRuleIf);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.CALL_RULE: {
				CallRule callRule = (CallRule)theEObject;
				T result = caseCallRule(callRule);
				if (result == null) result = caseASMRuleInvocation(callRule);
				if (result == null) result = caseGTASMElement(callRule);
				if (result == null) result = caseAnnotatedElement(callRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.RULE_UPDATE_VARIABLE: {
				RuleUpdateVariable ruleUpdateVariable = (RuleUpdateVariable)theEObject;
				T result = caseRuleUpdateVariable(ruleUpdateVariable);
				if (result == null) result = caseRuleUpdate(ruleUpdateVariable);
				if (result == null) result = caseASMRuleInvocation(ruleUpdateVariable);
				if (result == null) result = caseGTASMElement(ruleUpdateVariable);
				if (result == null) result = caseAnnotatedElement(ruleUpdateVariable);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.RULE_UPDATE: {
				RuleUpdate ruleUpdate = (RuleUpdate)theEObject;
				T result = caseRuleUpdate(ruleUpdate);
				if (result == null) result = caseASMRuleInvocation(ruleUpdate);
				if (result == null) result = caseGTASMElement(ruleUpdate);
				if (result == null) result = caseAnnotatedElement(ruleUpdate);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.GT_RULE_INVOCATION: {
				GTRuleInvocation gtRuleInvocation = (GTRuleInvocation)theEObject;
				T result = caseGTRuleInvocation(gtRuleInvocation);
				if (result == null) result = caseASMRuleInvocation(gtRuleInvocation);
				if (result == null) result = caseGTASMElement(gtRuleInvocation);
				if (result == null) result = caseAnnotatedElement(gtRuleInvocation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.RULE_UPDATE_ASM_FUNCTION: {
				RuleUpdateASMFunction ruleUpdateASMFunction = (RuleUpdateASMFunction)theEObject;
				T result = caseRuleUpdateASMFunction(ruleUpdateASMFunction);
				if (result == null) result = caseRuleUpdate(ruleUpdateASMFunction);
				if (result == null) result = caseASMRuleInvocation(ruleUpdateASMFunction);
				if (result == null) result = caseGTASMElement(ruleUpdateASMFunction);
				if (result == null) result = caseAnnotatedElement(ruleUpdateASMFunction);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.FAIL_RULE: {
				FailRule failRule = (FailRule)theEObject;
				T result = caseFailRule(failRule);
				if (result == null) result = caseASMRuleInvocation(failRule);
				if (result == null) result = caseGTASMElement(failRule);
				if (result == null) result = caseAnnotatedElement(failRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.LOG_RULE: {
				LogRule logRule = (LogRule)theEObject;
				T result = caseLogRule(logRule);
				if (result == null) result = caseASMRuleInvocation(logRule);
				if (result == null) result = caseGTASMElement(logRule);
				if (result == null) result = caseAnnotatedElement(logRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.PRINT_RULE: {
				PrintRule printRule = (PrintRule)theEObject;
				T result = casePrintRule(printRule);
				if (result == null) result = caseASMRuleInvocation(printRule);
				if (result == null) result = caseGTASMElement(printRule);
				if (result == null) result = caseAnnotatedElement(printRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.SKIP_RULE: {
				SkipRule skipRule = (SkipRule)theEObject;
				T result = caseSkipRule(skipRule);
				if (result == null) result = caseASMRuleInvocation(skipRule);
				if (result == null) result = caseGTASMElement(skipRule);
				if (result == null) result = caseAnnotatedElement(skipRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.MODEL_MANIPULATION_RULE: {
				ModelManipulationRule modelManipulationRule = (ModelManipulationRule)theEObject;
				T result = caseModelManipulationRule(modelManipulationRule);
				if (result == null) result = caseASMRuleInvocation(modelManipulationRule);
				if (result == null) result = caseGTASMElement(modelManipulationRule);
				if (result == null) result = caseAnnotatedElement(modelManipulationRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.ASM_RULE_INVOCATION: {
				ASMRuleInvocation asmRuleInvocation = (ASMRuleInvocation)theEObject;
				T result = caseASMRuleInvocation(asmRuleInvocation);
				if (result == null) result = caseGTASMElement(asmRuleInvocation);
				if (result == null) result = caseAnnotatedElement(asmRuleInvocation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SimpleRulesPackage.PRINT_LN_RULE: {
				PrintLnRule printLnRule = (PrintLnRule)theEObject;
				T result = casePrintLnRule(printLnRule);
				if (result == null) result = caseASMRuleInvocation(printLnRule);
				if (result == null) result = caseGTASMElement(printLnRule);
				if (result == null) result = caseAnnotatedElement(printLnRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Conditional Rule Try</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Conditional Rule Try</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConditionalRuleTry(ConditionalRuleTry object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Conditional Rule If</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Conditional Rule If</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConditionalRuleIf(ConditionalRuleIf object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Call Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Call Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCallRule(CallRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rule Update Variable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rule Update Variable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRuleUpdateVariable(RuleUpdateVariable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rule Update</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rule Update</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRuleUpdate(RuleUpdate object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>GT Rule Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>GT Rule Invocation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGTRuleInvocation(GTRuleInvocation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rule Update ASM Function</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rule Update ASM Function</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRuleUpdateASMFunction(RuleUpdateASMFunction object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Fail Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Fail Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFailRule(FailRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Log Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Log Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLogRule(LogRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Print Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Print Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrintRule(PrintRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Skip Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Skip Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseSkipRule(SkipRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Model Manipulation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Model Manipulation Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModelManipulationRule(ModelManipulationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ASM Rule Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ASM Rule Invocation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseASMRuleInvocation(ASMRuleInvocation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Print Ln Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Print Ln Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePrintLnRule(PrintLnRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Annotated Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnnotatedElement(AnnotatedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>GTASM Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>GTASM Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGTASMElement(GTASMElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //SimpleRulesSwitch
