/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms;

import org.eclipse.emf.common.util.EList;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTPattern;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>GT Pattern Call</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall#getActualParameters <em>Actual Parameters</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall#getCalledPattern <em>Called Pattern</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall#getMatchCounter <em>Match Counter</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.TermsPackage#getGTPatternCall()
 * @model
 * @generated
 */
public interface GTPatternCall extends Term {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Returns the value of the '<em><b>Actual Parameters</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Actual Parameters</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Actual Parameters</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.TermsPackage#getGTPatternCall_ActualParameters()
	 * @model containment="true"
	 * @generated
	 */
	EList<Term> getActualParameters();

	/**
	 * Returns the value of the '<em><b>Called Pattern</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Called Pattern</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Called Pattern</em>' reference.
	 * @see #setCalledPattern(GTPattern)
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.TermsPackage#getGTPatternCall_CalledPattern()
	 * @model ordered="false"
	 * @generated
	 */
	GTPattern getCalledPattern();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall#getCalledPattern <em>Called Pattern</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Called Pattern</em>' reference.
	 * @see #getCalledPattern()
	 * @generated
	 */
	void setCalledPattern(GTPattern value);

	/**
	 * Returns the value of the '<em><b>Match Counter</b></em>' containment reference.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getPatternCall <em>Pattern Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Match Counter</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Match Counter</em>' containment reference.
	 * @see #setMatchCounter(GTMatchCounter)
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.TermsPackage#getGTPatternCall_MatchCounter()
	 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.gt.GTMatchCounter#getPatternCall
	 * @model opposite="patternCall" containment="true"
	 * @generated
	 */
	GTMatchCounter getMatchCounter();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.GTPatternCall#getMatchCounter <em>Match Counter</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Match Counter</em>' containment reference.
	 * @see #getMatchCounter()
	 * @generated
	 */
	void setMatchCounter(GTMatchCounter value);

} // GTPatternCall
