/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.builtInFunctions.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.GTASMElement;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.FunctionInvocation;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.Term;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.builtInFunctions.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.terms.builtInFunctions.BuiltInFunctionsPackage
 * @generated
 */
public class BuiltInFunctionsSwitch<T> {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static BuiltInFunctionsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BuiltInFunctionsSwitch() {
		if (modelPackage == null) {
			modelPackage = BuiltInFunctionsPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case BuiltInFunctionsPackage.ARITHMETIC_OPERATION: {
				ArithmeticOperation arithmeticOperation = (ArithmeticOperation)theEObject;
				T result = caseArithmeticOperation(arithmeticOperation);
				if (result == null) result = caseFunctionInvocation(arithmeticOperation);
				if (result == null) result = caseTerm(arithmeticOperation);
				if (result == null) result = caseGTASMElement(arithmeticOperation);
				if (result == null) result = caseAnnotatedElement(arithmeticOperation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.REMAINDER: {
				Remainder remainder = (Remainder)theEObject;
				T result = caseRemainder(remainder);
				if (result == null) result = caseArithmeticOperation(remainder);
				if (result == null) result = caseFunctionInvocation(remainder);
				if (result == null) result = caseTerm(remainder);
				if (result == null) result = caseGTASMElement(remainder);
				if (result == null) result = caseAnnotatedElement(remainder);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.MULTIPLY: {
				Multiply multiply = (Multiply)theEObject;
				T result = caseMultiply(multiply);
				if (result == null) result = caseArithmeticOperation(multiply);
				if (result == null) result = caseFunctionInvocation(multiply);
				if (result == null) result = caseTerm(multiply);
				if (result == null) result = caseGTASMElement(multiply);
				if (result == null) result = caseAnnotatedElement(multiply);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.PLUS: {
				Plus plus = (Plus)theEObject;
				T result = casePlus(plus);
				if (result == null) result = caseArithmeticOperation(plus);
				if (result == null) result = caseFunctionInvocation(plus);
				if (result == null) result = caseTerm(plus);
				if (result == null) result = caseGTASMElement(plus);
				if (result == null) result = caseAnnotatedElement(plus);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.MINUS: {
				Minus minus = (Minus)theEObject;
				T result = caseMinus(minus);
				if (result == null) result = caseArithmeticOperation(minus);
				if (result == null) result = caseFunctionInvocation(minus);
				if (result == null) result = caseTerm(minus);
				if (result == null) result = caseGTASMElement(minus);
				if (result == null) result = caseAnnotatedElement(minus);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.DIVISION: {
				Division division = (Division)theEObject;
				T result = caseDivision(division);
				if (result == null) result = caseArithmeticOperation(division);
				if (result == null) result = caseFunctionInvocation(division);
				if (result == null) result = caseTerm(division);
				if (result == null) result = caseGTASMElement(division);
				if (result == null) result = caseAnnotatedElement(division);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.RELATIONAL_OPERATION: {
				RelationalOperation relationalOperation = (RelationalOperation)theEObject;
				T result = caseRelationalOperation(relationalOperation);
				if (result == null) result = caseFunctionInvocation(relationalOperation);
				if (result == null) result = caseTerm(relationalOperation);
				if (result == null) result = caseGTASMElement(relationalOperation);
				if (result == null) result = caseAnnotatedElement(relationalOperation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.AND: {
				And and = (And)theEObject;
				T result = caseAnd(and);
				if (result == null) result = caseRelationalOperation(and);
				if (result == null) result = caseFunctionInvocation(and);
				if (result == null) result = caseTerm(and);
				if (result == null) result = caseGTASMElement(and);
				if (result == null) result = caseAnnotatedElement(and);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.EQUALS: {
				Equals equals = (Equals)theEObject;
				T result = caseEquals(equals);
				if (result == null) result = caseRelationalOperation(equals);
				if (result == null) result = caseFunctionInvocation(equals);
				if (result == null) result = caseTerm(equals);
				if (result == null) result = caseGTASMElement(equals);
				if (result == null) result = caseAnnotatedElement(equals);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.GREATER_THAN: {
				GreaterThan greaterThan = (GreaterThan)theEObject;
				T result = caseGreaterThan(greaterThan);
				if (result == null) result = caseRelationalOperation(greaterThan);
				if (result == null) result = caseFunctionInvocation(greaterThan);
				if (result == null) result = caseTerm(greaterThan);
				if (result == null) result = caseGTASMElement(greaterThan);
				if (result == null) result = caseAnnotatedElement(greaterThan);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.GREATER_THAN_OR_EQUAL_TO: {
				GreaterThanOrEqualTo greaterThanOrEqualTo = (GreaterThanOrEqualTo)theEObject;
				T result = caseGreaterThanOrEqualTo(greaterThanOrEqualTo);
				if (result == null) result = caseRelationalOperation(greaterThanOrEqualTo);
				if (result == null) result = caseFunctionInvocation(greaterThanOrEqualTo);
				if (result == null) result = caseTerm(greaterThanOrEqualTo);
				if (result == null) result = caseGTASMElement(greaterThanOrEqualTo);
				if (result == null) result = caseAnnotatedElement(greaterThanOrEqualTo);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.LESS_THAN: {
				LessThan lessThan = (LessThan)theEObject;
				T result = caseLessThan(lessThan);
				if (result == null) result = caseRelationalOperation(lessThan);
				if (result == null) result = caseFunctionInvocation(lessThan);
				if (result == null) result = caseTerm(lessThan);
				if (result == null) result = caseGTASMElement(lessThan);
				if (result == null) result = caseAnnotatedElement(lessThan);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.LESS_THAN_OR_EQUAL_TO: {
				LessThanOrEqualTo lessThanOrEqualTo = (LessThanOrEqualTo)theEObject;
				T result = caseLessThanOrEqualTo(lessThanOrEqualTo);
				if (result == null) result = caseRelationalOperation(lessThanOrEqualTo);
				if (result == null) result = caseFunctionInvocation(lessThanOrEqualTo);
				if (result == null) result = caseTerm(lessThanOrEqualTo);
				if (result == null) result = caseGTASMElement(lessThanOrEqualTo);
				if (result == null) result = caseAnnotatedElement(lessThanOrEqualTo);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.NOT: {
				Not not = (Not)theEObject;
				T result = caseNot(not);
				if (result == null) result = caseRelationalOperation(not);
				if (result == null) result = caseFunctionInvocation(not);
				if (result == null) result = caseTerm(not);
				if (result == null) result = caseGTASMElement(not);
				if (result == null) result = caseAnnotatedElement(not);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.NOT_EQUALS: {
				NotEquals notEquals = (NotEquals)theEObject;
				T result = caseNotEquals(notEquals);
				if (result == null) result = caseRelationalOperation(notEquals);
				if (result == null) result = caseFunctionInvocation(notEquals);
				if (result == null) result = caseTerm(notEquals);
				if (result == null) result = caseGTASMElement(notEquals);
				if (result == null) result = caseAnnotatedElement(notEquals);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.OR: {
				Or or = (Or)theEObject;
				T result = caseOr(or);
				if (result == null) result = caseRelationalOperation(or);
				if (result == null) result = caseFunctionInvocation(or);
				if (result == null) result = caseTerm(or);
				if (result == null) result = caseGTASMElement(or);
				if (result == null) result = caseAnnotatedElement(or);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.XOR: {
				XOr xOr = (XOr)theEObject;
				T result = caseXOr(xOr);
				if (result == null) result = caseRelationalOperation(xOr);
				if (result == null) result = caseFunctionInvocation(xOr);
				if (result == null) result = caseTerm(xOr);
				if (result == null) result = caseGTASMElement(xOr);
				if (result == null) result = caseAnnotatedElement(xOr);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.TO_STRING: {
				ToString toString = (ToString)theEObject;
				T result = caseToString(toString);
				if (result == null) result = caseConversionOperation(toString);
				if (result == null) result = caseFunctionInvocation(toString);
				if (result == null) result = caseTerm(toString);
				if (result == null) result = caseGTASMElement(toString);
				if (result == null) result = caseAnnotatedElement(toString);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.TO_INT: {
				ToInt toInt = (ToInt)theEObject;
				T result = caseToInt(toInt);
				if (result == null) result = caseConversionOperation(toInt);
				if (result == null) result = caseFunctionInvocation(toInt);
				if (result == null) result = caseTerm(toInt);
				if (result == null) result = caseGTASMElement(toInt);
				if (result == null) result = caseAnnotatedElement(toInt);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.TO_BOOLEAN: {
				ToBoolean toBoolean = (ToBoolean)theEObject;
				T result = caseToBoolean(toBoolean);
				if (result == null) result = caseConversionOperation(toBoolean);
				if (result == null) result = caseFunctionInvocation(toBoolean);
				if (result == null) result = caseTerm(toBoolean);
				if (result == null) result = caseGTASMElement(toBoolean);
				if (result == null) result = caseAnnotatedElement(toBoolean);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.TO_DOUBLE: {
				ToDouble toDouble = (ToDouble)theEObject;
				T result = caseToDouble(toDouble);
				if (result == null) result = caseConversionOperation(toDouble);
				if (result == null) result = caseFunctionInvocation(toDouble);
				if (result == null) result = caseTerm(toDouble);
				if (result == null) result = caseGTASMElement(toDouble);
				if (result == null) result = caseAnnotatedElement(toDouble);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.TO_MODEL_ELEMENT: {
				ToModelElement toModelElement = (ToModelElement)theEObject;
				T result = caseToModelElement(toModelElement);
				if (result == null) result = caseConversionOperation(toModelElement);
				if (result == null) result = caseFunctionInvocation(toModelElement);
				if (result == null) result = caseTerm(toModelElement);
				if (result == null) result = caseGTASMElement(toModelElement);
				if (result == null) result = caseAnnotatedElement(toModelElement);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.TO_MULTIPLICITY: {
				ToMultiplicity toMultiplicity = (ToMultiplicity)theEObject;
				T result = caseToMultiplicity(toMultiplicity);
				if (result == null) result = caseConversionOperation(toMultiplicity);
				if (result == null) result = caseFunctionInvocation(toMultiplicity);
				if (result == null) result = caseTerm(toMultiplicity);
				if (result == null) result = caseGTASMElement(toMultiplicity);
				if (result == null) result = caseAnnotatedElement(toMultiplicity);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case BuiltInFunctionsPackage.CONVERSION_OPERATION: {
				ConversionOperation conversionOperation = (ConversionOperation)theEObject;
				T result = caseConversionOperation(conversionOperation);
				if (result == null) result = caseFunctionInvocation(conversionOperation);
				if (result == null) result = caseTerm(conversionOperation);
				if (result == null) result = caseGTASMElement(conversionOperation);
				if (result == null) result = caseAnnotatedElement(conversionOperation);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Arithmetic Operation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Arithmetic Operation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseArithmeticOperation(ArithmeticOperation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Remainder</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Remainder</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRemainder(Remainder object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Multiply</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Multiply</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMultiply(Multiply object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Plus</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Plus</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePlus(Plus object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Minus</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Minus</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseMinus(Minus object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Division</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Division</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseDivision(Division object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Relational Operation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Relational Operation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRelationalOperation(RelationalOperation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>And</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>And</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnd(And object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Equals</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Equals</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEquals(Equals object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Greater Than</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Greater Than</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGreaterThan(GreaterThan object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Greater Than Or Equal To</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Greater Than Or Equal To</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGreaterThanOrEqualTo(GreaterThanOrEqualTo object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Less Than</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Less Than</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLessThan(LessThan object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Less Than Or Equal To</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Less Than Or Equal To</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLessThanOrEqualTo(LessThanOrEqualTo object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Not</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Not</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNot(Not object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Not Equals</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Not Equals</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseNotEquals(NotEquals object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Or</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Or</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOr(Or object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>XOr</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>XOr</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseXOr(XOr object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>To String</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>To String</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToString(ToString object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>To Int</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>To Int</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToInt(ToInt object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>To Boolean</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>To Boolean</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToBoolean(ToBoolean object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>To Double</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>To Double</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToDouble(ToDouble object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>To Model Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>To Model Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToModelElement(ToModelElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>To Multiplicity</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>To Multiplicity</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseToMultiplicity(ToMultiplicity object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Conversion Operation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Conversion Operation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConversionOperation(ConversionOperation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Annotated Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnnotatedElement(AnnotatedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>GTASM Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>GTASM Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGTASMElement(GTASMElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Term</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Term</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTerm(Term object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Function Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Function Invocation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFunctionInvocation(FunctionInvocation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //BuiltInFunctionsSwitch
