/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.creation.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.AnnotatedElement;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.core.GTASMElement;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.ASMRuleInvocation;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.simpleRules.ModelManipulationRule;

import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.creation.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.modelmanagement.manipulationRules.creation.CreationPackage
 * @generated
 */
public class CreationSwitch<T> {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static CreationPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CreationSwitch() {
		if (modelPackage == null) {
			modelPackage = CreationPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	public T doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		}
		else {
			List<EClass> eSuperTypes = theEClass.getESuperTypes();
			return
				eSuperTypes.isEmpty() ?
					defaultCase(theEObject) :
					doSwitch(eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case CreationPackage.RELATIONSHIP_CREATE_RULE: {
				RelationshipCreateRule relationshipCreateRule = (RelationshipCreateRule)theEObject;
				T result = caseRelationshipCreateRule(relationshipCreateRule);
				if (result == null) result = caseModelManipulationRule(relationshipCreateRule);
				if (result == null) result = caseASMRuleInvocation(relationshipCreateRule);
				if (result == null) result = caseGTASMElement(relationshipCreateRule);
				if (result == null) result = caseAnnotatedElement(relationshipCreateRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CreationPackage.RELATION_CREATE_RULE: {
				RelationCreateRule relationCreateRule = (RelationCreateRule)theEObject;
				T result = caseRelationCreateRule(relationCreateRule);
				if (result == null) result = caseElementCreateRule(relationCreateRule);
				if (result == null) result = caseModelManipulationRule(relationCreateRule);
				if (result == null) result = caseASMRuleInvocation(relationCreateRule);
				if (result == null) result = caseGTASMElement(relationCreateRule);
				if (result == null) result = caseAnnotatedElement(relationCreateRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CreationPackage.ELEMENT_CREATE_RULE: {
				ElementCreateRule elementCreateRule = (ElementCreateRule)theEObject;
				T result = caseElementCreateRule(elementCreateRule);
				if (result == null) result = caseModelManipulationRule(elementCreateRule);
				if (result == null) result = caseASMRuleInvocation(elementCreateRule);
				if (result == null) result = caseGTASMElement(elementCreateRule);
				if (result == null) result = caseAnnotatedElement(elementCreateRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CreationPackage.ENTITY_CREATE_RULE: {
				EntityCreateRule entityCreateRule = (EntityCreateRule)theEObject;
				T result = caseEntityCreateRule(entityCreateRule);
				if (result == null) result = caseElementCreateRule(entityCreateRule);
				if (result == null) result = caseModelManipulationRule(entityCreateRule);
				if (result == null) result = caseASMRuleInvocation(entityCreateRule);
				if (result == null) result = caseGTASMElement(entityCreateRule);
				if (result == null) result = caseAnnotatedElement(entityCreateRule);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CreationPackage.CREATE_SUPERTYPE_OF: {
				CreateSupertypeOf createSupertypeOf = (CreateSupertypeOf)theEObject;
				T result = caseCreateSupertypeOf(createSupertypeOf);
				if (result == null) result = caseRelationshipCreateRule(createSupertypeOf);
				if (result == null) result = caseModelManipulationRule(createSupertypeOf);
				if (result == null) result = caseASMRuleInvocation(createSupertypeOf);
				if (result == null) result = caseGTASMElement(createSupertypeOf);
				if (result == null) result = caseAnnotatedElement(createSupertypeOf);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case CreationPackage.CREATE_INSTANCE_OF: {
				CreateInstanceOf createInstanceOf = (CreateInstanceOf)theEObject;
				T result = caseCreateInstanceOf(createInstanceOf);
				if (result == null) result = caseRelationshipCreateRule(createInstanceOf);
				if (result == null) result = caseModelManipulationRule(createInstanceOf);
				if (result == null) result = caseASMRuleInvocation(createInstanceOf);
				if (result == null) result = caseGTASMElement(createInstanceOf);
				if (result == null) result = caseAnnotatedElement(createInstanceOf);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Relationship Create Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Relationship Create Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRelationshipCreateRule(RelationshipCreateRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Relation Create Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Relation Create Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRelationCreateRule(RelationCreateRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Element Create Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Element Create Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseElementCreateRule(ElementCreateRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Entity Create Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Entity Create Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEntityCreateRule(EntityCreateRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Create Supertype Of</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Create Supertype Of</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCreateSupertypeOf(CreateSupertypeOf object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Create Instance Of</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Create Instance Of</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCreateInstanceOf(CreateInstanceOf object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Annotated Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Annotated Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAnnotatedElement(AnnotatedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>GTASM Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>GTASM Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGTASMElement(GTASMElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>ASM Rule Invocation</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>ASM Rule Invocation</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseASMRuleInvocation(ASMRuleInvocation object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Model Manipulation Rule</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Model Manipulation Rule</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModelManipulationRule(ModelManipulationRule object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public T defaultCase(EObject object) {
		return null;
	}

} //CreationSwitch
