/**
 * Copyright (c) 2004-2008 Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * Contributors:  
 * 	Andras Balogh, Akos Horvath, Istvan Rath, Gergely Varro, Daniel Varro - initial model and refinements
 *
 * $Id$
 */
package org.eclipse.viatra2.gtasmmodel.vpm.editmodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Model Element</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getInstance <em>Instance</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSupertype <em>Supertype</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubtype <em>Subtype</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsTo <em>Relations To</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubRelationships <em>Sub Relationships</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSuperRelationships <em>Super Relationships</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getTypeStr <em>Type Str</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getNamespaceStr <em>Namespace Str</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRealElement <em>Real Element</em>}</li>
 *   <li>{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRelationsFrom <em>Relations From</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement()
 * @model abstract="true"
 * @generated
 */
public interface ModelElement extends VPMElement {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = " * Copyright (c) 2006-2010 Istvan Rath and Daniel Varro\r\n * All rights reserved. This program and the accompanying materials\r\n * are made available under the terms of the Eclipse Public License v1.0\r\n * which accompanies this distribution, and is available at\r\n * http://www.eclipse.org/legal/epl-v10.html\r\n *\r\n * Contributors:\r\n *    Istvan Rath, Daniel Varro - initial API and implementation\r\n";

	/**
	 * Returns the value of the '<em><b>Type</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getInstance <em>Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_Type()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getInstance
	 * @model opposite="instance" ordered="false"
	 * @generated
	 */
	EList<ModelElement> getType();

	/**
	 * Returns the value of the '<em><b>Instance</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Instance</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Instance</em>' reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_Instance()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getType
	 * @model opposite="type" ordered="false"
	 * @generated
	 */
	EList<ModelElement> getInstance();

	/**
	 * Returns the value of the '<em><b>Supertype</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubtype <em>Subtype</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Supertype</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Supertype</em>' reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_Supertype()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSubtype
	 * @model opposite="subtype" ordered="false"
	 * @generated
	 */
	EList<ModelElement> getSupertype();

	/**
	 * Returns the value of the '<em><b>Subtype</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSupertype <em>Supertype</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Subtype</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Subtype</em>' reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_Subtype()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getSupertype
	 * @model opposite="supertype" ordered="false"
	 * @generated
	 */
	EList<ModelElement> getSubtype();

	/**
	 * Returns the value of the '<em><b>Relations To</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getTo <em>To</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Relations To</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Relations To</em>' reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_RelationsTo()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getTo
	 * @model opposite="to"
	 * @generated
	 */
	EList<Relation> getRelationsTo();

	/**
	 * Returns the value of the '<em><b>Sub Relationships</b></em>' reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplier <em>Supplier</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sub Relationships</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sub Relationships</em>' reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_SubRelationships()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getSupplier
	 * @model opposite="supplier" ordered="false"
	 * @generated
	 */
	EList<Relationship> getSubRelationships();

	/**
	 * Returns the value of the '<em><b>Super Relationships</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClient <em>Client</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Super Relationships</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Super Relationships</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_SuperRelationships()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relationship#getClient
	 * @model opposite="client" containment="true" ordered="false"
	 * @generated
	 */
	EList<Relationship> getSuperRelationships();

	/**
	 * Returns the value of the '<em><b>Type Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type Str</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type Str</em>' attribute.
	 * @see #setTypeStr(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_TypeStr()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getTypeStr();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getTypeStr <em>Type Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type Str</em>' attribute.
	 * @see #getTypeStr()
	 * @generated
	 */
	void setTypeStr(String value);

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_Name()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getName <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Namespace Str</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Namespace Str</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Namespace Str</em>' attribute.
	 * @see #setNamespaceStr(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_NamespaceStr()
	 * @model unique="false" required="true" ordered="false"
	 * @generated
	 */
	String getNamespaceStr();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getNamespaceStr <em>Namespace Str</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Namespace Str</em>' attribute.
	 * @see #getNamespaceStr()
	 * @generated
	 */
	void setNamespaceStr(String value);

	/**
	 * Returns the value of the '<em><b>Real Element</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Real Element</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Real Element</em>' attribute.
	 * @see #setRealElement(String)
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_RealElement()
	 * @model
	 * @generated
	 */
	String getRealElement();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.ModelElement#getRealElement <em>Real Element</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Real Element</em>' attribute.
	 * @see #getRealElement()
	 * @generated
	 */
	void setRealElement(String value);

	/**
	 * Returns the value of the '<em><b>Relations From</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation}.
	 * It is bidirectional and its opposite is '{@link org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFrom <em>From</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Relations From</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Relations From</em>' containment reference list.
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.EditmodelPackage#getModelElement_RelationsFrom()
	 * @see org.eclipse.viatra2.gtasmmodel.vpm.editmodel.Relation#getFrom
	 * @model opposite="from" containment="true"
	 * @generated
	 */
	EList<Relation> getRelationsFrom();

} // ModelElement
