/**
* Copyright (c) 2007 OptXware Research and Development LLC.
* All rights reserved.   This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*   Daniel Varro - Initial API and implementation
*   Istvan Rath  - Parser Result wrapper
*
*/

package org.eclipse.viatra2.lpgparser.loader;

import org.eclipse.viatra2.errors.info.ErrorInformation;
import org.eclipse.viatra2.gtasmmodel.gtasm.metamodel.asm.definitions.Module;

import java.util.List;

/**
 * This wrapper class is integrated into VTCLParseController
 * 
 * Value Object for passing information to any component calling the parser.
 * Contains:
 * 	- model object (if built)
 *  - error list
 * 
 * @author istvan rath
 * @deprecated
 *
 */
public class ParserResult 
{

	public ParserResult(List<ErrorInformation> errors, Module m) 
	{
		module = m;
		errorList = errors;
	}
	
	public List<ErrorInformation> errorList;
	
	public Module module;
	
}
