/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.treeeditor.commands;

import java.util.Vector;

import org.eclipse.viatra2.errors.VPMCoreException;

public class ViatraCompoundCommand extends ViatraEditorCommand {
	private Vector<ViatraEditorCommand> commands;
	
	public ViatraCompoundCommand()
	{
		commands = new Vector<ViatraEditorCommand>();
	}
	
	public void add(ViatraEditorCommand cmd)
	{
		commands.add(cmd);
	}
	
	public boolean isEmpty()
	{
		return (commands.size() == 0);
	}

	@Override
	public void execute() throws VPMCoreException
	{
		for (int i = 0; i < commands.size(); i++)
			commands.get(i).execute();
	}

	@Override
	public void undo() throws VPMCoreException
	{
		for (int i = commands.size(); i > 0; i--)
			commands.get(i - 1).undo();
	}
}
