/*******************************************************************************
 * Copyright (c) 2004-2008 Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Istvan Rath - initial API and implementation
 *******************************************************************************/

 package org.eclipse.viatra2.treeeditor.properties.validators;

import org.eclipse.viatra2.core.IModelElement;

/**
 * Reports errors when a non-valid FQN is entered in a [;,]-delimited list of FQNs.
 * @author Istvan Rath
 *
 */
public class DelimitedFQNListValidator extends VPMValidator
{

	public DelimitedFQNListValidator(IModelElement e) {super(e);}

	public String isValid(Object value) 
	{
		// strip string of unnecessary whitespaces
		String stripped = ((String) value).replaceAll("[\\s]", "");
		String[] elements = stripped.split("[,;]");
		for (String fqn: elements)
		{
			if (iElement.getModelSpace().getModelManager().getElementByName( fqn )==null)
			{
				return "Invalid FQN";
			}	
		}
		return null; // means valid
	}

}
