/*******************************************************************************
 * Copyright (c) 2009-2010, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Istvan Rath - initial API and implementation
 *******************************************************************************/

package org.eclipse.viatra2.imports.uml2.galileo.modelimporter;

import org.eclipse.viatra2.core.IEntity;
import org.eclipse.viatra2.core.IRelation;
import org.eclipse.viatra2.core.IModelManager;
import org.eclipse.viatra2.errors.VPMCoreException;
import org.eclipse.viatra2.errors.VPMRuntimeException;

/* @generated */
public class UmlModelReference {

IModelManager mm;
public UmlModelReference(IModelManager m) throws Exception
{
	mm=m;
	init();
}
	public IEntity ENT_UML_INTEGER;
	public IEntity ENT_UML_BOOLEAN;
	public IEntity ENT_UML_STRING;
	public IEntity ENT_UML_UNLIMITEDNATURAL;
	public IEntity ENT_UML_COMMENT;
	public IRelation REL_UML_COMMENT_BODY;
	public IRelation REL_UML_COMMENT_ANNOTATEDELEMENT;
	public IEntity ENT_UML_ELEMENT;
	public IRelation REL_UML_ELEMENT_OWNEDELEMENT;
	public IRelation REL_UML_ELEMENT_OWNER;
	public IRelation REL_UML_ELEMENT_OWNEDCOMMENT;
	public IEntity ENT_UML_PACKAGE;
	public IRelation REL_UML_PACKAGE_OWNEDTYPE;
	public IRelation REL_UML_PACKAGE_PACKAGEMERGE;
	public IRelation REL_UML_PACKAGE_PACKAGEDELEMENT;
	public IRelation REL_UML_PACKAGE_NESTEDPACKAGE;
	public IRelation REL_UML_PACKAGE_NESTINGPACKAGE;
	public IRelation REL_UML_PACKAGE_PROFILEAPPLICATION;
	public IEntity ENT_UML_PACKAGEABLEELEMENT;
	public IEntity ENT_UML_NAMEDELEMENT;
	public IRelation REL_UML_NAMEDELEMENT_NAME;
	public IRelation REL_UML_NAMEDELEMENT_VISIBILITY;
	public IRelation REL_UML_NAMEDELEMENT_QUALIFIEDNAME;
	public IRelation REL_UML_NAMEDELEMENT_CLIENTDEPENDENCY;
	public IRelation REL_UML_NAMEDELEMENT_NAMESPACE;
	public IRelation REL_UML_NAMEDELEMENT_NAMEEXPRESSION;
	public IEntity ENT_UML_VISIBILITYKIND;
	public IEntity ENT_UML_DEPENDENCY;
	public IRelation REL_UML_DEPENDENCY_SUPPLIER;
	public IRelation REL_UML_DEPENDENCY_CLIENT;
	public IEntity ENT_UML_DIRECTEDRELATIONSHIP;
	public IRelation REL_UML_DIRECTEDRELATIONSHIP_SOURCE;
	public IRelation REL_UML_DIRECTEDRELATIONSHIP_TARGET;
	public IEntity ENT_UML_RELATIONSHIP;
	public IRelation REL_UML_RELATIONSHIP_RELATEDELEMENT;
	public IEntity ENT_UML_NAMESPACE;
	public IRelation REL_UML_NAMESPACE_ELEMENTIMPORT;
	public IRelation REL_UML_NAMESPACE_PACKAGEIMPORT;
	public IRelation REL_UML_NAMESPACE_OWNEDRULE;
	public IRelation REL_UML_NAMESPACE_MEMBER;
	public IRelation REL_UML_NAMESPACE_IMPORTEDMEMBER;
	public IRelation REL_UML_NAMESPACE_OWNEDMEMBER;
	public IEntity ENT_UML_ELEMENTIMPORT;
	public IRelation REL_UML_ELEMENTIMPORT_VISIBILITY;
	public IRelation REL_UML_ELEMENTIMPORT_ALIAS;
	public IRelation REL_UML_ELEMENTIMPORT_IMPORTEDELEMENT;
	public IRelation REL_UML_ELEMENTIMPORT_IMPORTINGNAMESPACE;
	public IEntity ENT_UML_PACKAGEIMPORT;
	public IRelation REL_UML_PACKAGEIMPORT_VISIBILITY;
	public IRelation REL_UML_PACKAGEIMPORT_IMPORTEDPACKAGE;
	public IRelation REL_UML_PACKAGEIMPORT_IMPORTINGNAMESPACE;
	public IEntity ENT_UML_CONSTRAINT;
	public IRelation REL_UML_CONSTRAINT_CONSTRAINEDELEMENT;
	public IRelation REL_UML_CONSTRAINT_SPECIFICATION;
	public IRelation REL_UML_CONSTRAINT_CONTEXT;
	public IEntity ENT_UML_VALUESPECIFICATION;
	public IEntity ENT_UML_TYPEDELEMENT;
	public IRelation REL_UML_TYPEDELEMENT_TYPE;
	public IEntity ENT_UML_TYPE;
	public IRelation REL_UML_TYPE_PACKAGE;
	public IEntity ENT_UML_ASSOCIATION;
	public IRelation REL_UML_ASSOCIATION_ISDERIVED;
	public IRelation REL_UML_ASSOCIATION_OWNEDEND;
	public IRelation REL_UML_ASSOCIATION_MEMBEREND;
	public IRelation REL_UML_ASSOCIATION_ENDTYPE;
	public IRelation REL_UML_ASSOCIATION_NAVIGABLEOWNEDEND;
	public IEntity ENT_UML_CLASSIFIER;
	public IRelation REL_UML_CLASSIFIER_ISABSTRACT;
	public IRelation REL_UML_CLASSIFIER_GENERALIZATION;
	public IRelation REL_UML_CLASSIFIER_POWERTYPEEXTENT;
	public IRelation REL_UML_CLASSIFIER_FEATURE;
	public IRelation REL_UML_CLASSIFIER_INHERITEDMEMBER;
	public IRelation REL_UML_CLASSIFIER_REDEFINEDCLASSIFIER;
	public IRelation REL_UML_CLASSIFIER_GENERAL;
	public IRelation REL_UML_CLASSIFIER_SUBSTITUTION;
	public IRelation REL_UML_CLASSIFIER_ATTRIBUTE;
	public IRelation REL_UML_CLASSIFIER_REPRESENTATION;
	public IRelation REL_UML_CLASSIFIER_COLLABORATIONUSE;
	public IRelation REL_UML_CLASSIFIER_OWNEDUSECASE;
	public IRelation REL_UML_CLASSIFIER_USECASE;
	public IEntity ENT_UML_REDEFINABLEELEMENT;
	public IRelation REL_UML_REDEFINABLEELEMENT_ISLEAF;
	public IRelation REL_UML_REDEFINABLEELEMENT_REDEFINEDELEMENT;
	public IRelation REL_UML_REDEFINABLEELEMENT_REDEFINITIONCONTEXT;
	public IEntity ENT_UML_TEMPLATEABLEELEMENT;
	public IRelation REL_UML_TEMPLATEABLEELEMENT_TEMPLATEBINDING;
	public IRelation REL_UML_TEMPLATEABLEELEMENT_OWNEDTEMPLATESIGNATURE;
	public IEntity ENT_UML_TEMPLATEBINDING;
	public IRelation REL_UML_TEMPLATEBINDING_SIGNATURE;
	public IRelation REL_UML_TEMPLATEBINDING_PARAMETERSUBSTITUTION;
	public IRelation REL_UML_TEMPLATEBINDING_BOUNDELEMENT;
	public IEntity ENT_UML_TEMPLATESIGNATURE;
	public IRelation REL_UML_TEMPLATESIGNATURE_PARAMETER;
	public IRelation REL_UML_TEMPLATESIGNATURE_OWNEDPARAMETER;
	public IRelation REL_UML_TEMPLATESIGNATURE_TEMPLATE;
	public IEntity ENT_UML_TEMPLATEPARAMETER;
	public IRelation REL_UML_TEMPLATEPARAMETER_SIGNATURE;
	public IRelation REL_UML_TEMPLATEPARAMETER_PARAMETEREDELEMENT;
	public IRelation REL_UML_TEMPLATEPARAMETER_OWNEDPARAMETEREDELEMENT;
	public IRelation REL_UML_TEMPLATEPARAMETER_DEFAULT;
	public IRelation REL_UML_TEMPLATEPARAMETER_OWNEDDEFAULT;
	public IEntity ENT_UML_PARAMETERABLEELEMENT;
	public IRelation REL_UML_PARAMETERABLEELEMENT_OWNINGTEMPLATEPARAMETER;
	public IRelation REL_UML_PARAMETERABLEELEMENT_TEMPLATEPARAMETER;
	public IEntity ENT_UML_TEMPLATEPARAMETERSUBSTITUTION;
	public IRelation REL_UML_TEMPLATEPARAMETERSUBSTITUTION_FORMAL;
	public IRelation REL_UML_TEMPLATEPARAMETERSUBSTITUTION_ACTUAL;
	public IRelation REL_UML_TEMPLATEPARAMETERSUBSTITUTION_OWNEDACTUAL;
	public IRelation REL_UML_TEMPLATEPARAMETERSUBSTITUTION_TEMPLATEBINDING;
	public IEntity ENT_UML_GENERALIZATION;
	public IRelation REL_UML_GENERALIZATION_ISSUBSTITUTABLE;
	public IRelation REL_UML_GENERALIZATION_GENERAL;
	public IRelation REL_UML_GENERALIZATION_GENERALIZATIONSET;
	public IRelation REL_UML_GENERALIZATION_SPECIFIC;
	public IEntity ENT_UML_GENERALIZATIONSET;
	public IRelation REL_UML_GENERALIZATIONSET_ISCOVERING;
	public IRelation REL_UML_GENERALIZATIONSET_ISDISJOINT;
	public IRelation REL_UML_GENERALIZATIONSET_POWERTYPE;
	public IRelation REL_UML_GENERALIZATIONSET_GENERALIZATION;
	public IEntity ENT_UML_FEATURE;
	public IRelation REL_UML_FEATURE_ISSTATIC;
	public IRelation REL_UML_FEATURE_FEATURINGCLASSIFIER;
	public IEntity ENT_UML_SUBSTITUTION;
	public IRelation REL_UML_SUBSTITUTION_CONTRACT;
	public IRelation REL_UML_SUBSTITUTION_SUBSTITUTINGCLASSIFIER;
	public IEntity ENT_UML_REALIZATION;
	public IEntity ENT_UML_ABSTRACTION;
	public IRelation REL_UML_ABSTRACTION_MAPPING;
	public IEntity ENT_UML_OPAQUEEXPRESSION;
	public IRelation REL_UML_OPAQUEEXPRESSION_BODY;
	public IRelation REL_UML_OPAQUEEXPRESSION_LANGUAGE;
	public IRelation REL_UML_OPAQUEEXPRESSION_RESULT;
	public IRelation REL_UML_OPAQUEEXPRESSION_BEHAVIOR;
	public IEntity ENT_UML_PARAMETER;
	public IRelation REL_UML_PARAMETER_DIRECTION;
	public IRelation REL_UML_PARAMETER_DEFAULT;
	public IRelation REL_UML_PARAMETER_ISEXCEPTION;
	public IRelation REL_UML_PARAMETER_ISSTREAM;
	public IRelation REL_UML_PARAMETER_EFFECT;
	public IRelation REL_UML_PARAMETER_PARAMETERSET;
	public IRelation REL_UML_PARAMETER_OPERATION;
	public IRelation REL_UML_PARAMETER_DEFAULTVALUE;
	public IEntity ENT_UML_MULTIPLICITYELEMENT;
	public IRelation REL_UML_MULTIPLICITYELEMENT_ISORDERED;
	public IRelation REL_UML_MULTIPLICITYELEMENT_ISUNIQUE;
	public IRelation REL_UML_MULTIPLICITYELEMENT_UPPER;
	public IRelation REL_UML_MULTIPLICITYELEMENT_LOWER;
	public IRelation REL_UML_MULTIPLICITYELEMENT_UPPERVALUE;
	public IRelation REL_UML_MULTIPLICITYELEMENT_LOWERVALUE;
	public IEntity ENT_UML_CONNECTABLEELEMENT;
	public IRelation REL_UML_CONNECTABLEELEMENT_END;
	public IEntity ENT_UML_CONNECTOREND;
	public IRelation REL_UML_CONNECTOREND_DEFININGEND;
	public IRelation REL_UML_CONNECTOREND_ROLE;
	public IRelation REL_UML_CONNECTOREND_PARTWITHPORT;
	public IEntity ENT_UML_PROPERTY;
	public IRelation REL_UML_PROPERTY_ISDERIVED;
	public IRelation REL_UML_PROPERTY_ISDERIVEDUNION;
	public IRelation REL_UML_PROPERTY_DEFAULT;
	public IRelation REL_UML_PROPERTY_AGGREGATION;
	public IRelation REL_UML_PROPERTY_ISCOMPOSITE;
	public IRelation REL_UML_PROPERTY_CLASS;
	public IRelation REL_UML_PROPERTY_DATATYPE;
	public IRelation REL_UML_PROPERTY_REDEFINEDPROPERTY;
	public IRelation REL_UML_PROPERTY_OWNINGASSOCIATION;
	public IRelation REL_UML_PROPERTY_DEFAULTVALUE;
	public IRelation REL_UML_PROPERTY_OPPOSITE;
	public IRelation REL_UML_PROPERTY_SUBSETTEDPROPERTY;
	public IRelation REL_UML_PROPERTY_ASSOCIATION;
	public IRelation REL_UML_PROPERTY_QUALIFIER;
	public IRelation REL_UML_PROPERTY_ASSOCIATIONEND;
	public IEntity ENT_UML_DEPLOYMENTTARGET;
	public IRelation REL_UML_DEPLOYMENTTARGET_DEPLOYMENT;
	public IRelation REL_UML_DEPLOYMENTTARGET_DEPLOYEDELEMENT;
	public IEntity ENT_UML_DEPLOYMENT;
	public IRelation REL_UML_DEPLOYMENT_DEPLOYEDARTIFACT;
	public IRelation REL_UML_DEPLOYMENT_CONFIGURATION;
	public IRelation REL_UML_DEPLOYMENT_LOCATION;
	public IEntity ENT_UML_DEPLOYEDARTIFACT;
	public IEntity ENT_UML_DEPLOYMENTSPECIFICATION;
	public IRelation REL_UML_DEPLOYMENTSPECIFICATION_DEPLOYMENTLOCATION;
	public IRelation REL_UML_DEPLOYMENTSPECIFICATION_EXECUTIONLOCATION;
	public IRelation REL_UML_DEPLOYMENTSPECIFICATION_DEPLOYMENT;
	public IEntity ENT_UML_ARTIFACT;
	public IRelation REL_UML_ARTIFACT_FILENAME;
	public IRelation REL_UML_ARTIFACT_NESTEDARTIFACT;
	public IRelation REL_UML_ARTIFACT_MANIFESTATION;
	public IRelation REL_UML_ARTIFACT_OWNEDOPERATION;
	public IRelation REL_UML_ARTIFACT_OWNEDATTRIBUTE;
	public IEntity ENT_UML_MANIFESTATION;
	public IRelation REL_UML_MANIFESTATION_UTILIZEDELEMENT;
	public IEntity ENT_UML_OPERATION;
	public IRelation REL_UML_OPERATION_ISQUERY;
	public IRelation REL_UML_OPERATION_ISORDERED;
	public IRelation REL_UML_OPERATION_ISUNIQUE;
	public IRelation REL_UML_OPERATION_LOWER;
	public IRelation REL_UML_OPERATION_UPPER;
	public IRelation REL_UML_OPERATION_INTERFACE;
	public IRelation REL_UML_OPERATION_CLASS;
	public IRelation REL_UML_OPERATION_PRECONDITION;
	public IRelation REL_UML_OPERATION_POSTCONDITION;
	public IRelation REL_UML_OPERATION_REDEFINEDOPERATION;
	public IRelation REL_UML_OPERATION_DATATYPE;
	public IRelation REL_UML_OPERATION_BODYCONDITION;
	public IRelation REL_UML_OPERATION_TYPE;
	public IEntity ENT_UML_BEHAVIORALFEATURE;
	public IRelation REL_UML_BEHAVIORALFEATURE_ISABSTRACT;
	public IRelation REL_UML_BEHAVIORALFEATURE_CONCURRENCY;
	public IRelation REL_UML_BEHAVIORALFEATURE_OWNEDPARAMETER;
	public IRelation REL_UML_BEHAVIORALFEATURE_METHOD;
	public IRelation REL_UML_BEHAVIORALFEATURE_RAISEDEXCEPTION;
	public IRelation REL_UML_BEHAVIORALFEATURE_OWNEDPARAMETERSET;
	public IEntity ENT_UML_BEHAVIOR;
	public IRelation REL_UML_BEHAVIOR_ISREENTRANT;
	public IRelation REL_UML_BEHAVIOR_REDEFINEDBEHAVIOR;
	public IRelation REL_UML_BEHAVIOR_OWNEDPARAMETER;
	public IRelation REL_UML_BEHAVIOR_CONTEXT;
	public IRelation REL_UML_BEHAVIOR_PRECONDITION;
	public IRelation REL_UML_BEHAVIOR_POSTCONDITION;
	public IRelation REL_UML_BEHAVIOR_OWNEDPARAMETERSET;
	public IRelation REL_UML_BEHAVIOR_SPECIFICATION;
	public IEntity ENT_UML_CLASS;
	public IRelation REL_UML_CLASS_ISACTIVE;
	public IRelation REL_UML_CLASS_NESTEDCLASSIFIER;
	public IRelation REL_UML_CLASS_OWNEDOPERATION;
	public IRelation REL_UML_CLASS_SUPERCLASS;
	public IRelation REL_UML_CLASS_OWNEDRECEPTION;
	public IRelation REL_UML_CLASS_EXTENSION;
	public IEntity ENT_UML_BEHAVIOREDCLASSIFIER;
	public IRelation REL_UML_BEHAVIOREDCLASSIFIER_OWNEDBEHAVIOR;
	public IRelation REL_UML_BEHAVIOREDCLASSIFIER_CLASSIFIERBEHAVIOR;
	public IRelation REL_UML_BEHAVIOREDCLASSIFIER_INTERFACEREALIZATION;
	public IRelation REL_UML_BEHAVIOREDCLASSIFIER_OWNEDTRIGGER;
	public IEntity ENT_UML_INTERFACEREALIZATION;
	public IRelation REL_UML_INTERFACEREALIZATION_CONTRACT;
	public IRelation REL_UML_INTERFACEREALIZATION_IMPLEMENTINGCLASSIFIER;
	public IEntity ENT_UML_INTERFACE;
	public IRelation REL_UML_INTERFACE_OWNEDATTRIBUTE;
	public IRelation REL_UML_INTERFACE_OWNEDOPERATION;
	public IRelation REL_UML_INTERFACE_NESTEDCLASSIFIER;
	public IRelation REL_UML_INTERFACE_REDEFINEDINTERFACE;
	public IRelation REL_UML_INTERFACE_OWNEDRECEPTION;
	public IRelation REL_UML_INTERFACE_PROTOCOL;
	public IEntity ENT_UML_RECEPTION;
	public IRelation REL_UML_RECEPTION_SIGNAL;
	public IEntity ENT_UML_SIGNAL;
	public IRelation REL_UML_SIGNAL_OWNEDATTRIBUTE;
	public IEntity ENT_UML_PROTOCOLSTATEMACHINE;
	public IRelation REL_UML_PROTOCOLSTATEMACHINE_CONFORMANCE;
	public IEntity ENT_UML_STATEMACHINE;
	public IRelation REL_UML_STATEMACHINE_REGION;
	public IRelation REL_UML_STATEMACHINE_SUBMACHINESTATE;
	public IRelation REL_UML_STATEMACHINE_CONNECTIONPOINT;
	public IRelation REL_UML_STATEMACHINE_EXTENDEDSTATEMACHINE;
	public IEntity ENT_UML_REGION;
	public IRelation REL_UML_REGION_SUBVERTEX;
	public IRelation REL_UML_REGION_TRANSITION;
	public IRelation REL_UML_REGION_STATE;
	public IRelation REL_UML_REGION_EXTENDEDREGION;
	public IRelation REL_UML_REGION_STATEMACHINE;
	public IEntity ENT_UML_VERTEX;
	public IRelation REL_UML_VERTEX_OUTGOING;
	public IRelation REL_UML_VERTEX_INCOMING;
	public IRelation REL_UML_VERTEX_CONTAINER;
	public IEntity ENT_UML_TRANSITION;
	public IRelation REL_UML_TRANSITION_KIND;
	public IRelation REL_UML_TRANSITION_CONTAINER;
	public IRelation REL_UML_TRANSITION_SOURCE;
	public IRelation REL_UML_TRANSITION_TARGET;
	public IRelation REL_UML_TRANSITION_REDEFINEDTRANSITION;
	public IRelation REL_UML_TRANSITION_GUARD;
	public IRelation REL_UML_TRANSITION_EFFECT;
	public IRelation REL_UML_TRANSITION_TRIGGER;
	public IEntity ENT_UML_TRANSITIONKIND;
	public IEntity ENT_UML_TRIGGER;
	public IRelation REL_UML_TRIGGER_EVENT;
	public IRelation REL_UML_TRIGGER_PORT;
	public IEntity ENT_UML_EVENT;
	public IEntity ENT_UML_PORT;
	public IRelation REL_UML_PORT_ISBEHAVIOR;
	public IRelation REL_UML_PORT_ISSERVICE;
	public IRelation REL_UML_PORT_REQUIRED;
	public IRelation REL_UML_PORT_REDEFINEDPORT;
	public IRelation REL_UML_PORT_PROVIDED;
	public IRelation REL_UML_PORT_PROTOCOL;
	public IEntity ENT_UML_STATE;
	public IRelation REL_UML_STATE_ISCOMPOSITE;
	public IRelation REL_UML_STATE_ISORTHOGONAL;
	public IRelation REL_UML_STATE_ISSIMPLE;
	public IRelation REL_UML_STATE_ISSUBMACHINESTATE;
	public IRelation REL_UML_STATE_SUBMACHINE;
	public IRelation REL_UML_STATE_CONNECTION;
	public IRelation REL_UML_STATE_CONNECTIONPOINT;
	public IRelation REL_UML_STATE_REDEFINEDSTATE;
	public IRelation REL_UML_STATE_STATEINVARIANT;
	public IRelation REL_UML_STATE_ENTRY;
	public IRelation REL_UML_STATE_EXIT;
	public IRelation REL_UML_STATE_DOACTIVITY;
	public IRelation REL_UML_STATE_DEFERRABLETRIGGER;
	public IRelation REL_UML_STATE_REGION;
	public IEntity ENT_UML_CONNECTIONPOINTREFERENCE;
	public IRelation REL_UML_CONNECTIONPOINTREFERENCE_ENTRY;
	public IRelation REL_UML_CONNECTIONPOINTREFERENCE_EXIT;
	public IRelation REL_UML_CONNECTIONPOINTREFERENCE_STATE;
	public IEntity ENT_UML_PSEUDOSTATE;
	public IRelation REL_UML_PSEUDOSTATE_KIND;
	public IRelation REL_UML_PSEUDOSTATE_STATEMACHINE;
	public IRelation REL_UML_PSEUDOSTATE_STATE;
	public IEntity ENT_UML_PSEUDOSTATEKIND;
	public IEntity ENT_UML_PROTOCOLCONFORMANCE;
	public IRelation REL_UML_PROTOCOLCONFORMANCE_GENERALMACHINE;
	public IRelation REL_UML_PROTOCOLCONFORMANCE_SPECIFICMACHINE;
	public IEntity ENT_UML_ENCAPSULATEDCLASSIFIER;
	public IRelation REL_UML_ENCAPSULATEDCLASSIFIER_OWNEDPORT;
	public IEntity ENT_UML_STRUCTUREDCLASSIFIER;
	public IRelation REL_UML_STRUCTUREDCLASSIFIER_OWNEDATTRIBUTE;
	public IRelation REL_UML_STRUCTUREDCLASSIFIER_PART;
	public IRelation REL_UML_STRUCTUREDCLASSIFIER_ROLE;
	public IRelation REL_UML_STRUCTUREDCLASSIFIER_OWNEDCONNECTOR;
	public IEntity ENT_UML_CONNECTOR;
	public IRelation REL_UML_CONNECTOR_KIND;
	public IRelation REL_UML_CONNECTOR_TYPE;
	public IRelation REL_UML_CONNECTOR_REDEFINEDCONNECTOR;
	public IRelation REL_UML_CONNECTOR_END;
	public IRelation REL_UML_CONNECTOR_CONTRACT;
	public IEntity ENT_UML_CONNECTORKIND;
	public IEntity ENT_UML_EXTENSION;
	public IRelation REL_UML_EXTENSION_ISREQUIRED;
	public IRelation REL_UML_EXTENSION_METACLASS;
	public IEntity ENT_UML_EXTENSIONEND;
	public IEntity ENT_UML_STEREOTYPE;
	public IRelation REL_UML_STEREOTYPE_ICON;
	public IEntity ENT_UML_IMAGE;
	public IRelation REL_UML_IMAGE_CONTENT;
	public IRelation REL_UML_IMAGE_LOCATION;
	public IRelation REL_UML_IMAGE_FORMAT;
	public IEntity ENT_UML_PROFILE;
	public IRelation REL_UML_PROFILE_OWNEDSTEREOTYPE;
	public IRelation REL_UML_PROFILE_METACLASSREFERENCE;
	public IRelation REL_UML_PROFILE_METAMODELREFERENCE;
	public IEntity ENT_UML_MODEL;
	public IRelation REL_UML_MODEL_VIEWPOINT;
	public IEntity ENT_UML_PARAMETERSET;
	public IRelation REL_UML_PARAMETERSET_PARAMETER;
	public IRelation REL_UML_PARAMETERSET_CONDITION;
	public IEntity ENT_UML_CALLCONCURRENCYKIND;
	public IEntity ENT_UML_DATATYPE;
	public IRelation REL_UML_DATATYPE_OWNEDATTRIBUTE;
	public IRelation REL_UML_DATATYPE_OWNEDOPERATION;
	public IEntity ENT_UML_OPERATIONTEMPLATEPARAMETER;
	public IEntity ENT_UML_STRUCTURALFEATURE;
	public IRelation REL_UML_STRUCTURALFEATURE_ISREADONLY;
	public IEntity ENT_UML_AGGREGATIONKIND;
	public IEntity ENT_UML_CONNECTABLEELEMENTTEMPLATEPARAMETER;
	public IEntity ENT_UML_PARAMETERDIRECTIONKIND;
	public IEntity ENT_UML_PARAMETEREFFECTKIND;
	public IEntity ENT_UML_COLLABORATIONUSE;
	public IRelation REL_UML_COLLABORATIONUSE_TYPE;
	public IRelation REL_UML_COLLABORATIONUSE_ROLEBINDING;
	public IEntity ENT_UML_COLLABORATION;
	public IRelation REL_UML_COLLABORATION_COLLABORATIONROLE;
	public IEntity ENT_UML_USECASE;
	public IRelation REL_UML_USECASE_INCLUDE;
	public IRelation REL_UML_USECASE_EXTEND;
	public IRelation REL_UML_USECASE_EXTENSIONPOINT;
	public IRelation REL_UML_USECASE_SUBJECT;
	public IEntity ENT_UML_INCLUDE;
	public IRelation REL_UML_INCLUDE_ADDITION;
	public IRelation REL_UML_INCLUDE_INCLUDINGCASE;
	public IEntity ENT_UML_EXTEND;
	public IRelation REL_UML_EXTEND_EXTENDEDCASE;
	public IRelation REL_UML_EXTEND_CONDITION;
	public IRelation REL_UML_EXTEND_EXTENSIONLOCATION;
	public IRelation REL_UML_EXTEND_EXTENSION;
	public IEntity ENT_UML_EXTENSIONPOINT;
	public IRelation REL_UML_EXTENSIONPOINT_USECASE;
	public IEntity ENT_UML_REDEFINABLETEMPLATESIGNATURE;
	public IRelation REL_UML_REDEFINABLETEMPLATESIGNATURE_EXTENDEDSIGNATURE;
	public IRelation REL_UML_REDEFINABLETEMPLATESIGNATURE_INHERITEDPARAMETER;
	public IRelation REL_UML_REDEFINABLETEMPLATESIGNATURE_CLASSIFIER;
	public IEntity ENT_UML_CLASSIFIERTEMPLATEPARAMETER;
	public IRelation REL_UML_CLASSIFIERTEMPLATEPARAMETER_ALLOWSUBSTITUTABLE;
	public IRelation REL_UML_CLASSIFIERTEMPLATEPARAMETER_CONSTRAININGCLASSIFIER;
	public IEntity ENT_UML_STRINGEXPRESSION;
	public IRelation REL_UML_STRINGEXPRESSION_SUBEXPRESSION;
	public IRelation REL_UML_STRINGEXPRESSION_OWNINGEXPRESSION;
	public IEntity ENT_UML_EXPRESSION;
	public IRelation REL_UML_EXPRESSION_SYMBOL;
	public IRelation REL_UML_EXPRESSION_OPERAND;
	public IEntity ENT_UML_USAGE;
	public IEntity ENT_UML_PACKAGEMERGE;
	public IRelation REL_UML_PACKAGEMERGE_MERGEDPACKAGE;
	public IRelation REL_UML_PACKAGEMERGE_RECEIVINGPACKAGE;
	public IEntity ENT_UML_PROFILEAPPLICATION;
	public IRelation REL_UML_PROFILEAPPLICATION_ISSTRICT;
	public IRelation REL_UML_PROFILEAPPLICATION_APPLIEDPROFILE;
	public IRelation REL_UML_PROFILEAPPLICATION_APPLYINGPACKAGE;
	public IEntity ENT_UML_ENUMERATION;
	public IRelation REL_UML_ENUMERATION_OWNEDLITERAL;
	public IEntity ENT_UML_ENUMERATIONLITERAL;
	public IRelation REL_UML_ENUMERATIONLITERAL_ENUMERATION;
	public IEntity ENT_UML_INSTANCESPECIFICATION;
	public IRelation REL_UML_INSTANCESPECIFICATION_CLASSIFIER;
	public IRelation REL_UML_INSTANCESPECIFICATION_SLOT;
	public IRelation REL_UML_INSTANCESPECIFICATION_SPECIFICATION;
	public IEntity ENT_UML_SLOT;
	public IRelation REL_UML_SLOT_DEFININGFEATURE;
	public IRelation REL_UML_SLOT_VALUE;
	public IRelation REL_UML_SLOT_OWNINGINSTANCE;
	public IEntity ENT_UML_PRIMITIVETYPE;
	public IEntity ENT_UML_LITERALSPECIFICATION;
	public IEntity ENT_UML_LITERALINTEGER;
	public IRelation REL_UML_LITERALINTEGER_VALUE;
	public IEntity ENT_UML_LITERALSTRING;
	public IRelation REL_UML_LITERALSTRING_VALUE;
	public IEntity ENT_UML_LITERALBOOLEAN;
	public IRelation REL_UML_LITERALBOOLEAN_VALUE;
	public IEntity ENT_UML_LITERALNULL;
	public IEntity ENT_UML_INSTANCEVALUE;
	public IRelation REL_UML_INSTANCEVALUE_INSTANCE;
	public IEntity ENT_UML_LITERALUNLIMITEDNATURAL;
	public IRelation REL_UML_LITERALUNLIMITEDNATURAL_VALUE;
	public IEntity ENT_UML_OPAQUEBEHAVIOR;
	public IRelation REL_UML_OPAQUEBEHAVIOR_BODY;
	public IRelation REL_UML_OPAQUEBEHAVIOR_LANGUAGE;
	public IEntity ENT_UML_FUNCTIONBEHAVIOR;
	public IEntity ENT_UML_OPAQUEACTION;
	public IRelation REL_UML_OPAQUEACTION_BODY;
	public IRelation REL_UML_OPAQUEACTION_LANGUAGE;
	public IRelation REL_UML_OPAQUEACTION_INPUTVALUE;
	public IRelation REL_UML_OPAQUEACTION_OUTPUTVALUE;
	public IEntity ENT_UML_ACTION;
	public IRelation REL_UML_ACTION_OUTPUT;
	public IRelation REL_UML_ACTION_INPUT;
	public IRelation REL_UML_ACTION_CONTEXT;
	public IRelation REL_UML_ACTION_LOCALPRECONDITION;
	public IRelation REL_UML_ACTION_LOCALPOSTCONDITION;
	public IEntity ENT_UML_EXECUTABLENODE;
	public IRelation REL_UML_EXECUTABLENODE_HANDLER;
	public IEntity ENT_UML_ACTIVITYNODE;
	public IRelation REL_UML_ACTIVITYNODE_INSTRUCTUREDNODE;
	public IRelation REL_UML_ACTIVITYNODE_ACTIVITY;
	public IRelation REL_UML_ACTIVITYNODE_OUTGOING;
	public IRelation REL_UML_ACTIVITYNODE_INCOMING;
	public IRelation REL_UML_ACTIVITYNODE_INPARTITION;
	public IRelation REL_UML_ACTIVITYNODE_ININTERRUPTIBLEREGION;
	public IRelation REL_UML_ACTIVITYNODE_INGROUP;
	public IRelation REL_UML_ACTIVITYNODE_REDEFINEDNODE;
	public IEntity ENT_UML_STRUCTUREDACTIVITYNODE;
	public IRelation REL_UML_STRUCTUREDACTIVITYNODE_MUSTISOLATE;
	public IRelation REL_UML_STRUCTUREDACTIVITYNODE_VARIABLE;
	public IRelation REL_UML_STRUCTUREDACTIVITYNODE_EDGE;
	public IRelation REL_UML_STRUCTUREDACTIVITYNODE_NODE;
	public IEntity ENT_UML_ACTIVITYGROUP;
	public IRelation REL_UML_ACTIVITYGROUP_SUBGROUP;
	public IRelation REL_UML_ACTIVITYGROUP_SUPERGROUP;
	public IRelation REL_UML_ACTIVITYGROUP_INACTIVITY;
	public IRelation REL_UML_ACTIVITYGROUP_CONTAINEDEDGE;
	public IRelation REL_UML_ACTIVITYGROUP_CONTAINEDNODE;
	public IEntity ENT_UML_ACTIVITY;
	public IRelation REL_UML_ACTIVITY_ISREADONLY;
	public IRelation REL_UML_ACTIVITY_ISSINGLEEXECUTION;
	public IRelation REL_UML_ACTIVITY_STRUCTUREDNODE;
	public IRelation REL_UML_ACTIVITY_VARIABLE;
	public IRelation REL_UML_ACTIVITY_NODE;
	public IRelation REL_UML_ACTIVITY_EDGE;
	public IRelation REL_UML_ACTIVITY_PARTITION;
	public IRelation REL_UML_ACTIVITY_GROUP;
	public IEntity ENT_UML_VARIABLE;
	public IRelation REL_UML_VARIABLE_SCOPE;
	public IRelation REL_UML_VARIABLE_ACTIVITYSCOPE;
	public IEntity ENT_UML_ACTIVITYEDGE;
	public IRelation REL_UML_ACTIVITYEDGE_SOURCE;
	public IRelation REL_UML_ACTIVITYEDGE_TARGET;
	public IRelation REL_UML_ACTIVITYEDGE_REDEFINEDEDGE;
	public IRelation REL_UML_ACTIVITYEDGE_INPARTITION;
	public IRelation REL_UML_ACTIVITYEDGE_GUARD;
	public IRelation REL_UML_ACTIVITYEDGE_WEIGHT;
	public IRelation REL_UML_ACTIVITYEDGE_INTERRUPTS;
	public IRelation REL_UML_ACTIVITYEDGE_INSTRUCTUREDNODE;
	public IRelation REL_UML_ACTIVITYEDGE_INGROUP;
	public IRelation REL_UML_ACTIVITYEDGE_ACTIVITY;
	public IEntity ENT_UML_ACTIVITYPARTITION;
	public IRelation REL_UML_ACTIVITYPARTITION_ISDIMENSION;
	public IRelation REL_UML_ACTIVITYPARTITION_ISEXTERNAL;
	public IRelation REL_UML_ACTIVITYPARTITION_NODE;
	public IRelation REL_UML_ACTIVITYPARTITION_SUBPARTITION;
	public IRelation REL_UML_ACTIVITYPARTITION_SUPERPARTITION;
	public IRelation REL_UML_ACTIVITYPARTITION_REPRESENTS;
	public IRelation REL_UML_ACTIVITYPARTITION_EDGE;
	public IEntity ENT_UML_INTERRUPTIBLEACTIVITYREGION;
	public IRelation REL_UML_INTERRUPTIBLEACTIVITYREGION_NODE;
	public IRelation REL_UML_INTERRUPTIBLEACTIVITYREGION_INTERRUPTINGEDGE;
	public IEntity ENT_UML_EXCEPTIONHANDLER;
	public IRelation REL_UML_EXCEPTIONHANDLER_HANDLERBODY;
	public IRelation REL_UML_EXCEPTIONHANDLER_EXCEPTIONINPUT;
	public IRelation REL_UML_EXCEPTIONHANDLER_EXCEPTIONTYPE;
	public IRelation REL_UML_EXCEPTIONHANDLER_PROTECTEDNODE;
	public IEntity ENT_UML_OBJECTNODE;
	public IRelation REL_UML_OBJECTNODE_ORDERING;
	public IRelation REL_UML_OBJECTNODE_ISCONTROLTYPE;
	public IRelation REL_UML_OBJECTNODE_UPPERBOUND;
	public IRelation REL_UML_OBJECTNODE_INSTATE;
	public IRelation REL_UML_OBJECTNODE_SELECTION;
	public IEntity ENT_UML_OBJECTNODEORDERINGKIND;
	public IEntity ENT_UML_OUTPUTPIN;
	public IEntity ENT_UML_PIN;
	public IRelation REL_UML_PIN_ISCONTROL;
	public IEntity ENT_UML_INPUTPIN;
	public IEntity ENT_UML_CALLACTION;
	public IRelation REL_UML_CALLACTION_ISSYNCHRONOUS;
	public IRelation REL_UML_CALLACTION_RESULT;
	public IEntity ENT_UML_INVOCATIONACTION;
	public IRelation REL_UML_INVOCATIONACTION_ARGUMENT;
	public IRelation REL_UML_INVOCATIONACTION_ONPORT;
	public IEntity ENT_UML_SENDSIGNALACTION;
	public IRelation REL_UML_SENDSIGNALACTION_TARGET;
	public IRelation REL_UML_SENDSIGNALACTION_SIGNAL;
	public IEntity ENT_UML_CALLOPERATIONACTION;
	public IRelation REL_UML_CALLOPERATIONACTION_OPERATION;
	public IRelation REL_UML_CALLOPERATIONACTION_TARGET;
	public IEntity ENT_UML_CALLBEHAVIORACTION;
	public IRelation REL_UML_CALLBEHAVIORACTION_BEHAVIOR;
	public IEntity ENT_UML_SEQUENCENODE;
	public IRelation REL_UML_SEQUENCENODE_EXECUTABLENODE;
	public IEntity ENT_UML_CONTROLNODE;
	public IEntity ENT_UML_CONTROLFLOW;
	public IEntity ENT_UML_INITIALNODE;
	public IEntity ENT_UML_ACTIVITYPARAMETERNODE;
	public IRelation REL_UML_ACTIVITYPARAMETERNODE_PARAMETER;
	public IEntity ENT_UML_VALUEPIN;
	public IRelation REL_UML_VALUEPIN_VALUE;
	public IEntity ENT_UML_MESSAGE;
	public IRelation REL_UML_MESSAGE_MESSAGEKIND;
	public IRelation REL_UML_MESSAGE_MESSAGESORT;
	public IRelation REL_UML_MESSAGE_RECEIVEEVENT;
	public IRelation REL_UML_MESSAGE_SENDEVENT;
	public IRelation REL_UML_MESSAGE_CONNECTOR;
	public IRelation REL_UML_MESSAGE_INTERACTION;
	public IRelation REL_UML_MESSAGE_ARGUMENT;
	public IRelation REL_UML_MESSAGE_SIGNATURE;
	public IEntity ENT_UML_MESSAGEKIND;
	public IEntity ENT_UML_MESSAGESORT;
	public IEntity ENT_UML_MESSAGEEND;
	public IRelation REL_UML_MESSAGEEND_MESSAGE;
	public IEntity ENT_UML_INTERACTION;
	public IRelation REL_UML_INTERACTION_LIFELINE;
	public IRelation REL_UML_INTERACTION_FRAGMENT;
	public IRelation REL_UML_INTERACTION_ACTION;
	public IRelation REL_UML_INTERACTION_FORMALGATE;
	public IRelation REL_UML_INTERACTION_MESSAGE;
	public IEntity ENT_UML_INTERACTIONFRAGMENT;
	public IRelation REL_UML_INTERACTIONFRAGMENT_COVERED;
	public IRelation REL_UML_INTERACTIONFRAGMENT_GENERALORDERING;
	public IRelation REL_UML_INTERACTIONFRAGMENT_ENCLOSINGINTERACTION;
	public IRelation REL_UML_INTERACTIONFRAGMENT_ENCLOSINGOPERAND;
	public IEntity ENT_UML_LIFELINE;
	public IRelation REL_UML_LIFELINE_REPRESENTS;
	public IRelation REL_UML_LIFELINE_INTERACTION;
	public IRelation REL_UML_LIFELINE_SELECTOR;
	public IRelation REL_UML_LIFELINE_DECOMPOSEDAS;
	public IRelation REL_UML_LIFELINE_COVEREDBY;
	public IEntity ENT_UML_PARTDECOMPOSITION;
	public IEntity ENT_UML_INTERACTIONUSE;
	public IRelation REL_UML_INTERACTIONUSE_REFERSTO;
	public IRelation REL_UML_INTERACTIONUSE_ACTUALGATE;
	public IRelation REL_UML_INTERACTIONUSE_ARGUMENT;
	public IEntity ENT_UML_GATE;
	public IEntity ENT_UML_GENERALORDERING;
	public IRelation REL_UML_GENERALORDERING_BEFORE;
	public IRelation REL_UML_GENERALORDERING_AFTER;
	public IEntity ENT_UML_OCCURRENCESPECIFICATION;
	public IRelation REL_UML_OCCURRENCESPECIFICATION_TOBEFORE;
	public IRelation REL_UML_OCCURRENCESPECIFICATION_EVENT;
	public IRelation REL_UML_OCCURRENCESPECIFICATION_TOAFTER;
	public IEntity ENT_UML_INTERACTIONOPERAND;
	public IRelation REL_UML_INTERACTIONOPERAND_GUARD;
	public IRelation REL_UML_INTERACTIONOPERAND_FRAGMENT;
	public IEntity ENT_UML_INTERACTIONCONSTRAINT;
	public IRelation REL_UML_INTERACTIONCONSTRAINT_MININT;
	public IRelation REL_UML_INTERACTIONCONSTRAINT_MAXINT;
	public IEntity ENT_UML_EXECUTIONSPECIFICATION;
	public IRelation REL_UML_EXECUTIONSPECIFICATION_START;
	public IRelation REL_UML_EXECUTIONSPECIFICATION_FINISH;
	public IEntity ENT_UML_STATEINVARIANT;
	public IRelation REL_UML_STATEINVARIANT_INVARIANT;
	public IEntity ENT_UML_ACTIONEXECUTIONSPECIFICATION;
	public IRelation REL_UML_ACTIONEXECUTIONSPECIFICATION_ACTION;
	public IEntity ENT_UML_BEHAVIOREXECUTIONSPECIFICATION;
	public IRelation REL_UML_BEHAVIOREXECUTIONSPECIFICATION_BEHAVIOR;
	public IEntity ENT_UML_EXECUTIONEVENT;
	public IEntity ENT_UML_CREATIONEVENT;
	public IEntity ENT_UML_DESTRUCTIONEVENT;
	public IEntity ENT_UML_SENDOPERATIONEVENT;
	public IRelation REL_UML_SENDOPERATIONEVENT_OPERATION;
	public IEntity ENT_UML_MESSAGEEVENT;
	public IEntity ENT_UML_SENDSIGNALEVENT;
	public IRelation REL_UML_SENDSIGNALEVENT_SIGNAL;
	public IEntity ENT_UML_MESSAGEOCCURRENCESPECIFICATION;
	public IEntity ENT_UML_EXECUTIONOCCURRENCESPECIFICATION;
	public IRelation REL_UML_EXECUTIONOCCURRENCESPECIFICATION_EXECUTION;
	public IEntity ENT_UML_RECEIVEOPERATIONEVENT;
	public IRelation REL_UML_RECEIVEOPERATIONEVENT_OPERATION;
	public IEntity ENT_UML_RECEIVESIGNALEVENT;
	public IRelation REL_UML_RECEIVESIGNALEVENT_SIGNAL;
	public IEntity ENT_UML_ACTOR;
	public IEntity ENT_UML_CALLEVENT;
	public IRelation REL_UML_CALLEVENT_OPERATION;
	public IEntity ENT_UML_CHANGEEVENT;
	public IRelation REL_UML_CHANGEEVENT_CHANGEEXPRESSION;
	public IEntity ENT_UML_SIGNALEVENT;
	public IRelation REL_UML_SIGNALEVENT_SIGNAL;
	public IEntity ENT_UML_ANYRECEIVEEVENT;
	public IEntity ENT_UML_FORKNODE;
	public IEntity ENT_UML_FLOWFINALNODE;
	public IEntity ENT_UML_FINALNODE;
	public IEntity ENT_UML_CENTRALBUFFERNODE;
	public IEntity ENT_UML_MERGENODE;
	public IEntity ENT_UML_DECISIONNODE;
	public IRelation REL_UML_DECISIONNODE_DECISIONINPUT;
	public IRelation REL_UML_DECISIONNODE_DECISIONINPUTFLOW;
	public IEntity ENT_UML_OBJECTFLOW;
	public IRelation REL_UML_OBJECTFLOW_ISMULTICAST;
	public IRelation REL_UML_OBJECTFLOW_ISMULTIRECEIVE;
	public IRelation REL_UML_OBJECTFLOW_TRANSFORMATION;
	public IRelation REL_UML_OBJECTFLOW_SELECTION;
	public IEntity ENT_UML_ACTIVITYFINALNODE;
	public IEntity ENT_UML_COMPONENTREALIZATION;
	public IRelation REL_UML_COMPONENTREALIZATION_ABSTRACTION;
	public IRelation REL_UML_COMPONENTREALIZATION_REALIZINGCLASSIFIER;
	public IEntity ENT_UML_COMPONENT;
	public IRelation REL_UML_COMPONENT_ISINDIRECTLYINSTANTIATED;
	public IRelation REL_UML_COMPONENT_REQUIRED;
	public IRelation REL_UML_COMPONENT_PROVIDED;
	public IRelation REL_UML_COMPONENT_PACKAGEDELEMENT;
	public IRelation REL_UML_COMPONENT_REALIZATION;
	public IEntity ENT_UML_NODE;
	public IRelation REL_UML_NODE_NESTEDNODE;
	public IEntity ENT_UML_COMMUNICATIONPATH;
	public IEntity ENT_UML_DEVICE;
	public IEntity ENT_UML_EXECUTIONENVIRONMENT;
	public IEntity ENT_UML_COMBINEDFRAGMENT;
	public IRelation REL_UML_COMBINEDFRAGMENT_INTERACTIONOPERATOR;
	public IRelation REL_UML_COMBINEDFRAGMENT_OPERAND;
	public IRelation REL_UML_COMBINEDFRAGMENT_CFRAGMENTGATE;
	public IEntity ENT_UML_INTERACTIONOPERATORKIND;
	public IEntity ENT_UML_CONTINUATION;
	public IRelation REL_UML_CONTINUATION_SETTING;
	public IEntity ENT_UML_CONSIDERIGNOREFRAGMENT;
	public IRelation REL_UML_CONSIDERIGNOREFRAGMENT_MESSAGE;
	public IEntity ENT_UML_CREATEOBJECTACTION;
	public IRelation REL_UML_CREATEOBJECTACTION_CLASSIFIER;
	public IRelation REL_UML_CREATEOBJECTACTION_RESULT;
	public IEntity ENT_UML_DESTROYOBJECTACTION;
	public IRelation REL_UML_DESTROYOBJECTACTION_ISDESTROYLINKS;
	public IRelation REL_UML_DESTROYOBJECTACTION_ISDESTROYOWNEDOBJECTS;
	public IRelation REL_UML_DESTROYOBJECTACTION_TARGET;
	public IEntity ENT_UML_TESTIDENTITYACTION;
	public IRelation REL_UML_TESTIDENTITYACTION_FIRST;
	public IRelation REL_UML_TESTIDENTITYACTION_SECOND;
	public IRelation REL_UML_TESTIDENTITYACTION_RESULT;
	public IEntity ENT_UML_READSELFACTION;
	public IRelation REL_UML_READSELFACTION_RESULT;
	public IEntity ENT_UML_STRUCTURALFEATUREACTION;
	public IRelation REL_UML_STRUCTURALFEATUREACTION_STRUCTURALFEATURE;
	public IRelation REL_UML_STRUCTURALFEATUREACTION_OBJECT;
	public IEntity ENT_UML_READSTRUCTURALFEATUREACTION;
	public IRelation REL_UML_READSTRUCTURALFEATUREACTION_RESULT;
	public IEntity ENT_UML_WRITESTRUCTURALFEATUREACTION;
	public IRelation REL_UML_WRITESTRUCTURALFEATUREACTION_VALUE;
	public IRelation REL_UML_WRITESTRUCTURALFEATUREACTION_RESULT;
	public IEntity ENT_UML_CLEARSTRUCTURALFEATUREACTION;
	public IRelation REL_UML_CLEARSTRUCTURALFEATUREACTION_RESULT;
	public IEntity ENT_UML_REMOVESTRUCTURALFEATUREVALUEACTION;
	public IRelation REL_UML_REMOVESTRUCTURALFEATUREVALUEACTION_ISREMOVEDUPLICATES;
	public IRelation REL_UML_REMOVESTRUCTURALFEATUREVALUEACTION_REMOVEAT;
	public IEntity ENT_UML_ADDSTRUCTURALFEATUREVALUEACTION;
	public IRelation REL_UML_ADDSTRUCTURALFEATUREVALUEACTION_ISREPLACEALL;
	public IRelation REL_UML_ADDSTRUCTURALFEATUREVALUEACTION_INSERTAT;
	public IEntity ENT_UML_LINKACTION;
	public IRelation REL_UML_LINKACTION_ENDDATA;
	public IRelation REL_UML_LINKACTION_INPUTVALUE;
	public IEntity ENT_UML_LINKENDDATA;
	public IRelation REL_UML_LINKENDDATA_VALUE;
	public IRelation REL_UML_LINKENDDATA_END;
	public IRelation REL_UML_LINKENDDATA_QUALIFIER;
	public IEntity ENT_UML_QUALIFIERVALUE;
	public IRelation REL_UML_QUALIFIERVALUE_QUALIFIER;
	public IRelation REL_UML_QUALIFIERVALUE_VALUE;
	public IEntity ENT_UML_READLINKACTION;
	public IRelation REL_UML_READLINKACTION_RESULT;
	public IEntity ENT_UML_LINKENDCREATIONDATA;
	public IRelation REL_UML_LINKENDCREATIONDATA_ISREPLACEALL;
	public IRelation REL_UML_LINKENDCREATIONDATA_INSERTAT;
	public IEntity ENT_UML_CREATELINKACTION;
	public IEntity ENT_UML_WRITELINKACTION;
	public IEntity ENT_UML_DESTROYLINKACTION;
	public IEntity ENT_UML_LINKENDDESTRUCTIONDATA;
	public IRelation REL_UML_LINKENDDESTRUCTIONDATA_ISDESTROYDUPLICATES;
	public IRelation REL_UML_LINKENDDESTRUCTIONDATA_DESTROYAT;
	public IEntity ENT_UML_CLEARASSOCIATIONACTION;
	public IRelation REL_UML_CLEARASSOCIATIONACTION_OBJECT;
	public IRelation REL_UML_CLEARASSOCIATIONACTION_ASSOCIATION;
	public IEntity ENT_UML_BROADCASTSIGNALACTION;
	public IRelation REL_UML_BROADCASTSIGNALACTION_SIGNAL;
	public IEntity ENT_UML_SENDOBJECTACTION;
	public IRelation REL_UML_SENDOBJECTACTION_TARGET;
	public IRelation REL_UML_SENDOBJECTACTION_REQUEST;
	public IEntity ENT_UML_VALUESPECIFICATIONACTION;
	public IRelation REL_UML_VALUESPECIFICATIONACTION_VALUE;
	public IRelation REL_UML_VALUESPECIFICATIONACTION_RESULT;
	public IEntity ENT_UML_TIMEEXPRESSION;
	public IRelation REL_UML_TIMEEXPRESSION_EXPR;
	public IRelation REL_UML_TIMEEXPRESSION_OBSERVATION;
	public IEntity ENT_UML_OBSERVATION;
	public IEntity ENT_UML_DURATION;
	public IRelation REL_UML_DURATION_EXPR;
	public IRelation REL_UML_DURATION_OBSERVATION;
	public IEntity ENT_UML_DURATIONINTERVAL;
	public IEntity ENT_UML_INTERVAL;
	public IRelation REL_UML_INTERVAL_MIN;
	public IRelation REL_UML_INTERVAL_MAX;
	public IEntity ENT_UML_TIMECONSTRAINT;
	public IRelation REL_UML_TIMECONSTRAINT_FIRSTEVENT;
	public IEntity ENT_UML_INTERVALCONSTRAINT;
	public IEntity ENT_UML_TIMEINTERVAL;
	public IEntity ENT_UML_DURATIONCONSTRAINT;
	public IRelation REL_UML_DURATIONCONSTRAINT_FIRSTEVENT;
	public IEntity ENT_UML_TIMEOBSERVATION;
	public IRelation REL_UML_TIMEOBSERVATION_FIRSTEVENT;
	public IRelation REL_UML_TIMEOBSERVATION_EVENT;
	public IEntity ENT_UML_DURATIONOBSERVATION;
	public IRelation REL_UML_DURATIONOBSERVATION_FIRSTEVENT;
	public IRelation REL_UML_DURATIONOBSERVATION_EVENT;
	public IEntity ENT_UML_FINALSTATE;
	public IEntity ENT_UML_TIMEEVENT;
	public IRelation REL_UML_TIMEEVENT_ISRELATIVE;
	public IRelation REL_UML_TIMEEVENT_WHEN;
	public IEntity ENT_UML_VARIABLEACTION;
	public IRelation REL_UML_VARIABLEACTION_VARIABLE;
	public IEntity ENT_UML_READVARIABLEACTION;
	public IRelation REL_UML_READVARIABLEACTION_RESULT;
	public IEntity ENT_UML_WRITEVARIABLEACTION;
	public IRelation REL_UML_WRITEVARIABLEACTION_VALUE;
	public IEntity ENT_UML_CLEARVARIABLEACTION;
	public IEntity ENT_UML_ADDVARIABLEVALUEACTION;
	public IRelation REL_UML_ADDVARIABLEVALUEACTION_ISREPLACEALL;
	public IRelation REL_UML_ADDVARIABLEVALUEACTION_INSERTAT;
	public IEntity ENT_UML_REMOVEVARIABLEVALUEACTION;
	public IRelation REL_UML_REMOVEVARIABLEVALUEACTION_ISREMOVEDUPLICATES;
	public IRelation REL_UML_REMOVEVARIABLEVALUEACTION_REMOVEAT;
	public IEntity ENT_UML_RAISEEXCEPTIONACTION;
	public IRelation REL_UML_RAISEEXCEPTIONACTION_EXCEPTION;
	public IEntity ENT_UML_ACTIONINPUTPIN;
	public IRelation REL_UML_ACTIONINPUTPIN_FROMACTION;
	public IEntity ENT_UML_INFORMATIONITEM;
	public IRelation REL_UML_INFORMATIONITEM_REPRESENTED;
	public IEntity ENT_UML_INFORMATIONFLOW;
	public IRelation REL_UML_INFORMATIONFLOW_REALIZATION;
	public IRelation REL_UML_INFORMATIONFLOW_CONVEYED;
	public IRelation REL_UML_INFORMATIONFLOW_INFORMATIONSOURCE;
	public IRelation REL_UML_INFORMATIONFLOW_INFORMATIONTARGET;
	public IRelation REL_UML_INFORMATIONFLOW_REALIZINGACTIVITYEDGE;
	public IRelation REL_UML_INFORMATIONFLOW_REALIZINGCONNECTOR;
	public IRelation REL_UML_INFORMATIONFLOW_REALIZINGMESSAGE;
	public IEntity ENT_UML_READEXTENTACTION;
	public IRelation REL_UML_READEXTENTACTION_RESULT;
	public IRelation REL_UML_READEXTENTACTION_CLASSIFIER;
	public IEntity ENT_UML_RECLASSIFYOBJECTACTION;
	public IRelation REL_UML_RECLASSIFYOBJECTACTION_ISREPLACEALL;
	public IRelation REL_UML_RECLASSIFYOBJECTACTION_OLDCLASSIFIER;
	public IRelation REL_UML_RECLASSIFYOBJECTACTION_NEWCLASSIFIER;
	public IRelation REL_UML_RECLASSIFYOBJECTACTION_OBJECT;
	public IEntity ENT_UML_READISCLASSIFIEDOBJECTACTION;
	public IRelation REL_UML_READISCLASSIFIEDOBJECTACTION_ISDIRECT;
	public IRelation REL_UML_READISCLASSIFIEDOBJECTACTION_CLASSIFIER;
	public IRelation REL_UML_READISCLASSIFIEDOBJECTACTION_RESULT;
	public IRelation REL_UML_READISCLASSIFIEDOBJECTACTION_OBJECT;
	public IEntity ENT_UML_STARTCLASSIFIERBEHAVIORACTION;
	public IRelation REL_UML_STARTCLASSIFIERBEHAVIORACTION_OBJECT;
	public IEntity ENT_UML_READLINKOBJECTENDACTION;
	public IRelation REL_UML_READLINKOBJECTENDACTION_OBJECT;
	public IRelation REL_UML_READLINKOBJECTENDACTION_END;
	public IRelation REL_UML_READLINKOBJECTENDACTION_RESULT;
	public IEntity ENT_UML_READLINKOBJECTENDQUALIFIERACTION;
	public IRelation REL_UML_READLINKOBJECTENDQUALIFIERACTION_OBJECT;
	public IRelation REL_UML_READLINKOBJECTENDQUALIFIERACTION_RESULT;
	public IRelation REL_UML_READLINKOBJECTENDQUALIFIERACTION_QUALIFIER;
	public IEntity ENT_UML_CREATELINKOBJECTACTION;
	public IRelation REL_UML_CREATELINKOBJECTACTION_RESULT;
	public IEntity ENT_UML_ACCEPTEVENTACTION;
	public IRelation REL_UML_ACCEPTEVENTACTION_ISUNMARSHALL;
	public IRelation REL_UML_ACCEPTEVENTACTION_RESULT;
	public IRelation REL_UML_ACCEPTEVENTACTION_TRIGGER;
	public IEntity ENT_UML_ACCEPTCALLACTION;
	public IRelation REL_UML_ACCEPTCALLACTION_RETURNINFORMATION;
	public IEntity ENT_UML_REPLYACTION;
	public IRelation REL_UML_REPLYACTION_REPLYTOCALL;
	public IRelation REL_UML_REPLYACTION_RETURNINFORMATION;
	public IRelation REL_UML_REPLYACTION_REPLYVALUE;
	public IEntity ENT_UML_UNMARSHALLACTION;
	public IRelation REL_UML_UNMARSHALLACTION_RESULT;
	public IRelation REL_UML_UNMARSHALLACTION_UNMARSHALLTYPE;
	public IRelation REL_UML_UNMARSHALLACTION_OBJECT;
	public IEntity ENT_UML_REDUCEACTION;
	public IRelation REL_UML_REDUCEACTION_ISORDERED;
	public IRelation REL_UML_REDUCEACTION_REDUCER;
	public IRelation REL_UML_REDUCEACTION_RESULT;
	public IRelation REL_UML_REDUCEACTION_COLLECTION;
	public IEntity ENT_UML_STARTOBJECTBEHAVIORACTION;
	public IRelation REL_UML_STARTOBJECTBEHAVIORACTION_OBJECT;
	public IEntity ENT_UML_JOINNODE;
	public IRelation REL_UML_JOINNODE_ISCOMBINEDUPLICATE;
	public IRelation REL_UML_JOINNODE_JOINSPEC;
	public IEntity ENT_UML_DATASTORENODE;
	public IEntity ENT_UML_CONDITIONALNODE;
	public IRelation REL_UML_CONDITIONALNODE_ISDETERMINATE;
	public IRelation REL_UML_CONDITIONALNODE_ISASSURED;
	public IRelation REL_UML_CONDITIONALNODE_CLAUSE;
	public IRelation REL_UML_CONDITIONALNODE_RESULT;
	public IEntity ENT_UML_CLAUSE;
	public IRelation REL_UML_CLAUSE_TEST;
	public IRelation REL_UML_CLAUSE_BODY;
	public IRelation REL_UML_CLAUSE_PREDECESSORCLAUSE;
	public IRelation REL_UML_CLAUSE_SUCCESSORCLAUSE;
	public IRelation REL_UML_CLAUSE_DECIDER;
	public IRelation REL_UML_CLAUSE_BODYOUTPUT;
	public IEntity ENT_UML_LOOPNODE;
	public IRelation REL_UML_LOOPNODE_ISTESTEDFIRST;
	public IRelation REL_UML_LOOPNODE_BODYPART;
	public IRelation REL_UML_LOOPNODE_SETUPPART;
	public IRelation REL_UML_LOOPNODE_DECIDER;
	public IRelation REL_UML_LOOPNODE_TEST;
	public IRelation REL_UML_LOOPNODE_RESULT;
	public IRelation REL_UML_LOOPNODE_LOOPVARIABLE;
	public IRelation REL_UML_LOOPNODE_BODYOUTPUT;
	public IRelation REL_UML_LOOPNODE_LOOPVARIABLEINPUT;
	public IEntity ENT_UML_EXPANSIONNODE;
	public IRelation REL_UML_EXPANSIONNODE_REGIONASOUTPUT;
	public IRelation REL_UML_EXPANSIONNODE_REGIONASINPUT;
	public IEntity ENT_UML_EXPANSIONREGION;
	public IRelation REL_UML_EXPANSIONREGION_MODE;
	public IRelation REL_UML_EXPANSIONREGION_INPUTELEMENT;
	public IRelation REL_UML_EXPANSIONREGION_OUTPUTELEMENT;
	public IEntity ENT_UML_EXPANSIONKIND;
	public IEntity ENT_UML_PROTOCOLTRANSITION;
	public IRelation REL_UML_PROTOCOLTRANSITION_POSTCONDITION;
	public IRelation REL_UML_PROTOCOLTRANSITION_REFERRED;
	public IRelation REL_UML_PROTOCOLTRANSITION_PRECONDITION;
	public IEntity ENT_UML_ASSOCIATIONCLASS;
private void init() throws Exception
{
	ENT_UML_INTEGER=(IEntity)mm.getElementByName("uml.metamodel.uml.Integer");
	if(ENT_UML_INTEGER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Integer is missing.");
	ENT_UML_BOOLEAN=(IEntity)mm.getElementByName("uml.metamodel.uml.Boolean");
	if(ENT_UML_BOOLEAN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Boolean is missing.");
	ENT_UML_STRING=(IEntity)mm.getElementByName("uml.metamodel.uml.String");
	if(ENT_UML_STRING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.String is missing.");
	ENT_UML_UNLIMITEDNATURAL=(IEntity)mm.getElementByName("uml.metamodel.uml.UnlimitedNatural");
	if(ENT_UML_UNLIMITEDNATURAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UnlimitedNatural is missing.");
	ENT_UML_COMMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.Comment");
	if(ENT_UML_COMMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Comment is missing.");
	REL_UML_COMMENT_BODY=(IRelation)mm.getElementByName("uml.metamodel.uml.Comment.body");
	if(REL_UML_COMMENT_BODY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Comment.body is missing.");
	REL_UML_COMMENT_ANNOTATEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Comment.annotatedElement");
	if(REL_UML_COMMENT_ANNOTATEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Comment.annotatedElement is missing.");
	ENT_UML_ELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.Element");
	if(ENT_UML_ELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Element is missing.");
	REL_UML_ELEMENT_OWNEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Element.ownedElement");
	if(REL_UML_ELEMENT_OWNEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Element.ownedElement is missing.");
	REL_UML_ELEMENT_OWNER=(IRelation)mm.getElementByName("uml.metamodel.uml.Element.owner");
	if(REL_UML_ELEMENT_OWNER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Element.owner is missing.");
	REL_UML_ELEMENT_OWNEDCOMMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Element.ownedComment");
	if(REL_UML_ELEMENT_OWNEDCOMMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Element.ownedComment is missing.");
	ENT_UML_PACKAGE=(IEntity)mm.getElementByName("uml.metamodel.uml.Package");
	if(ENT_UML_PACKAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Package is missing.");
	REL_UML_PACKAGE_OWNEDTYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Package.ownedType");
	if(REL_UML_PACKAGE_OWNEDTYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Package.ownedType is missing.");
	REL_UML_PACKAGE_PACKAGEMERGE=(IRelation)mm.getElementByName("uml.metamodel.uml.Package.packageMerge");
	if(REL_UML_PACKAGE_PACKAGEMERGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Package.packageMerge is missing.");
	REL_UML_PACKAGE_PACKAGEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Package.packagedElement");
	if(REL_UML_PACKAGE_PACKAGEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Package.packagedElement is missing.");
	REL_UML_PACKAGE_NESTEDPACKAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.Package.nestedPackage");
	if(REL_UML_PACKAGE_NESTEDPACKAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Package.nestedPackage is missing.");
	REL_UML_PACKAGE_NESTINGPACKAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.Package.nestingPackage");
	if(REL_UML_PACKAGE_NESTINGPACKAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Package.nestingPackage is missing.");
	REL_UML_PACKAGE_PROFILEAPPLICATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Package.profileApplication");
	if(REL_UML_PACKAGE_PROFILEAPPLICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Package.profileApplication is missing.");
	ENT_UML_PACKAGEABLEELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.PackageableElement");
	if(ENT_UML_PACKAGEABLEELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PackageableElement is missing.");
	ENT_UML_NAMEDELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.NamedElement");
	if(ENT_UML_NAMEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.NamedElement is missing.");
	REL_UML_NAMEDELEMENT_NAME=(IRelation)mm.getElementByName("uml.metamodel.uml.NamedElement.name");
	if(REL_UML_NAMEDELEMENT_NAME==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.NamedElement.name is missing.");
	REL_UML_NAMEDELEMENT_VISIBILITY=(IRelation)mm.getElementByName("uml.metamodel.uml.NamedElement.visibility");
	if(REL_UML_NAMEDELEMENT_VISIBILITY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.NamedElement.visibility is missing.");
	REL_UML_NAMEDELEMENT_QUALIFIEDNAME=(IRelation)mm.getElementByName("uml.metamodel.uml.NamedElement.qualifiedName");
	if(REL_UML_NAMEDELEMENT_QUALIFIEDNAME==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.NamedElement.qualifiedName is missing.");
	REL_UML_NAMEDELEMENT_CLIENTDEPENDENCY=(IRelation)mm.getElementByName("uml.metamodel.uml.NamedElement.clientDependency");
	if(REL_UML_NAMEDELEMENT_CLIENTDEPENDENCY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.NamedElement.clientDependency is missing.");
	REL_UML_NAMEDELEMENT_NAMESPACE=(IRelation)mm.getElementByName("uml.metamodel.uml.NamedElement.namespace");
	if(REL_UML_NAMEDELEMENT_NAMESPACE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.NamedElement.namespace is missing.");
	REL_UML_NAMEDELEMENT_NAMEEXPRESSION=(IRelation)mm.getElementByName("uml.metamodel.uml.NamedElement.nameExpression");
	if(REL_UML_NAMEDELEMENT_NAMEEXPRESSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.NamedElement.nameExpression is missing.");
	ENT_UML_VISIBILITYKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.VisibilityKind");
	if(ENT_UML_VISIBILITYKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.VisibilityKind is missing.");
	ENT_UML_DEPENDENCY=(IEntity)mm.getElementByName("uml.metamodel.uml.Dependency");
	if(ENT_UML_DEPENDENCY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Dependency is missing.");
	REL_UML_DEPENDENCY_SUPPLIER=(IRelation)mm.getElementByName("uml.metamodel.uml.Dependency.supplier");
	if(REL_UML_DEPENDENCY_SUPPLIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Dependency.supplier is missing.");
	REL_UML_DEPENDENCY_CLIENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Dependency.client");
	if(REL_UML_DEPENDENCY_CLIENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Dependency.client is missing.");
	ENT_UML_DIRECTEDRELATIONSHIP=(IEntity)mm.getElementByName("uml.metamodel.uml.DirectedRelationship");
	if(ENT_UML_DIRECTEDRELATIONSHIP==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DirectedRelationship is missing.");
	REL_UML_DIRECTEDRELATIONSHIP_SOURCE=(IRelation)mm.getElementByName("uml.metamodel.uml.DirectedRelationship.source");
	if(REL_UML_DIRECTEDRELATIONSHIP_SOURCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DirectedRelationship.source is missing.");
	REL_UML_DIRECTEDRELATIONSHIP_TARGET=(IRelation)mm.getElementByName("uml.metamodel.uml.DirectedRelationship.target");
	if(REL_UML_DIRECTEDRELATIONSHIP_TARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DirectedRelationship.target is missing.");
	ENT_UML_RELATIONSHIP=(IEntity)mm.getElementByName("uml.metamodel.uml.Relationship");
	if(ENT_UML_RELATIONSHIP==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Relationship is missing.");
	REL_UML_RELATIONSHIP_RELATEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Relationship.relatedElement");
	if(REL_UML_RELATIONSHIP_RELATEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Relationship.relatedElement is missing.");
	ENT_UML_NAMESPACE=(IEntity)mm.getElementByName("uml.metamodel.uml.Namespace");
	if(ENT_UML_NAMESPACE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Namespace is missing.");
	REL_UML_NAMESPACE_ELEMENTIMPORT=(IRelation)mm.getElementByName("uml.metamodel.uml.Namespace.elementImport");
	if(REL_UML_NAMESPACE_ELEMENTIMPORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Namespace.elementImport is missing.");
	REL_UML_NAMESPACE_PACKAGEIMPORT=(IRelation)mm.getElementByName("uml.metamodel.uml.Namespace.packageImport");
	if(REL_UML_NAMESPACE_PACKAGEIMPORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Namespace.packageImport is missing.");
	REL_UML_NAMESPACE_OWNEDRULE=(IRelation)mm.getElementByName("uml.metamodel.uml.Namespace.ownedRule");
	if(REL_UML_NAMESPACE_OWNEDRULE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Namespace.ownedRule is missing.");
	REL_UML_NAMESPACE_MEMBER=(IRelation)mm.getElementByName("uml.metamodel.uml.Namespace.member");
	if(REL_UML_NAMESPACE_MEMBER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Namespace.member is missing.");
	REL_UML_NAMESPACE_IMPORTEDMEMBER=(IRelation)mm.getElementByName("uml.metamodel.uml.Namespace.importedMember");
	if(REL_UML_NAMESPACE_IMPORTEDMEMBER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Namespace.importedMember is missing.");
	REL_UML_NAMESPACE_OWNEDMEMBER=(IRelation)mm.getElementByName("uml.metamodel.uml.Namespace.ownedMember");
	if(REL_UML_NAMESPACE_OWNEDMEMBER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Namespace.ownedMember is missing.");
	ENT_UML_ELEMENTIMPORT=(IEntity)mm.getElementByName("uml.metamodel.uml.ElementImport");
	if(ENT_UML_ELEMENTIMPORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ElementImport is missing.");
	REL_UML_ELEMENTIMPORT_VISIBILITY=(IRelation)mm.getElementByName("uml.metamodel.uml.ElementImport.visibility");
	if(REL_UML_ELEMENTIMPORT_VISIBILITY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ElementImport.visibility is missing.");
	REL_UML_ELEMENTIMPORT_ALIAS=(IRelation)mm.getElementByName("uml.metamodel.uml.ElementImport.alias");
	if(REL_UML_ELEMENTIMPORT_ALIAS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ElementImport.alias is missing.");
	REL_UML_ELEMENTIMPORT_IMPORTEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.ElementImport.importedElement");
	if(REL_UML_ELEMENTIMPORT_IMPORTEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ElementImport.importedElement is missing.");
	REL_UML_ELEMENTIMPORT_IMPORTINGNAMESPACE=(IRelation)mm.getElementByName("uml.metamodel.uml.ElementImport.importingNamespace");
	if(REL_UML_ELEMENTIMPORT_IMPORTINGNAMESPACE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ElementImport.importingNamespace is missing.");
	ENT_UML_PACKAGEIMPORT=(IEntity)mm.getElementByName("uml.metamodel.uml.PackageImport");
	if(ENT_UML_PACKAGEIMPORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PackageImport is missing.");
	REL_UML_PACKAGEIMPORT_VISIBILITY=(IRelation)mm.getElementByName("uml.metamodel.uml.PackageImport.visibility");
	if(REL_UML_PACKAGEIMPORT_VISIBILITY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PackageImport.visibility is missing.");
	REL_UML_PACKAGEIMPORT_IMPORTEDPACKAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.PackageImport.importedPackage");
	if(REL_UML_PACKAGEIMPORT_IMPORTEDPACKAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PackageImport.importedPackage is missing.");
	REL_UML_PACKAGEIMPORT_IMPORTINGNAMESPACE=(IRelation)mm.getElementByName("uml.metamodel.uml.PackageImport.importingNamespace");
	if(REL_UML_PACKAGEIMPORT_IMPORTINGNAMESPACE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PackageImport.importingNamespace is missing.");
	ENT_UML_CONSTRAINT=(IEntity)mm.getElementByName("uml.metamodel.uml.Constraint");
	if(ENT_UML_CONSTRAINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Constraint is missing.");
	REL_UML_CONSTRAINT_CONSTRAINEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Constraint.constrainedElement");
	if(REL_UML_CONSTRAINT_CONSTRAINEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Constraint.constrainedElement is missing.");
	REL_UML_CONSTRAINT_SPECIFICATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Constraint.specification");
	if(REL_UML_CONSTRAINT_SPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Constraint.specification is missing.");
	REL_UML_CONSTRAINT_CONTEXT=(IRelation)mm.getElementByName("uml.metamodel.uml.Constraint.context");
	if(REL_UML_CONSTRAINT_CONTEXT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Constraint.context is missing.");
	ENT_UML_VALUESPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.ValueSpecification");
	if(ENT_UML_VALUESPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ValueSpecification is missing.");
	ENT_UML_TYPEDELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.TypedElement");
	if(ENT_UML_TYPEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TypedElement is missing.");
	REL_UML_TYPEDELEMENT_TYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.TypedElement.type");
	if(REL_UML_TYPEDELEMENT_TYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TypedElement.type is missing.");
	ENT_UML_TYPE=(IEntity)mm.getElementByName("uml.metamodel.uml.Type");
	if(ENT_UML_TYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Type is missing.");
	REL_UML_TYPE_PACKAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.Type.package");
	if(REL_UML_TYPE_PACKAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Type.package is missing.");
	ENT_UML_ASSOCIATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Association");
	if(ENT_UML_ASSOCIATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Association is missing.");
	REL_UML_ASSOCIATION_ISDERIVED=(IRelation)mm.getElementByName("uml.metamodel.uml.Association.isDerived");
	if(REL_UML_ASSOCIATION_ISDERIVED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Association.isDerived is missing.");
	REL_UML_ASSOCIATION_OWNEDEND=(IRelation)mm.getElementByName("uml.metamodel.uml.Association.ownedEnd");
	if(REL_UML_ASSOCIATION_OWNEDEND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Association.ownedEnd is missing.");
	REL_UML_ASSOCIATION_MEMBEREND=(IRelation)mm.getElementByName("uml.metamodel.uml.Association.memberEnd");
	if(REL_UML_ASSOCIATION_MEMBEREND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Association.memberEnd is missing.");
	REL_UML_ASSOCIATION_ENDTYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Association.endType");
	if(REL_UML_ASSOCIATION_ENDTYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Association.endType is missing.");
	REL_UML_ASSOCIATION_NAVIGABLEOWNEDEND=(IRelation)mm.getElementByName("uml.metamodel.uml.Association.navigableOwnedEnd");
	if(REL_UML_ASSOCIATION_NAVIGABLEOWNEDEND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Association.navigableOwnedEnd is missing.");
	ENT_UML_CLASSIFIER=(IEntity)mm.getElementByName("uml.metamodel.uml.Classifier");
	if(ENT_UML_CLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier is missing.");
	REL_UML_CLASSIFIER_ISABSTRACT=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.isAbstract");
	if(REL_UML_CLASSIFIER_ISABSTRACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.isAbstract is missing.");
	REL_UML_CLASSIFIER_GENERALIZATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.generalization");
	if(REL_UML_CLASSIFIER_GENERALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.generalization is missing.");
	REL_UML_CLASSIFIER_POWERTYPEEXTENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.powertypeExtent");
	if(REL_UML_CLASSIFIER_POWERTYPEEXTENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.powertypeExtent is missing.");
	REL_UML_CLASSIFIER_FEATURE=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.feature");
	if(REL_UML_CLASSIFIER_FEATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.feature is missing.");
	REL_UML_CLASSIFIER_INHERITEDMEMBER=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.inheritedMember");
	if(REL_UML_CLASSIFIER_INHERITEDMEMBER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.inheritedMember is missing.");
	REL_UML_CLASSIFIER_REDEFINEDCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.redefinedClassifier");
	if(REL_UML_CLASSIFIER_REDEFINEDCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.redefinedClassifier is missing.");
	REL_UML_CLASSIFIER_GENERAL=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.general");
	if(REL_UML_CLASSIFIER_GENERAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.general is missing.");
	REL_UML_CLASSIFIER_SUBSTITUTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.substitution");
	if(REL_UML_CLASSIFIER_SUBSTITUTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.substitution is missing.");
	REL_UML_CLASSIFIER_ATTRIBUTE=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.attribute");
	if(REL_UML_CLASSIFIER_ATTRIBUTE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.attribute is missing.");
	REL_UML_CLASSIFIER_REPRESENTATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.representation");
	if(REL_UML_CLASSIFIER_REPRESENTATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.representation is missing.");
	REL_UML_CLASSIFIER_COLLABORATIONUSE=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.collaborationUse");
	if(REL_UML_CLASSIFIER_COLLABORATIONUSE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.collaborationUse is missing.");
	REL_UML_CLASSIFIER_OWNEDUSECASE=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.ownedUseCase");
	if(REL_UML_CLASSIFIER_OWNEDUSECASE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.ownedUseCase is missing.");
	REL_UML_CLASSIFIER_USECASE=(IRelation)mm.getElementByName("uml.metamodel.uml.Classifier.useCase");
	if(REL_UML_CLASSIFIER_USECASE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Classifier.useCase is missing.");
	ENT_UML_REDEFINABLEELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.RedefinableElement");
	if(ENT_UML_REDEFINABLEELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RedefinableElement is missing.");
	REL_UML_REDEFINABLEELEMENT_ISLEAF=(IRelation)mm.getElementByName("uml.metamodel.uml.RedefinableElement.isLeaf");
	if(REL_UML_REDEFINABLEELEMENT_ISLEAF==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RedefinableElement.isLeaf is missing.");
	REL_UML_REDEFINABLEELEMENT_REDEFINEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.RedefinableElement.redefinedElement");
	if(REL_UML_REDEFINABLEELEMENT_REDEFINEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RedefinableElement.redefinedElement is missing.");
	REL_UML_REDEFINABLEELEMENT_REDEFINITIONCONTEXT=(IRelation)mm.getElementByName("uml.metamodel.uml.RedefinableElement.redefinitionContext");
	if(REL_UML_REDEFINABLEELEMENT_REDEFINITIONCONTEXT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RedefinableElement.redefinitionContext is missing.");
	ENT_UML_TEMPLATEABLEELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.TemplateableElement");
	if(ENT_UML_TEMPLATEABLEELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateableElement is missing.");
	REL_UML_TEMPLATEABLEELEMENT_TEMPLATEBINDING=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateableElement.templateBinding");
	if(REL_UML_TEMPLATEABLEELEMENT_TEMPLATEBINDING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateableElement.templateBinding is missing.");
	REL_UML_TEMPLATEABLEELEMENT_OWNEDTEMPLATESIGNATURE=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateableElement.ownedTemplateSignature");
	if(REL_UML_TEMPLATEABLEELEMENT_OWNEDTEMPLATESIGNATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateableElement.ownedTemplateSignature is missing.");
	ENT_UML_TEMPLATEBINDING=(IEntity)mm.getElementByName("uml.metamodel.uml.TemplateBinding");
	if(ENT_UML_TEMPLATEBINDING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateBinding is missing.");
	REL_UML_TEMPLATEBINDING_SIGNATURE=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateBinding.signature");
	if(REL_UML_TEMPLATEBINDING_SIGNATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateBinding.signature is missing.");
	REL_UML_TEMPLATEBINDING_PARAMETERSUBSTITUTION=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateBinding.parameterSubstitution");
	if(REL_UML_TEMPLATEBINDING_PARAMETERSUBSTITUTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateBinding.parameterSubstitution is missing.");
	REL_UML_TEMPLATEBINDING_BOUNDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateBinding.boundElement");
	if(REL_UML_TEMPLATEBINDING_BOUNDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateBinding.boundElement is missing.");
	ENT_UML_TEMPLATESIGNATURE=(IEntity)mm.getElementByName("uml.metamodel.uml.TemplateSignature");
	if(ENT_UML_TEMPLATESIGNATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateSignature is missing.");
	REL_UML_TEMPLATESIGNATURE_PARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateSignature.parameter");
	if(REL_UML_TEMPLATESIGNATURE_PARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateSignature.parameter is missing.");
	REL_UML_TEMPLATESIGNATURE_OWNEDPARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateSignature.ownedParameter");
	if(REL_UML_TEMPLATESIGNATURE_OWNEDPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateSignature.ownedParameter is missing.");
	REL_UML_TEMPLATESIGNATURE_TEMPLATE=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateSignature.template");
	if(REL_UML_TEMPLATESIGNATURE_TEMPLATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateSignature.template is missing.");
	ENT_UML_TEMPLATEPARAMETER=(IEntity)mm.getElementByName("uml.metamodel.uml.TemplateParameter");
	if(ENT_UML_TEMPLATEPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameter is missing.");
	REL_UML_TEMPLATEPARAMETER_SIGNATURE=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameter.signature");
	if(REL_UML_TEMPLATEPARAMETER_SIGNATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameter.signature is missing.");
	REL_UML_TEMPLATEPARAMETER_PARAMETEREDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameter.parameteredElement");
	if(REL_UML_TEMPLATEPARAMETER_PARAMETEREDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameter.parameteredElement is missing.");
	REL_UML_TEMPLATEPARAMETER_OWNEDPARAMETEREDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameter.ownedParameteredElement");
	if(REL_UML_TEMPLATEPARAMETER_OWNEDPARAMETEREDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameter.ownedParameteredElement is missing.");
	REL_UML_TEMPLATEPARAMETER_DEFAULT=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameter.default");
	if(REL_UML_TEMPLATEPARAMETER_DEFAULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameter.default is missing.");
	REL_UML_TEMPLATEPARAMETER_OWNEDDEFAULT=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameter.ownedDefault");
	if(REL_UML_TEMPLATEPARAMETER_OWNEDDEFAULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameter.ownedDefault is missing.");
	ENT_UML_PARAMETERABLEELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.ParameterableElement");
	if(ENT_UML_PARAMETERABLEELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ParameterableElement is missing.");
	REL_UML_PARAMETERABLEELEMENT_OWNINGTEMPLATEPARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.ParameterableElement.owningTemplateParameter");
	if(REL_UML_PARAMETERABLEELEMENT_OWNINGTEMPLATEPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ParameterableElement.owningTemplateParameter is missing.");
	REL_UML_PARAMETERABLEELEMENT_TEMPLATEPARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.ParameterableElement.templateParameter");
	if(REL_UML_PARAMETERABLEELEMENT_TEMPLATEPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ParameterableElement.templateParameter is missing.");
	ENT_UML_TEMPLATEPARAMETERSUBSTITUTION=(IEntity)mm.getElementByName("uml.metamodel.uml.TemplateParameterSubstitution");
	if(ENT_UML_TEMPLATEPARAMETERSUBSTITUTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameterSubstitution is missing.");
	REL_UML_TEMPLATEPARAMETERSUBSTITUTION_FORMAL=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameterSubstitution.formal");
	if(REL_UML_TEMPLATEPARAMETERSUBSTITUTION_FORMAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameterSubstitution.formal is missing.");
	REL_UML_TEMPLATEPARAMETERSUBSTITUTION_ACTUAL=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameterSubstitution.actual");
	if(REL_UML_TEMPLATEPARAMETERSUBSTITUTION_ACTUAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameterSubstitution.actual is missing.");
	REL_UML_TEMPLATEPARAMETERSUBSTITUTION_OWNEDACTUAL=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameterSubstitution.ownedActual");
	if(REL_UML_TEMPLATEPARAMETERSUBSTITUTION_OWNEDACTUAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameterSubstitution.ownedActual is missing.");
	REL_UML_TEMPLATEPARAMETERSUBSTITUTION_TEMPLATEBINDING=(IRelation)mm.getElementByName("uml.metamodel.uml.TemplateParameterSubstitution.templateBinding");
	if(REL_UML_TEMPLATEPARAMETERSUBSTITUTION_TEMPLATEBINDING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TemplateParameterSubstitution.templateBinding is missing.");
	ENT_UML_GENERALIZATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Generalization");
	if(ENT_UML_GENERALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Generalization is missing.");
	REL_UML_GENERALIZATION_ISSUBSTITUTABLE=(IRelation)mm.getElementByName("uml.metamodel.uml.Generalization.isSubstitutable");
	if(REL_UML_GENERALIZATION_ISSUBSTITUTABLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Generalization.isSubstitutable is missing.");
	REL_UML_GENERALIZATION_GENERAL=(IRelation)mm.getElementByName("uml.metamodel.uml.Generalization.general");
	if(REL_UML_GENERALIZATION_GENERAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Generalization.general is missing.");
	REL_UML_GENERALIZATION_GENERALIZATIONSET=(IRelation)mm.getElementByName("uml.metamodel.uml.Generalization.generalizationSet");
	if(REL_UML_GENERALIZATION_GENERALIZATIONSET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Generalization.generalizationSet is missing.");
	REL_UML_GENERALIZATION_SPECIFIC=(IRelation)mm.getElementByName("uml.metamodel.uml.Generalization.specific");
	if(REL_UML_GENERALIZATION_SPECIFIC==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Generalization.specific is missing.");
	ENT_UML_GENERALIZATIONSET=(IEntity)mm.getElementByName("uml.metamodel.uml.GeneralizationSet");
	if(ENT_UML_GENERALIZATIONSET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.GeneralizationSet is missing.");
	REL_UML_GENERALIZATIONSET_ISCOVERING=(IRelation)mm.getElementByName("uml.metamodel.uml.GeneralizationSet.isCovering");
	if(REL_UML_GENERALIZATIONSET_ISCOVERING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.GeneralizationSet.isCovering is missing.");
	REL_UML_GENERALIZATIONSET_ISDISJOINT=(IRelation)mm.getElementByName("uml.metamodel.uml.GeneralizationSet.isDisjoint");
	if(REL_UML_GENERALIZATIONSET_ISDISJOINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.GeneralizationSet.isDisjoint is missing.");
	REL_UML_GENERALIZATIONSET_POWERTYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.GeneralizationSet.powertype");
	if(REL_UML_GENERALIZATIONSET_POWERTYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.GeneralizationSet.powertype is missing.");
	REL_UML_GENERALIZATIONSET_GENERALIZATION=(IRelation)mm.getElementByName("uml.metamodel.uml.GeneralizationSet.generalization");
	if(REL_UML_GENERALIZATIONSET_GENERALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.GeneralizationSet.generalization is missing.");
	ENT_UML_FEATURE=(IEntity)mm.getElementByName("uml.metamodel.uml.Feature");
	if(ENT_UML_FEATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Feature is missing.");
	REL_UML_FEATURE_ISSTATIC=(IRelation)mm.getElementByName("uml.metamodel.uml.Feature.isStatic");
	if(REL_UML_FEATURE_ISSTATIC==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Feature.isStatic is missing.");
	REL_UML_FEATURE_FEATURINGCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.Feature.featuringClassifier");
	if(REL_UML_FEATURE_FEATURINGCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Feature.featuringClassifier is missing.");
	ENT_UML_SUBSTITUTION=(IEntity)mm.getElementByName("uml.metamodel.uml.Substitution");
	if(ENT_UML_SUBSTITUTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Substitution is missing.");
	REL_UML_SUBSTITUTION_CONTRACT=(IRelation)mm.getElementByName("uml.metamodel.uml.Substitution.contract");
	if(REL_UML_SUBSTITUTION_CONTRACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Substitution.contract is missing.");
	REL_UML_SUBSTITUTION_SUBSTITUTINGCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.Substitution.substitutingClassifier");
	if(REL_UML_SUBSTITUTION_SUBSTITUTINGCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Substitution.substitutingClassifier is missing.");
	ENT_UML_REALIZATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Realization");
	if(ENT_UML_REALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Realization is missing.");
	ENT_UML_ABSTRACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.Abstraction");
	if(ENT_UML_ABSTRACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Abstraction is missing.");
	REL_UML_ABSTRACTION_MAPPING=(IRelation)mm.getElementByName("uml.metamodel.uml.Abstraction.mapping");
	if(REL_UML_ABSTRACTION_MAPPING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Abstraction.mapping is missing.");
	ENT_UML_OPAQUEEXPRESSION=(IEntity)mm.getElementByName("uml.metamodel.uml.OpaqueExpression");
	if(ENT_UML_OPAQUEEXPRESSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueExpression is missing.");
	REL_UML_OPAQUEEXPRESSION_BODY=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueExpression.body");
	if(REL_UML_OPAQUEEXPRESSION_BODY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueExpression.body is missing.");
	REL_UML_OPAQUEEXPRESSION_LANGUAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueExpression.language");
	if(REL_UML_OPAQUEEXPRESSION_LANGUAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueExpression.language is missing.");
	REL_UML_OPAQUEEXPRESSION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueExpression.result");
	if(REL_UML_OPAQUEEXPRESSION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueExpression.result is missing.");
	REL_UML_OPAQUEEXPRESSION_BEHAVIOR=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueExpression.behavior");
	if(REL_UML_OPAQUEEXPRESSION_BEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueExpression.behavior is missing.");
	ENT_UML_PARAMETER=(IEntity)mm.getElementByName("uml.metamodel.uml.Parameter");
	if(ENT_UML_PARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter is missing.");
	REL_UML_PARAMETER_DIRECTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Parameter.direction");
	if(REL_UML_PARAMETER_DIRECTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter.direction is missing.");
	REL_UML_PARAMETER_DEFAULT=(IRelation)mm.getElementByName("uml.metamodel.uml.Parameter.default");
	if(REL_UML_PARAMETER_DEFAULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter.default is missing.");
	REL_UML_PARAMETER_ISEXCEPTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Parameter.isException");
	if(REL_UML_PARAMETER_ISEXCEPTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter.isException is missing.");
	REL_UML_PARAMETER_ISSTREAM=(IRelation)mm.getElementByName("uml.metamodel.uml.Parameter.isStream");
	if(REL_UML_PARAMETER_ISSTREAM==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter.isStream is missing.");
	REL_UML_PARAMETER_EFFECT=(IRelation)mm.getElementByName("uml.metamodel.uml.Parameter.effect");
	if(REL_UML_PARAMETER_EFFECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter.effect is missing.");
	REL_UML_PARAMETER_PARAMETERSET=(IRelation)mm.getElementByName("uml.metamodel.uml.Parameter.parameterSet");
	if(REL_UML_PARAMETER_PARAMETERSET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter.parameterSet is missing.");
	REL_UML_PARAMETER_OPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Parameter.operation");
	if(REL_UML_PARAMETER_OPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter.operation is missing.");
	REL_UML_PARAMETER_DEFAULTVALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.Parameter.defaultValue");
	if(REL_UML_PARAMETER_DEFAULTVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Parameter.defaultValue is missing.");
	ENT_UML_MULTIPLICITYELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.MultiplicityElement");
	if(ENT_UML_MULTIPLICITYELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MultiplicityElement is missing.");
	REL_UML_MULTIPLICITYELEMENT_ISORDERED=(IRelation)mm.getElementByName("uml.metamodel.uml.MultiplicityElement.isOrdered");
	if(REL_UML_MULTIPLICITYELEMENT_ISORDERED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MultiplicityElement.isOrdered is missing.");
	REL_UML_MULTIPLICITYELEMENT_ISUNIQUE=(IRelation)mm.getElementByName("uml.metamodel.uml.MultiplicityElement.isUnique");
	if(REL_UML_MULTIPLICITYELEMENT_ISUNIQUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MultiplicityElement.isUnique is missing.");
	REL_UML_MULTIPLICITYELEMENT_UPPER=(IRelation)mm.getElementByName("uml.metamodel.uml.MultiplicityElement.upper");
	if(REL_UML_MULTIPLICITYELEMENT_UPPER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MultiplicityElement.upper is missing.");
	REL_UML_MULTIPLICITYELEMENT_LOWER=(IRelation)mm.getElementByName("uml.metamodel.uml.MultiplicityElement.lower");
	if(REL_UML_MULTIPLICITYELEMENT_LOWER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MultiplicityElement.lower is missing.");
	REL_UML_MULTIPLICITYELEMENT_UPPERVALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.MultiplicityElement.upperValue");
	if(REL_UML_MULTIPLICITYELEMENT_UPPERVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MultiplicityElement.upperValue is missing.");
	REL_UML_MULTIPLICITYELEMENT_LOWERVALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.MultiplicityElement.lowerValue");
	if(REL_UML_MULTIPLICITYELEMENT_LOWERVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MultiplicityElement.lowerValue is missing.");
	ENT_UML_CONNECTABLEELEMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.ConnectableElement");
	if(ENT_UML_CONNECTABLEELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectableElement is missing.");
	REL_UML_CONNECTABLEELEMENT_END=(IRelation)mm.getElementByName("uml.metamodel.uml.ConnectableElement.end");
	if(REL_UML_CONNECTABLEELEMENT_END==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectableElement.end is missing.");
	ENT_UML_CONNECTOREND=(IEntity)mm.getElementByName("uml.metamodel.uml.ConnectorEnd");
	if(ENT_UML_CONNECTOREND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectorEnd is missing.");
	REL_UML_CONNECTOREND_DEFININGEND=(IRelation)mm.getElementByName("uml.metamodel.uml.ConnectorEnd.definingEnd");
	if(REL_UML_CONNECTOREND_DEFININGEND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectorEnd.definingEnd is missing.");
	REL_UML_CONNECTOREND_ROLE=(IRelation)mm.getElementByName("uml.metamodel.uml.ConnectorEnd.role");
	if(REL_UML_CONNECTOREND_ROLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectorEnd.role is missing.");
	REL_UML_CONNECTOREND_PARTWITHPORT=(IRelation)mm.getElementByName("uml.metamodel.uml.ConnectorEnd.partWithPort");
	if(REL_UML_CONNECTOREND_PARTWITHPORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectorEnd.partWithPort is missing.");
	ENT_UML_PROPERTY=(IEntity)mm.getElementByName("uml.metamodel.uml.Property");
	if(ENT_UML_PROPERTY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property is missing.");
	REL_UML_PROPERTY_ISDERIVED=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.isDerived");
	if(REL_UML_PROPERTY_ISDERIVED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.isDerived is missing.");
	REL_UML_PROPERTY_ISDERIVEDUNION=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.isDerivedUnion");
	if(REL_UML_PROPERTY_ISDERIVEDUNION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.isDerivedUnion is missing.");
	REL_UML_PROPERTY_DEFAULT=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.default");
	if(REL_UML_PROPERTY_DEFAULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.default is missing.");
	REL_UML_PROPERTY_AGGREGATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.aggregation");
	if(REL_UML_PROPERTY_AGGREGATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.aggregation is missing.");
	REL_UML_PROPERTY_ISCOMPOSITE=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.isComposite");
	if(REL_UML_PROPERTY_ISCOMPOSITE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.isComposite is missing.");
	REL_UML_PROPERTY_CLASS=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.class");
	if(REL_UML_PROPERTY_CLASS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.class is missing.");
	REL_UML_PROPERTY_DATATYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.datatype");
	if(REL_UML_PROPERTY_DATATYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.datatype is missing.");
	REL_UML_PROPERTY_REDEFINEDPROPERTY=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.redefinedProperty");
	if(REL_UML_PROPERTY_REDEFINEDPROPERTY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.redefinedProperty is missing.");
	REL_UML_PROPERTY_OWNINGASSOCIATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.owningAssociation");
	if(REL_UML_PROPERTY_OWNINGASSOCIATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.owningAssociation is missing.");
	REL_UML_PROPERTY_DEFAULTVALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.defaultValue");
	if(REL_UML_PROPERTY_DEFAULTVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.defaultValue is missing.");
	REL_UML_PROPERTY_OPPOSITE=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.opposite");
	if(REL_UML_PROPERTY_OPPOSITE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.opposite is missing.");
	REL_UML_PROPERTY_SUBSETTEDPROPERTY=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.subsettedProperty");
	if(REL_UML_PROPERTY_SUBSETTEDPROPERTY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.subsettedProperty is missing.");
	REL_UML_PROPERTY_ASSOCIATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.association");
	if(REL_UML_PROPERTY_ASSOCIATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.association is missing.");
	REL_UML_PROPERTY_QUALIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.qualifier");
	if(REL_UML_PROPERTY_QUALIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.qualifier is missing.");
	REL_UML_PROPERTY_ASSOCIATIONEND=(IRelation)mm.getElementByName("uml.metamodel.uml.Property.associationEnd");
	if(REL_UML_PROPERTY_ASSOCIATIONEND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Property.associationEnd is missing.");
	ENT_UML_DEPLOYMENTTARGET=(IEntity)mm.getElementByName("uml.metamodel.uml.DeploymentTarget");
	if(ENT_UML_DEPLOYMENTTARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DeploymentTarget is missing.");
	REL_UML_DEPLOYMENTTARGET_DEPLOYMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.DeploymentTarget.deployment");
	if(REL_UML_DEPLOYMENTTARGET_DEPLOYMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DeploymentTarget.deployment is missing.");
	REL_UML_DEPLOYMENTTARGET_DEPLOYEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.DeploymentTarget.deployedElement");
	if(REL_UML_DEPLOYMENTTARGET_DEPLOYEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DeploymentTarget.deployedElement is missing.");
	ENT_UML_DEPLOYMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.Deployment");
	if(ENT_UML_DEPLOYMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Deployment is missing.");
	REL_UML_DEPLOYMENT_DEPLOYEDARTIFACT=(IRelation)mm.getElementByName("uml.metamodel.uml.Deployment.deployedArtifact");
	if(REL_UML_DEPLOYMENT_DEPLOYEDARTIFACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Deployment.deployedArtifact is missing.");
	REL_UML_DEPLOYMENT_CONFIGURATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Deployment.configuration");
	if(REL_UML_DEPLOYMENT_CONFIGURATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Deployment.configuration is missing.");
	REL_UML_DEPLOYMENT_LOCATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Deployment.location");
	if(REL_UML_DEPLOYMENT_LOCATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Deployment.location is missing.");
	ENT_UML_DEPLOYEDARTIFACT=(IEntity)mm.getElementByName("uml.metamodel.uml.DeployedArtifact");
	if(ENT_UML_DEPLOYEDARTIFACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DeployedArtifact is missing.");
	ENT_UML_DEPLOYMENTSPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.DeploymentSpecification");
	if(ENT_UML_DEPLOYMENTSPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DeploymentSpecification is missing.");
	REL_UML_DEPLOYMENTSPECIFICATION_DEPLOYMENTLOCATION=(IRelation)mm.getElementByName("uml.metamodel.uml.DeploymentSpecification.deploymentLocation");
	if(REL_UML_DEPLOYMENTSPECIFICATION_DEPLOYMENTLOCATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DeploymentSpecification.deploymentLocation is missing.");
	REL_UML_DEPLOYMENTSPECIFICATION_EXECUTIONLOCATION=(IRelation)mm.getElementByName("uml.metamodel.uml.DeploymentSpecification.executionLocation");
	if(REL_UML_DEPLOYMENTSPECIFICATION_EXECUTIONLOCATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DeploymentSpecification.executionLocation is missing.");
	REL_UML_DEPLOYMENTSPECIFICATION_DEPLOYMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.DeploymentSpecification.deployment");
	if(REL_UML_DEPLOYMENTSPECIFICATION_DEPLOYMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DeploymentSpecification.deployment is missing.");
	ENT_UML_ARTIFACT=(IEntity)mm.getElementByName("uml.metamodel.uml.Artifact");
	if(ENT_UML_ARTIFACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Artifact is missing.");
	REL_UML_ARTIFACT_FILENAME=(IRelation)mm.getElementByName("uml.metamodel.uml.Artifact.fileName");
	if(REL_UML_ARTIFACT_FILENAME==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Artifact.fileName is missing.");
	REL_UML_ARTIFACT_NESTEDARTIFACT=(IRelation)mm.getElementByName("uml.metamodel.uml.Artifact.nestedArtifact");
	if(REL_UML_ARTIFACT_NESTEDARTIFACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Artifact.nestedArtifact is missing.");
	REL_UML_ARTIFACT_MANIFESTATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Artifact.manifestation");
	if(REL_UML_ARTIFACT_MANIFESTATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Artifact.manifestation is missing.");
	REL_UML_ARTIFACT_OWNEDOPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Artifact.ownedOperation");
	if(REL_UML_ARTIFACT_OWNEDOPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Artifact.ownedOperation is missing.");
	REL_UML_ARTIFACT_OWNEDATTRIBUTE=(IRelation)mm.getElementByName("uml.metamodel.uml.Artifact.ownedAttribute");
	if(REL_UML_ARTIFACT_OWNEDATTRIBUTE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Artifact.ownedAttribute is missing.");
	ENT_UML_MANIFESTATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Manifestation");
	if(ENT_UML_MANIFESTATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Manifestation is missing.");
	REL_UML_MANIFESTATION_UTILIZEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Manifestation.utilizedElement");
	if(REL_UML_MANIFESTATION_UTILIZEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Manifestation.utilizedElement is missing.");
	ENT_UML_OPERATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Operation");
	if(ENT_UML_OPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation is missing.");
	REL_UML_OPERATION_ISQUERY=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.isQuery");
	if(REL_UML_OPERATION_ISQUERY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.isQuery is missing.");
	REL_UML_OPERATION_ISORDERED=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.isOrdered");
	if(REL_UML_OPERATION_ISORDERED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.isOrdered is missing.");
	REL_UML_OPERATION_ISUNIQUE=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.isUnique");
	if(REL_UML_OPERATION_ISUNIQUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.isUnique is missing.");
	REL_UML_OPERATION_LOWER=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.lower");
	if(REL_UML_OPERATION_LOWER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.lower is missing.");
	REL_UML_OPERATION_UPPER=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.upper");
	if(REL_UML_OPERATION_UPPER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.upper is missing.");
	REL_UML_OPERATION_INTERFACE=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.interface");
	if(REL_UML_OPERATION_INTERFACE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.interface is missing.");
	REL_UML_OPERATION_CLASS=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.class");
	if(REL_UML_OPERATION_CLASS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.class is missing.");
	REL_UML_OPERATION_PRECONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.precondition");
	if(REL_UML_OPERATION_PRECONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.precondition is missing.");
	REL_UML_OPERATION_POSTCONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.postcondition");
	if(REL_UML_OPERATION_POSTCONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.postcondition is missing.");
	REL_UML_OPERATION_REDEFINEDOPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.redefinedOperation");
	if(REL_UML_OPERATION_REDEFINEDOPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.redefinedOperation is missing.");
	REL_UML_OPERATION_DATATYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.datatype");
	if(REL_UML_OPERATION_DATATYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.datatype is missing.");
	REL_UML_OPERATION_BODYCONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.bodyCondition");
	if(REL_UML_OPERATION_BODYCONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.bodyCondition is missing.");
	REL_UML_OPERATION_TYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Operation.type");
	if(REL_UML_OPERATION_TYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Operation.type is missing.");
	ENT_UML_BEHAVIORALFEATURE=(IEntity)mm.getElementByName("uml.metamodel.uml.BehavioralFeature");
	if(ENT_UML_BEHAVIORALFEATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioralFeature is missing.");
	REL_UML_BEHAVIORALFEATURE_ISABSTRACT=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioralFeature.isAbstract");
	if(REL_UML_BEHAVIORALFEATURE_ISABSTRACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioralFeature.isAbstract is missing.");
	REL_UML_BEHAVIORALFEATURE_CONCURRENCY=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioralFeature.concurrency");
	if(REL_UML_BEHAVIORALFEATURE_CONCURRENCY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioralFeature.concurrency is missing.");
	REL_UML_BEHAVIORALFEATURE_OWNEDPARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioralFeature.ownedParameter");
	if(REL_UML_BEHAVIORALFEATURE_OWNEDPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioralFeature.ownedParameter is missing.");
	REL_UML_BEHAVIORALFEATURE_METHOD=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioralFeature.method");
	if(REL_UML_BEHAVIORALFEATURE_METHOD==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioralFeature.method is missing.");
	REL_UML_BEHAVIORALFEATURE_RAISEDEXCEPTION=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioralFeature.raisedException");
	if(REL_UML_BEHAVIORALFEATURE_RAISEDEXCEPTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioralFeature.raisedException is missing.");
	REL_UML_BEHAVIORALFEATURE_OWNEDPARAMETERSET=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioralFeature.ownedParameterSet");
	if(REL_UML_BEHAVIORALFEATURE_OWNEDPARAMETERSET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioralFeature.ownedParameterSet is missing.");
	ENT_UML_BEHAVIOR=(IEntity)mm.getElementByName("uml.metamodel.uml.Behavior");
	if(ENT_UML_BEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior is missing.");
	REL_UML_BEHAVIOR_ISREENTRANT=(IRelation)mm.getElementByName("uml.metamodel.uml.Behavior.isReentrant");
	if(REL_UML_BEHAVIOR_ISREENTRANT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior.isReentrant is missing.");
	REL_UML_BEHAVIOR_REDEFINEDBEHAVIOR=(IRelation)mm.getElementByName("uml.metamodel.uml.Behavior.redefinedBehavior");
	if(REL_UML_BEHAVIOR_REDEFINEDBEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior.redefinedBehavior is missing.");
	REL_UML_BEHAVIOR_OWNEDPARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.Behavior.ownedParameter");
	if(REL_UML_BEHAVIOR_OWNEDPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior.ownedParameter is missing.");
	REL_UML_BEHAVIOR_CONTEXT=(IRelation)mm.getElementByName("uml.metamodel.uml.Behavior.context");
	if(REL_UML_BEHAVIOR_CONTEXT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior.context is missing.");
	REL_UML_BEHAVIOR_PRECONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Behavior.precondition");
	if(REL_UML_BEHAVIOR_PRECONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior.precondition is missing.");
	REL_UML_BEHAVIOR_POSTCONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Behavior.postcondition");
	if(REL_UML_BEHAVIOR_POSTCONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior.postcondition is missing.");
	REL_UML_BEHAVIOR_OWNEDPARAMETERSET=(IRelation)mm.getElementByName("uml.metamodel.uml.Behavior.ownedParameterSet");
	if(REL_UML_BEHAVIOR_OWNEDPARAMETERSET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior.ownedParameterSet is missing.");
	REL_UML_BEHAVIOR_SPECIFICATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Behavior.specification");
	if(REL_UML_BEHAVIOR_SPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Behavior.specification is missing.");
	ENT_UML_CLASS=(IEntity)mm.getElementByName("uml.metamodel.uml.Class");
	if(ENT_UML_CLASS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Class is missing.");
	REL_UML_CLASS_ISACTIVE=(IRelation)mm.getElementByName("uml.metamodel.uml.Class.isActive");
	if(REL_UML_CLASS_ISACTIVE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Class.isActive is missing.");
	REL_UML_CLASS_NESTEDCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.Class.nestedClassifier");
	if(REL_UML_CLASS_NESTEDCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Class.nestedClassifier is missing.");
	REL_UML_CLASS_OWNEDOPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Class.ownedOperation");
	if(REL_UML_CLASS_OWNEDOPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Class.ownedOperation is missing.");
	REL_UML_CLASS_SUPERCLASS=(IRelation)mm.getElementByName("uml.metamodel.uml.Class.superClass");
	if(REL_UML_CLASS_SUPERCLASS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Class.superClass is missing.");
	REL_UML_CLASS_OWNEDRECEPTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Class.ownedReception");
	if(REL_UML_CLASS_OWNEDRECEPTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Class.ownedReception is missing.");
	REL_UML_CLASS_EXTENSION=(IRelation)mm.getElementByName("uml.metamodel.uml.Class.extension");
	if(REL_UML_CLASS_EXTENSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Class.extension is missing.");
	ENT_UML_BEHAVIOREDCLASSIFIER=(IEntity)mm.getElementByName("uml.metamodel.uml.BehavioredClassifier");
	if(ENT_UML_BEHAVIOREDCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioredClassifier is missing.");
	REL_UML_BEHAVIOREDCLASSIFIER_OWNEDBEHAVIOR=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioredClassifier.ownedBehavior");
	if(REL_UML_BEHAVIOREDCLASSIFIER_OWNEDBEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioredClassifier.ownedBehavior is missing.");
	REL_UML_BEHAVIOREDCLASSIFIER_CLASSIFIERBEHAVIOR=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioredClassifier.classifierBehavior");
	if(REL_UML_BEHAVIOREDCLASSIFIER_CLASSIFIERBEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioredClassifier.classifierBehavior is missing.");
	REL_UML_BEHAVIOREDCLASSIFIER_INTERFACEREALIZATION=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioredClassifier.interfaceRealization");
	if(REL_UML_BEHAVIOREDCLASSIFIER_INTERFACEREALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioredClassifier.interfaceRealization is missing.");
	REL_UML_BEHAVIOREDCLASSIFIER_OWNEDTRIGGER=(IRelation)mm.getElementByName("uml.metamodel.uml.BehavioredClassifier.ownedTrigger");
	if(REL_UML_BEHAVIOREDCLASSIFIER_OWNEDTRIGGER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehavioredClassifier.ownedTrigger is missing.");
	ENT_UML_INTERFACEREALIZATION=(IEntity)mm.getElementByName("uml.metamodel.uml.InterfaceRealization");
	if(ENT_UML_INTERFACEREALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InterfaceRealization is missing.");
	REL_UML_INTERFACEREALIZATION_CONTRACT=(IRelation)mm.getElementByName("uml.metamodel.uml.InterfaceRealization.contract");
	if(REL_UML_INTERFACEREALIZATION_CONTRACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InterfaceRealization.contract is missing.");
	REL_UML_INTERFACEREALIZATION_IMPLEMENTINGCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.InterfaceRealization.implementingClassifier");
	if(REL_UML_INTERFACEREALIZATION_IMPLEMENTINGCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InterfaceRealization.implementingClassifier is missing.");
	ENT_UML_INTERFACE=(IEntity)mm.getElementByName("uml.metamodel.uml.Interface");
	if(ENT_UML_INTERFACE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interface is missing.");
	REL_UML_INTERFACE_OWNEDATTRIBUTE=(IRelation)mm.getElementByName("uml.metamodel.uml.Interface.ownedAttribute");
	if(REL_UML_INTERFACE_OWNEDATTRIBUTE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interface.ownedAttribute is missing.");
	REL_UML_INTERFACE_OWNEDOPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Interface.ownedOperation");
	if(REL_UML_INTERFACE_OWNEDOPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interface.ownedOperation is missing.");
	REL_UML_INTERFACE_NESTEDCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.Interface.nestedClassifier");
	if(REL_UML_INTERFACE_NESTEDCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interface.nestedClassifier is missing.");
	REL_UML_INTERFACE_REDEFINEDINTERFACE=(IRelation)mm.getElementByName("uml.metamodel.uml.Interface.redefinedInterface");
	if(REL_UML_INTERFACE_REDEFINEDINTERFACE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interface.redefinedInterface is missing.");
	REL_UML_INTERFACE_OWNEDRECEPTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Interface.ownedReception");
	if(REL_UML_INTERFACE_OWNEDRECEPTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interface.ownedReception is missing.");
	REL_UML_INTERFACE_PROTOCOL=(IRelation)mm.getElementByName("uml.metamodel.uml.Interface.protocol");
	if(REL_UML_INTERFACE_PROTOCOL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interface.protocol is missing.");
	ENT_UML_RECEPTION=(IEntity)mm.getElementByName("uml.metamodel.uml.Reception");
	if(ENT_UML_RECEPTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Reception is missing.");
	REL_UML_RECEPTION_SIGNAL=(IRelation)mm.getElementByName("uml.metamodel.uml.Reception.signal");
	if(REL_UML_RECEPTION_SIGNAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Reception.signal is missing.");
	ENT_UML_SIGNAL=(IEntity)mm.getElementByName("uml.metamodel.uml.Signal");
	if(ENT_UML_SIGNAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Signal is missing.");
	REL_UML_SIGNAL_OWNEDATTRIBUTE=(IRelation)mm.getElementByName("uml.metamodel.uml.Signal.ownedAttribute");
	if(REL_UML_SIGNAL_OWNEDATTRIBUTE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Signal.ownedAttribute is missing.");
	ENT_UML_PROTOCOLSTATEMACHINE=(IEntity)mm.getElementByName("uml.metamodel.uml.ProtocolStateMachine");
	if(ENT_UML_PROTOCOLSTATEMACHINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolStateMachine is missing.");
	REL_UML_PROTOCOLSTATEMACHINE_CONFORMANCE=(IRelation)mm.getElementByName("uml.metamodel.uml.ProtocolStateMachine.conformance");
	if(REL_UML_PROTOCOLSTATEMACHINE_CONFORMANCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolStateMachine.conformance is missing.");
	ENT_UML_STATEMACHINE=(IEntity)mm.getElementByName("uml.metamodel.uml.StateMachine");
	if(ENT_UML_STATEMACHINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StateMachine is missing.");
	REL_UML_STATEMACHINE_REGION=(IRelation)mm.getElementByName("uml.metamodel.uml.StateMachine.region");
	if(REL_UML_STATEMACHINE_REGION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StateMachine.region is missing.");
	REL_UML_STATEMACHINE_SUBMACHINESTATE=(IRelation)mm.getElementByName("uml.metamodel.uml.StateMachine.submachineState");
	if(REL_UML_STATEMACHINE_SUBMACHINESTATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StateMachine.submachineState is missing.");
	REL_UML_STATEMACHINE_CONNECTIONPOINT=(IRelation)mm.getElementByName("uml.metamodel.uml.StateMachine.connectionPoint");
	if(REL_UML_STATEMACHINE_CONNECTIONPOINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StateMachine.connectionPoint is missing.");
	REL_UML_STATEMACHINE_EXTENDEDSTATEMACHINE=(IRelation)mm.getElementByName("uml.metamodel.uml.StateMachine.extendedStateMachine");
	if(REL_UML_STATEMACHINE_EXTENDEDSTATEMACHINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StateMachine.extendedStateMachine is missing.");
	ENT_UML_REGION=(IEntity)mm.getElementByName("uml.metamodel.uml.Region");
	if(ENT_UML_REGION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Region is missing.");
	REL_UML_REGION_SUBVERTEX=(IRelation)mm.getElementByName("uml.metamodel.uml.Region.subvertex");
	if(REL_UML_REGION_SUBVERTEX==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Region.subvertex is missing.");
	REL_UML_REGION_TRANSITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Region.transition");
	if(REL_UML_REGION_TRANSITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Region.transition is missing.");
	REL_UML_REGION_STATE=(IRelation)mm.getElementByName("uml.metamodel.uml.Region.state");
	if(REL_UML_REGION_STATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Region.state is missing.");
	REL_UML_REGION_EXTENDEDREGION=(IRelation)mm.getElementByName("uml.metamodel.uml.Region.extendedRegion");
	if(REL_UML_REGION_EXTENDEDREGION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Region.extendedRegion is missing.");
	REL_UML_REGION_STATEMACHINE=(IRelation)mm.getElementByName("uml.metamodel.uml.Region.stateMachine");
	if(REL_UML_REGION_STATEMACHINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Region.stateMachine is missing.");
	ENT_UML_VERTEX=(IEntity)mm.getElementByName("uml.metamodel.uml.Vertex");
	if(ENT_UML_VERTEX==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Vertex is missing.");
	REL_UML_VERTEX_OUTGOING=(IRelation)mm.getElementByName("uml.metamodel.uml.Vertex.outgoing");
	if(REL_UML_VERTEX_OUTGOING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Vertex.outgoing is missing.");
	REL_UML_VERTEX_INCOMING=(IRelation)mm.getElementByName("uml.metamodel.uml.Vertex.incoming");
	if(REL_UML_VERTEX_INCOMING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Vertex.incoming is missing.");
	REL_UML_VERTEX_CONTAINER=(IRelation)mm.getElementByName("uml.metamodel.uml.Vertex.container");
	if(REL_UML_VERTEX_CONTAINER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Vertex.container is missing.");
	ENT_UML_TRANSITION=(IEntity)mm.getElementByName("uml.metamodel.uml.Transition");
	if(ENT_UML_TRANSITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition is missing.");
	REL_UML_TRANSITION_KIND=(IRelation)mm.getElementByName("uml.metamodel.uml.Transition.kind");
	if(REL_UML_TRANSITION_KIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition.kind is missing.");
	REL_UML_TRANSITION_CONTAINER=(IRelation)mm.getElementByName("uml.metamodel.uml.Transition.container");
	if(REL_UML_TRANSITION_CONTAINER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition.container is missing.");
	REL_UML_TRANSITION_SOURCE=(IRelation)mm.getElementByName("uml.metamodel.uml.Transition.source");
	if(REL_UML_TRANSITION_SOURCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition.source is missing.");
	REL_UML_TRANSITION_TARGET=(IRelation)mm.getElementByName("uml.metamodel.uml.Transition.target");
	if(REL_UML_TRANSITION_TARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition.target is missing.");
	REL_UML_TRANSITION_REDEFINEDTRANSITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Transition.redefinedTransition");
	if(REL_UML_TRANSITION_REDEFINEDTRANSITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition.redefinedTransition is missing.");
	REL_UML_TRANSITION_GUARD=(IRelation)mm.getElementByName("uml.metamodel.uml.Transition.guard");
	if(REL_UML_TRANSITION_GUARD==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition.guard is missing.");
	REL_UML_TRANSITION_EFFECT=(IRelation)mm.getElementByName("uml.metamodel.uml.Transition.effect");
	if(REL_UML_TRANSITION_EFFECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition.effect is missing.");
	REL_UML_TRANSITION_TRIGGER=(IRelation)mm.getElementByName("uml.metamodel.uml.Transition.trigger");
	if(REL_UML_TRANSITION_TRIGGER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Transition.trigger is missing.");
	ENT_UML_TRANSITIONKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.TransitionKind");
	if(ENT_UML_TRANSITIONKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TransitionKind is missing.");
	ENT_UML_TRIGGER=(IEntity)mm.getElementByName("uml.metamodel.uml.Trigger");
	if(ENT_UML_TRIGGER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Trigger is missing.");
	REL_UML_TRIGGER_EVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Trigger.event");
	if(REL_UML_TRIGGER_EVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Trigger.event is missing.");
	REL_UML_TRIGGER_PORT=(IRelation)mm.getElementByName("uml.metamodel.uml.Trigger.port");
	if(REL_UML_TRIGGER_PORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Trigger.port is missing.");
	ENT_UML_EVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.Event");
	if(ENT_UML_EVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Event is missing.");
	ENT_UML_PORT=(IEntity)mm.getElementByName("uml.metamodel.uml.Port");
	if(ENT_UML_PORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Port is missing.");
	REL_UML_PORT_ISBEHAVIOR=(IRelation)mm.getElementByName("uml.metamodel.uml.Port.isBehavior");
	if(REL_UML_PORT_ISBEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Port.isBehavior is missing.");
	REL_UML_PORT_ISSERVICE=(IRelation)mm.getElementByName("uml.metamodel.uml.Port.isService");
	if(REL_UML_PORT_ISSERVICE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Port.isService is missing.");
	REL_UML_PORT_REQUIRED=(IRelation)mm.getElementByName("uml.metamodel.uml.Port.required");
	if(REL_UML_PORT_REQUIRED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Port.required is missing.");
	REL_UML_PORT_REDEFINEDPORT=(IRelation)mm.getElementByName("uml.metamodel.uml.Port.redefinedPort");
	if(REL_UML_PORT_REDEFINEDPORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Port.redefinedPort is missing.");
	REL_UML_PORT_PROVIDED=(IRelation)mm.getElementByName("uml.metamodel.uml.Port.provided");
	if(REL_UML_PORT_PROVIDED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Port.provided is missing.");
	REL_UML_PORT_PROTOCOL=(IRelation)mm.getElementByName("uml.metamodel.uml.Port.protocol");
	if(REL_UML_PORT_PROTOCOL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Port.protocol is missing.");
	ENT_UML_STATE=(IEntity)mm.getElementByName("uml.metamodel.uml.State");
	if(ENT_UML_STATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State is missing.");
	REL_UML_STATE_ISCOMPOSITE=(IRelation)mm.getElementByName("uml.metamodel.uml.State.isComposite");
	if(REL_UML_STATE_ISCOMPOSITE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.isComposite is missing.");
	REL_UML_STATE_ISORTHOGONAL=(IRelation)mm.getElementByName("uml.metamodel.uml.State.isOrthogonal");
	if(REL_UML_STATE_ISORTHOGONAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.isOrthogonal is missing.");
	REL_UML_STATE_ISSIMPLE=(IRelation)mm.getElementByName("uml.metamodel.uml.State.isSimple");
	if(REL_UML_STATE_ISSIMPLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.isSimple is missing.");
	REL_UML_STATE_ISSUBMACHINESTATE=(IRelation)mm.getElementByName("uml.metamodel.uml.State.isSubmachineState");
	if(REL_UML_STATE_ISSUBMACHINESTATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.isSubmachineState is missing.");
	REL_UML_STATE_SUBMACHINE=(IRelation)mm.getElementByName("uml.metamodel.uml.State.submachine");
	if(REL_UML_STATE_SUBMACHINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.submachine is missing.");
	REL_UML_STATE_CONNECTION=(IRelation)mm.getElementByName("uml.metamodel.uml.State.connection");
	if(REL_UML_STATE_CONNECTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.connection is missing.");
	REL_UML_STATE_CONNECTIONPOINT=(IRelation)mm.getElementByName("uml.metamodel.uml.State.connectionPoint");
	if(REL_UML_STATE_CONNECTIONPOINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.connectionPoint is missing.");
	REL_UML_STATE_REDEFINEDSTATE=(IRelation)mm.getElementByName("uml.metamodel.uml.State.redefinedState");
	if(REL_UML_STATE_REDEFINEDSTATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.redefinedState is missing.");
	REL_UML_STATE_STATEINVARIANT=(IRelation)mm.getElementByName("uml.metamodel.uml.State.stateInvariant");
	if(REL_UML_STATE_STATEINVARIANT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.stateInvariant is missing.");
	REL_UML_STATE_ENTRY=(IRelation)mm.getElementByName("uml.metamodel.uml.State.entry");
	if(REL_UML_STATE_ENTRY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.entry is missing.");
	REL_UML_STATE_EXIT=(IRelation)mm.getElementByName("uml.metamodel.uml.State.exit");
	if(REL_UML_STATE_EXIT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.exit is missing.");
	REL_UML_STATE_DOACTIVITY=(IRelation)mm.getElementByName("uml.metamodel.uml.State.doActivity");
	if(REL_UML_STATE_DOACTIVITY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.doActivity is missing.");
	REL_UML_STATE_DEFERRABLETRIGGER=(IRelation)mm.getElementByName("uml.metamodel.uml.State.deferrableTrigger");
	if(REL_UML_STATE_DEFERRABLETRIGGER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.deferrableTrigger is missing.");
	REL_UML_STATE_REGION=(IRelation)mm.getElementByName("uml.metamodel.uml.State.region");
	if(REL_UML_STATE_REGION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.State.region is missing.");
	ENT_UML_CONNECTIONPOINTREFERENCE=(IEntity)mm.getElementByName("uml.metamodel.uml.ConnectionPointReference");
	if(ENT_UML_CONNECTIONPOINTREFERENCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectionPointReference is missing.");
	REL_UML_CONNECTIONPOINTREFERENCE_ENTRY=(IRelation)mm.getElementByName("uml.metamodel.uml.ConnectionPointReference.entry");
	if(REL_UML_CONNECTIONPOINTREFERENCE_ENTRY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectionPointReference.entry is missing.");
	REL_UML_CONNECTIONPOINTREFERENCE_EXIT=(IRelation)mm.getElementByName("uml.metamodel.uml.ConnectionPointReference.exit");
	if(REL_UML_CONNECTIONPOINTREFERENCE_EXIT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectionPointReference.exit is missing.");
	REL_UML_CONNECTIONPOINTREFERENCE_STATE=(IRelation)mm.getElementByName("uml.metamodel.uml.ConnectionPointReference.state");
	if(REL_UML_CONNECTIONPOINTREFERENCE_STATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectionPointReference.state is missing.");
	ENT_UML_PSEUDOSTATE=(IEntity)mm.getElementByName("uml.metamodel.uml.Pseudostate");
	if(ENT_UML_PSEUDOSTATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Pseudostate is missing.");
	REL_UML_PSEUDOSTATE_KIND=(IRelation)mm.getElementByName("uml.metamodel.uml.Pseudostate.kind");
	if(REL_UML_PSEUDOSTATE_KIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Pseudostate.kind is missing.");
	REL_UML_PSEUDOSTATE_STATEMACHINE=(IRelation)mm.getElementByName("uml.metamodel.uml.Pseudostate.stateMachine");
	if(REL_UML_PSEUDOSTATE_STATEMACHINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Pseudostate.stateMachine is missing.");
	REL_UML_PSEUDOSTATE_STATE=(IRelation)mm.getElementByName("uml.metamodel.uml.Pseudostate.state");
	if(REL_UML_PSEUDOSTATE_STATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Pseudostate.state is missing.");
	ENT_UML_PSEUDOSTATEKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.PseudostateKind");
	if(ENT_UML_PSEUDOSTATEKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PseudostateKind is missing.");
	ENT_UML_PROTOCOLCONFORMANCE=(IEntity)mm.getElementByName("uml.metamodel.uml.ProtocolConformance");
	if(ENT_UML_PROTOCOLCONFORMANCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolConformance is missing.");
	REL_UML_PROTOCOLCONFORMANCE_GENERALMACHINE=(IRelation)mm.getElementByName("uml.metamodel.uml.ProtocolConformance.generalMachine");
	if(REL_UML_PROTOCOLCONFORMANCE_GENERALMACHINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolConformance.generalMachine is missing.");
	REL_UML_PROTOCOLCONFORMANCE_SPECIFICMACHINE=(IRelation)mm.getElementByName("uml.metamodel.uml.ProtocolConformance.specificMachine");
	if(REL_UML_PROTOCOLCONFORMANCE_SPECIFICMACHINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolConformance.specificMachine is missing.");
	ENT_UML_ENCAPSULATEDCLASSIFIER=(IEntity)mm.getElementByName("uml.metamodel.uml.EncapsulatedClassifier");
	if(ENT_UML_ENCAPSULATEDCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.EncapsulatedClassifier is missing.");
	REL_UML_ENCAPSULATEDCLASSIFIER_OWNEDPORT=(IRelation)mm.getElementByName("uml.metamodel.uml.EncapsulatedClassifier.ownedPort");
	if(REL_UML_ENCAPSULATEDCLASSIFIER_OWNEDPORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.EncapsulatedClassifier.ownedPort is missing.");
	ENT_UML_STRUCTUREDCLASSIFIER=(IEntity)mm.getElementByName("uml.metamodel.uml.StructuredClassifier");
	if(ENT_UML_STRUCTUREDCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredClassifier is missing.");
	REL_UML_STRUCTUREDCLASSIFIER_OWNEDATTRIBUTE=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuredClassifier.ownedAttribute");
	if(REL_UML_STRUCTUREDCLASSIFIER_OWNEDATTRIBUTE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredClassifier.ownedAttribute is missing.");
	REL_UML_STRUCTUREDCLASSIFIER_PART=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuredClassifier.part");
	if(REL_UML_STRUCTUREDCLASSIFIER_PART==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredClassifier.part is missing.");
	REL_UML_STRUCTUREDCLASSIFIER_ROLE=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuredClassifier.role");
	if(REL_UML_STRUCTUREDCLASSIFIER_ROLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredClassifier.role is missing.");
	REL_UML_STRUCTUREDCLASSIFIER_OWNEDCONNECTOR=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuredClassifier.ownedConnector");
	if(REL_UML_STRUCTUREDCLASSIFIER_OWNEDCONNECTOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredClassifier.ownedConnector is missing.");
	ENT_UML_CONNECTOR=(IEntity)mm.getElementByName("uml.metamodel.uml.Connector");
	if(ENT_UML_CONNECTOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Connector is missing.");
	REL_UML_CONNECTOR_KIND=(IRelation)mm.getElementByName("uml.metamodel.uml.Connector.kind");
	if(REL_UML_CONNECTOR_KIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Connector.kind is missing.");
	REL_UML_CONNECTOR_TYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Connector.type");
	if(REL_UML_CONNECTOR_TYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Connector.type is missing.");
	REL_UML_CONNECTOR_REDEFINEDCONNECTOR=(IRelation)mm.getElementByName("uml.metamodel.uml.Connector.redefinedConnector");
	if(REL_UML_CONNECTOR_REDEFINEDCONNECTOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Connector.redefinedConnector is missing.");
	REL_UML_CONNECTOR_END=(IRelation)mm.getElementByName("uml.metamodel.uml.Connector.end");
	if(REL_UML_CONNECTOR_END==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Connector.end is missing.");
	REL_UML_CONNECTOR_CONTRACT=(IRelation)mm.getElementByName("uml.metamodel.uml.Connector.contract");
	if(REL_UML_CONNECTOR_CONTRACT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Connector.contract is missing.");
	ENT_UML_CONNECTORKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.ConnectorKind");
	if(ENT_UML_CONNECTORKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectorKind is missing.");
	ENT_UML_EXTENSION=(IEntity)mm.getElementByName("uml.metamodel.uml.Extension");
	if(ENT_UML_EXTENSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Extension is missing.");
	REL_UML_EXTENSION_ISREQUIRED=(IRelation)mm.getElementByName("uml.metamodel.uml.Extension.isRequired");
	if(REL_UML_EXTENSION_ISREQUIRED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Extension.isRequired is missing.");
	REL_UML_EXTENSION_METACLASS=(IRelation)mm.getElementByName("uml.metamodel.uml.Extension.metaclass");
	if(REL_UML_EXTENSION_METACLASS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Extension.metaclass is missing.");
	ENT_UML_EXTENSIONEND=(IEntity)mm.getElementByName("uml.metamodel.uml.ExtensionEnd");
	if(ENT_UML_EXTENSIONEND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExtensionEnd is missing.");
	ENT_UML_STEREOTYPE=(IEntity)mm.getElementByName("uml.metamodel.uml.Stereotype");
	if(ENT_UML_STEREOTYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Stereotype is missing.");
	REL_UML_STEREOTYPE_ICON=(IRelation)mm.getElementByName("uml.metamodel.uml.Stereotype.icon");
	if(REL_UML_STEREOTYPE_ICON==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Stereotype.icon is missing.");
	ENT_UML_IMAGE=(IEntity)mm.getElementByName("uml.metamodel.uml.Image");
	if(ENT_UML_IMAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Image is missing.");
	REL_UML_IMAGE_CONTENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Image.content");
	if(REL_UML_IMAGE_CONTENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Image.content is missing.");
	REL_UML_IMAGE_LOCATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Image.location");
	if(REL_UML_IMAGE_LOCATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Image.location is missing.");
	REL_UML_IMAGE_FORMAT=(IRelation)mm.getElementByName("uml.metamodel.uml.Image.format");
	if(REL_UML_IMAGE_FORMAT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Image.format is missing.");
	ENT_UML_PROFILE=(IEntity)mm.getElementByName("uml.metamodel.uml.Profile");
	if(ENT_UML_PROFILE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Profile is missing.");
	REL_UML_PROFILE_OWNEDSTEREOTYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Profile.ownedStereotype");
	if(REL_UML_PROFILE_OWNEDSTEREOTYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Profile.ownedStereotype is missing.");
	REL_UML_PROFILE_METACLASSREFERENCE=(IRelation)mm.getElementByName("uml.metamodel.uml.Profile.metaclassReference");
	if(REL_UML_PROFILE_METACLASSREFERENCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Profile.metaclassReference is missing.");
	REL_UML_PROFILE_METAMODELREFERENCE=(IRelation)mm.getElementByName("uml.metamodel.uml.Profile.metamodelReference");
	if(REL_UML_PROFILE_METAMODELREFERENCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Profile.metamodelReference is missing.");
	ENT_UML_MODEL=(IEntity)mm.getElementByName("uml.metamodel.uml.Model");
	if(ENT_UML_MODEL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Model is missing.");
	REL_UML_MODEL_VIEWPOINT=(IRelation)mm.getElementByName("uml.metamodel.uml.Model.viewpoint");
	if(REL_UML_MODEL_VIEWPOINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Model.viewpoint is missing.");
	ENT_UML_PARAMETERSET=(IEntity)mm.getElementByName("uml.metamodel.uml.ParameterSet");
	if(ENT_UML_PARAMETERSET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ParameterSet is missing.");
	REL_UML_PARAMETERSET_PARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.ParameterSet.parameter");
	if(REL_UML_PARAMETERSET_PARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ParameterSet.parameter is missing.");
	REL_UML_PARAMETERSET_CONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.ParameterSet.condition");
	if(REL_UML_PARAMETERSET_CONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ParameterSet.condition is missing.");
	ENT_UML_CALLCONCURRENCYKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.CallConcurrencyKind");
	if(ENT_UML_CALLCONCURRENCYKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallConcurrencyKind is missing.");
	ENT_UML_DATATYPE=(IEntity)mm.getElementByName("uml.metamodel.uml.DataType");
	if(ENT_UML_DATATYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DataType is missing.");
	REL_UML_DATATYPE_OWNEDATTRIBUTE=(IRelation)mm.getElementByName("uml.metamodel.uml.DataType.ownedAttribute");
	if(REL_UML_DATATYPE_OWNEDATTRIBUTE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DataType.ownedAttribute is missing.");
	REL_UML_DATATYPE_OWNEDOPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.DataType.ownedOperation");
	if(REL_UML_DATATYPE_OWNEDOPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DataType.ownedOperation is missing.");
	ENT_UML_OPERATIONTEMPLATEPARAMETER=(IEntity)mm.getElementByName("uml.metamodel.uml.OperationTemplateParameter");
	if(ENT_UML_OPERATIONTEMPLATEPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OperationTemplateParameter is missing.");
	ENT_UML_STRUCTURALFEATURE=(IEntity)mm.getElementByName("uml.metamodel.uml.StructuralFeature");
	if(ENT_UML_STRUCTURALFEATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuralFeature is missing.");
	REL_UML_STRUCTURALFEATURE_ISREADONLY=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuralFeature.isReadOnly");
	if(REL_UML_STRUCTURALFEATURE_ISREADONLY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuralFeature.isReadOnly is missing.");
	ENT_UML_AGGREGATIONKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.AggregationKind");
	if(ENT_UML_AGGREGATIONKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AggregationKind is missing.");
	ENT_UML_CONNECTABLEELEMENTTEMPLATEPARAMETER=(IEntity)mm.getElementByName("uml.metamodel.uml.ConnectableElementTemplateParameter");
	if(ENT_UML_CONNECTABLEELEMENTTEMPLATEPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConnectableElementTemplateParameter is missing.");
	ENT_UML_PARAMETERDIRECTIONKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.ParameterDirectionKind");
	if(ENT_UML_PARAMETERDIRECTIONKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ParameterDirectionKind is missing.");
	ENT_UML_PARAMETEREFFECTKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.ParameterEffectKind");
	if(ENT_UML_PARAMETEREFFECTKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ParameterEffectKind is missing.");
	ENT_UML_COLLABORATIONUSE=(IEntity)mm.getElementByName("uml.metamodel.uml.CollaborationUse");
	if(ENT_UML_COLLABORATIONUSE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CollaborationUse is missing.");
	REL_UML_COLLABORATIONUSE_TYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.CollaborationUse.type");
	if(REL_UML_COLLABORATIONUSE_TYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CollaborationUse.type is missing.");
	REL_UML_COLLABORATIONUSE_ROLEBINDING=(IRelation)mm.getElementByName("uml.metamodel.uml.CollaborationUse.roleBinding");
	if(REL_UML_COLLABORATIONUSE_ROLEBINDING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CollaborationUse.roleBinding is missing.");
	ENT_UML_COLLABORATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Collaboration");
	if(ENT_UML_COLLABORATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Collaboration is missing.");
	REL_UML_COLLABORATION_COLLABORATIONROLE=(IRelation)mm.getElementByName("uml.metamodel.uml.Collaboration.collaborationRole");
	if(REL_UML_COLLABORATION_COLLABORATIONROLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Collaboration.collaborationRole is missing.");
	ENT_UML_USECASE=(IEntity)mm.getElementByName("uml.metamodel.uml.UseCase");
	if(ENT_UML_USECASE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UseCase is missing.");
	REL_UML_USECASE_INCLUDE=(IRelation)mm.getElementByName("uml.metamodel.uml.UseCase.include");
	if(REL_UML_USECASE_INCLUDE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UseCase.include is missing.");
	REL_UML_USECASE_EXTEND=(IRelation)mm.getElementByName("uml.metamodel.uml.UseCase.extend");
	if(REL_UML_USECASE_EXTEND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UseCase.extend is missing.");
	REL_UML_USECASE_EXTENSIONPOINT=(IRelation)mm.getElementByName("uml.metamodel.uml.UseCase.extensionPoint");
	if(REL_UML_USECASE_EXTENSIONPOINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UseCase.extensionPoint is missing.");
	REL_UML_USECASE_SUBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.UseCase.subject");
	if(REL_UML_USECASE_SUBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UseCase.subject is missing.");
	ENT_UML_INCLUDE=(IEntity)mm.getElementByName("uml.metamodel.uml.Include");
	if(ENT_UML_INCLUDE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Include is missing.");
	REL_UML_INCLUDE_ADDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Include.addition");
	if(REL_UML_INCLUDE_ADDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Include.addition is missing.");
	REL_UML_INCLUDE_INCLUDINGCASE=(IRelation)mm.getElementByName("uml.metamodel.uml.Include.includingCase");
	if(REL_UML_INCLUDE_INCLUDINGCASE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Include.includingCase is missing.");
	ENT_UML_EXTEND=(IEntity)mm.getElementByName("uml.metamodel.uml.Extend");
	if(ENT_UML_EXTEND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Extend is missing.");
	REL_UML_EXTEND_EXTENDEDCASE=(IRelation)mm.getElementByName("uml.metamodel.uml.Extend.extendedCase");
	if(REL_UML_EXTEND_EXTENDEDCASE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Extend.extendedCase is missing.");
	REL_UML_EXTEND_CONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Extend.condition");
	if(REL_UML_EXTEND_CONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Extend.condition is missing.");
	REL_UML_EXTEND_EXTENSIONLOCATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Extend.extensionLocation");
	if(REL_UML_EXTEND_EXTENSIONLOCATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Extend.extensionLocation is missing.");
	REL_UML_EXTEND_EXTENSION=(IRelation)mm.getElementByName("uml.metamodel.uml.Extend.extension");
	if(REL_UML_EXTEND_EXTENSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Extend.extension is missing.");
	ENT_UML_EXTENSIONPOINT=(IEntity)mm.getElementByName("uml.metamodel.uml.ExtensionPoint");
	if(ENT_UML_EXTENSIONPOINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExtensionPoint is missing.");
	REL_UML_EXTENSIONPOINT_USECASE=(IRelation)mm.getElementByName("uml.metamodel.uml.ExtensionPoint.useCase");
	if(REL_UML_EXTENSIONPOINT_USECASE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExtensionPoint.useCase is missing.");
	ENT_UML_REDEFINABLETEMPLATESIGNATURE=(IEntity)mm.getElementByName("uml.metamodel.uml.RedefinableTemplateSignature");
	if(ENT_UML_REDEFINABLETEMPLATESIGNATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RedefinableTemplateSignature is missing.");
	REL_UML_REDEFINABLETEMPLATESIGNATURE_EXTENDEDSIGNATURE=(IRelation)mm.getElementByName("uml.metamodel.uml.RedefinableTemplateSignature.extendedSignature");
	if(REL_UML_REDEFINABLETEMPLATESIGNATURE_EXTENDEDSIGNATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RedefinableTemplateSignature.extendedSignature is missing.");
	REL_UML_REDEFINABLETEMPLATESIGNATURE_INHERITEDPARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.RedefinableTemplateSignature.inheritedParameter");
	if(REL_UML_REDEFINABLETEMPLATESIGNATURE_INHERITEDPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RedefinableTemplateSignature.inheritedParameter is missing.");
	REL_UML_REDEFINABLETEMPLATESIGNATURE_CLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.RedefinableTemplateSignature.classifier");
	if(REL_UML_REDEFINABLETEMPLATESIGNATURE_CLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RedefinableTemplateSignature.classifier is missing.");
	ENT_UML_CLASSIFIERTEMPLATEPARAMETER=(IEntity)mm.getElementByName("uml.metamodel.uml.ClassifierTemplateParameter");
	if(ENT_UML_CLASSIFIERTEMPLATEPARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClassifierTemplateParameter is missing.");
	REL_UML_CLASSIFIERTEMPLATEPARAMETER_ALLOWSUBSTITUTABLE=(IRelation)mm.getElementByName("uml.metamodel.uml.ClassifierTemplateParameter.allowSubstitutable");
	if(REL_UML_CLASSIFIERTEMPLATEPARAMETER_ALLOWSUBSTITUTABLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClassifierTemplateParameter.allowSubstitutable is missing.");
	REL_UML_CLASSIFIERTEMPLATEPARAMETER_CONSTRAININGCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.ClassifierTemplateParameter.constrainingClassifier");
	if(REL_UML_CLASSIFIERTEMPLATEPARAMETER_CONSTRAININGCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClassifierTemplateParameter.constrainingClassifier is missing.");
	ENT_UML_STRINGEXPRESSION=(IEntity)mm.getElementByName("uml.metamodel.uml.StringExpression");
	if(ENT_UML_STRINGEXPRESSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StringExpression is missing.");
	REL_UML_STRINGEXPRESSION_SUBEXPRESSION=(IRelation)mm.getElementByName("uml.metamodel.uml.StringExpression.subExpression");
	if(REL_UML_STRINGEXPRESSION_SUBEXPRESSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StringExpression.subExpression is missing.");
	REL_UML_STRINGEXPRESSION_OWNINGEXPRESSION=(IRelation)mm.getElementByName("uml.metamodel.uml.StringExpression.owningExpression");
	if(REL_UML_STRINGEXPRESSION_OWNINGEXPRESSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StringExpression.owningExpression is missing.");
	ENT_UML_EXPRESSION=(IEntity)mm.getElementByName("uml.metamodel.uml.Expression");
	if(ENT_UML_EXPRESSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Expression is missing.");
	REL_UML_EXPRESSION_SYMBOL=(IRelation)mm.getElementByName("uml.metamodel.uml.Expression.symbol");
	if(REL_UML_EXPRESSION_SYMBOL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Expression.symbol is missing.");
	REL_UML_EXPRESSION_OPERAND=(IRelation)mm.getElementByName("uml.metamodel.uml.Expression.operand");
	if(REL_UML_EXPRESSION_OPERAND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Expression.operand is missing.");
	ENT_UML_USAGE=(IEntity)mm.getElementByName("uml.metamodel.uml.Usage");
	if(ENT_UML_USAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Usage is missing.");
	ENT_UML_PACKAGEMERGE=(IEntity)mm.getElementByName("uml.metamodel.uml.PackageMerge");
	if(ENT_UML_PACKAGEMERGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PackageMerge is missing.");
	REL_UML_PACKAGEMERGE_MERGEDPACKAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.PackageMerge.mergedPackage");
	if(REL_UML_PACKAGEMERGE_MERGEDPACKAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PackageMerge.mergedPackage is missing.");
	REL_UML_PACKAGEMERGE_RECEIVINGPACKAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.PackageMerge.receivingPackage");
	if(REL_UML_PACKAGEMERGE_RECEIVINGPACKAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PackageMerge.receivingPackage is missing.");
	ENT_UML_PROFILEAPPLICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.ProfileApplication");
	if(ENT_UML_PROFILEAPPLICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProfileApplication is missing.");
	REL_UML_PROFILEAPPLICATION_ISSTRICT=(IRelation)mm.getElementByName("uml.metamodel.uml.ProfileApplication.isStrict");
	if(REL_UML_PROFILEAPPLICATION_ISSTRICT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProfileApplication.isStrict is missing.");
	REL_UML_PROFILEAPPLICATION_APPLIEDPROFILE=(IRelation)mm.getElementByName("uml.metamodel.uml.ProfileApplication.appliedProfile");
	if(REL_UML_PROFILEAPPLICATION_APPLIEDPROFILE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProfileApplication.appliedProfile is missing.");
	REL_UML_PROFILEAPPLICATION_APPLYINGPACKAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.ProfileApplication.applyingPackage");
	if(REL_UML_PROFILEAPPLICATION_APPLYINGPACKAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProfileApplication.applyingPackage is missing.");
	ENT_UML_ENUMERATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Enumeration");
	if(ENT_UML_ENUMERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Enumeration is missing.");
	REL_UML_ENUMERATION_OWNEDLITERAL=(IRelation)mm.getElementByName("uml.metamodel.uml.Enumeration.ownedLiteral");
	if(REL_UML_ENUMERATION_OWNEDLITERAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Enumeration.ownedLiteral is missing.");
	ENT_UML_ENUMERATIONLITERAL=(IEntity)mm.getElementByName("uml.metamodel.uml.EnumerationLiteral");
	if(ENT_UML_ENUMERATIONLITERAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.EnumerationLiteral is missing.");
	REL_UML_ENUMERATIONLITERAL_ENUMERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.EnumerationLiteral.enumeration");
	if(REL_UML_ENUMERATIONLITERAL_ENUMERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.EnumerationLiteral.enumeration is missing.");
	ENT_UML_INSTANCESPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.InstanceSpecification");
	if(ENT_UML_INSTANCESPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InstanceSpecification is missing.");
	REL_UML_INSTANCESPECIFICATION_CLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.InstanceSpecification.classifier");
	if(REL_UML_INSTANCESPECIFICATION_CLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InstanceSpecification.classifier is missing.");
	REL_UML_INSTANCESPECIFICATION_SLOT=(IRelation)mm.getElementByName("uml.metamodel.uml.InstanceSpecification.slot");
	if(REL_UML_INSTANCESPECIFICATION_SLOT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InstanceSpecification.slot is missing.");
	REL_UML_INSTANCESPECIFICATION_SPECIFICATION=(IRelation)mm.getElementByName("uml.metamodel.uml.InstanceSpecification.specification");
	if(REL_UML_INSTANCESPECIFICATION_SPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InstanceSpecification.specification is missing.");
	ENT_UML_SLOT=(IEntity)mm.getElementByName("uml.metamodel.uml.Slot");
	if(ENT_UML_SLOT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Slot is missing.");
	REL_UML_SLOT_DEFININGFEATURE=(IRelation)mm.getElementByName("uml.metamodel.uml.Slot.definingFeature");
	if(REL_UML_SLOT_DEFININGFEATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Slot.definingFeature is missing.");
	REL_UML_SLOT_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.Slot.value");
	if(REL_UML_SLOT_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Slot.value is missing.");
	REL_UML_SLOT_OWNINGINSTANCE=(IRelation)mm.getElementByName("uml.metamodel.uml.Slot.owningInstance");
	if(REL_UML_SLOT_OWNINGINSTANCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Slot.owningInstance is missing.");
	ENT_UML_PRIMITIVETYPE=(IEntity)mm.getElementByName("uml.metamodel.uml.PrimitiveType");
	if(ENT_UML_PRIMITIVETYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PrimitiveType is missing.");
	ENT_UML_LITERALSPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.LiteralSpecification");
	if(ENT_UML_LITERALSPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralSpecification is missing.");
	ENT_UML_LITERALINTEGER=(IEntity)mm.getElementByName("uml.metamodel.uml.LiteralInteger");
	if(ENT_UML_LITERALINTEGER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralInteger is missing.");
	REL_UML_LITERALINTEGER_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.LiteralInteger.value");
	if(REL_UML_LITERALINTEGER_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralInteger.value is missing.");
	ENT_UML_LITERALSTRING=(IEntity)mm.getElementByName("uml.metamodel.uml.LiteralString");
	if(ENT_UML_LITERALSTRING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralString is missing.");
	REL_UML_LITERALSTRING_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.LiteralString.value");
	if(REL_UML_LITERALSTRING_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralString.value is missing.");
	ENT_UML_LITERALBOOLEAN=(IEntity)mm.getElementByName("uml.metamodel.uml.LiteralBoolean");
	if(ENT_UML_LITERALBOOLEAN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralBoolean is missing.");
	REL_UML_LITERALBOOLEAN_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.LiteralBoolean.value");
	if(REL_UML_LITERALBOOLEAN_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralBoolean.value is missing.");
	ENT_UML_LITERALNULL=(IEntity)mm.getElementByName("uml.metamodel.uml.LiteralNull");
	if(ENT_UML_LITERALNULL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralNull is missing.");
	ENT_UML_INSTANCEVALUE=(IEntity)mm.getElementByName("uml.metamodel.uml.InstanceValue");
	if(ENT_UML_INSTANCEVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InstanceValue is missing.");
	REL_UML_INSTANCEVALUE_INSTANCE=(IRelation)mm.getElementByName("uml.metamodel.uml.InstanceValue.instance");
	if(REL_UML_INSTANCEVALUE_INSTANCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InstanceValue.instance is missing.");
	ENT_UML_LITERALUNLIMITEDNATURAL=(IEntity)mm.getElementByName("uml.metamodel.uml.LiteralUnlimitedNatural");
	if(ENT_UML_LITERALUNLIMITEDNATURAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralUnlimitedNatural is missing.");
	REL_UML_LITERALUNLIMITEDNATURAL_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.LiteralUnlimitedNatural.value");
	if(REL_UML_LITERALUNLIMITEDNATURAL_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LiteralUnlimitedNatural.value is missing.");
	ENT_UML_OPAQUEBEHAVIOR=(IEntity)mm.getElementByName("uml.metamodel.uml.OpaqueBehavior");
	if(ENT_UML_OPAQUEBEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueBehavior is missing.");
	REL_UML_OPAQUEBEHAVIOR_BODY=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueBehavior.body");
	if(REL_UML_OPAQUEBEHAVIOR_BODY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueBehavior.body is missing.");
	REL_UML_OPAQUEBEHAVIOR_LANGUAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueBehavior.language");
	if(REL_UML_OPAQUEBEHAVIOR_LANGUAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueBehavior.language is missing.");
	ENT_UML_FUNCTIONBEHAVIOR=(IEntity)mm.getElementByName("uml.metamodel.uml.FunctionBehavior");
	if(ENT_UML_FUNCTIONBEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.FunctionBehavior is missing.");
	ENT_UML_OPAQUEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.OpaqueAction");
	if(ENT_UML_OPAQUEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueAction is missing.");
	REL_UML_OPAQUEACTION_BODY=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueAction.body");
	if(REL_UML_OPAQUEACTION_BODY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueAction.body is missing.");
	REL_UML_OPAQUEACTION_LANGUAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueAction.language");
	if(REL_UML_OPAQUEACTION_LANGUAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueAction.language is missing.");
	REL_UML_OPAQUEACTION_INPUTVALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueAction.inputValue");
	if(REL_UML_OPAQUEACTION_INPUTVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueAction.inputValue is missing.");
	REL_UML_OPAQUEACTION_OUTPUTVALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.OpaqueAction.outputValue");
	if(REL_UML_OPAQUEACTION_OUTPUTVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OpaqueAction.outputValue is missing.");
	ENT_UML_ACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.Action");
	if(ENT_UML_ACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Action is missing.");
	REL_UML_ACTION_OUTPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.Action.output");
	if(REL_UML_ACTION_OUTPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Action.output is missing.");
	REL_UML_ACTION_INPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.Action.input");
	if(REL_UML_ACTION_INPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Action.input is missing.");
	REL_UML_ACTION_CONTEXT=(IRelation)mm.getElementByName("uml.metamodel.uml.Action.context");
	if(REL_UML_ACTION_CONTEXT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Action.context is missing.");
	REL_UML_ACTION_LOCALPRECONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Action.localPrecondition");
	if(REL_UML_ACTION_LOCALPRECONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Action.localPrecondition is missing.");
	REL_UML_ACTION_LOCALPOSTCONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Action.localPostcondition");
	if(REL_UML_ACTION_LOCALPOSTCONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Action.localPostcondition is missing.");
	ENT_UML_EXECUTABLENODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ExecutableNode");
	if(ENT_UML_EXECUTABLENODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutableNode is missing.");
	REL_UML_EXECUTABLENODE_HANDLER=(IRelation)mm.getElementByName("uml.metamodel.uml.ExecutableNode.handler");
	if(REL_UML_EXECUTABLENODE_HANDLER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutableNode.handler is missing.");
	ENT_UML_ACTIVITYNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ActivityNode");
	if(ENT_UML_ACTIVITYNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode is missing.");
	REL_UML_ACTIVITYNODE_INSTRUCTUREDNODE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityNode.inStructuredNode");
	if(REL_UML_ACTIVITYNODE_INSTRUCTUREDNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode.inStructuredNode is missing.");
	REL_UML_ACTIVITYNODE_ACTIVITY=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityNode.activity");
	if(REL_UML_ACTIVITYNODE_ACTIVITY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode.activity is missing.");
	REL_UML_ACTIVITYNODE_OUTGOING=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityNode.outgoing");
	if(REL_UML_ACTIVITYNODE_OUTGOING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode.outgoing is missing.");
	REL_UML_ACTIVITYNODE_INCOMING=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityNode.incoming");
	if(REL_UML_ACTIVITYNODE_INCOMING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode.incoming is missing.");
	REL_UML_ACTIVITYNODE_INPARTITION=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityNode.inPartition");
	if(REL_UML_ACTIVITYNODE_INPARTITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode.inPartition is missing.");
	REL_UML_ACTIVITYNODE_ININTERRUPTIBLEREGION=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityNode.inInterruptibleRegion");
	if(REL_UML_ACTIVITYNODE_ININTERRUPTIBLEREGION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode.inInterruptibleRegion is missing.");
	REL_UML_ACTIVITYNODE_INGROUP=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityNode.inGroup");
	if(REL_UML_ACTIVITYNODE_INGROUP==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode.inGroup is missing.");
	REL_UML_ACTIVITYNODE_REDEFINEDNODE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityNode.redefinedNode");
	if(REL_UML_ACTIVITYNODE_REDEFINEDNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityNode.redefinedNode is missing.");
	ENT_UML_STRUCTUREDACTIVITYNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.StructuredActivityNode");
	if(ENT_UML_STRUCTUREDACTIVITYNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredActivityNode is missing.");
	REL_UML_STRUCTUREDACTIVITYNODE_MUSTISOLATE=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuredActivityNode.mustIsolate");
	if(REL_UML_STRUCTUREDACTIVITYNODE_MUSTISOLATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredActivityNode.mustIsolate is missing.");
	REL_UML_STRUCTUREDACTIVITYNODE_VARIABLE=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuredActivityNode.variable");
	if(REL_UML_STRUCTUREDACTIVITYNODE_VARIABLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredActivityNode.variable is missing.");
	REL_UML_STRUCTUREDACTIVITYNODE_EDGE=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuredActivityNode.edge");
	if(REL_UML_STRUCTUREDACTIVITYNODE_EDGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredActivityNode.edge is missing.");
	REL_UML_STRUCTUREDACTIVITYNODE_NODE=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuredActivityNode.node");
	if(REL_UML_STRUCTUREDACTIVITYNODE_NODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuredActivityNode.node is missing.");
	ENT_UML_ACTIVITYGROUP=(IEntity)mm.getElementByName("uml.metamodel.uml.ActivityGroup");
	if(ENT_UML_ACTIVITYGROUP==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityGroup is missing.");
	REL_UML_ACTIVITYGROUP_SUBGROUP=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityGroup.subgroup");
	if(REL_UML_ACTIVITYGROUP_SUBGROUP==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityGroup.subgroup is missing.");
	REL_UML_ACTIVITYGROUP_SUPERGROUP=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityGroup.superGroup");
	if(REL_UML_ACTIVITYGROUP_SUPERGROUP==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityGroup.superGroup is missing.");
	REL_UML_ACTIVITYGROUP_INACTIVITY=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityGroup.inActivity");
	if(REL_UML_ACTIVITYGROUP_INACTIVITY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityGroup.inActivity is missing.");
	REL_UML_ACTIVITYGROUP_CONTAINEDEDGE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityGroup.containedEdge");
	if(REL_UML_ACTIVITYGROUP_CONTAINEDEDGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityGroup.containedEdge is missing.");
	REL_UML_ACTIVITYGROUP_CONTAINEDNODE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityGroup.containedNode");
	if(REL_UML_ACTIVITYGROUP_CONTAINEDNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityGroup.containedNode is missing.");
	ENT_UML_ACTIVITY=(IEntity)mm.getElementByName("uml.metamodel.uml.Activity");
	if(ENT_UML_ACTIVITY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity is missing.");
	REL_UML_ACTIVITY_ISREADONLY=(IRelation)mm.getElementByName("uml.metamodel.uml.Activity.isReadOnly");
	if(REL_UML_ACTIVITY_ISREADONLY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity.isReadOnly is missing.");
	REL_UML_ACTIVITY_ISSINGLEEXECUTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Activity.isSingleExecution");
	if(REL_UML_ACTIVITY_ISSINGLEEXECUTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity.isSingleExecution is missing.");
	REL_UML_ACTIVITY_STRUCTUREDNODE=(IRelation)mm.getElementByName("uml.metamodel.uml.Activity.structuredNode");
	if(REL_UML_ACTIVITY_STRUCTUREDNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity.structuredNode is missing.");
	REL_UML_ACTIVITY_VARIABLE=(IRelation)mm.getElementByName("uml.metamodel.uml.Activity.variable");
	if(REL_UML_ACTIVITY_VARIABLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity.variable is missing.");
	REL_UML_ACTIVITY_NODE=(IRelation)mm.getElementByName("uml.metamodel.uml.Activity.node");
	if(REL_UML_ACTIVITY_NODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity.node is missing.");
	REL_UML_ACTIVITY_EDGE=(IRelation)mm.getElementByName("uml.metamodel.uml.Activity.edge");
	if(REL_UML_ACTIVITY_EDGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity.edge is missing.");
	REL_UML_ACTIVITY_PARTITION=(IRelation)mm.getElementByName("uml.metamodel.uml.Activity.partition");
	if(REL_UML_ACTIVITY_PARTITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity.partition is missing.");
	REL_UML_ACTIVITY_GROUP=(IRelation)mm.getElementByName("uml.metamodel.uml.Activity.group");
	if(REL_UML_ACTIVITY_GROUP==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Activity.group is missing.");
	ENT_UML_VARIABLE=(IEntity)mm.getElementByName("uml.metamodel.uml.Variable");
	if(ENT_UML_VARIABLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Variable is missing.");
	REL_UML_VARIABLE_SCOPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Variable.scope");
	if(REL_UML_VARIABLE_SCOPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Variable.scope is missing.");
	REL_UML_VARIABLE_ACTIVITYSCOPE=(IRelation)mm.getElementByName("uml.metamodel.uml.Variable.activityScope");
	if(REL_UML_VARIABLE_ACTIVITYSCOPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Variable.activityScope is missing.");
	ENT_UML_ACTIVITYEDGE=(IEntity)mm.getElementByName("uml.metamodel.uml.ActivityEdge");
	if(ENT_UML_ACTIVITYEDGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge is missing.");
	REL_UML_ACTIVITYEDGE_SOURCE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.source");
	if(REL_UML_ACTIVITYEDGE_SOURCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.source is missing.");
	REL_UML_ACTIVITYEDGE_TARGET=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.target");
	if(REL_UML_ACTIVITYEDGE_TARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.target is missing.");
	REL_UML_ACTIVITYEDGE_REDEFINEDEDGE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.redefinedEdge");
	if(REL_UML_ACTIVITYEDGE_REDEFINEDEDGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.redefinedEdge is missing.");
	REL_UML_ACTIVITYEDGE_INPARTITION=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.inPartition");
	if(REL_UML_ACTIVITYEDGE_INPARTITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.inPartition is missing.");
	REL_UML_ACTIVITYEDGE_GUARD=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.guard");
	if(REL_UML_ACTIVITYEDGE_GUARD==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.guard is missing.");
	REL_UML_ACTIVITYEDGE_WEIGHT=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.weight");
	if(REL_UML_ACTIVITYEDGE_WEIGHT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.weight is missing.");
	REL_UML_ACTIVITYEDGE_INTERRUPTS=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.interrupts");
	if(REL_UML_ACTIVITYEDGE_INTERRUPTS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.interrupts is missing.");
	REL_UML_ACTIVITYEDGE_INSTRUCTUREDNODE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.inStructuredNode");
	if(REL_UML_ACTIVITYEDGE_INSTRUCTUREDNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.inStructuredNode is missing.");
	REL_UML_ACTIVITYEDGE_INGROUP=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.inGroup");
	if(REL_UML_ACTIVITYEDGE_INGROUP==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.inGroup is missing.");
	REL_UML_ACTIVITYEDGE_ACTIVITY=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityEdge.activity");
	if(REL_UML_ACTIVITYEDGE_ACTIVITY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityEdge.activity is missing.");
	ENT_UML_ACTIVITYPARTITION=(IEntity)mm.getElementByName("uml.metamodel.uml.ActivityPartition");
	if(ENT_UML_ACTIVITYPARTITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityPartition is missing.");
	REL_UML_ACTIVITYPARTITION_ISDIMENSION=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityPartition.isDimension");
	if(REL_UML_ACTIVITYPARTITION_ISDIMENSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityPartition.isDimension is missing.");
	REL_UML_ACTIVITYPARTITION_ISEXTERNAL=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityPartition.isExternal");
	if(REL_UML_ACTIVITYPARTITION_ISEXTERNAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityPartition.isExternal is missing.");
	REL_UML_ACTIVITYPARTITION_NODE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityPartition.node");
	if(REL_UML_ACTIVITYPARTITION_NODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityPartition.node is missing.");
	REL_UML_ACTIVITYPARTITION_SUBPARTITION=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityPartition.subpartition");
	if(REL_UML_ACTIVITYPARTITION_SUBPARTITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityPartition.subpartition is missing.");
	REL_UML_ACTIVITYPARTITION_SUPERPARTITION=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityPartition.superPartition");
	if(REL_UML_ACTIVITYPARTITION_SUPERPARTITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityPartition.superPartition is missing.");
	REL_UML_ACTIVITYPARTITION_REPRESENTS=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityPartition.represents");
	if(REL_UML_ACTIVITYPARTITION_REPRESENTS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityPartition.represents is missing.");
	REL_UML_ACTIVITYPARTITION_EDGE=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityPartition.edge");
	if(REL_UML_ACTIVITYPARTITION_EDGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityPartition.edge is missing.");
	ENT_UML_INTERRUPTIBLEACTIVITYREGION=(IEntity)mm.getElementByName("uml.metamodel.uml.InterruptibleActivityRegion");
	if(ENT_UML_INTERRUPTIBLEACTIVITYREGION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InterruptibleActivityRegion is missing.");
	REL_UML_INTERRUPTIBLEACTIVITYREGION_NODE=(IRelation)mm.getElementByName("uml.metamodel.uml.InterruptibleActivityRegion.node");
	if(REL_UML_INTERRUPTIBLEACTIVITYREGION_NODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InterruptibleActivityRegion.node is missing.");
	REL_UML_INTERRUPTIBLEACTIVITYREGION_INTERRUPTINGEDGE=(IRelation)mm.getElementByName("uml.metamodel.uml.InterruptibleActivityRegion.interruptingEdge");
	if(REL_UML_INTERRUPTIBLEACTIVITYREGION_INTERRUPTINGEDGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InterruptibleActivityRegion.interruptingEdge is missing.");
	ENT_UML_EXCEPTIONHANDLER=(IEntity)mm.getElementByName("uml.metamodel.uml.ExceptionHandler");
	if(ENT_UML_EXCEPTIONHANDLER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExceptionHandler is missing.");
	REL_UML_EXCEPTIONHANDLER_HANDLERBODY=(IRelation)mm.getElementByName("uml.metamodel.uml.ExceptionHandler.handlerBody");
	if(REL_UML_EXCEPTIONHANDLER_HANDLERBODY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExceptionHandler.handlerBody is missing.");
	REL_UML_EXCEPTIONHANDLER_EXCEPTIONINPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.ExceptionHandler.exceptionInput");
	if(REL_UML_EXCEPTIONHANDLER_EXCEPTIONINPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExceptionHandler.exceptionInput is missing.");
	REL_UML_EXCEPTIONHANDLER_EXCEPTIONTYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.ExceptionHandler.exceptionType");
	if(REL_UML_EXCEPTIONHANDLER_EXCEPTIONTYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExceptionHandler.exceptionType is missing.");
	REL_UML_EXCEPTIONHANDLER_PROTECTEDNODE=(IRelation)mm.getElementByName("uml.metamodel.uml.ExceptionHandler.protectedNode");
	if(REL_UML_EXCEPTIONHANDLER_PROTECTEDNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExceptionHandler.protectedNode is missing.");
	ENT_UML_OBJECTNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ObjectNode");
	if(ENT_UML_OBJECTNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectNode is missing.");
	REL_UML_OBJECTNODE_ORDERING=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectNode.ordering");
	if(REL_UML_OBJECTNODE_ORDERING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectNode.ordering is missing.");
	REL_UML_OBJECTNODE_ISCONTROLTYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectNode.isControlType");
	if(REL_UML_OBJECTNODE_ISCONTROLTYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectNode.isControlType is missing.");
	REL_UML_OBJECTNODE_UPPERBOUND=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectNode.upperBound");
	if(REL_UML_OBJECTNODE_UPPERBOUND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectNode.upperBound is missing.");
	REL_UML_OBJECTNODE_INSTATE=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectNode.inState");
	if(REL_UML_OBJECTNODE_INSTATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectNode.inState is missing.");
	REL_UML_OBJECTNODE_SELECTION=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectNode.selection");
	if(REL_UML_OBJECTNODE_SELECTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectNode.selection is missing.");
	ENT_UML_OBJECTNODEORDERINGKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.ObjectNodeOrderingKind");
	if(ENT_UML_OBJECTNODEORDERINGKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectNodeOrderingKind is missing.");
	ENT_UML_OUTPUTPIN=(IEntity)mm.getElementByName("uml.metamodel.uml.OutputPin");
	if(ENT_UML_OUTPUTPIN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OutputPin is missing.");
	ENT_UML_PIN=(IEntity)mm.getElementByName("uml.metamodel.uml.Pin");
	if(ENT_UML_PIN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Pin is missing.");
	REL_UML_PIN_ISCONTROL=(IRelation)mm.getElementByName("uml.metamodel.uml.Pin.isControl");
	if(REL_UML_PIN_ISCONTROL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Pin.isControl is missing.");
	ENT_UML_INPUTPIN=(IEntity)mm.getElementByName("uml.metamodel.uml.InputPin");
	if(ENT_UML_INPUTPIN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InputPin is missing.");
	ENT_UML_CALLACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.CallAction");
	if(ENT_UML_CALLACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallAction is missing.");
	REL_UML_CALLACTION_ISSYNCHRONOUS=(IRelation)mm.getElementByName("uml.metamodel.uml.CallAction.isSynchronous");
	if(REL_UML_CALLACTION_ISSYNCHRONOUS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallAction.isSynchronous is missing.");
	REL_UML_CALLACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.CallAction.result");
	if(REL_UML_CALLACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallAction.result is missing.");
	ENT_UML_INVOCATIONACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.InvocationAction");
	if(ENT_UML_INVOCATIONACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InvocationAction is missing.");
	REL_UML_INVOCATIONACTION_ARGUMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.InvocationAction.argument");
	if(REL_UML_INVOCATIONACTION_ARGUMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InvocationAction.argument is missing.");
	REL_UML_INVOCATIONACTION_ONPORT=(IRelation)mm.getElementByName("uml.metamodel.uml.InvocationAction.onPort");
	if(REL_UML_INVOCATIONACTION_ONPORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InvocationAction.onPort is missing.");
	ENT_UML_SENDSIGNALACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.SendSignalAction");
	if(ENT_UML_SENDSIGNALACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendSignalAction is missing.");
	REL_UML_SENDSIGNALACTION_TARGET=(IRelation)mm.getElementByName("uml.metamodel.uml.SendSignalAction.target");
	if(REL_UML_SENDSIGNALACTION_TARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendSignalAction.target is missing.");
	REL_UML_SENDSIGNALACTION_SIGNAL=(IRelation)mm.getElementByName("uml.metamodel.uml.SendSignalAction.signal");
	if(REL_UML_SENDSIGNALACTION_SIGNAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendSignalAction.signal is missing.");
	ENT_UML_CALLOPERATIONACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.CallOperationAction");
	if(ENT_UML_CALLOPERATIONACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallOperationAction is missing.");
	REL_UML_CALLOPERATIONACTION_OPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.CallOperationAction.operation");
	if(REL_UML_CALLOPERATIONACTION_OPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallOperationAction.operation is missing.");
	REL_UML_CALLOPERATIONACTION_TARGET=(IRelation)mm.getElementByName("uml.metamodel.uml.CallOperationAction.target");
	if(REL_UML_CALLOPERATIONACTION_TARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallOperationAction.target is missing.");
	ENT_UML_CALLBEHAVIORACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.CallBehaviorAction");
	if(ENT_UML_CALLBEHAVIORACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallBehaviorAction is missing.");
	REL_UML_CALLBEHAVIORACTION_BEHAVIOR=(IRelation)mm.getElementByName("uml.metamodel.uml.CallBehaviorAction.behavior");
	if(REL_UML_CALLBEHAVIORACTION_BEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallBehaviorAction.behavior is missing.");
	ENT_UML_SEQUENCENODE=(IEntity)mm.getElementByName("uml.metamodel.uml.SequenceNode");
	if(ENT_UML_SEQUENCENODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SequenceNode is missing.");
	REL_UML_SEQUENCENODE_EXECUTABLENODE=(IRelation)mm.getElementByName("uml.metamodel.uml.SequenceNode.executableNode");
	if(REL_UML_SEQUENCENODE_EXECUTABLENODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SequenceNode.executableNode is missing.");
	ENT_UML_CONTROLNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ControlNode");
	if(ENT_UML_CONTROLNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ControlNode is missing.");
	ENT_UML_CONTROLFLOW=(IEntity)mm.getElementByName("uml.metamodel.uml.ControlFlow");
	if(ENT_UML_CONTROLFLOW==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ControlFlow is missing.");
	ENT_UML_INITIALNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.InitialNode");
	if(ENT_UML_INITIALNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InitialNode is missing.");
	ENT_UML_ACTIVITYPARAMETERNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ActivityParameterNode");
	if(ENT_UML_ACTIVITYPARAMETERNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityParameterNode is missing.");
	REL_UML_ACTIVITYPARAMETERNODE_PARAMETER=(IRelation)mm.getElementByName("uml.metamodel.uml.ActivityParameterNode.parameter");
	if(REL_UML_ACTIVITYPARAMETERNODE_PARAMETER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityParameterNode.parameter is missing.");
	ENT_UML_VALUEPIN=(IEntity)mm.getElementByName("uml.metamodel.uml.ValuePin");
	if(ENT_UML_VALUEPIN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ValuePin is missing.");
	REL_UML_VALUEPIN_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.ValuePin.value");
	if(REL_UML_VALUEPIN_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ValuePin.value is missing.");
	ENT_UML_MESSAGE=(IEntity)mm.getElementByName("uml.metamodel.uml.Message");
	if(ENT_UML_MESSAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message is missing.");
	REL_UML_MESSAGE_MESSAGEKIND=(IRelation)mm.getElementByName("uml.metamodel.uml.Message.messageKind");
	if(REL_UML_MESSAGE_MESSAGEKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message.messageKind is missing.");
	REL_UML_MESSAGE_MESSAGESORT=(IRelation)mm.getElementByName("uml.metamodel.uml.Message.messageSort");
	if(REL_UML_MESSAGE_MESSAGESORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message.messageSort is missing.");
	REL_UML_MESSAGE_RECEIVEEVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Message.receiveEvent");
	if(REL_UML_MESSAGE_RECEIVEEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message.receiveEvent is missing.");
	REL_UML_MESSAGE_SENDEVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Message.sendEvent");
	if(REL_UML_MESSAGE_SENDEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message.sendEvent is missing.");
	REL_UML_MESSAGE_CONNECTOR=(IRelation)mm.getElementByName("uml.metamodel.uml.Message.connector");
	if(REL_UML_MESSAGE_CONNECTOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message.connector is missing.");
	REL_UML_MESSAGE_INTERACTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Message.interaction");
	if(REL_UML_MESSAGE_INTERACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message.interaction is missing.");
	REL_UML_MESSAGE_ARGUMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Message.argument");
	if(REL_UML_MESSAGE_ARGUMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message.argument is missing.");
	REL_UML_MESSAGE_SIGNATURE=(IRelation)mm.getElementByName("uml.metamodel.uml.Message.signature");
	if(REL_UML_MESSAGE_SIGNATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Message.signature is missing.");
	ENT_UML_MESSAGEKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.MessageKind");
	if(ENT_UML_MESSAGEKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MessageKind is missing.");
	ENT_UML_MESSAGESORT=(IEntity)mm.getElementByName("uml.metamodel.uml.MessageSort");
	if(ENT_UML_MESSAGESORT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MessageSort is missing.");
	ENT_UML_MESSAGEEND=(IEntity)mm.getElementByName("uml.metamodel.uml.MessageEnd");
	if(ENT_UML_MESSAGEEND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MessageEnd is missing.");
	REL_UML_MESSAGEEND_MESSAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.MessageEnd.message");
	if(REL_UML_MESSAGEEND_MESSAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MessageEnd.message is missing.");
	ENT_UML_INTERACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.Interaction");
	if(ENT_UML_INTERACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interaction is missing.");
	REL_UML_INTERACTION_LIFELINE=(IRelation)mm.getElementByName("uml.metamodel.uml.Interaction.lifeline");
	if(REL_UML_INTERACTION_LIFELINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interaction.lifeline is missing.");
	REL_UML_INTERACTION_FRAGMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Interaction.fragment");
	if(REL_UML_INTERACTION_FRAGMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interaction.fragment is missing.");
	REL_UML_INTERACTION_ACTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Interaction.action");
	if(REL_UML_INTERACTION_ACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interaction.action is missing.");
	REL_UML_INTERACTION_FORMALGATE=(IRelation)mm.getElementByName("uml.metamodel.uml.Interaction.formalGate");
	if(REL_UML_INTERACTION_FORMALGATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interaction.formalGate is missing.");
	REL_UML_INTERACTION_MESSAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.Interaction.message");
	if(REL_UML_INTERACTION_MESSAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interaction.message is missing.");
	ENT_UML_INTERACTIONFRAGMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.InteractionFragment");
	if(ENT_UML_INTERACTIONFRAGMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionFragment is missing.");
	REL_UML_INTERACTIONFRAGMENT_COVERED=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionFragment.covered");
	if(REL_UML_INTERACTIONFRAGMENT_COVERED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionFragment.covered is missing.");
	REL_UML_INTERACTIONFRAGMENT_GENERALORDERING=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionFragment.generalOrdering");
	if(REL_UML_INTERACTIONFRAGMENT_GENERALORDERING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionFragment.generalOrdering is missing.");
	REL_UML_INTERACTIONFRAGMENT_ENCLOSINGINTERACTION=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionFragment.enclosingInteraction");
	if(REL_UML_INTERACTIONFRAGMENT_ENCLOSINGINTERACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionFragment.enclosingInteraction is missing.");
	REL_UML_INTERACTIONFRAGMENT_ENCLOSINGOPERAND=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionFragment.enclosingOperand");
	if(REL_UML_INTERACTIONFRAGMENT_ENCLOSINGOPERAND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionFragment.enclosingOperand is missing.");
	ENT_UML_LIFELINE=(IEntity)mm.getElementByName("uml.metamodel.uml.Lifeline");
	if(ENT_UML_LIFELINE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Lifeline is missing.");
	REL_UML_LIFELINE_REPRESENTS=(IRelation)mm.getElementByName("uml.metamodel.uml.Lifeline.represents");
	if(REL_UML_LIFELINE_REPRESENTS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Lifeline.represents is missing.");
	REL_UML_LIFELINE_INTERACTION=(IRelation)mm.getElementByName("uml.metamodel.uml.Lifeline.interaction");
	if(REL_UML_LIFELINE_INTERACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Lifeline.interaction is missing.");
	REL_UML_LIFELINE_SELECTOR=(IRelation)mm.getElementByName("uml.metamodel.uml.Lifeline.selector");
	if(REL_UML_LIFELINE_SELECTOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Lifeline.selector is missing.");
	REL_UML_LIFELINE_DECOMPOSEDAS=(IRelation)mm.getElementByName("uml.metamodel.uml.Lifeline.decomposedAs");
	if(REL_UML_LIFELINE_DECOMPOSEDAS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Lifeline.decomposedAs is missing.");
	REL_UML_LIFELINE_COVEREDBY=(IRelation)mm.getElementByName("uml.metamodel.uml.Lifeline.coveredBy");
	if(REL_UML_LIFELINE_COVEREDBY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Lifeline.coveredBy is missing.");
	ENT_UML_PARTDECOMPOSITION=(IEntity)mm.getElementByName("uml.metamodel.uml.PartDecomposition");
	if(ENT_UML_PARTDECOMPOSITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.PartDecomposition is missing.");
	ENT_UML_INTERACTIONUSE=(IEntity)mm.getElementByName("uml.metamodel.uml.InteractionUse");
	if(ENT_UML_INTERACTIONUSE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionUse is missing.");
	REL_UML_INTERACTIONUSE_REFERSTO=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionUse.refersTo");
	if(REL_UML_INTERACTIONUSE_REFERSTO==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionUse.refersTo is missing.");
	REL_UML_INTERACTIONUSE_ACTUALGATE=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionUse.actualGate");
	if(REL_UML_INTERACTIONUSE_ACTUALGATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionUse.actualGate is missing.");
	REL_UML_INTERACTIONUSE_ARGUMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionUse.argument");
	if(REL_UML_INTERACTIONUSE_ARGUMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionUse.argument is missing.");
	ENT_UML_GATE=(IEntity)mm.getElementByName("uml.metamodel.uml.Gate");
	if(ENT_UML_GATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Gate is missing.");
	ENT_UML_GENERALORDERING=(IEntity)mm.getElementByName("uml.metamodel.uml.GeneralOrdering");
	if(ENT_UML_GENERALORDERING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.GeneralOrdering is missing.");
	REL_UML_GENERALORDERING_BEFORE=(IRelation)mm.getElementByName("uml.metamodel.uml.GeneralOrdering.before");
	if(REL_UML_GENERALORDERING_BEFORE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.GeneralOrdering.before is missing.");
	REL_UML_GENERALORDERING_AFTER=(IRelation)mm.getElementByName("uml.metamodel.uml.GeneralOrdering.after");
	if(REL_UML_GENERALORDERING_AFTER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.GeneralOrdering.after is missing.");
	ENT_UML_OCCURRENCESPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.OccurrenceSpecification");
	if(ENT_UML_OCCURRENCESPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OccurrenceSpecification is missing.");
	REL_UML_OCCURRENCESPECIFICATION_TOBEFORE=(IRelation)mm.getElementByName("uml.metamodel.uml.OccurrenceSpecification.toBefore");
	if(REL_UML_OCCURRENCESPECIFICATION_TOBEFORE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OccurrenceSpecification.toBefore is missing.");
	REL_UML_OCCURRENCESPECIFICATION_EVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.OccurrenceSpecification.event");
	if(REL_UML_OCCURRENCESPECIFICATION_EVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OccurrenceSpecification.event is missing.");
	REL_UML_OCCURRENCESPECIFICATION_TOAFTER=(IRelation)mm.getElementByName("uml.metamodel.uml.OccurrenceSpecification.toAfter");
	if(REL_UML_OCCURRENCESPECIFICATION_TOAFTER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.OccurrenceSpecification.toAfter is missing.");
	ENT_UML_INTERACTIONOPERAND=(IEntity)mm.getElementByName("uml.metamodel.uml.InteractionOperand");
	if(ENT_UML_INTERACTIONOPERAND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionOperand is missing.");
	REL_UML_INTERACTIONOPERAND_GUARD=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionOperand.guard");
	if(REL_UML_INTERACTIONOPERAND_GUARD==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionOperand.guard is missing.");
	REL_UML_INTERACTIONOPERAND_FRAGMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionOperand.fragment");
	if(REL_UML_INTERACTIONOPERAND_FRAGMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionOperand.fragment is missing.");
	ENT_UML_INTERACTIONCONSTRAINT=(IEntity)mm.getElementByName("uml.metamodel.uml.InteractionConstraint");
	if(ENT_UML_INTERACTIONCONSTRAINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionConstraint is missing.");
	REL_UML_INTERACTIONCONSTRAINT_MININT=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionConstraint.minint");
	if(REL_UML_INTERACTIONCONSTRAINT_MININT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionConstraint.minint is missing.");
	REL_UML_INTERACTIONCONSTRAINT_MAXINT=(IRelation)mm.getElementByName("uml.metamodel.uml.InteractionConstraint.maxint");
	if(REL_UML_INTERACTIONCONSTRAINT_MAXINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionConstraint.maxint is missing.");
	ENT_UML_EXECUTIONSPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.ExecutionSpecification");
	if(ENT_UML_EXECUTIONSPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutionSpecification is missing.");
	REL_UML_EXECUTIONSPECIFICATION_START=(IRelation)mm.getElementByName("uml.metamodel.uml.ExecutionSpecification.start");
	if(REL_UML_EXECUTIONSPECIFICATION_START==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutionSpecification.start is missing.");
	REL_UML_EXECUTIONSPECIFICATION_FINISH=(IRelation)mm.getElementByName("uml.metamodel.uml.ExecutionSpecification.finish");
	if(REL_UML_EXECUTIONSPECIFICATION_FINISH==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutionSpecification.finish is missing.");
	ENT_UML_STATEINVARIANT=(IEntity)mm.getElementByName("uml.metamodel.uml.StateInvariant");
	if(ENT_UML_STATEINVARIANT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StateInvariant is missing.");
	REL_UML_STATEINVARIANT_INVARIANT=(IRelation)mm.getElementByName("uml.metamodel.uml.StateInvariant.invariant");
	if(REL_UML_STATEINVARIANT_INVARIANT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StateInvariant.invariant is missing.");
	ENT_UML_ACTIONEXECUTIONSPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.ActionExecutionSpecification");
	if(ENT_UML_ACTIONEXECUTIONSPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActionExecutionSpecification is missing.");
	REL_UML_ACTIONEXECUTIONSPECIFICATION_ACTION=(IRelation)mm.getElementByName("uml.metamodel.uml.ActionExecutionSpecification.action");
	if(REL_UML_ACTIONEXECUTIONSPECIFICATION_ACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActionExecutionSpecification.action is missing.");
	ENT_UML_BEHAVIOREXECUTIONSPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.BehaviorExecutionSpecification");
	if(ENT_UML_BEHAVIOREXECUTIONSPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehaviorExecutionSpecification is missing.");
	REL_UML_BEHAVIOREXECUTIONSPECIFICATION_BEHAVIOR=(IRelation)mm.getElementByName("uml.metamodel.uml.BehaviorExecutionSpecification.behavior");
	if(REL_UML_BEHAVIOREXECUTIONSPECIFICATION_BEHAVIOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BehaviorExecutionSpecification.behavior is missing.");
	ENT_UML_EXECUTIONEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.ExecutionEvent");
	if(ENT_UML_EXECUTIONEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutionEvent is missing.");
	ENT_UML_CREATIONEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.CreationEvent");
	if(ENT_UML_CREATIONEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CreationEvent is missing.");
	ENT_UML_DESTRUCTIONEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.DestructionEvent");
	if(ENT_UML_DESTRUCTIONEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DestructionEvent is missing.");
	ENT_UML_SENDOPERATIONEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.SendOperationEvent");
	if(ENT_UML_SENDOPERATIONEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendOperationEvent is missing.");
	REL_UML_SENDOPERATIONEVENT_OPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.SendOperationEvent.operation");
	if(REL_UML_SENDOPERATIONEVENT_OPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendOperationEvent.operation is missing.");
	ENT_UML_MESSAGEEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.MessageEvent");
	if(ENT_UML_MESSAGEEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MessageEvent is missing.");
	ENT_UML_SENDSIGNALEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.SendSignalEvent");
	if(ENT_UML_SENDSIGNALEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendSignalEvent is missing.");
	REL_UML_SENDSIGNALEVENT_SIGNAL=(IRelation)mm.getElementByName("uml.metamodel.uml.SendSignalEvent.signal");
	if(REL_UML_SENDSIGNALEVENT_SIGNAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendSignalEvent.signal is missing.");
	ENT_UML_MESSAGEOCCURRENCESPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.MessageOccurrenceSpecification");
	if(ENT_UML_MESSAGEOCCURRENCESPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MessageOccurrenceSpecification is missing.");
	ENT_UML_EXECUTIONOCCURRENCESPECIFICATION=(IEntity)mm.getElementByName("uml.metamodel.uml.ExecutionOccurrenceSpecification");
	if(ENT_UML_EXECUTIONOCCURRENCESPECIFICATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutionOccurrenceSpecification is missing.");
	REL_UML_EXECUTIONOCCURRENCESPECIFICATION_EXECUTION=(IRelation)mm.getElementByName("uml.metamodel.uml.ExecutionOccurrenceSpecification.execution");
	if(REL_UML_EXECUTIONOCCURRENCESPECIFICATION_EXECUTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutionOccurrenceSpecification.execution is missing.");
	ENT_UML_RECEIVEOPERATIONEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.ReceiveOperationEvent");
	if(ENT_UML_RECEIVEOPERATIONEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReceiveOperationEvent is missing.");
	REL_UML_RECEIVEOPERATIONEVENT_OPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.ReceiveOperationEvent.operation");
	if(REL_UML_RECEIVEOPERATIONEVENT_OPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReceiveOperationEvent.operation is missing.");
	ENT_UML_RECEIVESIGNALEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.ReceiveSignalEvent");
	if(ENT_UML_RECEIVESIGNALEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReceiveSignalEvent is missing.");
	REL_UML_RECEIVESIGNALEVENT_SIGNAL=(IRelation)mm.getElementByName("uml.metamodel.uml.ReceiveSignalEvent.signal");
	if(REL_UML_RECEIVESIGNALEVENT_SIGNAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReceiveSignalEvent.signal is missing.");
	ENT_UML_ACTOR=(IEntity)mm.getElementByName("uml.metamodel.uml.Actor");
	if(ENT_UML_ACTOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Actor is missing.");
	ENT_UML_CALLEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.CallEvent");
	if(ENT_UML_CALLEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallEvent is missing.");
	REL_UML_CALLEVENT_OPERATION=(IRelation)mm.getElementByName("uml.metamodel.uml.CallEvent.operation");
	if(REL_UML_CALLEVENT_OPERATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CallEvent.operation is missing.");
	ENT_UML_CHANGEEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.ChangeEvent");
	if(ENT_UML_CHANGEEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ChangeEvent is missing.");
	REL_UML_CHANGEEVENT_CHANGEEXPRESSION=(IRelation)mm.getElementByName("uml.metamodel.uml.ChangeEvent.changeExpression");
	if(REL_UML_CHANGEEVENT_CHANGEEXPRESSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ChangeEvent.changeExpression is missing.");
	ENT_UML_SIGNALEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.SignalEvent");
	if(ENT_UML_SIGNALEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SignalEvent is missing.");
	REL_UML_SIGNALEVENT_SIGNAL=(IRelation)mm.getElementByName("uml.metamodel.uml.SignalEvent.signal");
	if(REL_UML_SIGNALEVENT_SIGNAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SignalEvent.signal is missing.");
	ENT_UML_ANYRECEIVEEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.AnyReceiveEvent");
	if(ENT_UML_ANYRECEIVEEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AnyReceiveEvent is missing.");
	ENT_UML_FORKNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ForkNode");
	if(ENT_UML_FORKNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ForkNode is missing.");
	ENT_UML_FLOWFINALNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.FlowFinalNode");
	if(ENT_UML_FLOWFINALNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.FlowFinalNode is missing.");
	ENT_UML_FINALNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.FinalNode");
	if(ENT_UML_FINALNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.FinalNode is missing.");
	ENT_UML_CENTRALBUFFERNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.CentralBufferNode");
	if(ENT_UML_CENTRALBUFFERNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CentralBufferNode is missing.");
	ENT_UML_MERGENODE=(IEntity)mm.getElementByName("uml.metamodel.uml.MergeNode");
	if(ENT_UML_MERGENODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.MergeNode is missing.");
	ENT_UML_DECISIONNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.DecisionNode");
	if(ENT_UML_DECISIONNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DecisionNode is missing.");
	REL_UML_DECISIONNODE_DECISIONINPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.DecisionNode.decisionInput");
	if(REL_UML_DECISIONNODE_DECISIONINPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DecisionNode.decisionInput is missing.");
	REL_UML_DECISIONNODE_DECISIONINPUTFLOW=(IRelation)mm.getElementByName("uml.metamodel.uml.DecisionNode.decisionInputFlow");
	if(REL_UML_DECISIONNODE_DECISIONINPUTFLOW==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DecisionNode.decisionInputFlow is missing.");
	ENT_UML_OBJECTFLOW=(IEntity)mm.getElementByName("uml.metamodel.uml.ObjectFlow");
	if(ENT_UML_OBJECTFLOW==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectFlow is missing.");
	REL_UML_OBJECTFLOW_ISMULTICAST=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectFlow.isMulticast");
	if(REL_UML_OBJECTFLOW_ISMULTICAST==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectFlow.isMulticast is missing.");
	REL_UML_OBJECTFLOW_ISMULTIRECEIVE=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectFlow.isMultireceive");
	if(REL_UML_OBJECTFLOW_ISMULTIRECEIVE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectFlow.isMultireceive is missing.");
	REL_UML_OBJECTFLOW_TRANSFORMATION=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectFlow.transformation");
	if(REL_UML_OBJECTFLOW_TRANSFORMATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectFlow.transformation is missing.");
	REL_UML_OBJECTFLOW_SELECTION=(IRelation)mm.getElementByName("uml.metamodel.uml.ObjectFlow.selection");
	if(REL_UML_OBJECTFLOW_SELECTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ObjectFlow.selection is missing.");
	ENT_UML_ACTIVITYFINALNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ActivityFinalNode");
	if(ENT_UML_ACTIVITYFINALNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActivityFinalNode is missing.");
	ENT_UML_COMPONENTREALIZATION=(IEntity)mm.getElementByName("uml.metamodel.uml.ComponentRealization");
	if(ENT_UML_COMPONENTREALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ComponentRealization is missing.");
	REL_UML_COMPONENTREALIZATION_ABSTRACTION=(IRelation)mm.getElementByName("uml.metamodel.uml.ComponentRealization.abstraction");
	if(REL_UML_COMPONENTREALIZATION_ABSTRACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ComponentRealization.abstraction is missing.");
	REL_UML_COMPONENTREALIZATION_REALIZINGCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.ComponentRealization.realizingClassifier");
	if(REL_UML_COMPONENTREALIZATION_REALIZINGCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ComponentRealization.realizingClassifier is missing.");
	ENT_UML_COMPONENT=(IEntity)mm.getElementByName("uml.metamodel.uml.Component");
	if(ENT_UML_COMPONENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Component is missing.");
	REL_UML_COMPONENT_ISINDIRECTLYINSTANTIATED=(IRelation)mm.getElementByName("uml.metamodel.uml.Component.isIndirectlyInstantiated");
	if(REL_UML_COMPONENT_ISINDIRECTLYINSTANTIATED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Component.isIndirectlyInstantiated is missing.");
	REL_UML_COMPONENT_REQUIRED=(IRelation)mm.getElementByName("uml.metamodel.uml.Component.required");
	if(REL_UML_COMPONENT_REQUIRED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Component.required is missing.");
	REL_UML_COMPONENT_PROVIDED=(IRelation)mm.getElementByName("uml.metamodel.uml.Component.provided");
	if(REL_UML_COMPONENT_PROVIDED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Component.provided is missing.");
	REL_UML_COMPONENT_PACKAGEDELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.Component.packagedElement");
	if(REL_UML_COMPONENT_PACKAGEDELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Component.packagedElement is missing.");
	REL_UML_COMPONENT_REALIZATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Component.realization");
	if(REL_UML_COMPONENT_REALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Component.realization is missing.");
	ENT_UML_NODE=(IEntity)mm.getElementByName("uml.metamodel.uml.Node");
	if(ENT_UML_NODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Node is missing.");
	REL_UML_NODE_NESTEDNODE=(IRelation)mm.getElementByName("uml.metamodel.uml.Node.nestedNode");
	if(REL_UML_NODE_NESTEDNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Node.nestedNode is missing.");
	ENT_UML_COMMUNICATIONPATH=(IEntity)mm.getElementByName("uml.metamodel.uml.CommunicationPath");
	if(ENT_UML_COMMUNICATIONPATH==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CommunicationPath is missing.");
	ENT_UML_DEVICE=(IEntity)mm.getElementByName("uml.metamodel.uml.Device");
	if(ENT_UML_DEVICE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Device is missing.");
	ENT_UML_EXECUTIONENVIRONMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.ExecutionEnvironment");
	if(ENT_UML_EXECUTIONENVIRONMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExecutionEnvironment is missing.");
	ENT_UML_COMBINEDFRAGMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.CombinedFragment");
	if(ENT_UML_COMBINEDFRAGMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CombinedFragment is missing.");
	REL_UML_COMBINEDFRAGMENT_INTERACTIONOPERATOR=(IRelation)mm.getElementByName("uml.metamodel.uml.CombinedFragment.interactionOperator");
	if(REL_UML_COMBINEDFRAGMENT_INTERACTIONOPERATOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CombinedFragment.interactionOperator is missing.");
	REL_UML_COMBINEDFRAGMENT_OPERAND=(IRelation)mm.getElementByName("uml.metamodel.uml.CombinedFragment.operand");
	if(REL_UML_COMBINEDFRAGMENT_OPERAND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CombinedFragment.operand is missing.");
	REL_UML_COMBINEDFRAGMENT_CFRAGMENTGATE=(IRelation)mm.getElementByName("uml.metamodel.uml.CombinedFragment.cfragmentGate");
	if(REL_UML_COMBINEDFRAGMENT_CFRAGMENTGATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CombinedFragment.cfragmentGate is missing.");
	ENT_UML_INTERACTIONOPERATORKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.InteractionOperatorKind");
	if(ENT_UML_INTERACTIONOPERATORKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InteractionOperatorKind is missing.");
	ENT_UML_CONTINUATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Continuation");
	if(ENT_UML_CONTINUATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Continuation is missing.");
	REL_UML_CONTINUATION_SETTING=(IRelation)mm.getElementByName("uml.metamodel.uml.Continuation.setting");
	if(REL_UML_CONTINUATION_SETTING==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Continuation.setting is missing.");
	ENT_UML_CONSIDERIGNOREFRAGMENT=(IEntity)mm.getElementByName("uml.metamodel.uml.ConsiderIgnoreFragment");
	if(ENT_UML_CONSIDERIGNOREFRAGMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConsiderIgnoreFragment is missing.");
	REL_UML_CONSIDERIGNOREFRAGMENT_MESSAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.ConsiderIgnoreFragment.message");
	if(REL_UML_CONSIDERIGNOREFRAGMENT_MESSAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConsiderIgnoreFragment.message is missing.");
	ENT_UML_CREATEOBJECTACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.CreateObjectAction");
	if(ENT_UML_CREATEOBJECTACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CreateObjectAction is missing.");
	REL_UML_CREATEOBJECTACTION_CLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.CreateObjectAction.classifier");
	if(REL_UML_CREATEOBJECTACTION_CLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CreateObjectAction.classifier is missing.");
	REL_UML_CREATEOBJECTACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.CreateObjectAction.result");
	if(REL_UML_CREATEOBJECTACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CreateObjectAction.result is missing.");
	ENT_UML_DESTROYOBJECTACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.DestroyObjectAction");
	if(ENT_UML_DESTROYOBJECTACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DestroyObjectAction is missing.");
	REL_UML_DESTROYOBJECTACTION_ISDESTROYLINKS=(IRelation)mm.getElementByName("uml.metamodel.uml.DestroyObjectAction.isDestroyLinks");
	if(REL_UML_DESTROYOBJECTACTION_ISDESTROYLINKS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DestroyObjectAction.isDestroyLinks is missing.");
	REL_UML_DESTROYOBJECTACTION_ISDESTROYOWNEDOBJECTS=(IRelation)mm.getElementByName("uml.metamodel.uml.DestroyObjectAction.isDestroyOwnedObjects");
	if(REL_UML_DESTROYOBJECTACTION_ISDESTROYOWNEDOBJECTS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DestroyObjectAction.isDestroyOwnedObjects is missing.");
	REL_UML_DESTROYOBJECTACTION_TARGET=(IRelation)mm.getElementByName("uml.metamodel.uml.DestroyObjectAction.target");
	if(REL_UML_DESTROYOBJECTACTION_TARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DestroyObjectAction.target is missing.");
	ENT_UML_TESTIDENTITYACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.TestIdentityAction");
	if(ENT_UML_TESTIDENTITYACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TestIdentityAction is missing.");
	REL_UML_TESTIDENTITYACTION_FIRST=(IRelation)mm.getElementByName("uml.metamodel.uml.TestIdentityAction.first");
	if(REL_UML_TESTIDENTITYACTION_FIRST==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TestIdentityAction.first is missing.");
	REL_UML_TESTIDENTITYACTION_SECOND=(IRelation)mm.getElementByName("uml.metamodel.uml.TestIdentityAction.second");
	if(REL_UML_TESTIDENTITYACTION_SECOND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TestIdentityAction.second is missing.");
	REL_UML_TESTIDENTITYACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.TestIdentityAction.result");
	if(REL_UML_TESTIDENTITYACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TestIdentityAction.result is missing.");
	ENT_UML_READSELFACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReadSelfAction");
	if(ENT_UML_READSELFACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadSelfAction is missing.");
	REL_UML_READSELFACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadSelfAction.result");
	if(REL_UML_READSELFACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadSelfAction.result is missing.");
	ENT_UML_STRUCTURALFEATUREACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.StructuralFeatureAction");
	if(ENT_UML_STRUCTURALFEATUREACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuralFeatureAction is missing.");
	REL_UML_STRUCTURALFEATUREACTION_STRUCTURALFEATURE=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuralFeatureAction.structuralFeature");
	if(REL_UML_STRUCTURALFEATUREACTION_STRUCTURALFEATURE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuralFeatureAction.structuralFeature is missing.");
	REL_UML_STRUCTURALFEATUREACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.StructuralFeatureAction.object");
	if(REL_UML_STRUCTURALFEATUREACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StructuralFeatureAction.object is missing.");
	ENT_UML_READSTRUCTURALFEATUREACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReadStructuralFeatureAction");
	if(ENT_UML_READSTRUCTURALFEATUREACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadStructuralFeatureAction is missing.");
	REL_UML_READSTRUCTURALFEATUREACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadStructuralFeatureAction.result");
	if(REL_UML_READSTRUCTURALFEATUREACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadStructuralFeatureAction.result is missing.");
	ENT_UML_WRITESTRUCTURALFEATUREACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.WriteStructuralFeatureAction");
	if(ENT_UML_WRITESTRUCTURALFEATUREACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.WriteStructuralFeatureAction is missing.");
	REL_UML_WRITESTRUCTURALFEATUREACTION_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.WriteStructuralFeatureAction.value");
	if(REL_UML_WRITESTRUCTURALFEATUREACTION_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.WriteStructuralFeatureAction.value is missing.");
	REL_UML_WRITESTRUCTURALFEATUREACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.WriteStructuralFeatureAction.result");
	if(REL_UML_WRITESTRUCTURALFEATUREACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.WriteStructuralFeatureAction.result is missing.");
	ENT_UML_CLEARSTRUCTURALFEATUREACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ClearStructuralFeatureAction");
	if(ENT_UML_CLEARSTRUCTURALFEATUREACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClearStructuralFeatureAction is missing.");
	REL_UML_CLEARSTRUCTURALFEATUREACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ClearStructuralFeatureAction.result");
	if(REL_UML_CLEARSTRUCTURALFEATUREACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClearStructuralFeatureAction.result is missing.");
	ENT_UML_REMOVESTRUCTURALFEATUREVALUEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.RemoveStructuralFeatureValueAction");
	if(ENT_UML_REMOVESTRUCTURALFEATUREVALUEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RemoveStructuralFeatureValueAction is missing.");
	REL_UML_REMOVESTRUCTURALFEATUREVALUEACTION_ISREMOVEDUPLICATES=(IRelation)mm.getElementByName("uml.metamodel.uml.RemoveStructuralFeatureValueAction.isRemoveDuplicates");
	if(REL_UML_REMOVESTRUCTURALFEATUREVALUEACTION_ISREMOVEDUPLICATES==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RemoveStructuralFeatureValueAction.isRemoveDuplicates is missing.");
	REL_UML_REMOVESTRUCTURALFEATUREVALUEACTION_REMOVEAT=(IRelation)mm.getElementByName("uml.metamodel.uml.RemoveStructuralFeatureValueAction.removeAt");
	if(REL_UML_REMOVESTRUCTURALFEATUREVALUEACTION_REMOVEAT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RemoveStructuralFeatureValueAction.removeAt is missing.");
	ENT_UML_ADDSTRUCTURALFEATUREVALUEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.AddStructuralFeatureValueAction");
	if(ENT_UML_ADDSTRUCTURALFEATUREVALUEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AddStructuralFeatureValueAction is missing.");
	REL_UML_ADDSTRUCTURALFEATUREVALUEACTION_ISREPLACEALL=(IRelation)mm.getElementByName("uml.metamodel.uml.AddStructuralFeatureValueAction.isReplaceAll");
	if(REL_UML_ADDSTRUCTURALFEATUREVALUEACTION_ISREPLACEALL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AddStructuralFeatureValueAction.isReplaceAll is missing.");
	REL_UML_ADDSTRUCTURALFEATUREVALUEACTION_INSERTAT=(IRelation)mm.getElementByName("uml.metamodel.uml.AddStructuralFeatureValueAction.insertAt");
	if(REL_UML_ADDSTRUCTURALFEATUREVALUEACTION_INSERTAT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AddStructuralFeatureValueAction.insertAt is missing.");
	ENT_UML_LINKACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.LinkAction");
	if(ENT_UML_LINKACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkAction is missing.");
	REL_UML_LINKACTION_ENDDATA=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkAction.endData");
	if(REL_UML_LINKACTION_ENDDATA==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkAction.endData is missing.");
	REL_UML_LINKACTION_INPUTVALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkAction.inputValue");
	if(REL_UML_LINKACTION_INPUTVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkAction.inputValue is missing.");
	ENT_UML_LINKENDDATA=(IEntity)mm.getElementByName("uml.metamodel.uml.LinkEndData");
	if(ENT_UML_LINKENDDATA==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndData is missing.");
	REL_UML_LINKENDDATA_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkEndData.value");
	if(REL_UML_LINKENDDATA_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndData.value is missing.");
	REL_UML_LINKENDDATA_END=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkEndData.end");
	if(REL_UML_LINKENDDATA_END==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndData.end is missing.");
	REL_UML_LINKENDDATA_QUALIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkEndData.qualifier");
	if(REL_UML_LINKENDDATA_QUALIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndData.qualifier is missing.");
	ENT_UML_QUALIFIERVALUE=(IEntity)mm.getElementByName("uml.metamodel.uml.QualifierValue");
	if(ENT_UML_QUALIFIERVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.QualifierValue is missing.");
	REL_UML_QUALIFIERVALUE_QUALIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.QualifierValue.qualifier");
	if(REL_UML_QUALIFIERVALUE_QUALIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.QualifierValue.qualifier is missing.");
	REL_UML_QUALIFIERVALUE_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.QualifierValue.value");
	if(REL_UML_QUALIFIERVALUE_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.QualifierValue.value is missing.");
	ENT_UML_READLINKACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReadLinkAction");
	if(ENT_UML_READLINKACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkAction is missing.");
	REL_UML_READLINKACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadLinkAction.result");
	if(REL_UML_READLINKACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkAction.result is missing.");
	ENT_UML_LINKENDCREATIONDATA=(IEntity)mm.getElementByName("uml.metamodel.uml.LinkEndCreationData");
	if(ENT_UML_LINKENDCREATIONDATA==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndCreationData is missing.");
	REL_UML_LINKENDCREATIONDATA_ISREPLACEALL=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkEndCreationData.isReplaceAll");
	if(REL_UML_LINKENDCREATIONDATA_ISREPLACEALL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndCreationData.isReplaceAll is missing.");
	REL_UML_LINKENDCREATIONDATA_INSERTAT=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkEndCreationData.insertAt");
	if(REL_UML_LINKENDCREATIONDATA_INSERTAT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndCreationData.insertAt is missing.");
	ENT_UML_CREATELINKACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.CreateLinkAction");
	if(ENT_UML_CREATELINKACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CreateLinkAction is missing.");
	ENT_UML_WRITELINKACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.WriteLinkAction");
	if(ENT_UML_WRITELINKACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.WriteLinkAction is missing.");
	ENT_UML_DESTROYLINKACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.DestroyLinkAction");
	if(ENT_UML_DESTROYLINKACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DestroyLinkAction is missing.");
	ENT_UML_LINKENDDESTRUCTIONDATA=(IEntity)mm.getElementByName("uml.metamodel.uml.LinkEndDestructionData");
	if(ENT_UML_LINKENDDESTRUCTIONDATA==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndDestructionData is missing.");
	REL_UML_LINKENDDESTRUCTIONDATA_ISDESTROYDUPLICATES=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkEndDestructionData.isDestroyDuplicates");
	if(REL_UML_LINKENDDESTRUCTIONDATA_ISDESTROYDUPLICATES==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndDestructionData.isDestroyDuplicates is missing.");
	REL_UML_LINKENDDESTRUCTIONDATA_DESTROYAT=(IRelation)mm.getElementByName("uml.metamodel.uml.LinkEndDestructionData.destroyAt");
	if(REL_UML_LINKENDDESTRUCTIONDATA_DESTROYAT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LinkEndDestructionData.destroyAt is missing.");
	ENT_UML_CLEARASSOCIATIONACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ClearAssociationAction");
	if(ENT_UML_CLEARASSOCIATIONACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClearAssociationAction is missing.");
	REL_UML_CLEARASSOCIATIONACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.ClearAssociationAction.object");
	if(REL_UML_CLEARASSOCIATIONACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClearAssociationAction.object is missing.");
	REL_UML_CLEARASSOCIATIONACTION_ASSOCIATION=(IRelation)mm.getElementByName("uml.metamodel.uml.ClearAssociationAction.association");
	if(REL_UML_CLEARASSOCIATIONACTION_ASSOCIATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClearAssociationAction.association is missing.");
	ENT_UML_BROADCASTSIGNALACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.BroadcastSignalAction");
	if(ENT_UML_BROADCASTSIGNALACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BroadcastSignalAction is missing.");
	REL_UML_BROADCASTSIGNALACTION_SIGNAL=(IRelation)mm.getElementByName("uml.metamodel.uml.BroadcastSignalAction.signal");
	if(REL_UML_BROADCASTSIGNALACTION_SIGNAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.BroadcastSignalAction.signal is missing.");
	ENT_UML_SENDOBJECTACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.SendObjectAction");
	if(ENT_UML_SENDOBJECTACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendObjectAction is missing.");
	REL_UML_SENDOBJECTACTION_TARGET=(IRelation)mm.getElementByName("uml.metamodel.uml.SendObjectAction.target");
	if(REL_UML_SENDOBJECTACTION_TARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendObjectAction.target is missing.");
	REL_UML_SENDOBJECTACTION_REQUEST=(IRelation)mm.getElementByName("uml.metamodel.uml.SendObjectAction.request");
	if(REL_UML_SENDOBJECTACTION_REQUEST==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.SendObjectAction.request is missing.");
	ENT_UML_VALUESPECIFICATIONACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ValueSpecificationAction");
	if(ENT_UML_VALUESPECIFICATIONACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ValueSpecificationAction is missing.");
	REL_UML_VALUESPECIFICATIONACTION_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.ValueSpecificationAction.value");
	if(REL_UML_VALUESPECIFICATIONACTION_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ValueSpecificationAction.value is missing.");
	REL_UML_VALUESPECIFICATIONACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ValueSpecificationAction.result");
	if(REL_UML_VALUESPECIFICATIONACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ValueSpecificationAction.result is missing.");
	ENT_UML_TIMEEXPRESSION=(IEntity)mm.getElementByName("uml.metamodel.uml.TimeExpression");
	if(ENT_UML_TIMEEXPRESSION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeExpression is missing.");
	REL_UML_TIMEEXPRESSION_EXPR=(IRelation)mm.getElementByName("uml.metamodel.uml.TimeExpression.expr");
	if(REL_UML_TIMEEXPRESSION_EXPR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeExpression.expr is missing.");
	REL_UML_TIMEEXPRESSION_OBSERVATION=(IRelation)mm.getElementByName("uml.metamodel.uml.TimeExpression.observation");
	if(REL_UML_TIMEEXPRESSION_OBSERVATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeExpression.observation is missing.");
	ENT_UML_OBSERVATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Observation");
	if(ENT_UML_OBSERVATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Observation is missing.");
	ENT_UML_DURATION=(IEntity)mm.getElementByName("uml.metamodel.uml.Duration");
	if(ENT_UML_DURATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Duration is missing.");
	REL_UML_DURATION_EXPR=(IRelation)mm.getElementByName("uml.metamodel.uml.Duration.expr");
	if(REL_UML_DURATION_EXPR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Duration.expr is missing.");
	REL_UML_DURATION_OBSERVATION=(IRelation)mm.getElementByName("uml.metamodel.uml.Duration.observation");
	if(REL_UML_DURATION_OBSERVATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Duration.observation is missing.");
	ENT_UML_DURATIONINTERVAL=(IEntity)mm.getElementByName("uml.metamodel.uml.DurationInterval");
	if(ENT_UML_DURATIONINTERVAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DurationInterval is missing.");
	ENT_UML_INTERVAL=(IEntity)mm.getElementByName("uml.metamodel.uml.Interval");
	if(ENT_UML_INTERVAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interval is missing.");
	REL_UML_INTERVAL_MIN=(IRelation)mm.getElementByName("uml.metamodel.uml.Interval.min");
	if(REL_UML_INTERVAL_MIN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interval.min is missing.");
	REL_UML_INTERVAL_MAX=(IRelation)mm.getElementByName("uml.metamodel.uml.Interval.max");
	if(REL_UML_INTERVAL_MAX==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Interval.max is missing.");
	ENT_UML_TIMECONSTRAINT=(IEntity)mm.getElementByName("uml.metamodel.uml.TimeConstraint");
	if(ENT_UML_TIMECONSTRAINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeConstraint is missing.");
	REL_UML_TIMECONSTRAINT_FIRSTEVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.TimeConstraint.firstEvent");
	if(REL_UML_TIMECONSTRAINT_FIRSTEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeConstraint.firstEvent is missing.");
	ENT_UML_INTERVALCONSTRAINT=(IEntity)mm.getElementByName("uml.metamodel.uml.IntervalConstraint");
	if(ENT_UML_INTERVALCONSTRAINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.IntervalConstraint is missing.");
	ENT_UML_TIMEINTERVAL=(IEntity)mm.getElementByName("uml.metamodel.uml.TimeInterval");
	if(ENT_UML_TIMEINTERVAL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeInterval is missing.");
	ENT_UML_DURATIONCONSTRAINT=(IEntity)mm.getElementByName("uml.metamodel.uml.DurationConstraint");
	if(ENT_UML_DURATIONCONSTRAINT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DurationConstraint is missing.");
	REL_UML_DURATIONCONSTRAINT_FIRSTEVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.DurationConstraint.firstEvent");
	if(REL_UML_DURATIONCONSTRAINT_FIRSTEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DurationConstraint.firstEvent is missing.");
	ENT_UML_TIMEOBSERVATION=(IEntity)mm.getElementByName("uml.metamodel.uml.TimeObservation");
	if(ENT_UML_TIMEOBSERVATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeObservation is missing.");
	REL_UML_TIMEOBSERVATION_FIRSTEVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.TimeObservation.firstEvent");
	if(REL_UML_TIMEOBSERVATION_FIRSTEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeObservation.firstEvent is missing.");
	REL_UML_TIMEOBSERVATION_EVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.TimeObservation.event");
	if(REL_UML_TIMEOBSERVATION_EVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeObservation.event is missing.");
	ENT_UML_DURATIONOBSERVATION=(IEntity)mm.getElementByName("uml.metamodel.uml.DurationObservation");
	if(ENT_UML_DURATIONOBSERVATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DurationObservation is missing.");
	REL_UML_DURATIONOBSERVATION_FIRSTEVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.DurationObservation.firstEvent");
	if(REL_UML_DURATIONOBSERVATION_FIRSTEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DurationObservation.firstEvent is missing.");
	REL_UML_DURATIONOBSERVATION_EVENT=(IRelation)mm.getElementByName("uml.metamodel.uml.DurationObservation.event");
	if(REL_UML_DURATIONOBSERVATION_EVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DurationObservation.event is missing.");
	ENT_UML_FINALSTATE=(IEntity)mm.getElementByName("uml.metamodel.uml.FinalState");
	if(ENT_UML_FINALSTATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.FinalState is missing.");
	ENT_UML_TIMEEVENT=(IEntity)mm.getElementByName("uml.metamodel.uml.TimeEvent");
	if(ENT_UML_TIMEEVENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeEvent is missing.");
	REL_UML_TIMEEVENT_ISRELATIVE=(IRelation)mm.getElementByName("uml.metamodel.uml.TimeEvent.isRelative");
	if(REL_UML_TIMEEVENT_ISRELATIVE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeEvent.isRelative is missing.");
	REL_UML_TIMEEVENT_WHEN=(IRelation)mm.getElementByName("uml.metamodel.uml.TimeEvent.when");
	if(REL_UML_TIMEEVENT_WHEN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.TimeEvent.when is missing.");
	ENT_UML_VARIABLEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.VariableAction");
	if(ENT_UML_VARIABLEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.VariableAction is missing.");
	REL_UML_VARIABLEACTION_VARIABLE=(IRelation)mm.getElementByName("uml.metamodel.uml.VariableAction.variable");
	if(REL_UML_VARIABLEACTION_VARIABLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.VariableAction.variable is missing.");
	ENT_UML_READVARIABLEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReadVariableAction");
	if(ENT_UML_READVARIABLEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadVariableAction is missing.");
	REL_UML_READVARIABLEACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadVariableAction.result");
	if(REL_UML_READVARIABLEACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadVariableAction.result is missing.");
	ENT_UML_WRITEVARIABLEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.WriteVariableAction");
	if(ENT_UML_WRITEVARIABLEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.WriteVariableAction is missing.");
	REL_UML_WRITEVARIABLEACTION_VALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.WriteVariableAction.value");
	if(REL_UML_WRITEVARIABLEACTION_VALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.WriteVariableAction.value is missing.");
	ENT_UML_CLEARVARIABLEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ClearVariableAction");
	if(ENT_UML_CLEARVARIABLEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ClearVariableAction is missing.");
	ENT_UML_ADDVARIABLEVALUEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.AddVariableValueAction");
	if(ENT_UML_ADDVARIABLEVALUEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AddVariableValueAction is missing.");
	REL_UML_ADDVARIABLEVALUEACTION_ISREPLACEALL=(IRelation)mm.getElementByName("uml.metamodel.uml.AddVariableValueAction.isReplaceAll");
	if(REL_UML_ADDVARIABLEVALUEACTION_ISREPLACEALL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AddVariableValueAction.isReplaceAll is missing.");
	REL_UML_ADDVARIABLEVALUEACTION_INSERTAT=(IRelation)mm.getElementByName("uml.metamodel.uml.AddVariableValueAction.insertAt");
	if(REL_UML_ADDVARIABLEVALUEACTION_INSERTAT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AddVariableValueAction.insertAt is missing.");
	ENT_UML_REMOVEVARIABLEVALUEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.RemoveVariableValueAction");
	if(ENT_UML_REMOVEVARIABLEVALUEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RemoveVariableValueAction is missing.");
	REL_UML_REMOVEVARIABLEVALUEACTION_ISREMOVEDUPLICATES=(IRelation)mm.getElementByName("uml.metamodel.uml.RemoveVariableValueAction.isRemoveDuplicates");
	if(REL_UML_REMOVEVARIABLEVALUEACTION_ISREMOVEDUPLICATES==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RemoveVariableValueAction.isRemoveDuplicates is missing.");
	REL_UML_REMOVEVARIABLEVALUEACTION_REMOVEAT=(IRelation)mm.getElementByName("uml.metamodel.uml.RemoveVariableValueAction.removeAt");
	if(REL_UML_REMOVEVARIABLEVALUEACTION_REMOVEAT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RemoveVariableValueAction.removeAt is missing.");
	ENT_UML_RAISEEXCEPTIONACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.RaiseExceptionAction");
	if(ENT_UML_RAISEEXCEPTIONACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RaiseExceptionAction is missing.");
	REL_UML_RAISEEXCEPTIONACTION_EXCEPTION=(IRelation)mm.getElementByName("uml.metamodel.uml.RaiseExceptionAction.exception");
	if(REL_UML_RAISEEXCEPTIONACTION_EXCEPTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.RaiseExceptionAction.exception is missing.");
	ENT_UML_ACTIONINPUTPIN=(IEntity)mm.getElementByName("uml.metamodel.uml.ActionInputPin");
	if(ENT_UML_ACTIONINPUTPIN==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActionInputPin is missing.");
	REL_UML_ACTIONINPUTPIN_FROMACTION=(IRelation)mm.getElementByName("uml.metamodel.uml.ActionInputPin.fromAction");
	if(REL_UML_ACTIONINPUTPIN_FROMACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ActionInputPin.fromAction is missing.");
	ENT_UML_INFORMATIONITEM=(IEntity)mm.getElementByName("uml.metamodel.uml.InformationItem");
	if(ENT_UML_INFORMATIONITEM==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationItem is missing.");
	REL_UML_INFORMATIONITEM_REPRESENTED=(IRelation)mm.getElementByName("uml.metamodel.uml.InformationItem.represented");
	if(REL_UML_INFORMATIONITEM_REPRESENTED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationItem.represented is missing.");
	ENT_UML_INFORMATIONFLOW=(IEntity)mm.getElementByName("uml.metamodel.uml.InformationFlow");
	if(ENT_UML_INFORMATIONFLOW==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationFlow is missing.");
	REL_UML_INFORMATIONFLOW_REALIZATION=(IRelation)mm.getElementByName("uml.metamodel.uml.InformationFlow.realization");
	if(REL_UML_INFORMATIONFLOW_REALIZATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationFlow.realization is missing.");
	REL_UML_INFORMATIONFLOW_CONVEYED=(IRelation)mm.getElementByName("uml.metamodel.uml.InformationFlow.conveyed");
	if(REL_UML_INFORMATIONFLOW_CONVEYED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationFlow.conveyed is missing.");
	REL_UML_INFORMATIONFLOW_INFORMATIONSOURCE=(IRelation)mm.getElementByName("uml.metamodel.uml.InformationFlow.informationSource");
	if(REL_UML_INFORMATIONFLOW_INFORMATIONSOURCE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationFlow.informationSource is missing.");
	REL_UML_INFORMATIONFLOW_INFORMATIONTARGET=(IRelation)mm.getElementByName("uml.metamodel.uml.InformationFlow.informationTarget");
	if(REL_UML_INFORMATIONFLOW_INFORMATIONTARGET==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationFlow.informationTarget is missing.");
	REL_UML_INFORMATIONFLOW_REALIZINGACTIVITYEDGE=(IRelation)mm.getElementByName("uml.metamodel.uml.InformationFlow.realizingActivityEdge");
	if(REL_UML_INFORMATIONFLOW_REALIZINGACTIVITYEDGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationFlow.realizingActivityEdge is missing.");
	REL_UML_INFORMATIONFLOW_REALIZINGCONNECTOR=(IRelation)mm.getElementByName("uml.metamodel.uml.InformationFlow.realizingConnector");
	if(REL_UML_INFORMATIONFLOW_REALIZINGCONNECTOR==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationFlow.realizingConnector is missing.");
	REL_UML_INFORMATIONFLOW_REALIZINGMESSAGE=(IRelation)mm.getElementByName("uml.metamodel.uml.InformationFlow.realizingMessage");
	if(REL_UML_INFORMATIONFLOW_REALIZINGMESSAGE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.InformationFlow.realizingMessage is missing.");
	ENT_UML_READEXTENTACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReadExtentAction");
	if(ENT_UML_READEXTENTACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadExtentAction is missing.");
	REL_UML_READEXTENTACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadExtentAction.result");
	if(REL_UML_READEXTENTACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadExtentAction.result is missing.");
	REL_UML_READEXTENTACTION_CLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadExtentAction.classifier");
	if(REL_UML_READEXTENTACTION_CLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadExtentAction.classifier is missing.");
	ENT_UML_RECLASSIFYOBJECTACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReclassifyObjectAction");
	if(ENT_UML_RECLASSIFYOBJECTACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReclassifyObjectAction is missing.");
	REL_UML_RECLASSIFYOBJECTACTION_ISREPLACEALL=(IRelation)mm.getElementByName("uml.metamodel.uml.ReclassifyObjectAction.isReplaceAll");
	if(REL_UML_RECLASSIFYOBJECTACTION_ISREPLACEALL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReclassifyObjectAction.isReplaceAll is missing.");
	REL_UML_RECLASSIFYOBJECTACTION_OLDCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.ReclassifyObjectAction.oldClassifier");
	if(REL_UML_RECLASSIFYOBJECTACTION_OLDCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReclassifyObjectAction.oldClassifier is missing.");
	REL_UML_RECLASSIFYOBJECTACTION_NEWCLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.ReclassifyObjectAction.newClassifier");
	if(REL_UML_RECLASSIFYOBJECTACTION_NEWCLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReclassifyObjectAction.newClassifier is missing.");
	REL_UML_RECLASSIFYOBJECTACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReclassifyObjectAction.object");
	if(REL_UML_RECLASSIFYOBJECTACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReclassifyObjectAction.object is missing.");
	ENT_UML_READISCLASSIFIEDOBJECTACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReadIsClassifiedObjectAction");
	if(ENT_UML_READISCLASSIFIEDOBJECTACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadIsClassifiedObjectAction is missing.");
	REL_UML_READISCLASSIFIEDOBJECTACTION_ISDIRECT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadIsClassifiedObjectAction.isDirect");
	if(REL_UML_READISCLASSIFIEDOBJECTACTION_ISDIRECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadIsClassifiedObjectAction.isDirect is missing.");
	REL_UML_READISCLASSIFIEDOBJECTACTION_CLASSIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadIsClassifiedObjectAction.classifier");
	if(REL_UML_READISCLASSIFIEDOBJECTACTION_CLASSIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadIsClassifiedObjectAction.classifier is missing.");
	REL_UML_READISCLASSIFIEDOBJECTACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadIsClassifiedObjectAction.result");
	if(REL_UML_READISCLASSIFIEDOBJECTACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadIsClassifiedObjectAction.result is missing.");
	REL_UML_READISCLASSIFIEDOBJECTACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadIsClassifiedObjectAction.object");
	if(REL_UML_READISCLASSIFIEDOBJECTACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadIsClassifiedObjectAction.object is missing.");
	ENT_UML_STARTCLASSIFIERBEHAVIORACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.StartClassifierBehaviorAction");
	if(ENT_UML_STARTCLASSIFIERBEHAVIORACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StartClassifierBehaviorAction is missing.");
	REL_UML_STARTCLASSIFIERBEHAVIORACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.StartClassifierBehaviorAction.object");
	if(REL_UML_STARTCLASSIFIERBEHAVIORACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StartClassifierBehaviorAction.object is missing.");
	ENT_UML_READLINKOBJECTENDACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReadLinkObjectEndAction");
	if(ENT_UML_READLINKOBJECTENDACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkObjectEndAction is missing.");
	REL_UML_READLINKOBJECTENDACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadLinkObjectEndAction.object");
	if(REL_UML_READLINKOBJECTENDACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkObjectEndAction.object is missing.");
	REL_UML_READLINKOBJECTENDACTION_END=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadLinkObjectEndAction.end");
	if(REL_UML_READLINKOBJECTENDACTION_END==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkObjectEndAction.end is missing.");
	REL_UML_READLINKOBJECTENDACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadLinkObjectEndAction.result");
	if(REL_UML_READLINKOBJECTENDACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkObjectEndAction.result is missing.");
	ENT_UML_READLINKOBJECTENDQUALIFIERACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReadLinkObjectEndQualifierAction");
	if(ENT_UML_READLINKOBJECTENDQUALIFIERACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkObjectEndQualifierAction is missing.");
	REL_UML_READLINKOBJECTENDQUALIFIERACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadLinkObjectEndQualifierAction.object");
	if(REL_UML_READLINKOBJECTENDQUALIFIERACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkObjectEndQualifierAction.object is missing.");
	REL_UML_READLINKOBJECTENDQUALIFIERACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadLinkObjectEndQualifierAction.result");
	if(REL_UML_READLINKOBJECTENDQUALIFIERACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkObjectEndQualifierAction.result is missing.");
	REL_UML_READLINKOBJECTENDQUALIFIERACTION_QUALIFIER=(IRelation)mm.getElementByName("uml.metamodel.uml.ReadLinkObjectEndQualifierAction.qualifier");
	if(REL_UML_READLINKOBJECTENDQUALIFIERACTION_QUALIFIER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReadLinkObjectEndQualifierAction.qualifier is missing.");
	ENT_UML_CREATELINKOBJECTACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.CreateLinkObjectAction");
	if(ENT_UML_CREATELINKOBJECTACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CreateLinkObjectAction is missing.");
	REL_UML_CREATELINKOBJECTACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.CreateLinkObjectAction.result");
	if(REL_UML_CREATELINKOBJECTACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.CreateLinkObjectAction.result is missing.");
	ENT_UML_ACCEPTEVENTACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.AcceptEventAction");
	if(ENT_UML_ACCEPTEVENTACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AcceptEventAction is missing.");
	REL_UML_ACCEPTEVENTACTION_ISUNMARSHALL=(IRelation)mm.getElementByName("uml.metamodel.uml.AcceptEventAction.isUnmarshall");
	if(REL_UML_ACCEPTEVENTACTION_ISUNMARSHALL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AcceptEventAction.isUnmarshall is missing.");
	REL_UML_ACCEPTEVENTACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.AcceptEventAction.result");
	if(REL_UML_ACCEPTEVENTACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AcceptEventAction.result is missing.");
	REL_UML_ACCEPTEVENTACTION_TRIGGER=(IRelation)mm.getElementByName("uml.metamodel.uml.AcceptEventAction.trigger");
	if(REL_UML_ACCEPTEVENTACTION_TRIGGER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AcceptEventAction.trigger is missing.");
	ENT_UML_ACCEPTCALLACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.AcceptCallAction");
	if(ENT_UML_ACCEPTCALLACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AcceptCallAction is missing.");
	REL_UML_ACCEPTCALLACTION_RETURNINFORMATION=(IRelation)mm.getElementByName("uml.metamodel.uml.AcceptCallAction.returnInformation");
	if(REL_UML_ACCEPTCALLACTION_RETURNINFORMATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AcceptCallAction.returnInformation is missing.");
	ENT_UML_REPLYACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReplyAction");
	if(ENT_UML_REPLYACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReplyAction is missing.");
	REL_UML_REPLYACTION_REPLYTOCALL=(IRelation)mm.getElementByName("uml.metamodel.uml.ReplyAction.replyToCall");
	if(REL_UML_REPLYACTION_REPLYTOCALL==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReplyAction.replyToCall is missing.");
	REL_UML_REPLYACTION_RETURNINFORMATION=(IRelation)mm.getElementByName("uml.metamodel.uml.ReplyAction.returnInformation");
	if(REL_UML_REPLYACTION_RETURNINFORMATION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReplyAction.returnInformation is missing.");
	REL_UML_REPLYACTION_REPLYVALUE=(IRelation)mm.getElementByName("uml.metamodel.uml.ReplyAction.replyValue");
	if(REL_UML_REPLYACTION_REPLYVALUE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReplyAction.replyValue is missing.");
	ENT_UML_UNMARSHALLACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.UnmarshallAction");
	if(ENT_UML_UNMARSHALLACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UnmarshallAction is missing.");
	REL_UML_UNMARSHALLACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.UnmarshallAction.result");
	if(REL_UML_UNMARSHALLACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UnmarshallAction.result is missing.");
	REL_UML_UNMARSHALLACTION_UNMARSHALLTYPE=(IRelation)mm.getElementByName("uml.metamodel.uml.UnmarshallAction.unmarshallType");
	if(REL_UML_UNMARSHALLACTION_UNMARSHALLTYPE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UnmarshallAction.unmarshallType is missing.");
	REL_UML_UNMARSHALLACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.UnmarshallAction.object");
	if(REL_UML_UNMARSHALLACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.UnmarshallAction.object is missing.");
	ENT_UML_REDUCEACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.ReduceAction");
	if(ENT_UML_REDUCEACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReduceAction is missing.");
	REL_UML_REDUCEACTION_ISORDERED=(IRelation)mm.getElementByName("uml.metamodel.uml.ReduceAction.isOrdered");
	if(REL_UML_REDUCEACTION_ISORDERED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReduceAction.isOrdered is missing.");
	REL_UML_REDUCEACTION_REDUCER=(IRelation)mm.getElementByName("uml.metamodel.uml.ReduceAction.reducer");
	if(REL_UML_REDUCEACTION_REDUCER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReduceAction.reducer is missing.");
	REL_UML_REDUCEACTION_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ReduceAction.result");
	if(REL_UML_REDUCEACTION_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReduceAction.result is missing.");
	REL_UML_REDUCEACTION_COLLECTION=(IRelation)mm.getElementByName("uml.metamodel.uml.ReduceAction.collection");
	if(REL_UML_REDUCEACTION_COLLECTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ReduceAction.collection is missing.");
	ENT_UML_STARTOBJECTBEHAVIORACTION=(IEntity)mm.getElementByName("uml.metamodel.uml.StartObjectBehaviorAction");
	if(ENT_UML_STARTOBJECTBEHAVIORACTION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StartObjectBehaviorAction is missing.");
	REL_UML_STARTOBJECTBEHAVIORACTION_OBJECT=(IRelation)mm.getElementByName("uml.metamodel.uml.StartObjectBehaviorAction.object");
	if(REL_UML_STARTOBJECTBEHAVIORACTION_OBJECT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.StartObjectBehaviorAction.object is missing.");
	ENT_UML_JOINNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.JoinNode");
	if(ENT_UML_JOINNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.JoinNode is missing.");
	REL_UML_JOINNODE_ISCOMBINEDUPLICATE=(IRelation)mm.getElementByName("uml.metamodel.uml.JoinNode.isCombineDuplicate");
	if(REL_UML_JOINNODE_ISCOMBINEDUPLICATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.JoinNode.isCombineDuplicate is missing.");
	REL_UML_JOINNODE_JOINSPEC=(IRelation)mm.getElementByName("uml.metamodel.uml.JoinNode.joinSpec");
	if(REL_UML_JOINNODE_JOINSPEC==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.JoinNode.joinSpec is missing.");
	ENT_UML_DATASTORENODE=(IEntity)mm.getElementByName("uml.metamodel.uml.DataStoreNode");
	if(ENT_UML_DATASTORENODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.DataStoreNode is missing.");
	ENT_UML_CONDITIONALNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ConditionalNode");
	if(ENT_UML_CONDITIONALNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConditionalNode is missing.");
	REL_UML_CONDITIONALNODE_ISDETERMINATE=(IRelation)mm.getElementByName("uml.metamodel.uml.ConditionalNode.isDeterminate");
	if(REL_UML_CONDITIONALNODE_ISDETERMINATE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConditionalNode.isDeterminate is missing.");
	REL_UML_CONDITIONALNODE_ISASSURED=(IRelation)mm.getElementByName("uml.metamodel.uml.ConditionalNode.isAssured");
	if(REL_UML_CONDITIONALNODE_ISASSURED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConditionalNode.isAssured is missing.");
	REL_UML_CONDITIONALNODE_CLAUSE=(IRelation)mm.getElementByName("uml.metamodel.uml.ConditionalNode.clause");
	if(REL_UML_CONDITIONALNODE_CLAUSE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConditionalNode.clause is missing.");
	REL_UML_CONDITIONALNODE_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.ConditionalNode.result");
	if(REL_UML_CONDITIONALNODE_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ConditionalNode.result is missing.");
	ENT_UML_CLAUSE=(IEntity)mm.getElementByName("uml.metamodel.uml.Clause");
	if(ENT_UML_CLAUSE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Clause is missing.");
	REL_UML_CLAUSE_TEST=(IRelation)mm.getElementByName("uml.metamodel.uml.Clause.test");
	if(REL_UML_CLAUSE_TEST==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Clause.test is missing.");
	REL_UML_CLAUSE_BODY=(IRelation)mm.getElementByName("uml.metamodel.uml.Clause.body");
	if(REL_UML_CLAUSE_BODY==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Clause.body is missing.");
	REL_UML_CLAUSE_PREDECESSORCLAUSE=(IRelation)mm.getElementByName("uml.metamodel.uml.Clause.predecessorClause");
	if(REL_UML_CLAUSE_PREDECESSORCLAUSE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Clause.predecessorClause is missing.");
	REL_UML_CLAUSE_SUCCESSORCLAUSE=(IRelation)mm.getElementByName("uml.metamodel.uml.Clause.successorClause");
	if(REL_UML_CLAUSE_SUCCESSORCLAUSE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Clause.successorClause is missing.");
	REL_UML_CLAUSE_DECIDER=(IRelation)mm.getElementByName("uml.metamodel.uml.Clause.decider");
	if(REL_UML_CLAUSE_DECIDER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Clause.decider is missing.");
	REL_UML_CLAUSE_BODYOUTPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.Clause.bodyOutput");
	if(REL_UML_CLAUSE_BODYOUTPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.Clause.bodyOutput is missing.");
	ENT_UML_LOOPNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.LoopNode");
	if(ENT_UML_LOOPNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode is missing.");
	REL_UML_LOOPNODE_ISTESTEDFIRST=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.isTestedFirst");
	if(REL_UML_LOOPNODE_ISTESTEDFIRST==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.isTestedFirst is missing.");
	REL_UML_LOOPNODE_BODYPART=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.bodyPart");
	if(REL_UML_LOOPNODE_BODYPART==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.bodyPart is missing.");
	REL_UML_LOOPNODE_SETUPPART=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.setupPart");
	if(REL_UML_LOOPNODE_SETUPPART==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.setupPart is missing.");
	REL_UML_LOOPNODE_DECIDER=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.decider");
	if(REL_UML_LOOPNODE_DECIDER==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.decider is missing.");
	REL_UML_LOOPNODE_TEST=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.test");
	if(REL_UML_LOOPNODE_TEST==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.test is missing.");
	REL_UML_LOOPNODE_RESULT=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.result");
	if(REL_UML_LOOPNODE_RESULT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.result is missing.");
	REL_UML_LOOPNODE_LOOPVARIABLE=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.loopVariable");
	if(REL_UML_LOOPNODE_LOOPVARIABLE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.loopVariable is missing.");
	REL_UML_LOOPNODE_BODYOUTPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.bodyOutput");
	if(REL_UML_LOOPNODE_BODYOUTPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.bodyOutput is missing.");
	REL_UML_LOOPNODE_LOOPVARIABLEINPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.LoopNode.loopVariableInput");
	if(REL_UML_LOOPNODE_LOOPVARIABLEINPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.LoopNode.loopVariableInput is missing.");
	ENT_UML_EXPANSIONNODE=(IEntity)mm.getElementByName("uml.metamodel.uml.ExpansionNode");
	if(ENT_UML_EXPANSIONNODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExpansionNode is missing.");
	REL_UML_EXPANSIONNODE_REGIONASOUTPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.ExpansionNode.regionAsOutput");
	if(REL_UML_EXPANSIONNODE_REGIONASOUTPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExpansionNode.regionAsOutput is missing.");
	REL_UML_EXPANSIONNODE_REGIONASINPUT=(IRelation)mm.getElementByName("uml.metamodel.uml.ExpansionNode.regionAsInput");
	if(REL_UML_EXPANSIONNODE_REGIONASINPUT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExpansionNode.regionAsInput is missing.");
	ENT_UML_EXPANSIONREGION=(IEntity)mm.getElementByName("uml.metamodel.uml.ExpansionRegion");
	if(ENT_UML_EXPANSIONREGION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExpansionRegion is missing.");
	REL_UML_EXPANSIONREGION_MODE=(IRelation)mm.getElementByName("uml.metamodel.uml.ExpansionRegion.mode");
	if(REL_UML_EXPANSIONREGION_MODE==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExpansionRegion.mode is missing.");
	REL_UML_EXPANSIONREGION_INPUTELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.ExpansionRegion.inputElement");
	if(REL_UML_EXPANSIONREGION_INPUTELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExpansionRegion.inputElement is missing.");
	REL_UML_EXPANSIONREGION_OUTPUTELEMENT=(IRelation)mm.getElementByName("uml.metamodel.uml.ExpansionRegion.outputElement");
	if(REL_UML_EXPANSIONREGION_OUTPUTELEMENT==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExpansionRegion.outputElement is missing.");
	ENT_UML_EXPANSIONKIND=(IEntity)mm.getElementByName("uml.metamodel.uml.ExpansionKind");
	if(ENT_UML_EXPANSIONKIND==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ExpansionKind is missing.");
	ENT_UML_PROTOCOLTRANSITION=(IEntity)mm.getElementByName("uml.metamodel.uml.ProtocolTransition");
	if(ENT_UML_PROTOCOLTRANSITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolTransition is missing.");
	REL_UML_PROTOCOLTRANSITION_POSTCONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.ProtocolTransition.postCondition");
	if(REL_UML_PROTOCOLTRANSITION_POSTCONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolTransition.postCondition is missing.");
	REL_UML_PROTOCOLTRANSITION_REFERRED=(IRelation)mm.getElementByName("uml.metamodel.uml.ProtocolTransition.referred");
	if(REL_UML_PROTOCOLTRANSITION_REFERRED==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolTransition.referred is missing.");
	REL_UML_PROTOCOLTRANSITION_PRECONDITION=(IRelation)mm.getElementByName("uml.metamodel.uml.ProtocolTransition.preCondition");
	if(REL_UML_PROTOCOLTRANSITION_PRECONDITION==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.ProtocolTransition.preCondition is missing.");
	ENT_UML_ASSOCIATIONCLASS=(IEntity)mm.getElementByName("uml.metamodel.uml.AssociationClass");
	if(ENT_UML_ASSOCIATIONCLASS==null) throw new VPMRuntimeException("Metamodel incomplete. Element uml.metamodel.uml.AssociationClass is missing.");
}
}
